angular.module('goldcar', ['ionic', 'goldcar.config', 'goldcar.services', 'ionic.contrib.drawer', 'angular-click-outside', 'ngCordova', 'ngAnimate', 'ngMaterial', 'ngMessages', 'uiGmapgoogle-maps', 'ngMask', 'ionic-datepicker', 'ionic-timepicker', 'whimsicalRipple', 'angularLoad', 'ngCordovaOauth'])

    .run(function ($filter, $rootScope, $window, $ionicPlatform, $ionicLoading, $ionicPopup, $log, $ionicModal, $ionicBackdrop, $cordovaDevice, $timeout, JsonService, $cordovaSplashscreen, $q, $state, GoldcarService, OAUTHService, Language, Session, $cordovaAppVersion, $cordovaDialogs, $cordovaNetwork, $interval, $ionicScrollDelegate) {

        // RECIBIR SI SE ABRE LA APP POR UNA URL PERSONALIZADA

        $rootScope.$on('logged-in', function(event, args) {
            $rootScope.mostrarAlerta = false;
        });

        $rootScope.abrirLogin = false;
        $rootScope.abrirReservas = false;
        $rootScope.mostrarAsistenciaCompleta = false;
        $rootScope.ticketCogido = false;

        $window.handleOpenURL = function(url) {

            $rootScope.$broadcast('customURL', url);
        };

        $rootScope.$on('customURL', function (event, url) {

            if ( url.slice(0, 13) == 'goldcarapp://' ) {

                console.log(url);

                if ( localStorage['isLogged'] == 'true' ) {

                    $ionicLoading.show({
                        template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.recuperando_reservas) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
                    });

                    var newURL = 'menu.' + url.slice(14);

                    $state.go(newURL);
                    $rootScope.abrirReservas = true;

                } else {

                    if ( typeof $rootScope.mostrarModalLogin === 'undefined' ) {

                        $rootScope.abrirLogin = true;
                    } else {

                        $rootScope.mostrarModalLogin();
                    }

                }
            }
        });

        /////////

        $rootScope.arrancandoAPP = true;

        // PUSH NOTIFICATIONS ********************************************
        var pushNotificationRegister = function () {
            if (typeof PushNotification !== "undefined") {

                var push = PushNotification.init({
                    android: $rootScope.config.push.androidConfig, //{ "senderID": "589349113195" }
                    ios: $rootScope.config.push.iosConfig, // { "badge": false, "sound": false, "alert": false, }
                    windows: $rootScope.config.push.windowsConfig //{}
                });

                $log.debug("PUSH", push);

                $log.debug("push config", push);
                document.addEventListener("deviceready", function () {

                    if(typeof StatusBar !== 'undefined'){
                        if(ionic.Platform.isIOS()) {
                            StatusBar.overlaysWebView(false);
                            StatusBar.overlaysWebView(true);
                            StatusBar.styleDefault();
                        }
                    }

                    $log.debug("Register Push");

                    push.on('registration', function (data) {
                        // data.registrationId
                        $log.debug("Registration data", data);
                        if (data.registrationId.length > 0) {
                            $log.debug("Registration", data);
                            var sns = new AWS.SNS({
                                region: $rootScope.config.push.sns.region, // 'eu-west-1',
                                accessKeyId: $rootScope.config.push.sns.accessKeyId, // 'AKIAJS7MPM6URRBCQO3Q',
                                secretAccessKey: $rootScope.config.push.sns.secretAccessKey // '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'
                            });

                            var params;
                            var topicParams;

                            if (ionic.Platform.isAndroid()) {
                                params = {
                                    PlatformApplicationArn: $rootScope.config.push.androidConfig.snsPlatformApplicationArn, //'arn:aws:sns:eu-west-1:140885132653:app/GCM/Goldcar_App_test',
                                    Token: data.registrationId,
                                    Attributes: {},
                                    CustomUserData: $cordovaDevice.getUUID()
                                };

                                topicParams = {
                                    TopicArn: $rootScope.config.push.androidConfig.snsTopicArn, //'arn:aws:sns:eu-west-1:140885132653:GoldcarApp_Android_es',
                                    Protocol: 'application'
                                };
                            }
                            else if (ionic.Platform.isIOS()) {
                                params = {
                                    PlatformApplicationArn: $rootScope.config.push.iosConfig.snsPlatformApplicationArn, //'arn:aws:sns:eu-west-1:140885132653:app/GCM/Goldcar_App_test',
                                    Token: data.registrationId,
                                    Attributes: {},
                                    CustomUserData: $cordovaDevice.getUUID()
                                };

                                topicParams = {
                                    TopicArn: $rootScope.config.push.iosConfig.snsTopicArn, //'arn:aws:sns:eu-west-1:140885132653:GoldcarApp_Android_es',
                                    Protocol: 'application'
                                };
                            }

                            if (params) {

                                sns.createPlatformEndpoint(params, function (err, data) {
                                    if (err) {
                                        $log.error("Error Creating endpoint", err.message);
                                    }
                                    else {
                                        localStorage.setItem('EndpointArn', data.EndpointArn);
                                        $log.info("Created endpoint", data);
                                        topicParams.Endpoint = data.EndpointArn;
                                        sns.subscribe(topicParams, function (err, data) {
                                            if (err) {
                                                $log.error("Error subscribing topic", err.message);
                                            }
                                            else {
                                                $log.info("Subscribed to topic", data);
                                            }
                                        });
                                    }

                                });
                            }
                        }
                    });


                }, false);

                push.on('notification', function (data) {
                    // data.message,
                    // data.title,
                    // data.count,
                    // data.sound,
                    // data.image,
                    // data.additionalData
                    $log.debug("New notification", data);
                    $ionicPopup.alert({
                        title: 'Nueva notificación',
                        template: data.message
                    }); // successful response

                });

                push.on('error', function (e) {
                    // e.message
                    $log.debug(e);
                    $ionicPopup.alert({
                        title: 'Error',
                        template: e.message
                    }); // successful response
                });
            } else {
                $log.error("PushNotification not defined");
            }
        };

        var tryLogin = function (user, passwd, errFn) {
            GoldcarService.login(user, passwd).then(function (result) {
                loginOk(user, passwd, result);
            }, function (error) {
                if (errFn) errFn(error);
            });
        };

        var loginOk = function (user, passwd, result) {
            localStorage['user'] = user;
            localStorage['passwd'] = passwd;

            localStorage['nombreUsuario'] = $rootScope.nombreUsuario = result.data.Nombre;
            localStorage['apellidosUsuario'] = $rootScope.apellidosUsuario = result.data.Apellidos;
            localStorage['puntosClub'] = $rootScope.puntosClub = result.data.Puntosclub;
            if ( result.data.Picture ) {

                localStorage['imagenPerfil'] = $rootScope.imagenPerfil = result.data.Picture;
            } else {

                localStorage['imagenPerfil'] = $rootScope.imagenPerfil = "img/usuario.svg";
            }
            localStorage['isLogged'] = $rootScope.isLogged = true;
            // console.log("BROADCAST");
            $rootScope.$broadcast('logged-in');
            $rootScope.datosUsuario = result.data;

            Session.set({

                "Lang": localStorage['lang'],
                "nombre": $rootScope.datosUsuario.Nombre,
                "apellidos": $rootScope.datosUsuario.Apellidos,
                "user": $rootScope.datosUsuario.user,
                "authenticated": $rootScope.datosUsuario.Authenticated,
                "paquetes_disponibilidad": [],
                "paquetes": []
            }).then(function (result) {

            });

            if( typeof result.data.Cover !== 'undefined' && result.data.Cover ) {

                localStorage['imagenCover'] = $rootScope.profileCoverImage = result.data.Cover;
            } else {

                if ( typeof result.data.Picture !== 'undefined' && result.data.Picture ) {

                    localStorage['imagenCover'] = $rootScope.profileCoverImage = result.data.Picture;
                } else {

                    localStorage['imagenCover'] = $rootScope.profileCoverImage = "img/usuario.svg";
                }
            }

            GoldcarService.getReservasActivas().then(function (result) {

                    if (result.data.length > 0) {
                        $rootScope.someBooking = true;
                        $rootScope.someBookingLoaded = true;

                        result.data.forEach(function (reserva) {
                            var now = new Date().getTime();
                            var diffHoursRecogida = reserva.Pickupdate;
                            var diffHoursEntrega = reserva.Dropoffdate;

                            if (reserva.Estado == 2 || reserva.Estado == 5) {

                                // $rootScope.reservaDisfrutando = reserva;

                                if (now > diffHoursRecogida && now < diffHoursEntrega) {
                                    $rootScope.someBooking = true;
                                    $rootScope.tieneReservasDisfrutando = true;
                                    for ( var i = 0; i < $rootScope.config.oficinas_franquicia.length; i++ ) {

                                        if ( reserva.pickupplace.Codigo != $rootScope.config.oficinas_franquicia[i] ) {

                                            $rootScope.mostrarAsistenciaCompleta = true;
                                        }
                                    }
                                    $rootScope.reservaDisfrutando = reserva;
                                    return true;
                                } else {

                                    $rootScope.tieneReservasDisfrutando = false;
                                }
                            }
                        });

                        return true;
                    }
                    reservasPosiblementeActivas();
                },
                function (error) {
                    $log.debug("Error cargando reservasActivas: " + error);
                    reservasPosiblementeActivas();
                }
            );

            var reservasPosiblementeActivas = function(){

                GoldcarService.getReservasAnteriores().then(function (result) {

                        if(result.data.length > 0){
                            result.data.forEach(function (reserva) {
                                var diffHoursRecogida = reserva.Pickupdate;
                                var diffHoursEntrega = reserva.Dropoffdate;
                                var now = new Date().getTime();

                                if(reserva.Estado == 2 || reserva.Estado == 5){
                                    if(now > diffHoursRecogida && now < diffHoursEntrega) {
                                        $rootScope.someBooking = true;
                                        $rootScope.someBookingLoaded = true;
                                        $rootScope.tieneReservasDisfrutando = true;
                                        for ( var i = 0; i < $rootScope.config.oficinas_franquicia.length; i++ ) {

                                            if ( typeof reserva.Pickupplace.Codigo !== 'undefined' && reserva.Pickupplace.Codigo != $rootScope.config.oficinas_franquicia[i] ) {

                                                $rootScope.mostrarAsistenciaCompleta = true;
                                            }
                                        }
                                        $rootScope.reservaDisfrutando = reserva;
                                        return true;
                                    } else {
                                        $rootScope.tieneReservasDisfrutando = false;
                                    }
                                }
                            });
                        }
                    },
                    function(error){
                        $log.debug("Error con reservasAnteriores: " + error);
                    });
            };

            // RELLENAR FICHA CLIENTE
            $rootScope.cliente = result.data;
            if ( !$rootScope.abrirReservas ) {

                $state.go('menu.home');
            }
        };

        var loginError = function (error) {
            $log.error(error);
            $rootScope.nombreUsuario = $filter("translate")($rootScope.translations.general.usuario_anonimo);
            $rootScope.apellidosUsuario = "";
            $rootScope.puntosClub = "0";
            $rootScope.imagenPerfil = "img/usuario.svg";
            $rootScope.isLogged = false;
            if ( !$rootScope.abrirReservas ) {

                $state.go('menu.home');
            }
        };

        var initialLogin = function () {
            var deferred = $q.defer();

            Session.set({
                "authenticated": false,
                "referer": "app"
            }).then(function() {
    
                var user = '';
                var passwd = '';
    
                if (typeof localStorage['redSocial'] !== "undefined") {
    
                    if(localStorage['redSocial'] == "facebook"){
                        OAUTHService.FBSilentLogin().then(function(){
                            deferred.resolve(true);
                            $rootScope.isLogged = true;
                            $rootScope.$broadcast('logged-in');
                        })
                        .catch(function (error) {
                            $log.error("Error llamando a FBSilentLogin");
                            OAUTHService.FBSilentLogin().then(function () {
                                deferred.resolve(true);
                                $rootScope.isLogged = true;
                                $rootScope.$broadcast('logged-in');
                                // $rootScope.mostrarAlerta = false;
                            }, function (error) {
                                deferred.reject(error);
                            });
                        });
                    }
                    else if(localStorage['redSocial'] == "GooglePlus"){
                        OAUTHService.GPlusSilentLogin().then(function(){
                            deferred.resolve(true);
                            $rootScope.isLogged = true;
                            $rootScope.$broadcast('logged-in');
                        })
                        .catch(function (error) {
                            $log.error("Error llamando a GPlusSilentLogin");
                            OAUTHService.GPlusLogin().then(function () {
                                deferred.resolve(true);
                                $rootScope.isLogged = true;
                                $rootScope.$broadcast('logged-in');
                                // $rootScope.mostrarAlerta = false;
                            }, function (error) {
                                deferred.reject(error);
                            });
                        });
                    }
    
                }
    
                if (typeof localStorage['user'] !== "undefined" && typeof localStorage['passwd'] !== "undefined") {
                    user = localStorage['user'];
                    passwd = localStorage['passwd'];
                }
    
                if (user != '' && passwd != '') {
                    tryLogin(user, passwd,
                        function (error) {
                            $timeout(function () {
                                tryLogin(user, passwd, loginError);
                            }, 1000);
                        }
                    );
                    deferred.resolve(true);
                } else {
    
                    $rootScope.nombreUsuario = $filter("translate")($rootScope.translations.general.usuario_anonimo);
                    $rootScope.apellidosUsuario = "";
                    $rootScope.puntosClub = "0";
                    $rootScope.imagenPerfil = "img/usuario.svg";
                    $rootScope.isLogged = false;
                    if ( !$rootScope.abrirReservas ) {
    
                        $state.go('menu.home');
                    }
                    deferred.resolve(true);
                }
    
            });
            
            return deferred.promise;
        };

        var arraySorting =  function(property) {
            var sortOrder = 1;
            if (property[0] === "-") {
                sortOrder = -1;
                property = property.substr(1);
            }
            return function (a, b) {
                var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
                return result * sortOrder;
            }
        };

        if ( !localStorage['lang'] )
            $rootScope.language = 'es';
        else
            $rootScope.language = localStorage['lang'];

        $rootScope.nuevaReserva = [];

        $rootScope.someBooking = false;
        $rootScope.someBookingLoaded = false;

        $rootScope.nextScreen = 'home';

        $rootScope.misReservasLoadFirstTime = true;
        $rootScope.historialReservasLoadFirstTime = true;
        $rootScope.misPromocionesLoadFirstTime = true;
        $rootScope.misPuntosLoadFirstTime = true;
        $rootScope.misPremiosLoadFirstTime = true;
        $rootScope.regaloBienvenidaLoadFirstTime = true;
        $rootScope.listaPremiosLoadFirstTime = true;

        $rootScope.modalNoOlvidesIsClose = false;
        $rootScope.modalNoOlvidesCreado = false;

        $rootScope.modalTelefonosIsClose = false;
        $rootScope.modalTelefonosCreado = false;

        $rootScope.modalTicketsIsClose = false;
        $rootScope.modalTicketsCreado = false;

        $rootScope.config = localStorage['content_goldcarapp-config'] ? JSON.parse(localStorage['content_goldcarapp-config']) : [];
        $rootScope.translations = localStorage['content_goldcarapp-translations-v2'] ? JSON.parse(localStorage['content_goldcarapp-translations-v2']) : [];

        //--------------------------
        // APP READY
        //--------------------------

        $ionicPlatform.ready(function () {
            if(typeof Offline !== 'undefined')
            {
                Offline.options = {
                    checkOnLoad: true,
                    checks: {
                        xhr: {
                            url: 'https://m.goldcar.es'
                        }
                    },
                    interceptRequests: true,
                    reconnect: {
                        initialDelay: 3
                    },
                    requests: false,
                    game: false
                };
            }

            //--------------------------
            // GET CONFIGURATIONS
            //--------------------------

            JsonService.getContentJSON('goldcarapp-config', 'en')
                .then(function (data) {
                    $log.debug("get config data", data);
                    if (data) {
                        $rootScope.config = data;

                        //--------------------------
                        // CARGAR IDIOMAS
                        //--------------------------

                        Language.get().then(function() {

                            //--------------------------
                            // GET TRANSLATIONS
                            //--------------------------

                            JsonService.getContentJSON('goldcarapp-translations-v2', $rootScope.language, 2, 'json')
                                .then(function (data) {

                                    if (data) {
                                        $rootScope.translations = data;

                                        //--------------------------
                                        // GET OFICINAS
                                        //--------------------------

                                        moment.locale($rootScope.config.mapeo_moment[$rootScope.language]);

                                        JsonService.getOfficesByCountry().then(function (offices) {

                                                $rootScope.todasLasOficinas = offices;

                                                // if ( localStorage['lastOffice'] && localStorage['lastOffice'] != '' ) {

                                                //     var lastOffice = angular.fromJson(localStorage['lastOffice']);
                                                //     var oficinaActual = JsonService.getOfficeByCode(lastOffice.lugarRecogidaCodigo);

                                                //     $log.debug("Oficina actual: ", oficinaActual);

                                                //     $rootScope.nuevaReserva.lugarRecogida = $rootScope.nuevaReserva.lugarEntrega = oficinaActual.fullname;
                                                //     $rootScope.nuevaReserva.lugarRecogidaCodigo = $rootScope.nuevaReserva.lugarEntregaCodigo = oficinaActual.code;
                                                //     $rootScope.nuevaReserva.busCortesia = oficinaActual.bus;
                                                //     if ( oficinaActual.type == 'airport' ) {

                                                //         $rootScope.nuevaReserva.pickupType = "1";
                                                //     }
                                                //     localStorage['lastOffice'] = angular.toJson({
                                                //         "lugarRecogida": $rootScope.nuevaReserva.lugarRecogida,
                                                //         "lugarRecogidaCodigo": $rootScope.nuevaReserva.lugarRecogidaCodigo
                                                //     });
                                                // }

                                                $rootScope.todasLasOficinas.forEach(function (pais, index) {

                                                    function getTimestamp() {

                                                        return Math.floor(Date.now() / 1000);
                                                    }

                                                    var codigoPais = pais.code;
                                                    codigoPais = codigoPais.toUpperCase();
                                                    $rootScope.paises.push({
                                                        bandera: 'https://gcdata-documents.s3.amazonaws.com/goldcar-app/banderas-paises-2018/' + codigoPais + '.svg?time=' + getTimestamp(),
                                                        nombre: pais.name,
                                                        posicion: index
                                                    });
                                                });

                                                $rootScope.paises.sort(arraySorting("nombre"));

                                                initialLogin().then(function () {
                                                    if (navigator.splashscreen) {

                                                        $cordovaSplashscreen.hide();
                                                    }
                                                }, function (error) {
                                                    if (navigator.splashscreen) {

                                                        $cordovaSplashscreen.hide();
                                                    }
                                                });
                                                pushNotificationRegister();
                                            },
                                            function (error) {
                                                $log.error("Fallo trayendo las oficinas", error);
                                                $ionicPopup.alert({
                                                    title: $filter("translate")($rootScope.translations.general.error),
                                                    template: $filter("translate")($rootScope.translations.alertas.error_conexion)
                                                });
                                            }
                                        );
                                    }
                                }, function (err) {
                                    $log.error("get translation error", err);
                                    $ionicPopup.alert({
                                        title: $rootScope.translations ? $filter("translate")($rootScope.translations.general.error) : "Internet error connection",
                                        template: $rootScope.translations ? $filter("translate")($rootScope.translations.alertas.error_conexion) : "You must have internet connection for using this application"
                                    }).then(function () {
                                        window.location.reload();
                                    });
                                });
                        });
                    }
                }, function (err) {
                    $log.error("get config error", err);
                    $ionicPopup.alert({
                        title: $rootScope.translations ? $filter("translate")($rootScope.translations.general.error) : "Internet error connection",
                        template: $rootScope.translations ? $filter("translate")($rootScope.translations.alertas.error_conexion) : "You must have internet connection for using this application"
                    }).then(function () {
                        window.location.reload();
                    });
                });

            // ANALYTICS //
            // var analytics;
            // function analyticsOK(data){ console.log("VIEW SEND", data); }
            // function analyticsFail(err){ console.log("FAIL ANALYTICS", err); }
            //
            // function advertisingIdOK(data) { console.log("AdvertisingID OK", data); }
            // function advertisingIdFail(err) { console.log("AdvertisingID OK", err); }
            //
            // function trackerOK(data) {
            //     console.log("TRACKER OK", data);
            //     analytics.enableAdvertisingIdCollection(advertisingIdOK, advertisingIdFail);
            // }
            // function trackerFail(err) { console.log("TRACKER FAIL", err); }
            //
            // if(typeof navigator.analytics !== "undefined") {
            //     $log.debug("+ Google Analytics Available +");
            //     var analytics = navigator.analytics;
            //     analytics.setTrackingId("UA-6134091-34", trackerOK, trackerFail);
            //     analytics.sendAppView('start', analyticsOK, analyticsFail);
            // } else {
            //     $log.debug("+ Google Analytics Unavailable +");
            // }
            //
            // $rootScope.rastrearVista = function (vista) {
            //     $log.debug("rastrearVista: ", vista);
            //     if(typeof analytics !== "undefined") {
            //         analytics.sendAppView(vista, analyticsOK, analyticsFail);
            //     }
            // };
            //////////////////
            function trackerOK(result){
                console.log("TRACKER OK", result);
                window.ga.setAllowIDFACollection(true, idfaOK, idfaFail);
            }
            function trackerFail(err){
                console.log("TRACKER FAIL", err);
            }
            function idfaOK(result){
                console.log("IDFA OK", result);
                $rootScope.rastrearVista('start');
            }
            function idfaFail(err){
                console.log("IDFA Fail", err);
                $rootScope.rastrearVista('start');
            }
            function analyticsOK(result){
                console.log("ANALYTICS OK", result);
            }
            function analyticsFail(err){
                console.log("ANALYTICS Fail", err);
            }
            // PREFIJOS TELEFONICOS //
            $rootScope.prefijosTlf = [];
            JsonService.getContentJSON('goldcarapp-prefijos', 'en')
                .then(function (data) {
                    $rootScope.prefijosTlf = data;
                    console.log(data);
                })
                .catch(function (err) {
                    console.log(err);
                });

            function analyticsOK(data){ console.log("VIEW SEND", data); }
            function analyticsFail(err){ console.log("FAIL ANALYTICS", err); }

            if(typeof window.ga !== 'undefined'){
                window.ga.startTrackerWithId("G-214569767", null, trackerOK, trackerFail);
                window.ga.enableUncaughtExceptionReporting(false);
            }

            $rootScope.rastrearVista = function (vista) {
                if(typeof window.ga !== "undefined") {
                    window.ga.trackView(vista, null, null, analyticsOK, analyticsFail);
                }
            };

            $rootScope.platformIOS = ionic.Platform.isIOS() ? true : false;

            $rootScope.paises = [];

            //--------------------------
            // CONTROL MODALES Y BACKDROP
            //--------------------------

            $rootScope.$on('modal.shown', function(e, modal) {

                $log.debug("Modal shown");

                if (modal.id === "oficinas") modal.vista = '/' + $rootScope.language + '/oficinas/' + $rootScope.cleanSpecialCharacters($rootScope.paisSeleccionado);
                else if (modal.id === "office_details") modal.vista = '/' + $rootScope.language + '/oficinas/oficina-' + $rootScope.oficinaSeleccionada.code;
                else if (modal.id === 'login') modal.vista = '/' + $rootScope.language + '/login';
                else if (modal.vista == 'Seleccionar oficinas') modal.vista = '/' + $rootScope.language + '/reserva/paso1/oficina';
                else if (modal.vista == 'Seleccionar fechas' && !$rootScope.elegidaFechaRecogida) modal.vista = '/' + $rootScope.language + '/reserva/paso2/fecha-recogida';
                else if (modal.vista == 'Seleccionar fechas' && $rootScope.elegidaFechaRecogida) modal.vista = '/' + $rootScope.language + '/reserva/paso2/fecha-devolucion';
                else if (modal.vista == 'Seleccionar horas' && !$rootScope.horaRSeleccionada) modal.vista = '/' + $rootScope.language + '/reserva/paso2/hora-recogida';
                else if (modal.vista == 'Seleccionar horas' && $rootScope.horaRSeleccionada) modal.vista = '/' + $rootScope.language + '/reserva/paso2/hora-devolucion';

                $rootScope.rastrearVista(modal.vista);

                $ionicBackdrop.retain();
            });

            $rootScope.$on('modal.hidden', function() {

                $log.debug("Modal hidden");

                if( !$rootScope.modalTelefonosIsClose && $rootScope.modalTelefonosCreado ){
                    $rootScope.cerrarOtrosTelefonos();
                }

                else if( !$rootScope.modalNoOlvidesIsClose && $rootScope.modalNoOlvidesCreado ){
                    $rootScope.cerrarNoOlvides();
                }

                else if( !$rootScope.modalTicketsIsClose && $rootScope.modalTicketsCreado ) {
                    $rootScope.cerrarTickets();
                }

                else{
                    $ionicBackdrop.release();
                }
            });

            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard for form inputs)
            if ((typeof Keyboard !== 'undefined' && Keyboard) && ionic.Platform.isWebView()) {
                Keyboard.hideFormAccessoryBar(false);
                Keyboard.setResizeMode('body');
            }

            window.addEventListener('keyboardWillShow', (event) => {
                function freezeVp(e){
                    e.preventDefault();
                }
                document.body.addEventListener("touchmove", freezeVp, false);
                $ionicScrollDelegate.freezeAllScrolls(true);
            });

            window.addEventListener('keyboardWillHide', (event) => {
                function freezeVp(e){
                    e.preventDefault();
                }
                document.body.removeEventListener("touchmove", freezeVp, false);
                $ionicScrollDelegate.freezeAllScrolls(false);
            });

            // CONTROL DE VERSION
            $rootScope.compararVersiones = function (v1, v2, options) {

                // COMPARAR VERSIONES DE LA APP / 0 IGUALES / 1 PRIMERO MAYOR / -1 SEGUNDO MAYOR
                var lexicographical = options && options.lexicographical,
                    zeroExtend = options && options.zeroExtend,
                    v1parts = v1.split('.'),
                    v2parts = v2.split('.');

                function isValidPart(x) {
                    return (lexicographical ? /^\d+[A-Za-z]*$/ : /^\d+$/).test(x);
                }

                if (!v1parts.every(isValidPart) || !v2parts.every(isValidPart)) {
                    return NaN;
                }

                if (zeroExtend) {
                    while (v1parts.length < v2parts.length) v1parts.push("0");
                    while (v2parts.length < v1parts.length) v2parts.push("0");
                }

                if (!lexicographical) {
                    v1parts = v1parts.map(Number);
                    v2parts = v2parts.map(Number);
                }

                for (var i = 0; i < v1parts.length; ++i) {
                    if (v2parts.length == i) {
                        return 1;
                    }

                    if (v1parts[i] == v2parts[i]) {
                        continue;
                    }
                    else if (v1parts[i] > v2parts[i]) {
                        return 1;
                    }
                    else {
                        return -1;
                    }
                }

                if (v1parts.length != v2parts.length) {
                    return -1;
                }

                return 0;
            };

            var testUpdate = $interval(function () {

                if ( $rootScope.config.versiones ) {

                    if ( ionic.Platform.isWebView() ) {

                        $cordovaAppVersion.getVersionNumber().then(function (version) {

                            $rootScope.APPversion = version;

                            if ( ionic.Platform.isIOS() ) {

                                if ( $rootScope.compararVersiones($rootScope.APPversion, $rootScope.config.versiones.ios.min) < 0 ) {

                                    $cordovaDialogs.alert($filter("translate")($rootScope.translations.alertas.actualizacion), '', $filter("translate")($rootScope.translations.alertas.boton_actualizar)).then(function() {

                                        // RUTA A LA APPSTORE
                                        window.open('https://itunes.apple.com/es/app/goldcar/id1070220317?mt=8', '_system', 'shouldPauseOnSuspend=yes');
                                        window.location.reload();
                                    });
                                    $interval.cancel(testUpdate);
                                } else {

                                    console.log("APP UPDATED!!");
                                    $interval.cancel(testUpdate);
                                }

                            } else if ( ionic.Platform.isAndroid() ) {

                                if ( $rootScope.compararVersiones($rootScope.APPversion, $rootScope.config.versiones.android.min) < 0 ) {

                                    $cordovaDialogs.alert($filter("translate")($rootScope.translations.alertas.actualizacion), '', $filter("translate")($rootScope.translations.alertas.boton_actualizar)).then(function() {

                                        // RUTA AL GOOGLE PLAY
                                        window.open('https://play.google.com/store/apps/details?id=com.goldcar.app&hl=es', '_system', 'shouldPauseOnSuspend=yes');
                                        window.location.reload();
                                    });
                                    $interval.cancel(testUpdate);
                                } else {

                                    console.log("APP UPDATED!!");
                                    $interval.cancel(testUpdate);
                                }
                            }
                        });
                    }
                }
            }, 500);
        });
    });
