angular.module('goldcar.config', [])

    .constant('$ionicLoadingConfig', {
        delay: 200, // SI TARDA MENOS DE 200ms NO APARECE EL LOADER
        duration: 240000, // MAXIMO 4 MINUTOS
        hideOnStateChange: false,
        template: '<div class="cargando"><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
    })

    .config(function($stateProvider, $compileProvider, $ionicConfigProvider) {
        $compileProvider.debugInfoEnabled(false);

        $stateProvider
            .state('menu', {
                abstract: true,
                url: '/menu',
                templateUrl: 'templates/sidemenu/sidemenu.html',
                controller: 'GlobalCtrl'
            })

            .state('menu.home', {
                url: '/home',
                templateUrl: 'templates/home/home.html',
                controller: 'HomeCtrl'
            })

            .state('menu.ayuda', {
                url: '/ayuda',
                templateUrl: 'templates/ayuda/ayuda.html',
                controller: 'AyudaCtrl'
            })

            .state('menu.reservarDisponibilidad', {
                url: '/reservar/disponibilidad',
                templateUrl: 'templates/reservar/disponibilidad.html',
                controller: 'DisponibilidadCtrl'
            })

            .state('menu.reservarExtras', {
                url: '/reservar/extras',
                templateUrl: 'templates/reservar/extras.html',
                controller: 'ExtrasCtrl'
            })

            .state('menu.reservarPago', {
                url: '/reservar/pago',
                templateUrl: 'templates/reservar/pago.html',
                controller: 'PagoCtrl'
            })

            .state('menu.reservarDatos', {
                url: '/reservar/datos',
                templateUrl: 'templates/reservar/datos.html',
                controller: 'DatosCtrl'
            })

            .state('menu.oficinas', {
                url: '/oficinas',
                templateUrl: 'templates/oficinas/oficinasPorPais.html',
                controller: 'OficinasCtrl'
            })

            .state('menu.concursos', {
                url: '/concursos',
                templateUrl: 'templates/concursos/lista_concursos.html',
                controller: 'ConcursosCtrl'
            })

            .state('menu.sugerencias', {
                url: '/sugerencias',
                templateUrl: 'templates/sugerencias/sugerencias.html',
                controller: 'SugerenciasCtrl'
            })

            .state('menu.condicionesUso', {
                url: '/condicionesUso',
                templateUrl: 'templates/condiciones_uso/condiciones_uso.html',
                controller: 'CondicionesUsoCtrl'
            })

            .state('menu.configuracion', {
                url: '/configuracion',
                templateUrl: 'templates/configuracion/configuracion.html',
                controller: 'ConfigCtrl'
            })

            .state('menu.areaUsuario', {
                url: '/areaUsuario',
                templateUrl: 'templates/area_usuario/area_usuario.html',
                controller: 'AreaUsuarioCtrl'
            })

            .state('menu.misReservas', {
                url: '/misReservas',
                templateUrl: 'templates/area_usuario/mis_reservas.html',
                controller: 'AreaUsuarioCtrl'
            })

            .state('menu.detallesReserva', {
                url: '/detallesReserva',
                templateUrl: 'templates/reservar/detailReserve.html',
                controller: 'PagoCtrl'
            })

            .state('menu.historicoReservas', {
                url: '/historicoReservas',
                templateUrl: 'templates/area_usuario/historico_reservas.html',
                controller: 'AreaUsuarioCtrl'
            })

            .state('menu.misFacturas', {
                url: '/misFacturas',
                templateUrl: 'templates/area_usuario/mis_facturas.html',
                controller: 'AreaUsuarioCtrl'
            })

            .state('menu.loginClub', {
                url: '/loginClub',
                templateUrl: 'templates/login_club/login_club.html',
                controller: 'LoginCtrl'
            })

            .state('menu.goldcarClub', {
                url: '/goldcarClub',
                templateUrl: 'templates/goldcar_club/goldcar_club.html',
                controller: 'GoldcarClubCtrl'
            })

            .state('menu.misPromociones', {
                url: '/misPromociones',
                templateUrl: 'templates/goldcar_club/mis_promociones.html',
                controller: 'MisPromocionesCtrl'
            })

            .state('menu.misPuntos', {
                url: '/misPuntos',
                templateUrl: 'templates/goldcar_club/mis_puntos.html',
                controller: 'MisPuntosCtrl'
            })

            .state('menu.misTarjetas', {
                url: '/misTarjetas',
                templateUrl: 'templates/tarjetas/tarjetas.html',
                controller: 'TarjetasCtrl'
            })

            .state('menu.fitur18', {
                url: '/fitur18',
                templateUrl: 'templates/fitur18/fitur_home.html',
                controller: 'Fitur18Ctrl'
            })

            .state('menu.fitur18Concursos', {
                url: '/fitur18/concursos',
                templateUrl: 'templates/fitur18/fitur_concursos.html',
                controller: 'Fitur18Ctrl'
            })
            
            .state('menu.fitur18Click', {
                url: '/fitur18/concursos/click',
                templateUrl: 'templates/fitur18/fitur_click.html',
                controller: 'Fitur18Ctrl'
            })
            
            .state('menu.fitur18Moto', {
                url: '/fitur18/concursos/moto',
                templateUrl: 'templates/fitur18/fitur_moto.html',
                controller: 'Fitur18Ctrl'
            })
            
            .state('menu.fitur18Simulador', {
                url: '/fitur18/concursos/simulador',
                templateUrl: 'templates/fitur18/fitur_simulador.html',
                controller: 'Fitur18Ctrl'
            })
            
            .state('menu.fitur18Iframe', {
                url: '/fitur18/concursos/iframe',
                templateUrl: 'templates/fitur18/fitur_iframe.html',
                controller: 'Fitur18Ctrl'
            })
            
            .state('menu.fitur18Slider', {
                url: '/fitur18/concursos/slider',
                templateUrl: 'templates/fitur18/fitur_slider.html',
                controller: 'Fitur18Ctrl'
            })

            .state('menu.ra', {
                url: '/ra',
                templateUrl: 'templates/ra/ra.html',
                controller: 'RaCtrl'
            })

            .state('menu.fitur', {
                url: '/fitur',
                templateUrl: 'templates/promo_fitur/galeria_matriculas.html',
                controller: 'FiturCtrl'
            })

            .state('menu.misPremios', {
                url: '/misPremios',
                templateUrl: 'templates/goldcar_club/mis_premios.html',
                controller: 'GoldcarClubCtrl'
            });
    });
