angular.module('goldcar').controller('GlobalCtrl', function ($scope, $rootScope, $interval, $state, $ionicBackdrop, $ionicModal, $ionicLoading, $filter, JsonService, $timeout, $compile, GoldcarService, $q, $cordovaInAppBrowser, $cordovaDatePicker, $ionicSlideBoxDelegate, $ionicPopup, $cordovaGeolocation, $log, $cordovaSocialSharing, $sce, $ionicActionSheet, Session, $ionicScrollDelegate, $ionicPlatform) {

    // EVITA ABRIR VARIAS VECES LA SECCION DE RESERVAS

    $rootScope.editAbrirReservas = function () {

        $rootScope.abrirReservas = false;
    };

    ///////

    // $rootScope.versionAPP = '2.8.4'; // VERSION DE LA APP

    $rootScope.mostrarParaTesteo = false;

    $rootScope.comprobarMenusActivos = function () {

        for ( var f = 0; f < $rootScope.config.usuarios_testeo.length; f++ ) {

            if ( $rootScope.config.usuarios_testeo[f] == localStorage['user'] ) {

                $rootScope.mostrarParaTesteo = true;
            }
        }
    };

    // ----------------------------------------------------------------------------------------------------- //
    // ------------------------------------------- MENU LATERAL -------------------------------------------- //
    // ----------------------------------------------------------------------------------------------------- //

    $rootScope.goTo = function (view) {

    // if ( !$rootScope.isLogged && view == 'menu.goldcarClub' ) {
    //     $rootScope.closeMenu();
    //     $rootScope.closeDrawer();
    //     //   $rootScope.registroClubGoldcar = true;
    //     $state.go('menu.loginClub');
        if ( !$rootScope.isLogged && view == 'menu.misPuntos' ) {
            $rootScope.closeMenu();
            $rootScope.closeDrawer();
            $rootScope.mostrarModalLogin();
        } else if ( !$rootScope.isLogged && view == 'menu.misPremios' ) {
            $rootScope.closeMenu();
            $rootScope.closeDrawer();
            $rootScope.mostrarModalLogin();
        } else if ( !$rootScope.isLogged && view == 'menu.misPromociones' ) {
            $rootScope.closeMenu();
            $rootScope.closeDrawer();
            $rootScope.mostrarModalLogin();
        } else if ( !$rootScope.isLogged && view == 'menu.concursos' ) {
            $rootScope.closeMenu();
            $rootScope.closeDrawer();
            $rootScope.mostrarModalLogin();
        } else {
            $state.go(view);
            $rootScope.closeMenu();
            $rootScope.closeDrawer();
        }
    };

    $scope.abrirCanjearMisPuntos = function () {
        $rootScope.goTo('menu.misPuntos');
        setTimeout( function () {
            $rootScope.abrirCanjearPuntos();
        }, 500)
    };

    $scope.showLoader = function () {

        $ionicLoading.show();
    };

    $scope.open = false;

    $rootScope.openMenu = function () {

        $ionicBackdrop.retain();
        $scope.open = true;
    };

    $rootScope.closeMenu = function () {

        if ($scope.open == true) {

            $ionicBackdrop.release();
            $scope.open = false;
        }
    };

    //------------------------------
    // MODAL TU CUENTA
    //------------------------------
    
    // $rootScope.registroClubGoldcar = false;
    $scope.abrirTuCuenta = function () {
        // if(mostrarRegistro) $rootScope.registroClubGoldcar = true;
        // else $rootScope.registroClubGoldcar = false;
        if ( $rootScope.isLogged ) {
            $ionicModal.fromTemplateUrl('templates/tu_cuenta/tu_cuenta.html', {
                vista: "Tu cuenta",
                id: "account",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function (modalTuCuenta) {
                $rootScope.modalTuCuenta = modalTuCuenta;
                $rootScope.recuperarDatosUsuario();
                modalTuCuenta.show();
            });
        } else {
            $rootScope.mostrarModalLogin();
        }
    };

    //------------------------------
    // RECUPERAR DATOS CUENTA
    //------------------------------

    $scope.abrirModalTuCuenta = function () {

        $scope.abrirTuCuenta();
    };

    // ----------------------------------------------------------------------------------------------------- //
    // ----------------------------------------------- GLOBAL ---------------------------------------------- //
    // ----------------------------------------------------------------------------------------------------- //

    //-----------------------------
    // LLAMAR ASISTENCIA
    //-----------------------------

    $rootScope.llamarAsistencia = function (nombre, numero, variousPhones) {

        var telefonos = [];

        if ( variousPhones ) {

            for ( var i = 0; i < numero.length; i++ ) {

                telefonos.push({
                    text: '<i class="icon ion-ios-telephone"></i>' + numero[i],
                    numero: numero[i]
                });
            }
        } else {

            telefonos.push({
                text: '<i class="icon ion-ios-telephone"></i>' + numero,
                numero: numero
            });
        }

        $ionicActionSheet.show({
            buttons: telefonos,
            //titleText: $filter("translate")($rootScope.translations.general.llamar),
            titleText: nombre,
            cancelText: $filter("translate")($rootScope.translations.general.cancelar),
            buttonClicked: function(index) {

                llamar(telefonos[index].numero);
                return true;
            }
        });

        function llamar(numero) {

            window.plugins.CallNumber.callNumber(onSuccess, onError, numero, true);

            function onSuccess(result) {

                $log.debug(result);
            }

            function onError(error) {

                $log.debug(error);
            }
        }
    };

    //-----------------------------
    // ABRIR ENLACES
    //-----------------------------

    $scope.abrirModal = function (modal) {

        if ( modal === 'asistencia' ) {

            $rootScope.modalAsistencia.show();
        } else if ( modal === 'faqs' ) {

            $rootScope.resetFAQS();
            $rootScope.getCategoriasFaq();
            $rootScope.modalAllFaqs.show();
        } else if ( modal === 'perfil' ) {

            if ( $rootScope.isLogged ) {

                $scope.abrirTuCuenta();
            } else {

                $rootScope.mostrarModalLogin();
            }
        } else if ( modal === 'canjear_puntos' ) {

            if ( $rootScope.isLogged ) {

                $ionicLoading.show();

                $state.go('menu.goldcarClub');

                setTimeout(function () {
                    $rootScope.abrirCanjearPuntos();
                    $ionicLoading.hide();
                }, 100);
            } else {

                $rootScope.mostrarModalLogin();
            }
        } else if ( modal === 'localizaciones' ) {

            $rootScope.modalLocalizaciones.show();
        } else if ( modal.substr(0, 7) === 'oficina') {

            var oficina = modal.substr(8, 3);

            $ionicLoading.show();

            $state.go('menu.oficinas');
            setTimeout(function () {
                $state.go('menu.home');
                $rootScope.abrirOficina(oficina);
                $ionicLoading.hide();
            }, 100);
        }
    };

    $rootScope.abrirBanner = function(banner){

        if ( typeof banner.pickupplace !== 'undefined'){

            GoldcarService.getOficinas().then(function (result) {

                if ( typeof result !== 'undefined' && typeof result.data != 'undefined' ) {

                    if ( typeof result.data.error !== 'undefined' && result.data.error == true ) {

                        $ionicLoading.hide();

                        $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.titulo_atencion), template: $filter("translate")($rootScope.translations.disponibilidad.no_disponible)});
                    } else {

                        var oficinas = result.data;

                        for ( var i = 0; i < oficinas.length; i++ ) {

                            if ( banner.pickupplace == oficinas[i].Codigo ) {

                                $rootScope.nuevaReserva = {

                                    lugarRecogida : oficinas[i].Fullname,
                                    lugarEntrega : oficinas[i].Fullname,
                                    lugarRecogidaCodigo : oficinas[i].Codigo,
                                    lugarEntregaCodigo : oficinas[i].Codigo,
                                    pickupType : oficinas[i].Tipo,
                                    busCortesia : oficinas[i].Buscortesia
                                };

                                $rootScope.abrirSeleccionDeFechas($rootScope.nuevaReserva.lugarRecogidaCodigo, 'recogida');
                            }
                        }

                        // $rootScope.elegirRecogida = 0;
                        console.log(result.data);
                    }
                }
            });
            console.log(banner);
        } else if ( typeof banner.modal !== 'undefined' ) {
            $scope.abrirModal(banner.modal);
        } else if ( typeof banner.vista !== 'undefined' ) {
            if ( !$rootScope.isLogged && (banner.vista === 'areaUsuario' || banner.vista === 'misReservas' || banner.vista === 'historicoReservas' || banner.vista === 'misPromociones' || banner.vista === 'misPuntos' || banner.vista === 'misPremios') ) {
                $rootScope.mostrarModalLogin();
            } else if (banner.vista === 'goldcarClub'){
                $rootScope.goTo('menu.loginClub');
            } else {
                $rootScope.goTo('menu.' + banner.vista);
            }
        } else if ( typeof banner.link !== 'undefined' ) {
            $cordovaInAppBrowser.open(banner.url, '_system', {location: 'yes'})
                .then(function(event) {

                })
                .catch(function(event) {

                });
        } else if ( typeof banner.nolink !== 'undefined' ) {

        }
    };

    //----------------------------
    // OBTENER POSICION USUARIO
    //----------------------------

    $rootScope.getMiPosicion = function () {

        $rootScope.miPosicion = {
            "nombre" : $rootScope.reservaDisfrutando.Cliente.Name,
            "contrato" : $rootScope.reservaDisfrutando.BonoAgencia
        }

        var opciones = {

            timeout: 10000,
            enableHighAccuracy: false
        };

        navigator.geolocation.getCurrentPosition(successGeolocation, errorGeolocation, opciones);

        function successGeolocation(posicion) {

            var latitud = posicion.coords.latitude;
            var longitud = posicion.coords.longitude;

            $rootScope.miPosicion.latitud = latitud;
            $rootScope.miPosicion.longitud = longitud;

            $rootScope.modalMiPosicion.show();
        }

        function errorGeolocation(error) {

            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_get_geoloc) });
            $log.error("Error geolocation", error);
        }
    };

    //----------------------------
    // COMPARTIR MI POSICION
    //----------------------------

    $rootScope.compartirMiPosicion = function () {

        var link = 'http://www.google.com/maps/place/' + $rootScope.miPosicion.latitud + ',' + $rootScope.miPosicion.longitud + '(' + $rootScope.nombreUsuario + ')';

        $cordovaSocialSharing
            .share(null, null, null, link) // Share via native share sheet
            .then(function(result) {

            }, function(err) {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_share_geoloc) });
                $log.error("Error compartiendo localizacion: ", err);
            });
    };

    //----------------------------
    // ENVIAR MI POSICION
    //----------------------------

    $rootScope.enviarMiPosicion = function() {

        var continuar = true;

        if ( typeof $rootScope.miPosicion.nombre === 'undefined' || $rootScope.miPosicion.nombre == '' ) {

            continuar = 'nombre';
        } else if ( typeof $rootScope.miPosicion.telefono === 'undefined' || $rootScope.miPosicion.telefono == '' ) {

            continuar = 'telefono';
        } else if ( typeof $rootScope.miPosicion.contrato === 'undefined' || $rootScope.miPosicion.contrato == '' ) {

            continuar = 'contrato';
        } else if ( typeof $rootScope.miPosicion.matricula === 'undefined' || $rootScope.miPosicion.matricula == '' ) {

            continuar = 'matricula';
        }

        if ( continuar == true ) {

            $ionicLoading.show({

                template: '<div class="cargando"><i style="font-weight: bold; padding-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.enviando) + '</i><br><ion-spinner icon="lines" class="spinner-positive"></ion-spinner></div>'
            });

            var envioMiPosicion = {

                handle: "goldcarapp-miposicion",
                lang: $rootScope.language,
                latitud: $rootScope.miPosicion.latitud,
                longitud: $rootScope.miPosicion.longitud,
                nombre: $rootScope.miPosicion.nombre,
                telefono: $rootScope.miPosicion.telefono,
                num_contrato: $rootScope.miPosicion.contrato,
                num_matricula: $rootScope.miPosicion.matricula,
                comentarios: $rootScope.miPosicion.comentarios,
                maps: "https://www.google.com/maps/@" + $rootScope.miPosicion.latitud + "," + $rootScope.miPosicion.longitud + ",21z"
            };

            JsonService.postMail(envioMiPosicion).then(function (result) {

                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.alertas.exito),
                    template: $filter("translate")($rootScope.translations.alertas.respuesta_asistencia)
                });
                $rootScope.modalMiPosicion.hide();
            }, function (error) {

                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.alertas.error_conexion)
                });
                $log.error(error);
            })
        } else {

            var mensaje = "";

            if ( continuar == 'nombre' ) {

                mensaje = $filter("translate")($rootScope.translations.datos.falta_nombre);
            } else if ( continuar == 'telefono' ) {

                mensaje = $filter("translate")($rootScope.translations.datos.falta_telefono);
            } else if ( continuar = 'contrato' ) {

                mensaje = $filter("translate")($rootScope.translations.alertas.falta_contrato);
            } else if ( continuar = 'matricula' ) {

                mensaje = $filter("translate")($rootScope.translations.alertas.falta_matricula);
            }

            $ionicPopup.alert({

                title: $filter("translate")($rootScope.translations.general.error),
                template: mensaje
            })
        }
    };

    //----------------------------
    // ABRIR EN MAPA MI POSICION
    //----------------------------

    $rootScope.abrirMiPosicion = function () {

        var destino = $rootScope.miPosicion.latitud + ',' + $rootScope.miPosicion.longitud;

        var opciones = {

            app: launchnavigator.APP.USER_SELECT,
            destinationName: $filter("translate")($rootScope.translations.localizaciiones.tu_posicion),
            start: destino,
            transportMode: launchnavigator.TRANSPORT_MODE.WALKING
        };

        launchnavigator.navigate(destino, successNavigate, errorNavigate, opciones);

        function successNavigate(result) {
            $log.debug("Navegación completada: ", result);
        }

        function errorNavigate(error) {
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_show_geoloc) });
            $log.error("Error navigate", error);
        }
    };

    //--------------------------
    // MODAL NO OLVIDES
    //--------------------------

    $rootScope.createModalNoOlvides = function(fn) {
        $rootScope.modalNoOlvidesCreado = true;
        $ionicModal.fromTemplateUrl('templates/no_olvides/no_olvides.html', {

            vista: "/" + $rootScope.language + "/remember",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalNoOlvides) {

            $rootScope.modalNoOlvides = modalNoOlvides;
            $rootScope.modalNoOlvidesIsClose = false;
            if(fn) fn();
        });
    };

    $rootScope.abrirNoOlvides = function() {

        if ( typeof $rootScope.modalNoOlvides === "undefined" || $rootScope.modalNoOlvidesIsClose == true ) {

            $rootScope.createModalNoOlvides(function () {
                $rootScope.modalNoOlvides.show();
            });
        } else {

            $rootScope.modalNoOlvides.show();
        }
    };

    $rootScope.cerrarNoOlvides = function(){

        $rootScope.modalNoOlvidesIsClose = true;
        $rootScope.modalNoOlvides.remove();
        $ionicBackdrop.release();
        $rootScope.modalNoOlvidesCreado = false;
    };

    //--------------------------
    // MODAL LOCALIZACIONES
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/localizaciones/localizaciones.html', {

        vista: "/" + $rootScope.language + "/gps",
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modalLocalizaciones) {

        $rootScope.modalLocalizaciones = modalLocalizaciones;
    });

    //----------------------------
    // MODAL MI POSICION
    //----------------------------

    $rootScope.abrirModalMiPosicion = function () {

        // $rootScope.tieneReservasDisfrutando = true; // TESTEO SOLO, COMENTAR AL SUBIR

        if ( $rootScope.tieneReservasDisfrutando == true ) {

            if ( typeof $rootScope.modalMiPosicion === "undefined" ) {

                $ionicModal.fromTemplateUrl('templates/asistencia_carretera/mi_posicion.html', {

                    vista: "Mi Posicion",
                    scope: $rootScope,
                    animation: 'slide-in-up'
                }).then(function(modalMiPosicion) {

                    $rootScope.modalMiPosicion = modalMiPosicion;
                    $rootScope.getMiPosicion();
                });
            } else {

                $rootScope.getMiPosicion();
            }
        } else {

            $ionicPopup.alert({ title: "Atención", template: $filter("translate")($rootScope.translations.alertas.debes_reservar)});
        }
    };

    //----------------------------
    // MODAL DETALLES RESERVA
    //----------------------------

    $rootScope.abrirModalDetalles = function () {

        $ionicModal.fromTemplateUrl('templates/detalles_reserva/detalles_reserva.html', {

            vista: "Detalles Reserva",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalDetallesRes) {

            $rootScope.modalDetallesRes = modalDetallesRes;
            modalDetallesRes.show();
        });
    };

    //-----------------------------
    // MODAL CONDICIONES ALQUILER
    //-----------------------------

    $ionicModal.fromTemplateUrl('templates/detalles_reserva/condiciones_alquiler.html', {

        vista: "/" + $rootScope.language + "/mygoldcar/tyc",
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modalCondicAlquiler) {

        $rootScope.modalCondicAlquiler = modalCondicAlquiler;
    });

    //-----------------------------
    // MODAL NUEVO USUARIO
    //-----------------------------

    $rootScope.crearModalNuevoUsuario = function () {
        $ionicModal.fromTemplateUrl('templates/login/nuevo_user.html', {
            vista: "/" + $rootScope.language + "/club/signup",
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modalNuevoUsuario) {
            $rootScope.modalNuevoUsuario = modalNuevoUsuario;
            $rootScope.usuarioNuevo = {
                "nombre": "",
                "apellidos": "",
                "mail": "",
                "password": ""
            };
            $rootScope.registro_gdpr = {
                // privacidad_accepted_club: false,
                publi_accepted_club: false,
                club_accepted_club: false,
                perfil_accepted_club: false
            }
            modalNuevoUsuario.show();
        });
    };

    function modificacionGdpr(){
        var defered = $q.defer();  
        var promise = defered.promise;

        $ionicLoading.show();
        
        GoldcarService.setCheckOptionsClub($rootScope.registro_gdpr).then(function(result){
            console.log(result);
            defered.resolve(true);
        })
        .catch(function(err){
            console.log(err);
            defered.reject(err);
        });       
        $ionicLoading.hide();
        
        return promise;
    }

    $rootScope.registro = function () {
        $ionicLoading.show();
        if ( typeof $rootScope.usuarioNuevo.nombre === 'undefined' || $rootScope.usuarioNuevo.nombre === '' ) {
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.falta_nombre) });
        } else if ( typeof $rootScope.usuarioNuevo.apellidos === 'undefined' || $rootScope.usuarioNuevo.apellidos === '' ) {
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.falta_apellidos) });
        } else if ( $rootScope.usuarioNuevo.mail === '' ) {
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.falta_correo) });
        } else if ( typeof $rootScope.usuarioNuevo.mail === 'undefined' || !/^([a-z0-9_\.-]+)@([\da-z\.-]+)\.([a-z\.]{2,6})$/.test($rootScope.usuarioNuevo.mail)) {
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.erroneo_correo) });
        } else if ( typeof $rootScope.usuarioNuevo.password === 'undefined' || $rootScope.usuarioNuevo.password === '' ) {
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.falta_password) });
        } else if(!/^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])[0-9a-zA-Z@_.!%$()-]{8,}$/.test($rootScope.usuarioNuevo.password)){
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.minimo_password) });
        } else if ( !$rootScope.registro_gdpr.club_accepted_club ) {
            $ionicLoading.hide();
            $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.alertas_nuevas.confirmar_politica) });
        } else {
            if ( typeof $rootScope.usuarioNuevo.origen === 'undefined' || $rootScope.usuarioNuevo.origen == '' ) $rootScope.usuarioNuevo.origen = '';
            $rootScope.usuarioNuevo.idioma = $rootScope.language;
            $rootScope.usuarioNuevo.tipo = 'club';
            $rootScope.usuarioNuevo.checks = [
            {
                'codigo': 'club_accepted',
                'estado': $rootScope.registro_gdpr.club_accepted_club
            },
            {
                'codigo': 'publi_accepted',
                'estado': $rootScope.registro_gdpr.publi_accepted_club
            },
            {
                'codigo': 'perfil_accepted',
                'estado': $rootScope.registro_gdpr.perfil_accepted_club   
            }];
            GoldcarService.postUsuario($rootScope.usuarioNuevo).then(function (result) {
                if ( result.data.status === true ) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.registro.registrado_titulo), "template": $filter("translate")($rootScope.translations.registro.registrado_texto) }).then(function () {
                        $rootScope.modalNuevoUsuario.remove();
                    });
                } else {
                    $ionicLoading.hide();
                    if(result.data.errCod == 'pass-no-correct') $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.minimo_password) });
                    else if(result.data.errCod == 'email_existente') $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.existe_correo) });
                    else if(result.data.errCod == 'email_no_valido') $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.correo_no_valido) });
                    else $ionicPopup.alert({ "title": $filter("translate")($rootScope.translations.alertas.titulo_atencion), "template": $filter("translate")($rootScope.translations.registro.error_registro) });
                }
            })
        }
    };

    $rootScope.comprobarCheck = function(type)
    {
        setTimeout(function()
        {
            if(typeof type !== 'undefined' && type == 'publi') var status = $rootScope.registro_gdpr.publi_accepted_club;
            else if(typeof type !== 'undefined' && type == 'club') var status = $rootScope.registro_gdpr.club_accepted_club;
            else if(typeof type !== 'undefined' && type == 'perfil') var status = $rootScope.registro_gdpr.perfil_accepted_club;
            GoldcarService.setGdprTerms(type, status).then(function(result)
            {
                console.log(result);
            })
            .catch(function(err)
            {
                console.log(err);
            });
        }, 500);
    };

    //----------------------------------
    // CREAR MODAL DE LISTA FACTURAS
    //----------------------------------

    $rootScope.createListaFacturas = function() {
        $ionicModal.fromTemplateUrl('templates/ayuda/listaFacturas.html', {

            vista: "Lista Facturas",
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modalListaFacturas) {

            $rootScope.modalListaFacturas = modalListaFacturas;
            $rootScope.modalListaFacturas.show();
        });
    };

    //----------------------------
    // MODAL ASISTENCIA CARRETERA
    //----------------------------

    $ionicModal.fromTemplateUrl('templates/asistencia_carretera/asistencia_carretera.html', {

        vista: "/" + $rootScope.language + "/help/assistance",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalAsistencia) {

        $ionicLoading.show();

        JsonService.getContentJSON('goldcarapp-asistencia').then(function (data){

                for ( var i = 0; i < data.oficinas.length; i++ ) {

                    if ( typeof data.oficinas[i].phone === 'object' ) {

                        data.oficinas[i].variosTelefonos = true;
                    } else {

                        data.oficinas[i].variosTelefonos = false;
                    }
                }
                $rootScope.telefonosAsistencia = data.oficinas;
                $rootScope.modalAsistencia = modalAsistencia;
                $ionicLoading.hide();
            },
            function(error){
                $log.debug("Error: " + error);
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.alertas.error_conexion)
                });
            }
        );
    });

    //-----------------------------
    // MODAL AVISO LEGAL
    //-----------------------------

    $ionicModal.fromTemplateUrl('templates/aviso_legal/aviso_legal.html', {

        vista: "/" + $rootScope.language + "/legal",
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modalAvisoLegal) {

        $rootScope.modalAvisoLegal = modalAvisoLegal;
    });

    $rootScope.getAvisoLegal = function () {

        $ionicLoading.show();

        $rootScope.aviso_legal = [];

        JsonService.getContentData('goldcarapp-legal').then(function (result) {

            $rootScope.aviso_legal.texto = result.content.text;
            $rootScope.aviso_legal.titulo = (result.content.title).toUpperCase();
            $ionicLoading.hide();
        }, function(error) {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $rootScope.modalAvisoLegal.hide();
            $log.debug("Error conexión getAvisoLegal: ", error);
        })
    };

    //-----------------------------
    // MODAL SOBRE GOLDCAR
    //-----------------------------

    $ionicModal.fromTemplateUrl('templates/sobre_goldcar/sobre_goldcar.html', {

        vista: "/" + $rootScope.language + "/about",
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modalSobreGoldcar) {

        $rootScope.modalSobreGoldcar = modalSobreGoldcar;
    });

    $rootScope.getSobreGoldcar = function () {

        $ionicLoading.show();

        $rootScope.sobre_goldcar = [];

        JsonService.getContentData('goldcarapp-info').then(function (result) {

            $rootScope.sobre_goldcar.texto = result.content.text;
            $rootScope.sobre_goldcar.titulo = (result.content.title).toUpperCase();
            $ionicLoading.hide();
        }, function(error) {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $rootScope.modalSobreGoldcar.hide();
            $log.debug("Error conexión gerSobreGoldcar: ", error);
        });

        JsonService.getPress().then(function (result) {

            $rootScope.notasPrensa = result.data.items;
        })
    };

    $rootScope.abrirNotasPrensa = function () {

        if ( localStorage['lang'] == 'es' ) {
            window.open('https://corporate.goldcar.es/sala-de-prensa/noticias/', '_system', 'shouldPauseOnSuspend=yes');
        } else {
            window.open('https://corporate.goldcar.es/en/press-room/news/', '_system', 'shouldPauseOnSuspend=yes');
        }
    };

    $rootScope.notaPrensaSeleccionada = null;

    $rootScope.abrirNotaPrensa = function (notaPrensa) {

        $rootScope.notaPrensaSeleccionada = notaPrensa;

        if ( typeof $rootScope.modalNotaPrensa === 'undefined' ) {

            $ionicModal.fromTemplateUrl('templates/sobre_goldcar/nota_prensa.html', {

                vista: "Nota de prensa",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalNotaPrensa) {

                $rootScope.modalNotaPrensa = modalNotaPrensa;
                modalNotaPrensa.show();
            });
        } else {

            $rootScope.modalNotaPrensa.show();
            setTimeout(function(){

                $ionicScrollDelegate.$getByHandle('modalContent').scrollTop();
            }, 500);
        }
    };

    //-----------------------------
    // MODAL POLITICA PRIVACIDAD
    //-----------------------------

    $scope.createModalPolitica = function () {

        $ionicModal.fromTemplateUrl('templates/politica_privacidad/politica_privacidad.html', {

            vista: "/" + $rootScope.language + "/privacy",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalPoliticaPrivacidad) {

            $rootScope.modalPoliticaPrivacidad = modalPoliticaPrivacidad;
            modalPoliticaPrivacidad.show();
        });
    };

    $rootScope.getPoliticaPrivacidad = function (event) {

        if(typeof event !== 'undefined' && event) event.stopPropagation();
        $ionicLoading.show();

        $rootScope.politica_privacidad = [];

        JsonService.getContentData('goldcarapp-privacidad').then(function (result) {

            $rootScope.politica_privacidad.texto = result.content.text;
            $rootScope.politica_privacidad.titulo = (result.content.title).toUpperCase();
            $ionicLoading.hide();

            $scope.createModalPolitica();
        }, function(error) {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $rootScope.modalPoliticaPrivacidad.hide();
            $log.debug("Error de conexión getPoliticaPrivacidad: ", error);
        })
    };

    //-------------------------------------
    // MOSTRAR GUIA DE ACTUACION ACCIDENTE
    //-------------------------------------

    $scope.getDatosGuiaActuacion = function () {

        JsonService.getContentData('goldcarapp-actuacion').then(function (result) {
            $rootScope.guiaActuacion = [];

            $rootScope.guiaActuacion.title = result.content.title;
            $rootScope.guiaActuacion.text = $sce.trustAsHtml(result.content.text);
            $ionicLoading.hide();
        }, function (error) {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $log.error("Error en getDatosGuiaActuacion: ", error);
        })
    };

    $rootScope.mostrarGuiaActuacion = function () {

        $ionicLoading.show();

        if ( typeof $rootScope.modalGuiaActuacion === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/accidente/guia_actuacion.html', {

                vista: "Guia Actuacion",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function (modalGuiaActuacion) {

                $scope.getDatosGuiaActuacion();
                $rootScope.modalGuiaActuacion = modalGuiaActuacion;
                modalGuiaActuacion.show();
            });
        } else {

            $scope.getDatosGuiaActuacion();
            $rootScope.modalGuiaActuacion.show();
        }
    };

    //----------------------------------
    // CREAR SOLICITAR FACTURA
    //----------------------------------

    $rootScope.createSolicitarFacturas = function(fn) {
        $ionicModal.fromTemplateUrl('templates/ayuda/solicitarFactura.html', {

            vista: "/" + $rootScope.language + "/help/invoice",
            scope: $rootScope,
            animation: 'slide-in-right'
        }).then(function(modalSolicitarFactura) {
            $rootScope.modalSolicitarFactura = modalSolicitarFactura;
            if(fn) fn();
        });
    };

    $rootScope.abrirSolicitarFactura = function(){

        if ( typeof $rootScope.modalSolicitarFactura === "undefined" ) {

            $rootScope.createSolicitarFacturas(function () {
                $rootScope.modalSolicitarFactura.show();
            });
        } else {

            $rootScope.modalSolicitarFactura.show();
        }

    };

    //--------------------------
    // MODAL ACCIDENTE COMENZAR
    //--------------------------

    $rootScope.abrirModalAccidente = function () {

        // $rootScope.tieneReservasDisfrutando = true; // COMENTAR AL PUBLICAR, SOLO TEST

        if ( $rootScope.tieneReservasDisfrutando ) {

            $rootScope.comprobarReservaActual();

            if ( typeof $rootScope.modalAccidente == 'undefined' ) {

                $ionicModal.fromTemplateUrl('templates/accidente/accidente_0.html', {

                    vista: "Accidente Inicio",
                    scope: $rootScope,
                    animation: 'slide-in-up'
                }).then(function(modalAccidente) {

                    $rootScope.modalAccidente = modalAccidente;
                    modalAccidente.show();
                });
            } else {

                $rootScope.modalAccidente.show();
            }
        } else {

            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.atencion), template: $filter("translate")($rootScope.translations.alertas.debes_reservar)});
        }
    };

    //--------------------------
    // MODAL ACCIDENTE 1
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/accidente/accidente_1.html', {

        vista: "Accidente Paso 1",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalAccidente1) {

        $rootScope.modalAccidente1 = modalAccidente1;
    });

    //--------------------------
    // MODAL ACCIDENTE 2
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/accidente/accidente_2.html', {

        vista: "Accidente Paso 2",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalAccidente2) {

        $rootScope.modalAccidente2 = modalAccidente2;
    });

    //--------------------------
    // MODAL ACCIDENTE 3
    //--------------------------

    $rootScope.abrirModalAccidente3 = function () {

        if ( typeof $rootScope.modalAccidente3 === 'undefined' ) {

            $ionicModal.fromTemplateUrl('templates/accidente/accidente_3.html', {

                vista: "Accidente Paso 3",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalAccidente3) {

                $rootScope.modalAccidente3 = modalAccidente3;
                modalAccidente3.show();
            });
        } else {

            $rootScope.modalAccidente3.show();
        }
    };

    //--------------------------
    // MODAL ACCIDENTE 4
    //--------------------------

    $rootScope.abrirModalAccidente4 = function () {

        if ( typeof $rootScope.modalAccidente4 === 'undefined') {

            $ionicModal.fromTemplateUrl('templates/accidente/accidente_4.html', {

                vista: "Accidente Paso 4",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalAccidente4) {

                $rootScope.modalAccidente4 = modalAccidente4;
                modalAccidente4.show();
            });
        } else {

            $rootScope.modalAccidente4.show();
        }
    };

    //----------------------------------------------------------------
    // MODAL ACCIDENTE 4_1 ( Solo con mas de 1 vehiculo implicado )
    //----------------------------------------------------------------

    $rootScope.abrirModalAccidente4_1 = function () {

        if ( typeof $rootScope.modalAccidente4_1 === 'undefined') {

            $ionicModal.fromTemplateUrl('templates/accidente/accidente_4_1.html', {

                vista: "Accidente Paso 4.1",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalAccidente4_1) {

                $rootScope.modalAccidente4_1 = modalAccidente4_1;
                modalAccidente4_1.show();
            });
        } else {

            $rootScope.modalAccidente4_1.show();
        }
    };

    //--------------------------
    // MODAL ACCIDENTE 5
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/accidente/accidente_5.html', {

        vista: "Accidente Paso 5",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalAccidente5) {

        $rootScope.modalAccidente5 = modalAccidente5;
    });

    //--------------------------
    // MODAL ROBO COMENZAR
    //--------------------------

    $rootScope.abrirModalRobo = function () {

        if ( $rootScope.tieneReservasDisfrutando ) {

            if (typeof $rootScope.modalRobo == 'undefined') {

                $ionicModal.fromTemplateUrl('templates/robo/robo_0.html', {

                    vista: "Robo Inicio",
                    scope: $rootScope,
                    animation: 'slide-in-up'
                }).then(function (modalRobo) {

                    $rootScope.modalRobo = modalRobo;
                    modalRobo.show();
                });
            } else {

                $rootScope.modalRobo.show();
            }
        } else {

            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.atencion), template: $filter("translate")($rootScope.translations.alertas.debes_reservar)});
        }
    };

    //--------------------------
    // MODAL ROBO 1
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/robo/robo_1.html', {

        vista: "Robo Paso 1",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalRobo1) {

        $rootScope.modalRobo1 = modalRobo1;
    });

    //--------------------------
    // MODAL ROBO 2
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/robo/robo_2.html', {

        vista: "Robo Paso 2",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalRobo2) {

        $rootScope.modalRobo2 = modalRobo2;
    });

    //--------------------------
    // MODAL ROBO 3
    //--------------------------

    $ionicModal.fromTemplateUrl('templates/robo/robo_3.html', {

        vista: "Robo Paso 3",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalRobo3) {

        $rootScope.modalRobo3 = modalRobo3;
    });

    //--------------------------------
    // MODAL TERMINOS Y CONDICIONES
    //--------------------------------

    $rootScope.abrirTerminos = function () {
        $rootScope.seleccionados = false;
        $rootScope.terminos = [];
        $rootScope.terminos.titulo = ($filter("translate")($rootScope.translations.terminos_y_condiciones.titulo)).toUpperCase();

        $ionicModal.fromTemplateUrl('templates/terminos/terminos.html', {

            vista: "/" + $rootScope.language + "/tyc",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalTerminos) {

            $rootScope.modalTerminos = modalTerminos;
        });
    };

    $rootScope.limpiaTarifaId = function (tarifaId) {
        if(tarifaId == 'PackClickngo') return 'FullFuel';
        else return tarifaId.replace(/^TNR/,"").replace(/SDR$/,"").replace(/SDC$/,"");
    };

    $rootScope.getOficinasTerminos = function() {
        $rootScope.oficinasTerminos = [];

        $ionicLoading.show();

        GoldcarService.getOficinas().then(function (result) {

            for ( var i = 0; i != result.data.length; i++ ) {

                $rootScope.oficinasTerminos.push({nombre: result.data[i].Fullname, codigo: result.data[i].Codigo});
            }

            $ionicLoading.hide();
        }, function (error) {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $log.debug("Error de conexion getOficinasTerminos: ", error);
        })
    };

    $rootScope.getTerminos = function (oficina) {

        function makeExternalLinks(texto){

            var regex = /target="_blank"/g;
            var newString = texto.replace(regex,'');

            regex = /href="([\S]+)"/g;
            newString = newString.replace(regex, "href=\"#\" onClick=\"window.open('$1', '_system', 'location=yes,shouldPauseOnSuspend=yes')\"");

            return newString;
        }

        $ionicLoading.show();

        GoldcarService.getTerminosSinReserva(oficina).then(function (result) {

            $rootScope.terminos.texto = makeExternalLinks(result.data.texto);
            $rootScope.seleccionados = true;
            $ionicLoading.hide();
        }, function (error) {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $log.debug("Error de conexion getTerminosSinReserva: ", error);
        })
    };

    $rootScope.solucionBugSelectTerminos = function() {   // Solucion bug desplegable (SELECT)

        setTimeout(function() {

            var y = document.getElementsByClassName('selectorModalOficinas');

            for ( var i = 0; i != y.length; i++ ) {

                document.getElementById('contenidoTerminos').appendChild(y[i]);
            }

        }, 500);
    };

    //----------------------------
    // MODAL TRANSFER
    //----------------------------

    $rootScope.createModalTransfer = function() {
        $ionicModal.fromTemplateUrl('templates/transfer/transfer.html', {

            vista: "Transfer",
            id: 'modalTransfer',
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalTransfer) {
            $rootScope.modalTransfer = modalTransfer;
            $rootScope.modalTransfer.show();
        });
    };

    $rootScope.openModalTransfer = function(office, officeCode) {
        if(typeof office.busData !== 'undefined' && office.busData !== null) {
            $rootScope.modalTransferOfficeCode = officeCode;
            $rootScope.createModalTransfer();
        }
    };

    //----------------------------
    // MODAL COMO LLEGAR
    //----------------------------

    $rootScope.createModalComoLlegar = function(fn) {
        $ionicModal.fromTemplateUrl('templates/como_llegar/como_llegar.html', {

            vista: "Como Llegar",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalComoLlegar) {

            $rootScope.modalComoLlegar = modalComoLlegar;
            if(fn) fn();
        });
    };

    $rootScope.abrirComoLlegar = function (oficina , status) {

        $ionicLoading.show();

        GoldcarService.getDetallesOficina(oficina).then(function (result) {
            $rootScope.oficina = result.data;
            
            $rootScope.createModalComoLlegar(function () {
                if(status == "Extended")
                    $rootScope.estiloComoLlegar = {"width": "100%", "height": "100%", "top": "0", "left": "0"};
                else
                    $rootScope.estiloComoLlegar = {};
    
                $rootScope.modalComoLlegar.show();
            });

            $ionicLoading.hide();
        });

    };

    //-----------------------------
    // MODAL FAQs
    //-----------------------------

    $ionicModal.fromTemplateUrl('templates/faqs/faqs.html', {

        vista: "/" + $rootScope.language + "/faqs",
        scope: $rootScope,
        animation: 'slide-in-right'
    }).then(function(modalAllFaqs) {

        $rootScope.modalAllFaqs = modalAllFaqs;
    });

    $rootScope.getCategoriasFaq = function() {

        $ionicLoading.show({
            template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 15px;">' + $filter("translate")($rootScope.translations.loading.loading_faqs) + '</i><br><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
        });

        $rootScope.categoriasReserva = [];
        $rootScope.categoriasDisfrutando = [];
        $rootScope.categoriasHistorico = [];
        $rootScope.categorias = undefined;

        if ( typeof $rootScope.categorias === "undefined" ) {

            JsonService.getFAQ().then(function (items) {

                if ( $rootScope.esProximaReserva == true ) {

                    for ( var i = 0; i != items.length; i++ ) {

                        if ( items[i].id_faqsection == 13 || items[i].id_faqsection == 19 ){

                            $rootScope.categoriasReserva.push(items[i]);
                        }
                    }
                    $rootScope.categorias = $scope.categoriasReserva;
                } else if ( $rootScope.esDisfrutandoVehiculo == true ) {

                    for ( var i = 0; i != items.length; i++ ) {

                        if ( items[i].id_faqsection == 16 || items[i].id_faqsection == 20 || items[i].id_faqsection == 28 ) {

                            $rootScope.categoriasDisfrutando.push(items[i]);
                        }
                    }
                    $rootScope.categorias = $scope.categoriasDisfrutando;
                } else if ( $rootScope.esHistorico == true ) {

                    for ( var i = 0; i != items.length; i++ ) {

                        if ( items[i].id_faqsection == 20 ) {

                            $rootScope.categoriasHistorico.push(items[i]);
                        }
                    }
                    $rootScope.categorias = $scope.categoriasHistorico;
                } else {

                    $rootScope.categorias = items;
                }

                $ionicLoading.hide();

            }, function (error) {

                $ionicLoading.hide();
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                $log.debug("Error de conexión getFAQs: ", error);
            });
        }
    };

    $rootScope.crearModalFAQs = function() {

        console.log("FAQS HOME");

        if ( typeof $rootScope.modalFAQS === "undefined" ) {
            $ionicModal.fromTemplateUrl('templates/faqs/modal_faqs.html', {

                vista: "/" + $rootScope.language + "/mygoldcar/faqs",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalFAQS) {

                $rootScope.modalFAQS = modalFAQS;
                modalFAQS.show();
            });
        } else {

            $rootScope.modalFAQS.show();
        }
    };

    $rootScope.resetFAQS = function() {
        $rootScope.esProximaReserva = false;
        $rootScope.esDisfrutandoVehiculo = false;
        $rootScope.esHistorico = false;
    };

    $rootScope.openFaqsReserva = function() {

        $rootScope.resetFAQS();
        $rootScope.esProximaReserva = true;
        $rootScope.crearModalFAQs();
    };

    $rootScope.openFaqsDisfrutando = function() {

        $rootScope.resetFAQS();
        $rootScope.esDisfrutandoVehiculo = true;
        $rootScope.crearModalFAQs();
    };

    $rootScope.openFaqsHistorico = function() {

        $rootScope.resetFAQS();
        $rootScope.esHistorico = true;
        $rootScope.crearModalFAQs();
    };

    //--------------------------
    // MODAL OTROS TELEFONOS
    //--------------------------

    $rootScope.createOtroTelefono = function(){
        $ionicModal.fromTemplateUrl('templates/otros_telefonos/otros_telefonos.html', {

            vista: "/" + $rootScope.language + "/help/phones",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalTelefonos) {

            $rootScope.modalTelefonos = modalTelefonos;
            modalTelefonos.show();
        });
    };

    $rootScope.abrirOtrosTelefonos = function(colorHeader, colorTexto){
        if ( !colorTexto ){
            colorTexto = colorHeader;
        }
        $rootScope.colorOtrosTelefonosTexto = {"color": colorTexto, "float": "right", "margin-top": "-19px"};
        $rootScope.colorOtrosTelefonosFondo = {"background-image" : "none","-webkit-box-shadow": "0px -1px 20px 0px rgba(50, 50, 50, 0.80)", "-moz-box-shadow": "0px -1px 20px 0px rgba(50, 50, 50, 0.80)", "box-shadow": "0px -1px 20px 0px rgba(50, 50, 50, 0.80)", "background-color": colorHeader};

        $rootScope.createOtroTelefono();

    };

    $rootScope.cerrarOtrosTelefonos = function(){

        $rootScope.modalTelefonos.remove();
    };

    //--------------------------
    // MODAL LOGIN USUARIO
    //--------------------------

    $rootScope.mostrarModalLogin = function(tipo) {

        $rootScope.nextScreen = tipo ? tipo : 'home';

        if ( typeof $rootScope.modalLogin === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/login/login.html', {

                vista: "Login",
                id: "login",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalLogin) {

                $rootScope.modalLogin = modalLogin;
                $rootScope.modalLogin.show();
            });
        } else {

            $rootScope.modalLogin.show();
        }
    };

    $rootScope.closeLogin = function () {

        $rootScope.modalLogin.remove();
        $rootScope.modalLogin = undefined;
    };

    //--------------------------
    // RECORDAR PASSWORD
    //--------------------------

    $rootScope.abrirRecordarPasswd = function () {

        if ( typeof $rootScope.modalRecordarPasswd === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/login/recordar_passwd.html', {

                vista: "/" + $rootScope.language + "/login/password",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function (modalRecordarPasswd) {

                $rootScope.modalRecordarPasswd = modalRecordarPasswd;
                modalRecordarPasswd.show();
            })
        } else {

            $rootScope.modalRecordarPasswd.show();
        }
    };

    $rootScope.recuperarPasswd = [];

    $rootScope.recordarPasswd = function (correo) {

        if(typeof correo === "undefined" || correo == "")
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.faltan_datos), template: $filter("translate")($rootScope.translations.alertas.error_no_email) });

        else{
            GoldcarService.postRecuperarPasswd(correo).then(function (result) {

                if ( result.data.status == true ) {

                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.enviado), template: $filter("translate")($rootScope.translations.alertas.reset_pass_ok) });
                    $rootScope.recuperarPasswd.correo = "";
                    $rootScope.modalRecordarPasswd.hide();
                } else {

                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_correo) });
                    $rootScope.modalRecordarPasswd.hide();
                }
            }, function (error) {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                $log.error(error);
            });
        }
    };

    //--------------------------------------
    // LOGIN CLUB GOLDCAR
    //--------------------------------------

    $rootScope.hacerLogin = function (user, passwd) {
        if(typeof user !== 'undefined' && typeof passwd !== 'undefined'){
            $ionicLoading.show({
                template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.entrando) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
            });

            GoldcarService.login(user, passwd).then(function (result) {
                if(typeof result.data.error === 'undefined' || !result.data.error)
                {
                    localStorage['user'] = user;
                    localStorage['passwd'] = passwd;
                    localStorage['nombreUsuario'] = $rootScope.nombreUsuario = result.data.Nombre;
                    localStorage['apellidosUsuario'] = $rootScope.apellidosUsuario = result.data.Apellidos;
                    localStorage['puntosClub'] = $rootScope.puntosClub = result.data.Puntosclub;
                    if ( result.data.Picture ) {
                        localStorage['imagenPerfil'] = $rootScope.imagenPerfil = result.data.Picture;
                    } else {
                        localStorage['imagenPerfil'] = $rootScope.imagenPerfil = "img/default.png";
                    }
                    localStorage['isLogged'] = $rootScope.isLogged = true;
                    $rootScope.datosUsuario = result.data;
        
                    // fnCheckLogged();
        
                    Session.set({
        
                        "Lang": localStorage['lang'],
                        "nombre": $rootScope.datosUsuario.Nombre,
                        "apellidos": $rootScope.datosUsuario.Apellidos,
                        "user": $rootScope.datosUsuario.user,
                        "authenticated": $rootScope.datosUsuario.Authenticated
                    }).then(function (result) {
        
                    });
        
                    console.log(result.data);
        
                    if( typeof result.data.Cover !== 'undefined' ) {
        
                        localStorage['imagenCover'] = $rootScope.profileCoverImage = result.data.Cover;
                    } else {
        
                        if ( typeof result.data.Picture !== 'undefined' ) {
        
                            localStorage['imagenCover'] = $rootScope.profileCoverImage = result.data.Picture;
                        } else {
        
                            localStorage['imagenCover'] = $rootScope.profileCoverImage = "img/default.png";
                        }
                    }
        
                    // RELLENAR FICHA CLIENTE
                    $rootScope.cliente = result.data;
        
                    if ($state.current.name == 'menu.loginClub') {
                        
                        $ionicScrollDelegate.$getByHandle('login-goldcar-content').scrollTop(true);
                        setTimeout(function(){
                            $ionicScrollDelegate.$getByHandle('login-goldcar-content').resize();
                        }, 500);
                    }
                    else if ($rootScope.nextScreen == 'home'){
        
                        $state.go('menu.home');
                        $rootScope.mostrarValoracionAPP();
                    }
                    else if ( $rootScope.nextScreen == 'goldcarClub' ) {
        
                        $state.goTo('menu.loginClub');
                        $rootScope.mostrarValoracionAPP();
                    }
                    else if ($rootScope.nextScreen == 'disponibilidad'){
                        $state.reload();
                    }
                    else if ($state.current.name == 'menu.reservarDisponibilidad') {
                        $rootScope.recogerDatosLogin(result.data);
                        $rootScope.obtenerTarjetas();
                        $timeout(function () {
                            $('.formulario-final').css({'top': '0%'});
                        }, 200);
                    }
                    else{
                        // if ( $rootScope.nextScreen == 'reserva'){
                        //     $rootScope.recogerDatosLogin(result.data);
                        // }
                        $rootScope.mostrarValoracionAPP();
                        if ( $rootScope.nextScreen == 'extras'){
                            $rootScope.recogerDatosLoginExtra(result.data);
                            $rootScope.getPromos();
                            $rootScope.getPremios();
                        }
                    }
        
    
                    $rootScope.cerrarAlerta();
                    if(typeof $rootScope.modalLogin !== 'undefined') $rootScope.closeLogin();
                    $ionicLoading.hide();
                }
                else
                {
                    $ionicLoading.hide();
                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.error_autenticacion), template: $filter("translate")($rootScope.translations.alertas.error_autenticacion_texto)});
                }
            }, function() {
    
                $ionicLoading.hide();
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.error_autenticacion), template: $filter("translate")($rootScope.translations.alertas.error_autenticacion_texto)});
            });
        }
        else {
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.error_autenticacion), template: $filter("translate")($rootScope.translations.alertas.user_pass_vacio)});
        }
    };

    //--------------------------------------
    // LOGOUT
    //--------------------------------------

    $rootScope.hacerLogout = function () {
        localStorage.removeItem('user');
        localStorage.removeItem('passwd');
        localStorage.removeItem('redSocial');

        $ionicScrollDelegate.$getByHandle('menu-lateral').scrollTop(true);

        $rootScope.mostrarParaTesteo = false;

        localStorage['nombreUsuario'] = $rootScope.nombreUsuario = $filter("translate")($rootScope.translations.general.usuario_anonimo);
        localStorage['apellidosUsuario'] = $rootScope.apellidosUsuario = "";
        localStorage['puntosClub'] = $rootScope.puntosClub = "0";
        localStorage['imagenPerfil'] = $rootScope.imagenPerfil = "img/usuario.svg";
        localStorage['isLogged'] = $rootScope.isLogged = false;
        $rootScope.datosUsuario = [];

        console.log("Session.set de hacerLogout -> global.js");
        Session.set({
            "Lang": $rootScope.language,
            "nombre": "",
            "apellidos": "",
            "user": "",
            "authenticated": false
        }).then(function(res) {
            
            console.log(res);
        });

        $state.go('menu.home');
    };

    //----------------------------
    // ENCUESTA SATISFACCION
    //----------------------------

    // $rootScope.crearModalEncuesta = function () {

    //     if ( typeof $rootScope.modalEncuesta === "undefined" ) {

    //         $ionicModal.fromTemplateUrl('templates/encuesta_satisfaccion/encuesta.html', {

    //             vista: "Encuesta de satisfaccion",
    //             scope: $rootScope,
    //             animation: 'slide-in-up'
    //         }).then(function (modalEncuesta) {

    //             $rootScope.modalEncuesta = modalEncuesta;
    //             modalEncuesta.show();
    //         })
    //     } else {

    //         $rootScope.modalEncuesta.show();
    //     }
    // };

    // $rootScope.valoracionSeleccionada = 1;

    // $rootScope.estrellas = [
    //     {
    //         valor: 1,
    //         color: '#E7E489'
    //     },
    //     {
    //         valor: 2,
    //         color: 'rgba(0,0,0,0.5)'
    //     },
    //     {
    //         valor: 3,
    //         color: 'rgba(0,0,0,0.5)'
    //     },
    //     {
    //         valor: 4,
    //         color: 'rgba(0,0,0,0.5)'
    //     },
    //     {
    //         valor: 5,
    //         color: 'rgba(0,0,0,0.5)'
    //     }
    // ];

    // $rootScope.valorarReserva = function (posicion) {

    //     $rootScope.valoracionSeleccionada = $rootScope.estrellas[posicion].valor;
    //     console.log("$rootScope.valoracionSeleccionada", $rootScope.valoracionSeleccionada);

    //     for ( var i = 0; i <= posicion; i++ ) {

    //         $rootScope.estrellas[i].color = '#E7E489';
    //     }

    //     for ( var j = posicion + 1; j <= $rootScope.estrellas.length; j++ ) {

    //         if(typeof $rootScope.estrellas[j] !== 'undefined') $rootScope.estrellas[j].color = 'rgba(0,0,0,0.5)';
    //     }
    // };

    $rootScope.tieneReservasDisfrutando = false;

    $rootScope.bookingSession = function(bookingPickupDay, bookingPickupTime) {

        console.log("bookingPickupDay", bookingPickupDay);
        console.log("bookingPickupTime", bookingPickupTime);

        var now = moment();
        var bookingDate = moment(bookingPickupDay + " " + bookingPickupTime, 'YYYY-MM-DD HH:mm');

        // console.log("Now", now);
        // console.log("BookingDate", bookingDate);

        var isBefore = now.isBefore(bookingDate);

        // console.log("IS BEFORE", isBefore);

        return isBefore;
    }
    
    $scope.$on('$locationChangeSuccess', function($event, next, current) { 
        if($rootScope.ticketCogido) $('ion-content').addClass('content-with-ticket');
        else $('ion-content').removeClass('content-with-ticket');
    });

    $rootScope.cleanSpecialCharacters = function(cadena){
        // Definimos los caracteres que queremos eliminar
        var specialChars = "!@#$^&%*()+=-[]\/{}|:<>?,.";
        
        // Los eliminamos todos
        for (var i = 0; i < specialChars.length; i++) {
            cadena= cadena.replace(new RegExp("\\" + specialChars[i], 'gi'), '');
        }   
        
        // Lo queremos devolver limpio en minusculas
        cadena = cadena.toLowerCase();
        
        // Quitamos espacios y los sustituimos por _ porque nos gusta mas asi
        cadena = cadena.replace(/ /g,"_");
        
        // Quitamos acentos y "ñ". Fijate en que va sin comillas el primer parametro
        cadena = cadena.replace(/á/gi,"a");
        cadena = cadena.replace(/é/gi,"e");
        cadena = cadena.replace(/í/gi,"i");
        cadena = cadena.replace(/ó/gi,"o");
        cadena = cadena.replace(/ú/gi,"u");
        cadena = cadena.replace(/ñ/gi,"n");
        
        return cadena;
    }

    //-----------------------------//
    // EDITAR FUNCION BOTÓN VOLVER //
    //-----------------------------//

    $ionicPlatform.registerBackButtonAction(function(event){
        console.log("event", event);
        console.log("state", $state);
        
        if($state.current.name == "menu.reservarDisponibilidad") $rootScope.volverDisponibilidad();
        else if($state.current.name !== 'menu.home') window.history.back(); 
        else if($state.current.name == 'menu.home') navigator.app.exitApp();
    }, 100);

    // MOSTRAR MODAL INFO WEB GOLDCAR GDPR //
    var modalGdpr;
    var modalInfoGdprWeb;

    $rootScope.verInfoGdpr = function(){
        $ionicModal.fromTemplateUrl('templates/reservar/modal-info-gdpr.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            modalGdpr = modal;
            modalGdpr.show();
        });
    }

    $rootScope.cerrarInfoGdpr = function(){
        modalGdpr.remove();
        modalGdpr = undefined;
    }

    $rootScope.abrirInfoGdprWeb = function(){
        $ionicModal.fromTemplateUrl('templates/reservar/modal-info-gdpr-web.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $rootScope.urlGdprWeb = $sce.trustAsResourceUrl('https://www.goldcar.es/' + $rootScope.language + '/politica-privacidad/#rights');
            modalInfoGdprWeb = modal;
            modalInfoGdprWeb.show();
        });
    }

    $rootScope.cerrarInfoGdprWeb = function(){
        modalInfoGdprWeb.remove();
        modalInfoGdprWeb = undefined;
    }

    $rootScope.abrirNavegadorPopup = function (url) {
        cordova.InAppBrowser.open(url, '_blank', 'location=yes');
    }

    //--------------------//
    // FIREBASE ANALYTICS //
    //--------------------//

    // {
    //     "items": [
    //         {
    //             "ITEM_ID": "sku8282",
    //             "ITEM_NAME": "car",
    //             "ITEM_CATEGORY": "ve-ALC-ES-económicos-AA",
    //             "ITEM_VARIANT": "tarifa-smart",
    //             "ITEM_BRAND": "skoda",
    //             "PRICE": "29.99",
    //             "CURRENCY": "EUR",
    //             "QUANTITY": "1"
    //         }
    //     ],
    //     "TRANSACTION_ID": "T2324452",
    //     "AFFILIATION": "complete",
    //     "VALUE": "29.99",
    //     "TAX": "0.00",
    //     "SHIPPING": "0.00",
    //     "CURRENCY": "EUR",
    //     "COUPON": "verano2018"
    // }

    // $rootScope.firebaseAnalytics = function(reserva, sesion, otrosDatos){
    //     var analyticsData = {};

    //     console.log("RESERVA FIREBASE", reserva);
    //     console.log("SESION FIREBASE", sesion);

    //     if(typeof reserva !== 'undefined' && typeof sesion !== 'undefined' && typeof reserva.CategoriaCod !== 'undefined'){
    //         analyticsData = {
    //             "items": [{
    //                 "ITEM_ID": reserva.Grupo.Idgrupo,
    //                 "ITEM_NAME": "car",
    //                 "ITEM_CATEGORY": "ve-" + sesion.pickupplace + "-" + sesion.countryOffice + "-" + reserva.CategoriaCod + "-" + reserva.Grupo.Codigo,
    //                 // "ITEM_VARIANT": reserva.Fuelpolicy, // NO ES CORRECTO
    //                 "ITEM_BRAND": reserva.Grupo.Codigo,
    //                 "PRICE": reserva.Totaldiv,
    //                 "CURRENCY": reserva.divisa,
    //                 "QUANTITY": 1
    //             }],
    //             "TRANSACTION_ID": reserva.BonoAgencia,
    //             // "AFFILIATION": reserva.Prepagos,
    //             "VALUE": reserva.conversion_euros,
    //             "TAX": (reserva.conversion_euros*reserva.Iva)/100,
    //             "SHIPPING": "0.00",
    //             "CURRENCY": reserva.cod_divisa,
    //         }

    //         if(typeof sesion.promo_code !== 'undefined' && sesion.promo_code != null && sesion.promo_code != ''){
    //             analyticsData.items.COUPON = sesion.promo_code;
    //         }
    //         else{
    //             analyticsData.items.COUPON = 'nn';
    //         }

    //         if(typeof reserva.Prepagos !== 'undefined' && reserva.Prepagos){

    //         }

    //         if(typeof reserva.Extras !== 'undefined' && reserva.Extras.length > 0){
    //             for(var i = 0; i < reserva.Extras.length; i++){
    //                 analyticsData.items.push({
    //                     "ITEM_ID": reserva.Extras[i].Idextra,
    //                     "ITEM_NAME": "extra",
    //                     "ITEM_CATEGORY": reserva.Extras[i].Codigo,
    //                     // "ITEM_VARIANT": reserva.Fuelpolicy, // NO ES CORRECTO
    //                     "ITEM_BRAND": reserva.Grupo.Codigo,
    //                     "PRICE": reserva.Extras[i].TotalEuros,
    //                     "CURRENCY": reserva.divisa,
    //                     "QUANTITY": reserva.Extras[i].Cantidad
    //                 });
    //             }
    //         }
    //     }
    // }

    $rootScope.refreshMenu = function () {
        $timeout(function () {
            var bottomPositionHeaderMenu = $('.menuHeader').offset().top + $('.menuHeader').height();
            $('.content-menu-lateral').css({'top': bottomPositionHeaderMenu + 'px'});
        });
    }

    // $rootScope.calcularDispo = function(tarifa, extras = null, extrasObligatorios = null, paquetes = null, codigosPromo = null) {
    //     var precioFinal = 0;
    //     var precioExtras = 0;
    //     var precioExtrasO = 0;
    //     var precioPaquetes = 0;
    //     var descuentos = 0;
    //
    //     console.log(extras);
    //     console.log(extrasObligatorios);
    //     console.log(paquetes);
    //
    //     console.log(tarifa);
    //
    //     // CALCULAR EXTRAS
    //     if(extras !== null) {
    //         for(var i = 0; i < extras.length; i++) {
    //             precioExtras += parseFloat(extras[i].precio_total);
    //         }
    //     }
    //
    //     console.log(precioExtras);
    //
    //     // CALCULAR EXTRAS OBLIGATORIOS
    //     if(extrasObligatorios !== null) {
    //         for(var i = 0; i < extrasObligatorios.length; i++) {
    //             precioExtrasO += extrasObligatorios[i].alias === 'PremiumFeeOffice' ? parseFloat(extrasObligatorios[i].precio) : parseFloat(extrasObligatorios[i].precio_total);
    //         }
    //     }
    //
    //     console.log(precioExtrasO);
    //
    //     // CALCULAR PAQUETES
    //     if(paquetes !== null) {
    //         for(var i = 0; i < paquetes.length; i++) {
    //             precioPaquetes += parseFloat(paquetes[i].precio);
    //         }
    //     }
    //
    //     console.log(precioPaquetes);
    //
    //     if(precioPaquetes == 0) precioFinal = parseFloat(tarifa) + precioExtras + precioExtrasO;
    //     else precioFinal = precioPaquetes + precioExtras + precioExtrasO;
    //
    //     console.log(precioFinal);
    //     // return precioFinal;
    // }
});
