angular.module('goldcar').factory('Session', function ($q, $log, GoldcarService) {

    var session = {};

    var updateSession = function (dataSet) {
        for(var p in dataSet) {
            session[p] = dataSet[p];
        }
    };

    var set = function(dataSet) {
        var deferred = $q.defer();

        var doit = function (deferred, dataSet) {
            updateSession(dataSet);
            GoldcarService.postSesion(session).then(function (result) {
                updateSession(result.data);
                deferred.resolve(result.data);
            }, function(error) {
                $log.error("Error en postSession", error);
                deferred.reject(error);
            });
        };

        if(session == null) {
            $log.debug("La sesion está vacía, la traemos");
            this.get().then(function () {
                doit(deferred, dataSet);
            }, function(error) {
                deferred.reject(error);
            });
        } else {
            doit(deferred, dataSet);
        }

        return deferred.promise;
    };

    var get = function () {
        var deferred = $q.defer();

        GoldcarService.getSesion().then(function (result) {
            updateSession(result.data);
            deferred.resolve(result.data);
        }, function (error) {
            $log.error("Error en getSession", error);
            deferred.reject(error);
        });

        return deferred.promise;
    };

    return {
        set: function(dataSet) {
            return set(dataSet);
        },
        get: function() {
            return get();
        }
    };
});