angular.module('goldcar').controller('AccidenteCtrl', function ($filter, $log, $ionicModal, $scope, $rootScope, $ionicLoading, JsonService, $parse, $ionicPopup, $location, $anchorScroll, $cordovaDatePicker, $ionicScrollDelegate) {

//-------------------------------------
// SELECCIONA TIPO ACCIDENTE (PASO 1)
//-------------------------------------

    var minImplicados = 1;
    var maxImplicados = 5;

    $scope.inicializarVariablesAccidente = function () {

        $rootScope.vehiculoCliente = [];
        $rootScope.vehiculosAccidentadosRelleno = false;
        $rootScope.numAccidentadosMod = false;

        $rootScope.existeFotografia = false;
        $rootScope.imagenMatricula = "";
        $rootScope.vehiculosImplicados = minImplicados;
        $scope.multiples = false;
        $rootScope.zonasAccidente = [];
        $rootScope.daaAccidentados = [];
        $scope.zonasMaped = [];
    };

    $scope.irPaso2 = function (item) {

        $rootScope.tipoAccidente = item;

        if ( item == 'Atropello a un peatón o ciclista' ) {

            $rootScope.textoImplicados = 'Sólo mi vehículo';
            $rootScope.variosVehiculos = false;
            $rootScope.modalAccidente3.show();
        } else {

            $rootScope.modalAccidente2.show();
        }
    };

//---------------------------------
// SELECCIONA IMPLICADOS (PASO 2)
//---------------------------------

    $scope.menosImplicados = function () {

        if ($rootScope.vehiculosImplicados > minImplicados) {
            $rootScope.vehiculosImplicados--;
            $rootScope.numAccidentadosMod = true;
        }
    };

    $scope.masImplicados = function () {

        if ($rootScope.vehiculosImplicados < maxImplicados) {
            $rootScope.vehiculosImplicados++;
            $rootScope.numAccidentadosMod = true;
        }
    };

    $scope.resetNumVehiculos = function () {

        if ($scope.multiples == true)
            $scope.multiples = false;
        else
            $scope.multiples = true;
    };

    $scope.irPaso3 = function (txtImplic, numImplicados) {

        if ($scope.multiples == false && numImplicados != 0) {

            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
                template: $filter("translate")($rootScope.translations.alertas.aviso_vehiculos_implicados)
            });
        } else {

            if (numImplicados >= 1) {

                $rootScope.daaAccidentados = [];

                $rootScope.textoImplicados = txtImplic;
                $rootScope.vehiculosImplicados = numImplicados;
                for ( var i = 0; i < $rootScope.vehiculosImplicados; i++ ) {

                    $rootScope.daaAccidentados.push({
                        numVehiculo: i + 1,
                        fotosDaa: []
                    })
                }
                console.log($rootScope.daaAccidentados);
                $rootScope.variosVehiculos = true;
            } else {

                $rootScope.textoImplicados = txtImplic;
                $rootScope.variosVehiculos = false;
            }

            $rootScope.abrirModalAccidente3();
        }
    };

//---------------------------------
// FOTOGRAFIA MATRICULA (PASO 3)
//---------------------------------

    $scope.volverPaso2 = function () {

        $scope.resetNumVehiculos(false);
        $rootScope.modalAccidente3.remove();
        $rootScope.modalAccidente3 = undefined;
    };

    $scope.fotoMatricula = function () {

        $ionicLoading.show();

        navigator.camera.getPicture(onSuccess, onFail, {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL
        });

        function onSuccess(imageData) {

            $rootScope.existeFotografia = true;
            $rootScope.imagenMatricula = "data:image/jpeg;base64," + imageData;
            $ionicLoading.hide();
        }

        function onFail(error) {

            $log.debug("Error en la imagen de la matricula: ", error);
            $ionicLoading.hide();
        }
    };

    $rootScope.borrarMatricula = function () {

        $rootScope.existeFotografia = false;
        $rootScope.imagenMatricula = "";
        $rootScope.modalDetallesImagenAccidente.hide();
    };

    $scope.irPaso4 = function () {

        if ($rootScope.vehiculosAccidentadosRelleno !== false) {

            for (var i = $rootScope.vehiculosImplicados; i < $rootScope.vehiculosAccidentadosRelleno; i++) {
                delete $rootScope.accidentados['vehiculo' + i];
            }
            for (var i = $rootScope.vehiculosAccidentadosRelleno; i < $rootScope.vehiculosImplicados; i++) {
                $rootScope.accidentados['vehiculo' + i] = [];
            }
            $rootScope.vehiculosAccidentadosRelleno = $rootScope.vehiculosImplicados;

        } else if ($rootScope.variosVehiculos == true) {
            $rootScope.accidentados = {};
            for (var i = 0; i < $rootScope.vehiculosImplicados; i++) {

                $rootScope.accidentados['vehiculo' + i] = [];
            }
            $rootScope.vehiculosAccidentadosRelleno = $rootScope.vehiculosImplicados;
        }

        if ( $scope.existeFotografia == false || $rootScope.vehiculoCliente == '' ) {

            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
                template: $filter("translate")($rootScope.translations.alertas.aviso_fotografias)
            });

        } else if ( $rootScope.zonasAccidente == '' ) {

            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
                template: $filter("translate")($rootScope.translations.alertas.areas),
            });
        } else {

            if ( $rootScope.variosVehiculos ) {

                $rootScope.abrirModalAccidente4_1();
            } else {

                $rootScope.abrirModalAccidente4();   
            }
        }
    };

//---------------------------------
// FOTOGRAFIAS DAÑOS (PASO 4)
//---------------------------------

    $scope.createModalAmpliarImagenAccidente = function () {
        $ionicModal.fromTemplateUrl('templates/accidente/detallesImagen.html', {

            vista: "Detalles Imagen Accidente",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function (modalDetallesImagenAccidente) {

            $rootScope.modalDetallesImagenAccidente = modalDetallesImagenAccidente;
            $rootScope.modalDetallesImagenAccidente.show();
        });
    };

    $scope.ampliarImagen = function (tipo, image, parentIndex, index) {

        if (tipo == 0) {

            $rootScope.imagenAmpliadaAccidente = {image: image};
            $rootScope.tipoImagenAmpliada = 0;
        } else if (tipo == 1) {

            $rootScope.imagenAmpliadaAccidente = {image: image, position: index};
            $rootScope.tipoImagenAmpliada = 1;
        } else if (tipo == 2) {

            $rootScope.imagenAmpliadaAccidente = {image: image, parentPosition: parentIndex, position: index};
            $rootScope.tipoImagenAmpliada = 2;
        } else if (tipo == 3) {

            $rootScope.imagenAmpliadaAccidente = {image: image, parentPosition: parentIndex, position: index};
            $rootScope.tipoImagenAmpliada = 3;
        }

        $scope.createModalAmpliarImagenAccidente();
    };

    $scope.volverPaso3 = function (tipo) {

        if ( $rootScope.variosVehiculos && tipo != 'multiple' ) {

            $rootScope.modalAccidente4_1.remove();
            $rootScope.modalAccidente4_1 = undefined;
        } else {

            $rootScope.modalAccidente4.remove();
            $rootScope.modalAccidente4 = undefined;
        }
    };

    $scope.fotoAccidenteCliente = function () {

        $ionicLoading.show();

        navigator.camera.getPicture(onSuccess, onFail, {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL
        });

        function onSuccess(imageData) {

            $rootScope.vehiculoCliente.push("data:image/jpeg;base64," + imageData);
            $ionicLoading.hide();
        }

        function onFail(error) {

            $log.debug("Error en la captura de la imagen del vehiculo propio: ", error);
            $ionicLoading.hide();
        }
    };

    $scope.fotoAccidente = function (index) {

        $ionicLoading.show();

        navigator.camera.getPicture(onSuccess, onFail, {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL
        });

        function onSuccess(imageData) {

            $rootScope.accidentados["vehiculo" + index].push("data:image/jpeg;base64," + imageData);
            $ionicLoading.hide();
        }

        function onFail(error) {

            $log.debug("Error en la captura de la imagen del vehiculo propio: ", error);
            $ionicLoading.hide();
        }
    };

    $scope.deleteAccidenteCliente = function (index) {

        $rootScope.vehiculoCliente.splice(index, 1);
        $rootScope.modalDetallesImagenAccidente.hide();
    };

    $scope.deleteAccidenteOtros = function (indexVehiculo, index) {

        $rootScope.accidentados["vehiculo" + indexVehiculo].splice(index, 1);
        $rootScope.modalDetallesImagenAccidente.hide();
    };

    $scope.deleteAccidenteParte = function (indexVehiculo, index) {

        $rootScope.daaAccidentados[indexVehiculo].fotosDaa.splice(index, 1);
        $rootScope.modalDetallesImagenAccidente.hide();
    };

    if ( typeof $rootScope.datosAccidente === 'undefined' ) {

        $rootScope.datosAccidente = [];
    }

    $scope.irPaso5 = function (tipo) {

        if ( tipo == 'unico' ) {

            var error = false;

            if ( $rootScope.datosAccidente.matricula == '' || typeof $rootScope.datosAccidente.matricula === 'undefined' ) {

                error = true;
            } else if ( $rootScope.datosAccidente.fecha == '' || typeof $rootScope.datosAccidente.fecha === 'undefined' ) {

                error = true;
            } else if ( $rootScope.datosAccidente.lugar == '' || typeof $rootScope.datosAccidente.lugar === 'undefined' ) {

                error = true;
            } else if ( $rootScope.datosAccidente.causa == '' || typeof $rootScope.datosAccidente.causa === 'undefined' ) {

                error = true;
            } else if ( $rootScope.datosAccidente.responsable == '' || typeof $rootScope.datosAccidente.responsable === 'undefined' ) {

                error = true;
            } else if ( $rootScope.datosAccidente.autoridad == 'Si' && ($rootScope.datosAccidente.numAtestado == '' || typeof $rootScope.datosAccidente.numAtestado === 'undefined') ) {

                error = true;
            }

            console.log(error);

            if ( error == false ) {

                $rootScope.modalAccidente5.show();
            }
        } else if ( tipo == 'multiple' ) {

            var error = false;

            for ( var i = 0; i < $rootScope.daaAccidentados.length; i++ ) {

                if ( $rootScope.daaAccidentados[i].fotosDaa == '' ) {

                    $ionicPopup.alert({
                        title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
                        template: $filter("translate")($rootScope.translations.alertas.parte_amistoso)
                    });
                    error = true;
                    break;
                }
            }

            if ( !error ) {

                $rootScope.abrirModalAccidente4();
            }
        }

        // if ($rootScope.variosVehiculos == true) {
        //
        //     $scope.faltanFotos = "";
        //
        //     for (var i = 0; i < $rootScope.vehiculosImplicados; i++) {
        //         if ($rootScope.accidentados["vehiculo" + i] == "")
        //             $scope.faltanFotos = $scope.faltanFotos.concat((i + 1) + ", ");
        //     }
        //
        //     if ($rootScope.vehiculoCliente == "")
        //         $ionicPopup.alert({title: $filter("translate")($rootScope.translations.alertas.faltan_datos), template: $filter("translate")($rootScope.translations.alertas.aviso_fotografias)});
        //
        //     else if (typeof $scope.faltanFotos[0] !== "undefined") {
        //
        //         $scope.faltanFotos = $scope.faltanFotos.slice(0, -2);
        //
        //         if (typeof $scope.faltanFotos[4] !== "undefined")
        //             $ionicPopup.alert({
        //                 title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
        //                 template: $filter("translate")($rootScope.translations.alertas.aviso_otros_coches) + $scope.faltanFotos + '.'
        //             });
        //
        //         else
        //             $ionicPopup.alert({
        //                 title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
        //                 template: $filter("translate")($rootScope.translations.alertas.aviso_otros_coches) + $scope.faltanFotos + '.'
        //             });
        //     }
        //
        //     else
        //         $rootScope.modalAccidente5.show();
        // }
        // else {
        //     if ($rootScope.vehiculoCliente == "")
        //         $ionicPopup.alert({title: $filter("translate")($rootScope.translations.alertas.faltan_datos), template: $filter("translate")($rootScope.translations.alertas.aviso_fotografias)});
        //     else
        //         $rootScope.modalAccidente5.show();
        // }
    };

//---------------------------------
// RESUMEN ACCIDENTE (PASO 5)
//---------------------------------

    $scope.volverPaso4 = function () {

        $rootScope.modalAccidente5.hide();
    };

    $scope.enviarAccidente = function () {

        $ionicLoading.show({
            template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.enviando) + '</i><br><ion-spinner icon="lines" class="spinner-calm"></ion-spinner></div>'
        });

        if ($rootScope.variosVehiculos == true) {

            $scope.envioAccidente = {
                handle: "goldcarapp-accidente",
                lang: $rootScope.language,
                "Tipo de accidente": $rootScope.tipoAccidente,
                "Implicados": $rootScope.textoImplicados + ": " + $rootScope.vehiculosImplicados,
                "Zonas afectadas": $scope.zonasMaped,
                "Nombre cliente": $rootScope.nombreAccidentado,
                "Numero de contrato": $rootScope.contratoAccidentado,
                "ID de reserva": $rootScope.idReservaAccidentado,
                "Matricula": $rootScope.datosAccidente.matricula,
                "Fecha del accidente": $rootScope.datosAccidente.fecha,
                "Lugar del accidente": $rootScope.datosAccidente.lugar,
                "Causa del accidente": $rootScope.datosAccidente.causa,
                "Lesionados": $rootScope.datosAccidente.lesionados,
                "Responsable del accidente": $rootScope.datosAccidente.responsable,
                attachments: [{"name": "matriculaCliente.jpg", "data": ($rootScope.imagenMatricula).substr(23)}]
            };

            if ( $rootScope.datosAccidente.autoridad == 'Si' ) {

                $scope.envioAccidente["Intervino la autoridad"] = $rootScope.datosAccidente.autoridad;
                $scope.envioAccidente["Numero de atestado"] = $rootScope.datosAccidente.numAtestado;
            }

            for (var i = 0; i != $rootScope.vehiculoCliente.length; i++) {

                $scope.envioAccidente.attachments.push({
                    "name": "vehiculoCliente" + i + ".jpg",
                    "data": ($rootScope.vehiculoCliente[i]).substr(23)
                });
            }

            for ( var k = 0; k < $rootScope.daaAccidentados.length; k++ ) {

                for ( var m = 0; m < $rootScope.daaAccidentados[k].fotosDaa.length; m++ ) {

                    $scope.envioAccidente.attachments.push({
                        "name" : "Parte vehiculo " + $rootScope.daaAccidentados[k].numVehiculo + '_' + m,
                        "data" : ($rootScope.daaAccidentados[k].fotosDaa[m]).substr(23)
                    });
                }
            }

            // for (var i = 0; i != $rootScope.vehiculosImplicados; i++) {
            //
            //     for (var k = 0; k != $rootScope.accidentados["vehiculo" + i].length; k++) {
            //
            //         $scope.envioAccidente.attachments.push({
            //             "name": "vehiculo" + i + "_" + k + ".jpg",
            //             "data": ($rootScope.accidentados["vehiculo" + i][k]).substr(23)
            //         });
            //     }
            // }

            JsonService.postMail($scope.envioAccidente).then(function () {

                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.alertas.exito),
                    template: $filter("translate")($rootScope.translations.alertas.envio_realizado)
                });

                $scope.inicializarVariablesAccidente();
                delete $rootScope.accidentados;

                $rootScope.modalAccidente.hide();
                $rootScope.modalAccidente1.hide();
                $rootScope.modalAccidente2.hide();
                $rootScope.modalAccidente3.hide();
                $rootScope.modalAccidente4.hide();
                $rootScope.modalAccidente4_1.remove();
                $rootScope.modalAccidente5.hide();

                $ionicLoading.hide();

            }, function () {

                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.alertas.error_conexion)
                });
                $ionicLoading.hide();
            })

        } else {

            $scope.zonasMaped = [];
            var l = 0;

            angular.forEach($rootScope.config.zonasAccidente_map, function (value, key) {

                for ( var n = 0; n < $rootScope.zonasAccidente.length; n++ ) {

                    if ( $rootScope.zonasAccidente[n] == key ) {

                        $scope.zonasMaped.push(value);
                    }
                }

                l++;
            });

            $ionicLoading.hide();

            $scope.envioAccidente = {
                handle: "goldcarapp-accidente",
                lang: $rootScope.language,
                "Tipo de accidente": $rootScope.tipoAccidente,
                "Zonas afectadas": $scope.zonasMaped,
                "Nombre cliente": $rootScope.nombreAccidentado,
                "Numero de contrato": $rootScope.contratoAccidentado,
                "ID de reserva": $rootScope.idReservaAccidentado,
                "Matricula": $rootScope.datosAccidente.matricula,
                "Fecha del accidente": $rootScope.datosAccidente.fecha,
                "Lugar del accidente": $rootScope.datosAccidente.lugar,
                "Causa del accidente": $rootScope.datosAccidente.causa,
                "Lesionados": $rootScope.datosAccidente.lesionados,
                "Responsable del accidente": $rootScope.datosAccidente.responsable,
                attachments: [{"name": "matriculaCliente.jpg", "data": ($rootScope.imagenMatricula).substr(23)}]
            };

            if ( $rootScope.datosAccidente.autoridad == 'Si' ) {

                $scope.envioAccidente["Intervino la autoridad"] = $rootScope.datosAccidente.autoridad;
                $scope.envioAccidente["Numero de atestado"] = $rootScope.datosAccidente.numAtestado;
            }

            for (var i = 0; i != $rootScope.vehiculoCliente.length; i++) {

                $scope.envioAccidente.attachments.push({
                    "name": "vehiculoCliente" + i + ".jpg",
                    "data": ($rootScope.vehiculoCliente[i]).substr(23)
                });
            }

            JsonService.postMail($scope.envioAccidente).then(function () {

                $ionicPopup.alert({title: $filter("translate")($rootScope.translations.alertas.exito), template: $filter("translate")($rootScope.translations.alertas.envio_realizado) });
                $scope.inicializarVariablesAccidente();

                $rootScope.modalAccidente.hide();
                $rootScope.modalAccidente1.hide();
                $rootScope.modalAccidente2.hide();
                $rootScope.modalAccidente3.hide();
                $rootScope.modalAccidente4.hide();
                $rootScope.modalAccidente5.hide();

                $ionicLoading.hide();

            }, function () {

                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.alertas.error_conexion)
                });
                $ionicLoading.hide();
            })
        }
    };

    //----------------------------------------------//

    // ACCIDENTE 3 // FOTOGRAFIAS

    if ( typeof $rootScope.zonasAccidente === 'undefined' ) {

        $rootScope.zonasAccidente = [];
    }

    $scope.addZone = function (zona) {

        var coincide = false;
        var i = 0;

        for ( i; i < $rootScope.zonasAccidente.length; i++ ) {

            if ( zona == $rootScope.zonasAccidente[i] ) {

                coincide = true;
                break;
            }
        }

        if ( !coincide ) {

            $rootScope.zonasAccidente.push(zona);
        } else {

            $rootScope.zonasAccidente.splice(i, 1);
        }

        console.log($rootScope.zonasAccidente);
    };

    // ACCIDENTE 4 // DATOS

    $scope.resizeModal = function () {

        $ionicScrollDelegate.resize();
    };

    $scope.localizarUbicacion = function() {

        $ionicLoading.show();

        var opciones = {

            timeout: 15000,
            enableHighAccuracy: true
        };

        navigator.geolocation.getCurrentPosition(successGeolocation, errorGeolocation, opciones);

        function successGeolocation(posicion) {

            latitud = posicion.coords.latitude;
            longitud = posicion.coords.longitude;

            $scope.datosAccidente.lugar = latitud.toFixed(6) + ', ' + longitud.toFixed(6);
            $ionicLoading.hide();
        }

        function errorGeolocation(error) {

            if ( error.code == 1 || error.code == 3 ) {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.atencion), template: $filter("translate")($rootScope.translations.alertas.error_deshabilitada_geoloc) });
            } else {

                $log.error("Error localizaciones", error);
            }
        }


    };

    $scope.getFechaAccidente = function() {

        var options = {
            date: new Date(),
            mode: 'date',
            androidTheme: 3
        };

        $cordovaDatePicker.show(options).then(function(date){

            $rootScope.datosAccidente.fecha = moment(date).format('DD/MM/YYYY');
        });
    };

    // ACCIDENTE 4.1 // FOTOS DAA ACCIDENTE MULTIPLE
    
    $rootScope.capturarDaa = function (index) {

        console.log("INDEX: " + index);

        $ionicLoading.show();

        navigator.camera.getPicture(onSuccess, onFail, {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL
        });

        function onSuccess(imageData) {

            $rootScope.daaAccidentados[index].fotosDaa.push("data:image/jpeg;base64," + imageData);
            $ionicLoading.hide();
        }

        function onFail(error) {

            $log.debug("Error en la captura de la imagen del vehiculo propio: ", error);
            $ionicLoading.hide();
        }
    };
    
    // ACCIDENTE 3 // FOTOGRAFIAS

    $rootScope.comprobarReservaActual = function () {

        if ( $rootScope.reservaDisfrutando ) {

            $rootScope.nombreAccidentado = $rootScope.reservaDisfrutando.Cliente.Name;
            $rootScope.contratoAccidentado = $rootScope.reservaDisfrutando.BonoAgencia;
            $rootScope.idReservaAccidentado = $rootScope.reservaDisfrutando.Idreserva;
        } else {
            
            $log.debug("No existe $rootScope.reservaDisfrutando");
        }
        
    };


});