angular.module('goldcar').controller('AreaUsuarioCtrl', function ($filter, $scope, $rootScope, $ionicModal, GoldcarService, JsonService, $ionicSlideBoxDelegate, $ionicLoading, $ionicPopup, $log, Session, $q) {

    // ------------------------- //
    // COMPROBAR TICKETS OFICINA //
    // ------------------------- //

    function comprobarSistemaTickets(idPais, codigoOficina) {

        var defered = $q.defer();
        var promise = defered.promise;
        var officesList = JSON.parse(localStorage['content_offices']);

        if (typeof officesList != 'undefined' && officesList != '' && officesList != null) {
            for (var l = 0; l < officesList.length; l++) {
                if (idPais == officesList[l].gcid) {
                    for (var i = 0; i < officesList[l].offices.length; i++) {
                        if (codigoOficina == officesList[l].offices[i].code) {
                            if (officesList[l].offices[i].ticketSystem !== null && officesList[l].offices[i].ticketSystem !== '') defered.resolve(true);
                            else defered.resolve(false);
                            break;
                        }
                    }
                }
            }
        } else defered.reject(false);

        return promise;
    }

    //----------------------------
    // DATOS TARJETAS
    //----------------------------

    $ionicLoading.hide();

    $rootScope.pocoTiempo = function () {

        if (typeof localStorage['user'] !== 'undefined') {

            if ($rootScope.misReservasLoadFirstTime) {
                $ionicLoading.show({
                    template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.recuperando_reservas) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
                });
            }

            var success = false;
            var tags = null;
            var now = new Date().getTime();
            var time = $rootScope.config.proximasReservas.desdeHoras * 60 * 60 * 1000;
            var closerTime = $rootScope.config.proximasReservas.desdeHorasCercanas * 60 * 60 * 1000;

            GoldcarService.getReservasActivas().then(function (result) {

                if (result.data.data_empty === true)
                    $rootScope.hayReservasActivas = false;
                else
                    $rootScope.hayReservasActivas = true;

                $rootScope.reservasFuturas = [];
                $rootScope.reservasProximas = [];
                $rootScope.reservasInminentes = [];

                if (result.data.length > 0) {
                    result.data.forEach(function (reserva) {

                        comprobarSistemaTickets(reserva.Pickupplace.Idpais, reserva.Pickupplace.Codigo).then(function (result) {
                            console.log(result);
                            reserva.TicketSystem = result;
                        }).catch(function () {
                            reserva.TicketSystem = false;
                        });
                        // console.log("RESERVAS", reserva);

                        var diffHours = reserva.Pickupdate - now;

                        var patron = $rootScope.config.patronPassbook;
                        var i = reserva.Idreserva + $rootScope.datosUsuario.Apellidos + reserva.BonoAgencia + patron;
                        var shaObj = new jsSHA("SHA-256", "TEXT");
                        shaObj.update(i);
                        var encripted = shaObj.getHash("HEX");
                        var url = 'https://www.goldcar.es/passbook/gen/idreserva/' + reserva.Idreserva + '/e/' + encripted;
                        reserva.url = url;

                        if (diffHours > time) {
                            success = true;
                            $rootScope.reservasFuturas.push(reserva);
                            tags = 'Futuras';
                        }

                        else if (diffHours <= time && diffHours > closerTime) {
                            success = true;
                            $rootScope.reservasProximas.push(reserva);
                            tags = 'Proximas';
                        }

                        else if (diffHours <= closerTime && diffHours > 0) {
                            success = true;
                            $rootScope.reservasInminentes.push(reserva);
                            tags = 'Inminentes';
                        }
                    });
                }
                reservasPosiblementeActivas(now, success, tags);
            },
                function (error) {
                    $log.debug("Error cargando reservasActivas: " + error);
                    reservasPosiblementeActivas(now, success, tags);
                });
        }
    };

    var reservasPosiblementeActivas = function (now, success, tags) {
        GoldcarService.getReservasAnteriores().then(function (result) {
            var hayReservas;

            if (result.data.data_empty === true && !$rootScope.hayReservasActivas)
                hayReservas = false;
            else
                hayReservas = true;

            $rootScope.reservasActuales = [];

            if (result.data.length > 0) {
                result.data.forEach(function (reserva) {
                    var diffHoursRecogida = reserva.Pickupdate;
                    var diffHoursEntrega = reserva.Dropoffdate;

                    if (reserva.Estado == 2 || reserva.Estado == 5) {
                        if (now > diffHoursRecogida && now < diffHoursEntrega) {
                            success = true;
                            $rootScope.reservasActuales.push(reserva);
                            hayReservas = true;
                            $rootScope.tieneReservasDisfrutando = true;
                            tags = 'Actuales';
                        } else {

                            $rootScope.tieneReservasDisfrutando = false;
                        }
                    }
                });
            }

            if (!success && !$rootScope.hayReservasActivas)
                hayReservas = false;

            $rootScope.hayReservas = hayReservas;

            if ($rootScope.misReservasLoadFirstTime) {
                $ionicLoading.hide();
            }

            $rootScope.misReservasLoadFirstTime = false;
            cargaBanners(success, tags);

            $ionicLoading.hide();
        },
            function (error) {
                $log.debug("Error con reservasAnteriores: " + error);
                if ($rootScope.misReservasLoadFirstTime) {
                    $ionicLoading.hide();
                }
                $rootScope.misReservasLoadFirstTime = false;
                cargaBanners(success, tags);
            }
        );
    };

    var cargaBanners = function (success, tags) {

        $rootScope.estadoBannersHomeReserva = 2;                           // estadoBanners = 2 -> CARGANDO
        $log.debug('Tags que se enviarian: ' + tags);
        //JsonService.getBanners(tags).then(function (result) { // TODO: DESCOMENTAR ESTA LINEA, Y ELIMINAR LA SIGUIENTE LINEA
        JsonService.getBanners('Home').then(function (banners) {
            $rootScope.bannersHomeReserva = [];
            $rootScope.bannersHomeReserva = banners;
            $rootScope.bannersHomeReserva.forEach(function (banner) {
                if (banner.url) {
                    var link = banner.url;
                    link = link.split('/');
                    for (var i = 0; i < link.length; i++) {
                        if (link[i].indexOf('pickupplace') >= 0) {
                            banner.pickupplace = link[i + 1];
                        }
                        if (link[i].indexOf('dropoffplace') >= 0) {
                            banner.dropoffplace = link[i + 1];
                        }
                        if (link[i].indexOf('pickupdate') >= 0) {
                            banner.pickupdate = link[i + 1];
                        }
                        if (link[i].indexOf('dropoffdate') >= 0) {
                            banner.dropoffate = link[i + 1];
                        }
                    }
                }
            });
            if (typeof banners[0] === "undefined") {
                $rootScope.bannersHomeReservaText = $filter("translate")($rootScope.translations.home.sin_ofertas);
                $rootScope.estadoBannersHomeReserva = 0;                   // estadoBanners = 0 -> VACIO
            }
            else
                $rootScope.estadoBannersHomeReserva = 1;                   // estadoBanners = 1 -> RELLENADO

            $ionicSlideBoxDelegate.update();
        });

        if (!$rootScope.misReservasLoadFirstTime)
            $rootScope.$broadcast('scroll.refreshComplete');

    };

    $scope.abrirReservaFutura = function (posicion, url) {
        $log.debug(url);
        $rootScope.reservaSeleccionada = $rootScope.reservasFuturas[posicion];
        // var patron = $rootScope.config.patronPassbook;
        // var encripted = sha256($rootScope.reservaSeleccionada.Idreserva + $rootScope.datosUsuario.Apellidos + $rootScope.reservaSeleccionada.BonoAgencia + patron);
        // var url = 'https://www.goldcar.es/passbook/gen/idreserva/' + $rootScope.reservaSeleccionada.Idreserva + '/e/' + encripted;
        $rootScope.reservaSeleccionada.url = url;
        $rootScope.tipoReserva = 0;
        $rootScope.abrirModalDetalles();
    };

    $scope.abrirReservaProxima = function (posicion, url) {
        $log.debug(url);
        $rootScope.reservaSeleccionada = $rootScope.reservasProximas[posicion];
        // var patron = $rootScope.config.patronPassbook;
        // var encripted = sha256($rootScope.reservaSeleccionada.Idreserva + $rootScope.datosUsuario.Apellidos + $rootScope.reservaSeleccionada.BonoAgencia + patron);
        // var url = 'https://www.goldcar.es/passbook/gen/idreserva/' + $rootScope.reservaSeleccionada.Idreserva + '/e/' + encripted;
        $rootScope.reservaSeleccionada.url = url;
        $rootScope.tipoReserva = 0;
        $rootScope.abrirModalDetalles();
    };

    $scope.abrirReservaInminente = function (posicion, url) {
        $log.debug(url);
        $rootScope.reservaSeleccionada = $rootScope.reservasInminentes[posicion];
        // var patron = $rootScope.config.patronPassbook;
        // var encripted = sha256($rootScope.reservaSeleccionada.Idreserva + $rootScope.datosUsuario.Apellidos + $rootScope.reservaSeleccionada.BonoAgencia + patron);
        // var url = 'https://www.goldcar.es/passbook/gen/idreserva/' + $rootScope.reservaSeleccionada.Idreserva + '/e/' + encripted;
        $rootScope.reservaSeleccionada.url = url;
        $rootScope.tipoReserva = 1;
        $rootScope.abrirModalDetalles();
    };

    $scope.abrirReservaActual = function (posicion) {
        $rootScope.reservaSeleccionada = $rootScope.reservasActuales[posicion];
        $rootScope.tipoReserva = 2;
        $rootScope.abrirModalDetalles();
    };

    //----------------------------
    // TICKETS
    //----------------------------

    $scope.createTicketsModal = function (office, fn) {
        $rootScope.ticketOffice = office;

        $ionicModal.fromTemplateUrl('templates/tickets/tickets.html', {

            vista: "Tickets",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function (modalTickets) {

            $rootScope.modalTickets = modalTickets;
            $rootScope.modalTicketsIsClose = false;
            if (typeof fn === 'function') fn();
        });
    };

    // $rootScope.showTickets = function(office) {
    //     $log.debug("showTickets", office);
    //     $rootScope.ticketOffice = office;
    //     if ( typeof $rootScope.modalTickets === "undefined" || $rootScope.modalTicketsIsClose == true ){
    //         $scope.createTicketsModal(office, function () {
    //             $rootScope.modalTicketsCreado = true;
    //             $rootScope.modalTickets.show();
    //             $rootScope.refreshticketServices(true);
    //         });
    //     }
    //     else {
    //         $rootScope.modalTickets.show();
    //         $rootScope.refreshticketServices(true);
    //     }
    // };

    $rootScope.ticketAviso5min = false;
    $rootScope.ticketAvisoSuturno = false;
    if (localStorage['ticketCogido']) {
        $rootScope.ticketCogido = JSON.parse(localStorage['ticketCogido']);
        $log.debug("Existe el ticket: ", $rootScope.ticketCogido);
        var ticketTime = Date.parse($rootScope.ticketCogido.createdtime);
        var now = new Date();
        if (now - ticketTime > 60 * 60000) {
            $rootScope.ticketCogido = false;
            delete localStorage['ticketCogido'];
        } else {
            $scope.createTicketsModal($rootScope.ticketCogido.office, function () {
                $rootScope.refreshTicket();
            });
        }
    } else {
        $rootScope.ticketCogido = false;
    }

    //--------------------------------
    // DATOS TARJETAS HISTORIAL
    //--------------------------------

    $scope.abrirReservaPasada = function (posicion) {
        GoldcarService.getDetalleReserva($scope.historicoReservas[posicion].Idreserva).then(function(res){
            // console.log(res);
        });
        $rootScope.reservaSeleccionada = $scope.historicoReservas[posicion];
        $rootScope.tipoReserva = 3;
        $rootScope.abrirModalDetalles();
    };

    $scope.getHistoricoReservas = function () {


        if ($rootScope.historialReservasLoadFirstTime) {
            $ionicLoading.show({
                template: '<div class="cargando"><i style="font-weight: bold;">' + $filter("translate")($rootScope.translations.loading.recuperando_historial) + '</i><br><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
            });
        }

        var now = new Date().getTime();
        GoldcarService.getReservasAnteriores().then(function (result) {

            $scope.historicoReservas = [];

            for (var i = 0; i != result.data.length; i++) {
                var diffHoursEntrega = Date.parse(result.data[i].Dropoffdate);
                if (diffHoursEntrega < now)
                    ($scope.historicoReservas).push(result.data[i]);
            }

            GoldcarService.getReservasCanceladas().then(function (result) {
                for (var i = 0; i != result.data.length; i++) {
                    if (result.data[i].Estado != 2 && result.data[i].Estado != 5)
                        ($scope.historicoReservas).push(result.data[i]);
                }

                if ($rootScope.historialReservasLoadFirstTime) {
                    $ionicLoading.hide();
                }
                $rootScope.historialReservasLoadFirstTime = false;
            }, function (error) {
                $log.debug("Error trayendo reservas canceladas", error);
                if ($rootScope.historialReservasLoadFirstTime) {
                    $ionicLoading.hide();
                }
                $rootScope.historialReservasLoadFirstTime = false;
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.alertas.error_conexionx)
                });
            });

        }, function (error) {
            $log.debug("Error trayendo reservas anteriores", error);
            if ($rootScope.historialReservasLoadFirstTime) {
                $ionicLoading.hide();
            }
            $rootScope.historialReservasLoadFirstTime = false;
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
        });

        if (!$rootScope.historialReservasLoadFirstTime)
            $rootScope.$broadcast('scroll.refreshComplete');
    }

    //-----------------------
    // MIS FACTURAS
    //-----------------------

    $rootScope.recuperarFacturas = function () {

        $ionicLoading.show();

        GoldcarService.getFacturas().then(function (result) {

            $log.debug("MIS FACTURAS", result.data);
            if (result.data.error != true) {

                $scope.listaFacturas = result.data;
            } else {

                $scope.noFacturas = $filter("translate")($rootScope.translations.mis_facturas.no_facturas);
            }

            $ionicLoading.hide();
        })
    }

    //-------------------------
    // DESCARGAR FACTURAS
    //-------------------------

    $scope.descargaFactura = function (factura) {

        var i = factura.split('-');
        window.open('https://www.goldcar.es/facturacion/facturapdf/serieFra/' + i[0] + '/numFra/' + i[1], '_system');
    };

    //-------------------------
    // ENVIAR FACTURAS
    //-------------------------

    $rootScope.enviaFactura = function (factura) {

        var i = factura.split('-');
        var link = 'https://www.goldcar.es/facturacion/facturapdf/serieFra/' + i[0] + '/numFra/' + i[1];

        $scope.data = {};

        $ionicPopup.show({
            template: '<input type="email" ng-model="data.correoA" style="border: 1px solid #eeeeee; text-align: center; padding: 5px">',
            title: $filter("translate")($rootScope.translations.ayuda.destinatario) + ": ",
            scope: $scope,
            buttons: [
                {
                    text: $filter("translate")($rootScope.translations.general.cancelar),
                    type: 'button-assertive buttonCancelar'
                },
                {
                    text: '<b>' + $filter("translate")($rootScope.translations.general.enviar) + '</b>',
                    type: 'button-positive buttonCancelar',
                    onTap: function (e) {
                        if (!$scope.data.correoA) {
                            e.preventDefault();
                        } else {
                            var text = "mailto:" + $scope.data.correoA + "?body=" + link;
                            window.location.href = decodeURIComponent(text);
                        }
                    }
                }
            ]
        });
    }

    // PASSBOOK //

    $scope.openReservaPassbook = function (urlPassbook) {

        cordova.InAppBrowser.open(encodeURI(urlPassbook), '_system');
    };
});
