angular.module('goldcar').controller('ComoLlegarCtrl', function($rootScope, $scope, $ionicModal, $ionicPopup, $filter) {

    var opciones = {
        timeout: 5000,
        maximumAge: 0,
        enableHighAccuracy: false
    };
    var myLocation = { latitude: null, longitude: null };
    if(ionic.Platform.isAndroid()){
        $scope.urlMaps = 'geo:' + $rootScope.oficinaSeleccionada.latitude + ',' + $rootScope.oficinaSeleccionada.longitude + '?q=' + $rootScope.oficinaSeleccionada.latitude + ',' + $rootScope.oficinaSeleccionada.longitude;
    } else {
        $scope.urlMaps = 'http://maps.apple.com/?ll=' + $rootScope.oficinaSeleccionada.latitude + ',' + $rootScope.oficinaSeleccionada.longitude;
    }

    navigator.geolocation.getCurrentPosition(function (coords) {
        myLocation.latitude = coords.coords.latitude;
        myLocation.longitude = coords.coords.longitude;

        if(ionic.Platform.isAndroid()){
            $scope.goToOffice = 'https://www.google.com/maps?f=d&saddr=' + myLocation.latitude + ', ' + myLocation.longitude + '&daddr=' + $scope.oficina.Coordenadas + '&dirflg=d';
        } else {
            $scope.goToOffice = 'http://maps.apple.com?saddr=' + myLocation.latitude + ', ' + myLocation.longitude + '&daddr=' + $scope.oficina.Coordenadas + '&dirflg=d';
        }
    }, function (error) {
        $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_deshabilitada_geoloc), cssClass: 'single-popup' });
    }, opciones);


    //----------------------------
    // MODAL HORARIOS
    //----------------------------

    $scope.createModalHorarios = function(fn) {
        $ionicModal.fromTemplateUrl('templates/como_llegar/horarios.html', {

            vista: "Horarios Oficina",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalHorarios) {

            $rootScope.modalHorarios = modalHorarios;
            if(fn) fn();
        });
    };

    //----------------------------
    // FUNCIONALIDADES
    //----------------------------

    $scope.openNavigation = function(coords) {
        console.log('coordenada es ....' , coords);

        if(!coords) return false;
        var list = coords.split(',');
        var destination = [list[0], list[1]];

        launchnavigator.navigate(destination).then(function() {
            console.log("Navigator launched");
        }, function (err) {
            console.log('error......' , err);
        });
    };

    $scope.abrirHorarios = function (horario) {
        $rootScope.horarioSeleccionado = horario;

        $scope.createModalHorarios(function () {
            $rootScope.modalHorarios.show();
        });
    };

    $scope.abrirPlanos = function(url){
        window.open(url, '_system');
    }

});
