angular.module('goldcar').controller('ConcursosCtrl', function($rootScope, $scope, $ionicModal, $log, $cordovaBarcodeScanner, JsonService, $ionicLoading, $timeout, GoldcarService, $ionicPopup, $filter, $state) {

    $rootScope.getListaConcursos = function () {

        $ionicLoading.show();

        JsonService.postListaConcursos().then(function (result) {

            if  ( result.success === true ) {

                $log.debug("RESULT LISTA CONCURSOS", result);
                $scope.listaConcursos = result.items;

                if ( result.items ) {

                    for ( var j = 0; j < result.items.length; j++ ) {

                        var imageList = null;
                        var imagen = null;

                        for ( var i = 0; i < result.items[j].files.length; i++ ) {

                            if ( result.items[j].files[i].type == 'image-list' && result.items[j].files[i].lang == $rootScope.language ) {

                                imageList = (result.items[j].files[i]);
                                break;
                            } else if ( imageList === null && result.items[j].files[i].type == 'image-list' && result.items[j].files[i].lang == null ) {

                                imageList = (result.items[j].files[i]);
                            }

                            if ( result.items[j].files[i].type == 'image' && result.items[j].files[i].lang == $rootScope.language ) {

                                imagen = (result.items[j].files[i]);
                                break;
                            } else if ( imagen === null && result.items[j].files[i].type == 'image' && result.items[j].files[i].lang == null ) {

                                imagen = (result.items[j].files[i]);
                            }
                        }

                        $scope.listaConcursos[j].files = [];
                        $scope.listaConcursos[j].files.push(imageList);
                        $scope.listaConcursos[j].files.push(imagen);
                    }

                    $log.debug("$scope.listaConcursos", $scope.listaConcursos);

                } else {

                    // $scope.listaConcursos = 'No hay concursos disponibles';
                }
            } else {

                $log.debug("Error");
            }

            $ionicLoading.hide();
        });
    };

    //----------------------------
    // MODAL CONCURSO
    //----------------------------

    $scope.data = "";

    $scope.createModalConcurso = function(index) {

        $rootScope.concursoSeleccionado = {};

        $ionicLoading.show();

        if ( typeof $rootScope.modalConcurso === 'undefined' ) {

            $ionicModal.fromTemplateUrl('templates/concursos/concurso.html', {

                vista: "Concurso",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalConcurso) {

                $rootScope.modalConcurso = modalConcurso;
                $rootScope.concursoSeleccionado = $scope.listaConcursos[index];
                // $log.debug("$rootScope.concursoSeleccionado", $rootScope.concursoSeleccionado);
                $timeout(modalConcurso.show(), 0);
                $ionicLoading.hide();
            });
        } else {

            $rootScope.concursoSeleccionado = $scope.listaConcursos[index];
            $timeout($rootScope.modalConcurso.show(), 0);
            $ionicLoading.hide();
        }
    };

    $scope.createModalBasesLegales = function() {

        $ionicLoading.show();

        if ( typeof $rootScope.modalBasesLegales === 'undefined' ) {

            $ionicModal.fromTemplateUrl('templates/concursos/bases_legales.html', {

                vista: "Bases Legales Concurso",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalBasesLegales) {

                $rootScope.modalBasesLegales = modalBasesLegales;
                modalBasesLegales.show();
                $ionicLoading.hide();
            });
        } else {

            $rootScope.modalBasesLegales.show();
            $ionicLoading.hide();
        }
    };

    $rootScope.capturarQR = function () {

        $ionicLoading.show();

        var params = {
            text_title: " ", // Android only
            text_instructions: " ", // Android only
            camera: "back", // defaults to "back"
            flash: false, // defaults to "auto". See Quirks
            drawSight: true //defaults to true, create a red sight/line in the center of the scanner view.
        }

        var encontrado = false;

        cloudSky.zBar.scan(params, onSuccess, onFailure);

        function onSuccess(result) {
            var qrs = $rootScope.config.qrs;
            for(var i in qrs){
                if(result == qrs[i].textoqr){
                    encontrado = true;
                    if(qrs[i].login) {
                        if(!$rootScope.isLogged) {
                            $ionicLoading.hide();
                            $ionicPopup.alert({title: $filter("translate")($rootScope.translations.alertas.atencion), template: $filter("translate")($rootScope.translations.alertas.debes_loguear_qr)});
                            $rootScope.mostrarModalLogin('qr');
                        }
                        else {
                            GoldcarService.getUsuario().then(function(result){
                                var dataUser = result.data;
                                if(qrs[i].replace_fields) {
                                    var url = qrs[i].url;
                                    while(url.substring(url.lastIndexOf("{")+1,url.lastIndexOf("}")) !== ''){
                                        var campo = url.substring(url.lastIndexOf("{")+1,url.lastIndexOf("}"));
                                        if(campo != 'Authenticated' && campo != 'Paramsb') {
                                            for(var l in dataUser){
                                                if(l == campo){
                                                    url = url.replace(url.substring(url.lastIndexOf("{"),url.lastIndexOf("}")+1), (dataUser[l]).replace(' ', '+'));
                                                }
                                            }
                                        }
                                    }
                                    $ionicLoading.hide();
                                    window.open(encodeURI(url), '_system');
                                }
                                else {
                                    $ionicLoading.hide();
                                    window.open(encodeURI(qrs[i].url), '_system');
                                }
                            });
                        }
                    }
                    else {
                        $ionicLoading.hide();
                        window.open(encodeURI(qrs[i].url), '_system');
                    }
                    break;
                }
            }
            if(!encontrado) {
                if ( result.slice(0, 4) === 'http' || result.slice(0, 5) === 'https' ) {
                    window.open(encodeURI(result), '_system');
                }
            }
            $ionicLoading.hide();
        }

        function onFailure(error) {
            $ionicLoading.hide();
            console.log(error);
            if(error != 'cancelled'){
                $ionicPopup.alert({title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.fitur.error_compatibilidad)});
            }
            // $state.go('menu.home');
        }
    }

});
