angular.module('goldcar').controller('ConfigCtrl', function ($filter, $log, $scope, $rootScope, $cordovaSplashscreen, $state, Session, $ionicModal, GoldcarService, $ionicLoading) {

    $scope.idiomas = $rootScope.config.idiomas;
    $scope.todosIdiomas = [];
    $scope.bloqueo = {};

    $ionicLoading.show();

    // CONFIGURACION BLOQUEO RESERVA POR HUELLA
    if ( typeof Fingerprint !== 'undefined' ) {

        Fingerprint.isAvailable(successFingerFn, errorFingerFn);

        function successFingerFn() {

            $scope.mostrarFinger = true;
            $ionicLoading.hide();
        }

        function errorFingerFn() {

            $scope.mostrarFinger = false;
            $ionicLoading.hide();
        }
    }
    else {
        $ionicLoading.hide();
    }

    if ( typeof localStorage['bloqueoHuella'] === 'undefined' || JSON.parse(localStorage['bloqueoHuella']) == 'undefined' ) {

        $scope.bloqueo.huella = false;
        localStorage['bloqueoHuella'] = false;
    } else {

        $scope.bloqueo.huella = JSON.parse(localStorage['bloqueoHuella']);
    }
    
    //

    angular.forEach($scope.idiomas, function (idioma, id) {

        $scope.todosIdiomas.push({ "bandera" : 'https://gcdata-documents.s3.amazonaws.com/goldcar-app/banderas-paises/' + $rootScope.config.mapeo_api[id].toUpperCase() + '.png', "id" : id, "name" : idioma });
    });

    // console.log($scope.todosIdiomas);

    $scope.monedas = $rootScope.config.monedas;
    setTimeout(function () {

        $scope.elige_idioma = $filter("translate")($rootScope.translations.configuracion.elige_idioma);
        $scope.elige_moneda = $filter("translate")($rootScope.translations.configuracion.elige_moneda);
    }, 3000);

    for ( var l = 0; l < $scope.todosIdiomas.length; l++ ) {

        if ( $scope.todosIdiomas[l].id == $rootScope.language ) {

            $scope.idiomaSeleccionado = $scope.todosIdiomas[l];
            // console.log("POSICION:" + l);
            // $scope.todosIdiomas.splice(l, 1);
        }
    }

    $rootScope.seleccionarIdioma = function (idioma) {

        Session.set({

            "lang": idioma
        }).then(function (result) {

            for ( var i = 0; i < $scope.todosIdiomas.length; i++ ) {
                if ($scope.todosIdiomas[i].id == idioma) {

                    $rootScope.language = localStorage['lang'] = $scope.todosIdiomas[i].id;

                    for (var x=0; x<=localStorage.length-1; x++)  {
                        var clave = localStorage.key(x);
                        if ( clave.indexOf('content') >= 0 ) {
                            if ( clave.indexOf('goldcarapp-config') >= 0 ) {
                                // NO BORRAR, SOLO NOS RESERVAMOS LA CONFIGURACION
                            }
                            else {
                                localStorage.removeItem(clave);
                                x--;
                            }
                        }
                        else {
                            // NO BORRAR, DISPONIBILIDAD Y DATOS DE USUARIOS INTACTOS
                        }
                    }

                    $rootScope.limpiarHistorial();
                    if (navigator.splashscreen)
                        $cordovaSplashscreen.show();
                    window.location.reload();
                    break;
                } else {

                    console.log('No encontrado');
                }
            }
        });
    };

    // $rootScope.abrirPreferenciasBusqueda = function (id) {

    //     if ( id > 0 ) {

    //         $rootScope.noGuardarPreferencias = true;
    //     } else {

    //         $rootScope.noGuardarPreferencias = false;
    //     }

    //     $ionicModal.fromTemplateUrl('templates/configuracion/pref_busqueda.html', {

    //         vista: "Preferencias de busqueda",
    //         scope: $rootScope,
    //         animation: 'slide-in-right'
    //     }).then(function(modalPreferenciasBusqueda) {

    //         $rootScope.modalPreferenciasBusqueda = modalPreferenciasBusqueda;
    //         modalPreferenciasBusqueda.show();
    //     });
    // };

    // CHECK BLOQUEO POR HUELLA
    $rootScope.cambiarBloqueoHuella = function(bloqueoHuella) {

        if ( bloqueoHuella == false && typeof Fingerprint !== 'undefined' ) {

            Fingerprint.show({

                clientId: 'Goldcar-APP',
                clientSecret: 'aN9W9h5uBB'
            }, successFingerFn);

            function successFingerFn(result) {

                localStorage['bloqueoHuella'] = bloqueoHuella;
            }
        } else {

            localStorage['bloqueoHuella'] = bloqueoHuella;
        }
    }

    //--------------------------
    // FILTROS DISPONIBILIDAD
    //--------------------------

    // SELECCIONAR TIPO

    // $scope.seleccionarTipo = function (tipo) {

    //     $rootScope.tipoSeleccionado = tipo;
    //     if ( !$rootScope.noGuardarPreferencias ) {

    //         localStorage.setItem('tipoVehiculo', JSON.stringify(tipo));
    //     }
    // };

    // SELECCIONAR FILTRO

    // $scope.seleccionarFiltro = function (filtro) {

    //     $rootScope.filtroSeleccionado = filtro;
    //     if ( !$rootScope.noGuardarPreferencias ) {

    //         localStorage.setItem('filtroSeleccionado', JSON.stringify(filtro));
    //     }
    // };

    // SELECCIONAR SOLO AUTOMATICOS

    // $rootScope.cambiarSoloAutomaticos = function () {

    //     $rootScope.soloAutomaticos = !$rootScope.soloAutomaticos;
    //     if ( !$rootScope.noGuardarPreferencias ) {

    //         localStorage.setItem('soloAutomaticos', $rootScope.soloAutomaticos);
    //     }
    // };

    // SELECCIONAR MAS 5 PLAZAS

    // $rootScope.cambiarMasCincoPlazas = function () {

    //     $rootScope.masCincoPlazas = !$rootScope.masCincoPlazas;
    //     if ( !$rootScope.noGuardarPreferencias ) {

    //         localStorage.setItem('masCincoPlazas', $rootScope.masCincoPlazas);
    //     }
    // };

});