angular.module('goldcar').controller('Fitur18Ctrl', function($scope, $cordovaGeolocation, $state, $sce, $rootScope, $ionicPopup, $filter, $ionicLoading) {

    $scope.goBack = function(state) {
        $state.go(state)
    }

    $scope.goConcursos = function() {

        // $state.go('menu.fitur18Concursos');

        if($rootScope.config.usarLimiteKmFitur) {

            $ionicLoading.show();

            var posOptions = { timeout: 10000, enableHighAccuracy: false };
            $cordovaGeolocation.getCurrentPosition(posOptions)
                .then(function (position) {
                    var lat  = position.coords.latitude
                    var long = position.coords.longitude

                    // console.log(lat);
                    // console.log(long);
                    // console.log($rootScope.config.latitudFitur);
                    // console.log($rootScope.config.longitudFitur);
    
                    var distanciaUsuario = getKilometros(lat, long, $rootScope.config.latitudFitur, $rootScope.config.longitudFitur);
    
                    // console.log("distanciaUsuario", distanciaUsuario);

                    $ionicLoading.hide();

                    if(distanciaUsuario < $rootScope.config.distanciaMaxFitur) $state.go('menu.fitur18Concursos');
                    else $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.fitur.no_detecta_title), template: $filter("translate")($rootScope.translations.fitur.no_detecta) });
                    
                }, function(err) {

                    $ionicLoading.hide();
                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.fitur.no_detecta_title), template: $filter("translate")($rootScope.translations.fitur.no_detecta) });
                });
        } else {
            $state.go('menu.fitur18Concursos');
        }

    }

    $scope.goSelected = function(state) {
        $state.go(state);
    }

    $scope.goParticipar = function(state) {

        $rootScope.hash = "";

        if(state == 'click') $rootScope.hash = 'Fitur2018ClickNGo';
        if(state == 'moto') $rootScope.hash = 'Fitur2018Moto';
        if(state == 'simulador') $rootScope.hash = 'Fitur2018Simulador';

        $state.go('menu.fitur18Iframe');
    }

    $scope.urlDestino = "";
    $scope.getURL = function() {

        var idioma = localStorage['lang'];
        var nombre = localStorage['nombreUsuario'] + " " + localStorage['apellidosUsuario'];
        var email = localStorage['user'];

        $scope.urlDestino = $sce.trustAsResourceUrl(encodeURI($rootScope.config.urlFitur18 + $rootScope.hash + "/" + idioma + "/login-email?name=" + nombre + "&email=" + email + ""));
    }

    $scope.comprobarQR = function() {

        var params = {
            text_title: " ", // Android only
            text_instructions: " ", // Android only
            camera: "back", // defaults to "back"
            flash: "false", // defaults to "auto". See Quirks
            drawSight: true //defaults to true, create a red sight/line in the center of the scanner view.
        }

        cloudSky.zBar.scan(params, onSuccess, onFailure);

        function onSuccess(result) {
            if (result == $rootScope.config.qrFitur18) {
                $scope.goParticipar('click');
            } else {
                $state.go('menu.fitur18');
            }
        }

        function onFailure(error) {
            console.log(error);
            if(error != 'cancelled') alert($filter("translate")($rootScope.translations.fitur.error_compatibilidad));
        }
                
        // function displayContents(err, text){
        //     if(err){
        //         $state.go('menu.fitur18');
        //     } else {
        //         if (text == $rootScope.config.qrFitur18) {
        //             $('html').removeClass('transparent-body');
        //             $('body').removeClass('transparent-body');
        //             $('.view-fitur18-concurso').removeClass('transparent-body');
        //             $('.content-fitur-concurso').removeClass('hidden-class');
        //             // QRScanner.destroy(function(status){
        //             //     console.log(status);
        //             // });
        //             $scope.goParticipar('click');
        //         } else {
        //             $('html').removeClass('transparent-body');
        //             $('body').removeClass('transparent-body');
        //             $('.view-fitur18-concurso').removeClass('transparent-body');
        //             $('.content-fitur-concurso').removeClass('hidden-class');
        //             // QRScanner.destroy(function(status){
        //             //     console.log(status);
        //             // });
        //             $state.go('menu.fitur18');
        //         }
        //     }
        // }

        // function onDone(err, status){
        //     if (err) {
        //         alert($filter("translate")($rootScope.translations.fitur.error_compatibilidad));
        //     } else {
        //         if (status.authorized) {
        //             $('html').addClass('transparent-body');
        //             $('body').addClass('transparent-body');
        //             $('.view-fitur18-concurso').addClass('transparent-body');
        //             $('.content-fitur-concurso').addClass('hidden-class');
        //             // QRScanner.show();
        //         } else if (status.denied) {
        //             $state.go('menu.fitur18');
        //         } else {
        //             $state.go('menu.fitur18');
        //         }
        //     }
        // }
    }

    var getKilometros = function(lat1,lon1,lat2,lon2)
    {
        rad = function(x) {return x*Math.PI/180;}
        
        var R = 6378.137; //Radio de la tierra en km
        var dLat = rad( lat2 - lat1 );
        var dLong = rad( lon2 - lon1 );
        var a = Math.sin(dLat/2) * Math.sin(dLat/2) + Math.cos(rad(lat1)) * Math.cos(rad(lat2)) * Math.sin(dLong/2) * Math.sin(dLong/2);
        var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
        var d = R * c;

        return d.toFixed(3)*1000; //Retorna tres decimales
    }

});