angular.module('goldcar').controller('GoldcarClubCtrl', function($filter, $scope, $ionicModal, $ionicLoading, $rootScope, $log, $ionicPopup, GoldcarService, $cordovaInAppBrowser, $cordovaClipboard, $cordovaToast) {

    $scope.getPuntosUsuario = function () {

        if ( $rootScope.isLogged ) {

            GoldcarService.getUsuario().then(function (result) {

                $scope.userWallet = result.data.UrlWallet;

                $log.debug("getUsuario", result);
                $scope.puntosUsuario = result.data.Puntosclub;

                if ( $scope.puntosUsuario <= 0) {

                    $scope.hayPuntos = false;
                } else {

                    $scope.hayPuntos = true;
                }
            }, function (error) {

                $log.debug("Fallo en getUsuario: ", error);
            });
        }
    };

    $scope.$on('$viewContentLoaded', function(){

        $ionicLoading.hide();
    });

    //--------------------------
    // MIS PREMIOS
    //--------------------------

    $rootScope.recuperarCodigosPromo = function () {

        if ( $rootScope.isLogged ) {

            if( $rootScope.misPremiosLoadFirstTime ) {
                $ionicLoading.show();
            }

            GoldcarService.getCodigosPromo().then(function (result) {

                $scope.listaCodigosPromo = result.data;
                if( $rootScope.misPremiosLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $rootScope.misPremiosLoadFirstTime = false;
            }, function (error) {

                if( $rootScope.misPremiosLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $log.error("Error getCodigosPromo: ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            });

            if( !$rootScope.misPremiosLoadFirstTime )
                $rootScope.$broadcast('scroll.refreshComplete');
        }
    };

    //--------------------------
    // MIS PREMIOS
    //--------------------------

    $rootScope.recuperarCodigoPromoBienvenida = function () {

        if ( $rootScope.isLogged ) {

            if( $rootScope.regaloBienvenidaLoadFirstTime ) {
                $ionicLoading.show();
            }

            GoldcarService.getCodigosPromo().then(function (result) {

                for ( var i = 0; i != result.data.length; i++ ) {

                    if ( result.data[i].Tipo == 'codigo_promocional_bienvenida' ) {

                        $scope.codigoPromoBienvenida = result.data[i];
                    }
                }

                $scope.getPuntosUsuario();
                if( $rootScope.regaloBienvenidaLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $rootScope.regaloBienvenidaLoadFirstTime = false;
            }, function (error) {

                if( $rootScope.regaloBienvenidaLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $log.error("Error getCodigosPromo: ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            })
        }

        if( !$rootScope.regaloBienvenidaLoadFirstTime )
            $rootScope.$broadcast('scroll.refreshComplete');
    };

    //--------------------------
    // COPIAR PORTAPAPELES
    //--------------------------

    $rootScope.copiarPortapapeles = function (texto) {

          $cordovaClipboard.copy(texto).then(function (result) {

              $cordovaToast.show($filter("translate")($rootScope.translations.toasts.codigo_portapapeles), 'long', 'bottom').then(function (result) {

                  $log.debug("Toast", result);
              }, function (error) {

                  $log.error("Error mostrando toast CopiarPortapapeles: ", error);
              });
              $log.debug("Copy", result);
          }, function (error) {

              $log.error("Error al copiar al portapapeles: ", error);
          })
    };

    //--------------------------
    // GOLDCAR GUIDEGO
    //--------------------------

    $scope.irGuideGo = function () {
        var lang = 'en-GB';
        if($rootScope.config.guidego_maplangs[$rootScope.language])
            lang = $rootScope.config.guidego_maplangs[$rootScope.language];

        var url = "http://goldcar.guidego.com/welcome/" + lang + "/";

        var options = {
            location: 'no',
            clearcache: 'no',
            toolbar: 'no'
        };

        $cordovaInAppBrowser.open(url, '_system', options)
            .then(function(event) {
                // success
            })
            .catch(function(event) {
                // error
            });
    };
});