angular.module('goldcar').controller('MisPromocionesCtrl', function($scope, $ionicModal, $ionicLoading, $rootScope, $log, $ionicPopup, GoldcarService) {

    //---------------------------------
    // MIS PROMOCIONES
    //---------------------------------

    $rootScope.recuperarPromociones = function () {

        if ( $rootScope.isLogged ) {

            if( $rootScope.misPromocionesLoadFirstTime ) {
                $ionicLoading.show();
            }

            GoldcarService.getPromociones().then(function (result) {

                $rootScope.listaPromociones = result.data;
                if( $rootScope.misPromocionesLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $rootScope.misPromocionesLoadFirstTime = false;
            }, function (error) {

                if( $rootScope.misPromocionesLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $log.error("Error getPromociones: ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            });

            if( !$rootScope.misPromocionesLoadFirstTime )
                $rootScope.$broadcast('scroll.refreshComplete');
        }
    };

    //---------------------------------
    // DETALLES DE PROMOCION
    //---------------------------------

    $scope.abrirDetallesPromo = function (idPromo) {

        if ( $rootScope.isLogged ) {

            $ionicLoading.show();

            var recuperarDetallesPromo = function (idPromo) {

                var modificarSrcVideos = function (texto) {

                    var regex = /(src="http:\/\/)/g;
                    var regex1 = /(src="https:\/\/)/g;
                    var matches = texto.match(regex);
                    var matches1 = texto.match(regex1);

                    if ( matches == null && matches1 == null ) {

                        return texto = texto.replace('src="', 'src="http:');
                    }

                    return texto;
                };

                GoldcarService.getPromo(idPromo).then(function (result) {

                    $rootScope.detallesPromo = result.data;

                    if ( $rootScope.detallesPromo.Descripcion ) {

                        $rootScope.detallesPromo.Descripcion = modificarSrcVideos($rootScope.detallesPromo.Descripcion);
                    }
                    $rootScope.modalDetallesPromo.show();
                    $ionicLoading.hide();
                }, function (error) {

                    $log.error("Error getPromo: ", error);
                })
            };

            if ( typeof $scope.modalDetallesPromo === "undefined" ) {

                $ionicModal.fromTemplateUrl('templates/goldcar_club/detalles_promo.html', {

                    vista: "Detalles Promo",
                    scope: $rootScope,
                    animation: 'slide-in-right'
                }).then(function(modalDetallesPromo) {

                    $rootScope.modalDetallesPromo = modalDetallesPromo;
                    recuperarDetallesPromo(idPromo);
                });
            } else {

                recuperarDetallesPromo(idPromo);
            }
        }
    };
});