angular.module('goldcar').controller('MisPuntosCtrl', function($filter, $scope, $ionicModal, $ionicLoading, $rootScope, $log, $ionicPopup, GoldcarService, $cordovaDatePicker, $ionicBackdrop) {

    //--------------------------
    // MIS PUNTOS
    //--------------------------

    $scope.getPuntosUsuario = function () {

        if ( $rootScope.isLogged ) {

            GoldcarService.getUsuario().then(function (result) {

                $log.debug("getUsuario", result);
                $rootScope.usuarioCanjeos = result.data;
                $scope.puntosUsuario = result.data.Puntosclub;

                if ( $scope.puntosUsuario <= 0) {

                    $scope.hayPuntos = false;
                } else {

                    $scope.hayPuntos = true;
                }
            }, function (error) {

                $log.debug("Fallo en getUsuario: ", error);
            });
        }
    };

    $rootScope.misPuntos = function () {

        if ( $rootScope.isLogged ) {

            if( $rootScope.misPuntosLoadFirstTime ) {
                $ionicLoading.show();
            }

            GoldcarService.getPuntos().then(function (result) {

                $rootScope.historicoPuntos = result.data;
                $scope.getPuntosUsuario();
                if( $rootScope.misPuntosLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $rootScope.misPuntosLoadFirstTime = false;
            }, function (error) {

                if( $rootScope.misPuntosLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $log.error("Error en la funcion getPuntos: ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            });

            if( !$rootScope.misPuntosLoadFirstTime )
                $rootScope.$broadcast('scroll.refreshComplete');
        }
    };

    //--------------------------
    // RECUPERAR PUNTOS
    //--------------------------

    $rootScope.abrirRecuperarPuntos = function () {

        if ( typeof $scope.modalRecuperarPuntos === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/goldcar_club/recuperar_puntos.html', {

                vista: "Recuperar Puntos",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalRecuperarPuntos) {

                $rootScope.modalRecuperarPuntos = modalRecuperarPuntos;
                modalRecuperarPuntos.show();
            });
        } else {

            $rootScope.modalRecuperarPuntos.show();
        }
    };

    $rootScope.recuperarPuntos = function (fechaRecogida, idReserva) {

        GoldcarService.putRecuperarPuntos(fechaRecogida, idReserva).then(function (result) {

            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.recuperando), template: $filter("translate")($rootScope.translations.alertas.revisando_datos) });
        }, function (error) {

            $log.debug("Error en putRecuperarPuntos: ", error);
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
        })
    };

    $rootScope.recuperar = [];

    $rootScope.seleccionarFecha = function() {

        var options = {
            date: new Date(),
            mode: 'date',
            allowOldDates: true,
            androidTheme: 3
        };

        $cordovaDatePicker.show(options).then(function(date){

            moment.locale($rootScope.config.mapeo_moment[$rootScope.language]);
            var dia = moment(date).format('DD [' + $filter("translate")($rootScope.translations.general.fecha_de) + '] MMMM [' + $filter("translate")($rootScope.translations.general.fecha_del) + '] YYYY');
            var fechaFormateada = moment(date).format('YYYY[-]MM[-]DD');
            $rootScope.recuperar.fecha = dia;
            $rootScope.recuperar.fechaFormateada = fechaFormateada;
        });
    };

    //--------------------------
    // CANJEAR PUNTOS
    //--------------------------

    $rootScope.abrirCanjearPuntos = function () {

        if ( typeof $scope.modalCanjearPuntos === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/goldcar_club/canjear_puntos.html', {

                vista: "Canjear Puntos",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalCanjearPuntos) {

                $rootScope.modalCanjearPuntos = modalCanjearPuntos;
                $rootScope.recuperarListaPremios();
            });
        } else {

            $rootScope.recuperarListaPremios();
        }
    };

    $rootScope.recuperarListaPremios = function () {

        if ( $rootScope.isLogged ) {

            $rootScope.modalCanjearPuntos.show();

            if( $rootScope.listaPremiosLoadFirstTime ) {
                $ionicLoading.show();
            }

            GoldcarService.getPremios().then(function (result) {

                $rootScope.listaTodosPremios = result.data;
                if( $rootScope.listaPremiosLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $rootScope.listaPremiosLoadFirstTime = false;
            }, function (error) {

                if( $rootScope.listaPremiosLoadFirstTime ) {
                    $ionicLoading.hide();
                }
                $log.debug("Error en getPremios: ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            });

            if( !$rootScope.listaPremiosLoadFirstTime ){

                $rootScope.$broadcast('scroll.refreshComplete');
                $ionicBackdrop.release();
            }
        }
    };

    $rootScope.checkPremio = [];

    $rootScope.abrirModalDatosCanjear = function (idPremio) {

        $rootScope.premioSeleccionado = idPremio;

        $rootScope.canjeo = {};

        $rootScope.canjeo.nombre = $rootScope.usuarioCanjeos.Nombre;
        $rootScope.canjeo.apellidos = $rootScope.usuarioCanjeos.Apellidos;
        $rootScope.canjeo.email = $rootScope.usuarioCanjeos.Email;
        $rootScope.canjeo.direccion = $rootScope.usuarioCanjeos.Direccion;
        $rootScope.canjeo.poblacion = $rootScope.usuarioCanjeos.Poblacion;
        $rootScope.canjeo.provincia = $rootScope.usuarioCanjeos.Provincia;
        $rootScope.canjeo.codigo_postal = $rootScope.usuarioCanjeos.Cpostal;

        $rootScope.canjeo.numero_calle = "";
        $rootScope.canjeo.piso = "";
        $rootScope.canjeo.puerta = "";

        if ( typeof $rootScope.modalDatosCanjear === 'undefined' ) {

            $ionicModal.fromTemplateUrl('templates/goldcar_club/modal_datos_canjear.html', {

                vista: "Formulario canjear premio",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalDatosCanjear) {

                $rootScope.modalDatosCanjear = modalDatosCanjear;
                modalDatosCanjear.show();
            });
        } else {

            $rootScope.modalDatosCanjear.show();
        }
    };

    $rootScope.cerrarModalDatosCanjear = function () {

        $rootScope.modalDatosCanjear.remove();
        $rootScope.modalDatosCanjear = undefined;
    };

    $rootScope.abrirPopupCanjear = function (idPremio) {

        var canjearPremios = function (idPremio) {

            $rootScope.checkPremio.canjear = false;

            GoldcarService.putPremio(idPremio, $scope.canjeo).then(function (result) {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.canjeado), template: $filter("translate")($rootScope.translations.alertas.premio_canjeado) });
                $scope.getPuntosUsuario();
                $rootScope.misPuntos();
                $rootScope.cerrarModalDatosCanjear();
            }, function (error) {

                $log.debug("Error en putPremio: ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            })
        };

        $ionicPopup.show({

            template: '<md-checkbox ng-model="checkPremio.canjear">' + $filter("translate")($rootScope.translations.club_goldcar.quiero_canjear) + '</md-checkbox>',
            title: $filter("translate")($rootScope.translations.club_goldcar.canjear_puntos),
            subTitle: $filter("translate")($rootScope.translations.alertas.confirmar_canjear),
            scope: $rootScope,
            buttons: [
                {
                    text: $filter("translate")($rootScope.translations.general.cancelar),
                    type: 'button-assertive',
                    onTap: $ionicPopup.show().close()
                },
                {
                    text: '<b>' + $filter("translate")($rootScope.translations.general.canjear) + '</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        if ( $rootScope.checkPremio.canjear != true ) {

                            e.preventDefault();
                        } else {

                            canjearPremios(idPremio);
                        }
                    }
                }
            ]
        });
    };

    $rootScope.mostrarInfoPremios = false;
    $rootScope.abrirInfoPremio = function (texto){
        $rootScope.mostrarInfoPremios = !$rootScope.mostrarInfoPremios;
        if(typeof texto !== 'undefined' && $rootScope.mostrarInfoPremios) $rootScope.descripcion = texto;
    }
});