angular.module('goldcar').factory('calendarFactory', function($q, $ionicLoading, $rootScope, GoldcarService, $ionicScrollDelegate, $filter) {

    var meses = [
        $filter("translate")($rootScope.translations.meses.enero), 
        $filter("translate")($rootScope.translations.meses.febrero), 
        $filter("translate")($rootScope.translations.meses.marzo), 
        $filter("translate")($rootScope.translations.meses.abril), 
        $filter("translate")($rootScope.translations.meses.mayo), 
        $filter("translate")($rootScope.translations.meses.junio), 
        $filter("translate")($rootScope.translations.meses.julio), 
        $filter("translate")($rootScope.translations.meses.agosto), 
        $filter("translate")($rootScope.translations.meses.septiembre), 
        $filter("translate")($rootScope.translations.meses.octubre), 
        $filter("translate")($rootScope.translations.meses.noviembre), 
        $filter("translate")($rootScope.translations.meses.diciembre)
    ];

    var listaFechas = [];
    var valAnterior = 0;

    var lastPosition = 0;
    var ultimoMes = 0;
    var ultimoAnyo = 0;

    var fechasNoValidasDev = [];

    var factoryFunctions = {
        // GENERAR CALENDARIO //
        crearCalendario: function() {

            var defered = $q.defer();
            var promise = defered.promise;

            $rootScope.cambiarTitulo($filter("translate")($rootScope.translations.home.fecha_recogida));

            /// ------- ///

            $rootScope.fechaRecogida = "";
            $rootScope.diaRecogida = "";
            $rootScope.fechaEntrega = "";
            $rootScope.diaEntrega = "";

            listaFechas = [];
            valAnterior = 0;

            fechasNoValidasDev = [];

            $rootScope.tipoDeSeleccion = 'recogida';

            // console.log("$rootScope.tipoDeSeleccion", $rootScope.tipoDeSeleccion);

            $rootScope.elegidaFechaRecogida = false;
            $rootScope.elegidaFechaDevolucion = false;

            /// -------- ///

            $(".calendar-container").datepicker({
                monthNames: meses,
                firstDay: 1,
                defaultDate: moment().format('YYYY-MM-DD'),
                onSelect: function(date) {
                    
                    factoryFunctions.bloqueoCalendario(true);

                    $ionicLoading.show();

                    if ( $rootScope.tipoDeSeleccion == 'recogida' ) { // AL SELECCIONAR LA FECHA DE RECOGIDA

                        $rootScope.cambiarTitulo($filter("translate")($rootScope.translations.home.fecha_entrega));

                        $rootScope.fechaRecogida = date;
                        
                        $rootScope.diaRecogida = moment($rootScope.fechaRecogida).format('D MMM');

                        $rootScope.tipoAnimacion('recogida');
                        $rootScope.tipoDeSeleccion = 'entrega';

                        var selectedDay = moment(date).format('YYYY-MM-DD');
                        $(".calendar-container").datepicker('selectedDay', selectedDay);

                        factoryFunctions.obtenerFechasDevolucion($rootScope.nuevaReserva.lugarEntregaCodigo).then(function(){
                            $rootScope.abrirSeleccionDeHoras('recogida');
                            factoryFunctions.bloqueoCalendario(false);
                            // $ionicLoading.hide();
                        });
                    } else if ( $rootScope.tipoDeSeleccion == 'entrega' ) { // AL SELECCIONAR LA FECHA DE DEVOLUCION

                        $rootScope.fechaEntrega = date;
                        
                        $rootScope.diaEntrega = moment($rootScope.fechaEntrega).format('D MMM');

                        $rootScope.tipoAnimacion('entrega');

                        var selectedLastDay = moment(date).format('YYYY-MM-DD');
                        $(".calendar-container").datepicker('selectedLastDay', selectedLastDay);

                        setTimeout(function() {

                            $rootScope.abrirSeleccionDeHoras('entrega');
                            factoryFunctions.bloqueoCalendario(false);
                            // $ionicLoading.hide();
                        }, 500);
                    }
                }
            });

            $(".calendar-container").datepicker('show');

            defered.resolve({ 'status': 1 });

            return promise;
        },
        // GENERAR CALENDARIO //
        abrirCalendario: function(type) {

            var defered = $q.defer();
            var promise = defered.promise;

            if(typeof type !== 'undefined' && type == 'recogida') $rootScope.cambiarTitulo($filter("translate")($rootScope.translations.home.fecha_recogida));
            else if(typeof type !== 'undefined' && type == 'entrega') $rootScope.cambiarTitulo($filter("translate")($rootScope.translations.home.fecha_entrega));

            /// ------- ///

            listaFechas = [];
            valAnterior = 0;

            fechasNoValidasDev = [];

            $rootScope.tipoDeSeleccion = type;

            /// -------- ///

            $(".calendar-container").datepicker({
                monthNames: meses,
                firstDay: 1,
                defaultDate: moment().format('YYYY-MM-DD'),
                onSelect: function(date) {
                    
                    $ionicLoading.show();

                    factoryFunctions.bloqueoCalendario(true);

                    if ( $rootScope.tipoDeSeleccion == 'recogida' ) { // AL SELECCIONAR LA FECHA DE RECOGIDA

                        $rootScope.fechaRecogida = date;                        
                        $rootScope.diaRecogida = moment($rootScope.fechaRecogida).format('D MMM');

                        $rootScope.tipoAnimacion($rootScope.tipoDeSeleccion);

                        var selectedDay = moment(date).format('YYYY-MM-DD');
                        $(".calendar-container").datepicker('selectedDay', selectedDay);

                        factoryFunctions.obtenerFechasDevolucion($rootScope.nuevaReserva.lugarEntregaCodigo).then(function(){
                            $rootScope.abrirSeleccionDeHoras($rootScope.tipoDeSeleccion);
                            factoryFunctions.bloqueoCalendario(false);
                            $rootScope.tipoDeSeleccion = 'entrega';
                            // $ionicLoading.hide();
                        });

                    } else if ( $rootScope.tipoDeSeleccion == 'entrega' ) { // AL SELECCIONAR LA FECHA DE DEVOLUCION

                        $rootScope.fechaEntrega = date;
                        
                        $rootScope.diaEntrega = moment($rootScope.fechaEntrega).format('D MMM');

                        $rootScope.tipoAnimacion($rootScope.tipoDeSeleccion);

                        var selectedLastDay = moment(date).format('YYYY-MM-DD');
                        $(".calendar-container").datepicker('selectedLastDay', selectedLastDay);

                        setTimeout(function() {
                            $rootScope.abrirSeleccionDeHoras($rootScope.tipoDeSeleccion);
                            factoryFunctions.bloqueoCalendario(false);
                            // $ionicLoading.hide();
                        }, 500);
                    }
                }
            });

            $(".calendar-container").datepicker('show');

            defered.resolve({ 'status': 1 });

            return promise;
        },
        // OBTENER PRIMERAS FECHAS //
        obtenerFechasRecogida: function(oficinaCode, reset) {

            var defered = $q.defer();
            var promise = defered.promise;

            // $ionicLoading.show();

            try{
                if (reset) {
                    listaFechas = [];
                    fechasNoValidasDev = [];
                }
    
                GoldcarService.getCalendario(oficinaCode, $rootScope.tipoDeSeleccion).then(function(result) {
                    console.log(result);

                    for (var i = 0; i < result.data.length; i++) {
                        for (var l = 0; l < result.data[i].dias.length; l++) {
                            if (!factoryFunctions.parseBool(result.data[i].dias[l].estado)) listaFechas.push(result.data[i].dias[l].fecha);
                            // if (l == result.data[i].dias.length - 1 && i == result.data.length - 2) ultimaFechaObtenida = result.data[i].dias[l].fecha;
                        }
                        if(i == result.data.length - 1) {
                            // console.log("AÑO MES", result.data[i].anyo + ' ' + result.data[i].mes);
                            // console.log("DIV AÑO MES", $("div[data-year='" + result.data[i].anyo + "'][data-month='" + result.data[i].mes + "']"));
                            // console.log("OFFSET TOP AÑO MES + 1", $("div[data-year='" + result.data[i].anyo + "'][data-month='" + (parseInt(result.data[i].mes) + 1) + "']").offset().top);
                            // console.log("FIRST SCROLL POSITION", $ionicScrollDelegate.$getByHandle('scrollFechas').getScrollPosition());
                            if(result.data[i].mes < 12) {
                                ultimoMes = parseInt(result.data[i].mes) + 1;
                                ultimoAnyo = result.data[i].anyo;
                            }
                            else {
                                ultimoMes = 1;
                                ultimoAnyo = parseInt(result.data[i].anyo) + 1;
                            }
                            lastPosition = parseInt($("div[data-year='" + ultimoAnyo + "'][data-month='" + ultimoMes + "']").position().top);
                        }
                        // console.log(listaFechas);
                        // console.log(result.data[i]);
                    }
                    $('.calendar-container').datepicker('addInvalidDates', listaFechas);
                    defered.resolve();
                });
            }catch(err){
                defered.reject();
            }

            return promise;
        },
        // OBTENER FECHAS OFICINA DEVOLUCION //
        obtenerFechasDevolucion: function(oficinaCode) {
            var defered = $q.defer();
            var promise = defered.promise;


            try{
                GoldcarService.getCalendarioOficina(oficinaCode, $rootScope.fechaRecogida, 'entrega').then(function(result) {
                    for ( var i = 0; i < result.data.length; i++ ) {
                        for ( var l = 0; l < result.data[i].dias.length; l++ ) {
                            if ( result.data[i].dias[l].estado == true ) {
                                listaFechas.push(result.data[i].dias[l].fecha);
                            } else {
                                fechasNoValidasDev.push(result.data[i].dias[l].fecha);
                            }
                        }
                    }

                    $('.calendar-container').datepicker('addValidDates', listaFechas);
                    $('.calendar-container').datepicker('addInvalidDates', fechasNoValidasDev);

                    // $ionicLoading.hide();
                    defered.resolve();
                });
            }catch(err){
                defered.reject();
            }

            return promise;
        },
        // OBTENER MAS FECHAS AL HACER SCROLL EN EL CALENDARIO //
        obtenerNuevasFechas: function(oficinaCode) {
            var defered = $q.defer();
            var promise = defered.promise;

            // $ionicLoading.show();

            $('.content-fechas').scroll(function() {
                try{
                    if ( $rootScope.tipoDeSeleccion == 'recogida' ) {
                        var infoScroll = $("div[data-year='" + ultimoAnyo + "'][data-month='" + ultimoMes + "']").offset().top;

                        if(parseInt(lastPosition) == parseInt(infoScroll) || (parseInt(lastPosition) > parseInt(infoScroll) && parseInt(lastPosition) < parseInt(infoScroll) + 300)) {
                            $ionicScrollDelegate.$getByHandle('scrollFechas').freezeAllScrolls(true);
                            $('.content-fechas').css({'pointer-events': 'none', 'overflow-y': 'hidden'});
                            $ionicLoading.show();
                            var newDate = ultimoAnyo + '/' + ultimoMes + '/01';
                            GoldcarService.getCalendarioOficina(oficinaCode, newDate, $rootScope.tipoDeSeleccion).then(function(result) {
                                $ionicLoading.hide();
                                for (var i = 0; i < result.data.length; i++) {
                                    for (var l = 0; l < result.data[i].dias.length; l++) {
                                        if (!factoryFunctions.parseBool(result.data[i].dias[l].estado)) listaFechas.push(result.data[i].dias[l].fecha);
                                    }
                                    if(i == result.data.length - 1) {
                                        if(parseInt(result.data[i].mes) < 12) {
                                            ultimoMes = parseInt(result.data[i].mes) + 1;
                                            ultimoAnyo = result.data[i].anyo;
                                        }
                                        else {
                                            ultimoMes = 1;
                                            ultimoAnyo = parseInt(result.data[i].anyo) + 1;
                                        }
                                        lastPosition = parseInt($("div[data-year='" + ultimoAnyo + "'][data-month='" + ultimoMes + "']").position().top) - parseInt(lastPosition);
                                    }
                                }
                                $('.calendar-container').datepicker('addInvalidDates', listaFechas);

                                $ionicScrollDelegate.$getByHandle('scrollFechas').freezeAllScrolls(false);
                                $('.content-fechas').css({'pointer-events': 'auto', 'overflow-y': 'auto'});
                                defered.resolve();
                                // $ionicLoading.hide();
                            })
                                .catch(function (err) {
                                    $ionicScrollDelegate.$getByHandle('scrollFechas').freezeAllScrolls(false);
                                    $('.content-fechas').css({'pointer-events': 'auto', 'overflow-y': 'auto'});
                                    $ionicLoading.hide();
                                });
                        }
                    }
                }catch(err){
                    defered.reject();   
                }
            });
            return promise;
        },
        bloqueoCalendario: function(status){
            if(status) $('.sys-datepicker-day').css({'pointer-events': 'none'});
            else $('.sys-datepicker-day').css({'pointer-events': ''});
        },
        seleccionarFechaRecogida: function(date){
            var defered = $q.defer();
            var promise = defered.promise;

            try{
                $rootScope.cambiarTitulo($filter("translate")($rootScope.translations.home.fecha_entrega));
    
                $rootScope.fechaRecogida = date;
                $rootScope.diaRecogida = moment($rootScope.fechaRecogida).format('D MMM');
    
                $rootScope.tipoAnimacion('recogida');
    
                $(".calendar-container").datepicker('selectedDay', date);
    
                factoryFunctions.obtenerFechasDevolucion($rootScope.nuevaReserva.lugarEntregaCodigo).then(function(){
                    factoryFunctions.bloqueoCalendario(false);
                    $rootScope.tipoDeSeleccion = 'entrega';
                    // $ionicLoading.hide();
                    defered.resolve();
                });
            }catch(err){
                defered.reject();
            }
            return promise;
        },
        seleccionarFechaDevolucion: function(date){
            var defered = $q.defer();
            var promise = defered.promise;

            try{
                $rootScope.fechaEntrega = date;
                $rootScope.diaEntrega = moment($rootScope.fechaEntrega).format('D MMM');
                $rootScope.horaRSeleccionada = true;
                $rootScope.horaDSeleccionada = false;
    
                $rootScope.tipoAnimacion('entrega');
    
                $(".calendar-container").datepicker('selectedLastDay', date);
                
                factoryFunctions.bloqueoCalendario(false);
                // $ionicLoading.hide();
                defered.resolve();
            }catch(err){
                defered.reject();
            }
            return promise;
        },
        parseBool: function (data) {
            if(data === 0 || (typeof data == "string" && data === 'false')) return false;
            else if (data === 1 || (typeof data == "string" && data === 'true')) return true;
            else return data;
        }
    };

    return factoryFunctions;
});
