angular.module('goldcar').controller('HomeCtrl', function($filter, $scope, $ionicModal, $rootScope, $compile, $ionicLoading, $location, JsonService, GoldcarService, $cordovaInAppBrowser, $cordovaDatePicker, $ionicSlideBoxDelegate, $ionicPopup, $log, Session, $state, ionicDatePicker, ionicTimePicker, $ionicScrollDelegate, $cordovaToast, calendarFactory, $q, $timeout) {

    $rootScope.fechaRecogida = "";
    $rootScope.fechaEntrega = "";
    $rootScope.busquedaNueva = { "texto": null };

    //------------------------------//
    // CARGAR BACKGROUNDS DINAMICOS //
    //------------------------------//
    var background_day = [];
    var background_night = [];
    var textoImg = "";

    $scope.cargarBackgrounds = function() {
        JsonService.getBackgrounds('background').then(function(data) {
            for (var i = 0; i < data.length; i++) {
                if (data[i].tags.indexOf('day') > 0) background_day.push(data[i].banner);
                if (data[i].tags.indexOf('night') > 0) background_night.push(data[i].banner);
            }

            if ( moment().hours() < 20 && moment().hours() > 7 ) {
                var random = Math.floor(Math.random()*background_day.length);
                $scope.back_img = background_day[random];
                $scope.esDeDia = true;
            } else {
                var random = Math.floor(Math.random()*background_night.length);
                $scope.back_img = background_night[random];
                $scope.esDeDia = false;
            }

            if(typeof data[random] !== 'undefined' && data[random].title) $scope.textoImg = data[random].title;
            else $scope.textoImg = false;
        });
    }

    // $rootScope.mostrarAlerta = false;

    $rootScope.cerrarAlerta = function () {

        $('.banner-no-logged').velocity({opacity: 0});
        $.Velocity.animate($('.banner-no-logged'), {height: 0, padding: 0}, {delay: 100}).then(function() {
            $rootScope.mostrarAlerta = false;
            $scope.mostrarExclamacion = true;
            $ionicScrollDelegate.$getByHandle('home_content').resize();
            $scope.$apply();
        });
    };

    $rootScope.tituloDateAndTime = $filter("translate")($rootScope.translations.home.fecha_recogida);

    $rootScope.cambiarTitulo = function(texto) {

        $.Velocity.animate($('.all-titles'), { opacity: 0 }).then(function (element) {

            $rootScope.tituloDateAndTime = texto;
            $('.all-titles').velocity({ opacity: 1 }, { delay: 300 });
        });
    }

    if (typeof $rootScope.mostrarAlerta === 'undefined'){
        $rootScope.mostrarAlerta = true;
    } else {
        $rootScope.cerrarAlerta();
    }

    //---------------------------
    // CARGAR BANNERS HOME
    //---------------------------

    $rootScope.cargarBannersHome = function(){
        $rootScope.estadoBannersHome = 2;        // estadoBannersHome = 2 -> CARGANDO
        var time = 0;

        if ( typeof $rootScope.language === "undefined" )
            time = 1000;

        setTimeout(function () {
            JsonService.getBanners('HomeReserva').then(function (banners) {
                $rootScope.bannersHome = [];
                $rootScope.bannersHome = banners;
                $rootScope.bannersHome.forEach(function (banner) {
                    if ( banner.url ){
                        var link = banner.url;
                        link = link.split('/');
                        for(var i=0; i<link.length; i++) {
                            if( link[i].indexOf('pickupplace') >= 0 ){
                                banner.pickupplace = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('dropoffplace') >= 0 ){
                                banner.dropoffplace = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('pickupdate') >= 0 ){
                                banner.pickupdate = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('dropoffdate') >= 0 ){
                                banner.dropoffate = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('vista') >= 0 ){
                                banner.vista = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('modal') >= 0 ){
                                banner.modal = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('link') >= 0 ){
                                banner.link = link[i+1];
                                i++;
                            }
                            if( link[i].indexOf('nolink') >= 0){
                                banner.nolink = link[i+1];
                                i++;
                            }
                        }
                    }
                });
                if(typeof banners[0] === "undefined"){
                    $rootScope.bannersHomeText = $filter("translate")($rootScope.translations.home.sin_ofertas);
                    $rootScope.estadoBannersHome = 0;                   // estadoBannersHome = 0 -> VACIO
                }
                else
                    $rootScope.estadoBannersHome = 1;                   // estadoBannersHome = 1 -> RELLENADO

                $ionicSlideBoxDelegate.update();
            });
        }, time);
    };

    // --------------------------------------- //
    // COMPROBAR SI HAY RESERVAS EN BACKGROUND //
    // --------------------------------------- //

    $rootScope.reservaDisfrutando = "";

    $rootScope.checkReservas = function(){

        if( typeof localStorage['user'] !== 'undefined' && $rootScope.someBookingLoaded ) {

            $rootScope.someBooking = false;

            setTimeout(function () {
                GoldcarService.getReservasActivas().then(function (result) {

                    if (result.data.length > 0) {
                        $rootScope.someBooking = true;
                        return true;
                    }

                    if (result.data.length > 0) {
                        result.data.forEach(function (reserva) {
                            var now = new Date().getTime();
                            var diffHoursRecogida = reserva.Pickupdate;
                            var diffHoursEntrega = reserva.Dropoffdate;

                            if (reserva.Estado == 2 || reserva.Estado == 5) {

                                if (now > diffHoursRecogida && now < diffHoursEntrega) {
                                    $rootScope.someBooking = true;
                                    $rootScope.tieneReservasDisfrutando = true;
                                    for ( var i = 0; i < $rootScope.config.oficinas_franquicia.length; i++ ) {

                                        if ( reserva.pickupplace.Codigo != $rootScope.config.oficinas_franquicia[i] ) {

                                            $rootScope.mostrarAsistenciaCompleta = true;
                                        }
                                    }
                                    // $rootScope.reservaDisfrutando = reserva;
                                    return true;
                                } else {

                                    $rootScope.tieneReservasDisfrutando = false;
                                }
                            }
                        });
                    }

                    reservasPosiblementeActivas();
                },
                    function (error) {
                        $log.debug("Error cargando reservasActivas: " + error);
                        reservasPosiblementeActivas();
                    }
                );
            },2000);
        }

        var reservasPosiblementeActivas = function(){

            GoldcarService.getReservasAnteriores().then(function (result) {

                if(result.data.length > 0){
                    result.data.forEach(function (reserva) {
                        var now = new Date().getTime();
                        var diffHoursRecogida = reserva.Pickupdate;
                        var diffHoursEntrega = reserva.Dropoffdate;

                        if(reserva.Estado == 2 || reserva.Estado == 5){

                            if(now > diffHoursRecogida && now < diffHoursEntrega) {
                                $rootScope.someBooking = true;
                                $rootScope.tieneReservasDisfrutando = true;
                                for ( var i = 0; i < $rootScope.config.oficinas_franquicia.length; i++ ) {

                                    if ( reserva.Pickupplace.Codigo != $rootScope.config.oficinas_franquicia[i] ) {

                                        $rootScope.mostrarAsistenciaCompleta = true;
                                    }
                                }
                                // $rootScope.reservaDisfrutando = reserva;
                                return true;
                            } else {

                                $rootScope.tieneReservasDisfrutando = false;
                            }
                        }
                    });
                }
            },
            function(error){
                $log.debug("Error con reservasAnteriores: " + error);
            });
        };
    };

// -------------- //
// HORAS Y FECHAS //
// -------------- //

    $scope.check = [];
    $scope.mesesConsultados = [];
    $rootScope.diasInvalidos = [];
    $rootScope.horasInvalidas = [];

    $scope.redondeoHora = function (hora) {

        if ( hora.get('minute') == 30 || hora.get('minute') == 0) {

            hora = hora.add(30, 'm');

        } else if ( hora.get('minute') < 30 ) {

            var minutos = hora.get('minute');
            hora = hora.subtract(minutos, 'minutes');
            hora = hora.add(30, 'm');

        } else if ( hora.get('minute') > 30 ) {

            var resta = hora.get('minute') - 30;
            hora = hora.subtract(resta, 'minutes');
            hora = hora.add(30, 'm');

        }

        return hora;
    };

    $scope.getMeses = function (fecha) {

        var date = new Date(fecha);
        var now = new Date();

        if ( date.getYear() > now.getYear() || ((date.getMonth()+1) >= (now.getMonth()+1) && date.getYear() == now.getYear()) ){

            $ionicLoading.show({
                template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.cargando_calendario) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
            });

            GoldcarService.getCalendarioOficina($rootScope.oficinaConsultada, fecha, $rootScope.tipoDeOficina).then(
                function (result) {

                    var mesesConsultados = [];
                    var dates = [];

                    if ( $scope.mesesConsultados[$rootScope.oficinaConsultada] )
                        mesesConsultados = $scope.mesesConsultados[$rootScope.oficinaConsultada];

                    var calendarioRecogida = result.data;

                    calendarioRecogida.forEach(function (mes) {

                        var nuevoMes = mes.abreviatura + "-" + mes.anyo;
                        var existe = false;

                        for (var i = 0; i < mesesConsultados.length; i++){
                            if (mesesConsultados[i] == nuevoMes)
                                existe = true;
                        }

                        if (!existe)
                            mesesConsultados.push(nuevoMes);

                        mes.dias.forEach(function (dia) {
                            if(dia.estado === false){ // CAMBIAR A FALSE PARA RESULTADO REAL
                                var fechaInvalida = dia.fecha;
                                var date = new Date(fechaInvalida);
                                dates.push(date.getTime());
                            }
                        });
                        $rootScope.diasInvalidos[$rootScope.oficinaConsultada] = dates;
                    });

                    mesesConsultados.pop();
                    $scope.mesesConsultados[$rootScope.oficinaConsultada] = mesesConsultados;

                    if ( !angular.element( document.querySelector( '.ionic_datepicker_popup') ).length )
                        $scope.openDatePicker();
                    else{
                        ionicDatePicker.refreshInvalidDates($rootScope.diasInvalidos[$rootScope.oficinaConsultada]);
                    }

                    $ionicLoading.hide();
                },
                function (error) {
                    $ionicLoading.hide();
                    $log.debug("Error trayendo calendario oficina " + $rootScope.oficinaConsultada + ": ", error);
                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                }
            );
        }
    };

    $rootScope.abrirCalendario = function(tipo) {

        if ( tipo == 'buscar' ) {

            $rootScope.enviarReserva();
        } else {

            if ( !$rootScope.nuevaReserva.lugarRecogidaCodigo || typeof $rootScope.nuevaReserva.lugarRecogidaCodigo === 'undefined') {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.titulo_atencion), template: $filter("translate")($rootScope.translations.alertas.error_no_calendar) });
            }

            else {

                $rootScope.tipoDeOficina = tipo;

                if (tipo == 'recogida') {

                    $rootScope.oficinaConsultada = $rootScope.nuevaReserva.lugarRecogidaCodigo;
                } else if (tipo == 'entrega') {

                    $rootScope.oficinaConsultada = $rootScope.nuevaReserva.lugarEntregaCodigo;
                }

                var consultado = false;
                var date = moment($rootScope.fechaRecogida);
                var month = date.format('MMM').toUpperCase()[0] + date.format('MMM').toUpperCase()[1] + date.format('MMM').toUpperCase()[2];
                var year = date.format('YYYY');
                var mes = month + '-' + year;

                if ( $scope.mesesConsultados[$rootScope.oficinaConsultada] ) {

                    $scope.mesesConsultados[$rootScope.oficinaConsultada].forEach(function (mesConsultado) {

                        if (mesConsultado == mes) {

                            consultado = true;
                        }
                    });

                    if ( !consultado ){

                        $scope.getMeses(date);
                    } else {

                        $scope.openDatePicker();
                    }
                } else {
                    $scope.getMeses(date);
                }
            }
        }

    };

    $scope.beforeRefreshDateList = function(currentDate) {

        var date = moment(currentDate);
        var month = date.format('MMM').toUpperCase()[0] + date.format('MMM').toUpperCase()[1] + date.format('MMM').toUpperCase()[2];
        var year = date.format('YYYY');
        var mes = month + '-' + year;
        var consultado = false;

        $log.debug("$scope.mesesConsultados: ", $scope.mesesConsultados);

        $scope.mesesConsultados[$rootScope.oficinaConsultada].forEach(function (mesConsultado) {
            if (mesConsultado == mes) consultado = true;
        });

        if (!consultado)
            $scope.getMeses(currentDate);
    };

    $scope.openDatePicker = function () {

        if ( moment($rootScope.fechaRecogida) < moment() ) {

            $rootScope.fechaRecogida = moment();
        }

        var fechaInicial, fechaMinima, fechaMaxima, fechaMarcada;

        if ($rootScope.tipoDeOficina == 'recogida'){

            fechaMinima = new Date();
            fechaInicial = moment($rootScope.fechaRecogida);
            fechaInicial = fechaInicial.toDate();
            fechaMaxima = null;
            fechaMarcada = null;

            $rootScope.tituloPopUpReservarFecha = $filter("translate")($rootScope.translations.home.fecha_recogida);
        }

        else if ($rootScope.tipoDeOficina == 'entrega'){

            fechaMinima = moment($rootScope.fechaRecogida);
            fechaMinima = fechaMinima.toDate();

            fechaInicial = moment($rootScope.fechaEntrega);
            if ( fechaMinima > fechaInicial )
                fechaInicial = fechaMinima;
            else
                fechaInicial = fechaInicial.toDate();

            fechaMaxima = moment(fechaMinima).add(28, 'd'); // 28 DIAS MAS QUE LA OTRA OPCION
            fechaMaxima = fechaMaxima.toDate();

            fechaMarcada = fechaMinima;

            $rootScope.tituloPopUpReservarFecha = $filter("translate")($rootScope.translations.home.fecha_entrega);
        }

        var calendario = {
            callback: function (val) {
                $log.debug('La fecha seleccionada es: ', new Date(val));

                var date = new Date (val);
                var dia = moment(date).format('D MMM').toUpperCase();

                if ( $rootScope.tipoDeOficina == 'recogida' ){
                    $rootScope.fechaRecogida = moment(date);
                    $rootScope.fechaEntrega = moment(date).add(3, 'd');
                    $rootScope.diaRecogida = dia;
                }

                else if ( $rootScope.tipoDeOficina == 'entrega' ){
                    $rootScope.fechaEntrega = moment(date);
                    $rootScope.diaEntrega = dia;
                }

                $scope.getHoras(new Date(val));
            },
            disabledDates: $rootScope.diasInvalidos[$rootScope.oficinaConsultada],
            weeksList: [$filter("translate")($rootScope.translations.calendario.domingo), $filter("translate")($rootScope.translations.calendario.lunes), $filter("translate")($rootScope.translations.calendario.martes), $filter("translate")($rootScope.translations.calendario.miercoles), $filter("translate")($rootScope.translations.calendario.jueves), $filter("translate")($rootScope.translations.calendario.viernes), $filter("translate")($rootScope.translations.calendario.sabado)],
            monthsList: [$filter("translate")($rootScope.translations.calendario.enero), $filter("translate")($rootScope.translations.calendario.febrero), $filter("translate")($rootScope.translations.calendario.marzo), $filter("translate")($rootScope.translations.calendario.abril), $filter("translate")($rootScope.translations.calendario.mayo), $filter("translate")($rootScope.translations.calendario.junio), $filter("translate")($rootScope.translations.calendario.julio), $filter("translate")($rootScope.translations.calendario.agosto), $filter("translate")($rootScope.translations.calendario.septiembre), $filter("translate")($rootScope.translations.calendario.octubre), $filter("translate")($rootScope.translations.calendario.noviembre), $filter("translate")($rootScope.translations.calendario.diciembre)],
            dateFormat: "dd-MM-yyyy",
            setLabel: $filter("translate")($rootScope.translations.general.seleccionar),
            closeLabel: $filter("translate")($rootScope.translations.general.cancelar),
            from: fechaMinima,
            to: fechaMaxima,
            inputDate: fechaInicial,
            mondayFirst: true,
            closeOnSelect: true,
            templateType: 'popup',
            remarkedDate: fechaMarcada,
            beforeRefreshDateList: $scope.beforeRefreshDateList
        };

        ionicDatePicker.openDatePicker(calendario);
        setTimeout(function () {

            angular.element( document.querySelector( '.button_set' ) ).attr('type', 'button');
            angular.element( document.querySelector( '.button_close' ) ).attr('type', 'button');
        }, 500);
    };

    $scope.getHoras = function (fecha) {

        $ionicLoading.show({
            template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.cargando_horario) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
        });

        GoldcarService.getHorarioOficina($rootScope.oficinaConsultada, fecha, $rootScope.tipoDeOficina).then(
            function (result) {
                var horario = result.data;
                $rootScope.horasInvalidas = [];

                var recogida = $rootScope.fechaRecogida;
                var entrega = $rootScope.fechaEntrega;

                for ( var hora in horario) {

                    if (horario[hora] === false && hora != "23:59"){
                        $rootScope.horasInvalidas.push(hora);
                    }

                    if ( $rootScope.tipoDeOficina == 'entrega' && recogida.toDate().toString() == entrega.toDate().toString() && hora <= $rootScope.horaRecogida){
                        $rootScope.horasInvalidas.push(hora);
                    }
                }

                $ionicLoading.hide();
                $rootScope.abrirHorario();
            },
            function (error) {
                $ionicLoading.hide();
                $log.debug("Error trayendo horario oficina " + $rootScope.oficinaConsultada + ": ", error);
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            });
    };

    $rootScope.abrirHorario = function () {

        setTimeout(function () {

            angular.element( document.querySelector( '.button_set' ) ).attr('type', 'button');
            angular.element( document.querySelector( '.button_close' ) ).attr('type', 'button');
        }, 500);

        var hh, mm, timeArray, meridian;

        if ( $rootScope.tipoDeOficina == 'recogida' ){

            timeArray = $rootScope.horaRecogida;
            $rootScope.tituloPopUpReservarHora = $filter("translate")($rootScope.translations.home.hora_recogida);
        }


        else if ( $rootScope.tipoDeOficina == 'entrega' ){

            timeArray = "10:00"; // LAS 10:00 POR DEFECTO EN LA HORA DE ENTREGA / DEVOLUCIÓN
            $rootScope.tituloPopUpReservarHora = $filter("translate")($rootScope.translations.home.hora_entrega);
        }

        timeArray = timeArray.split(':');

        hh = ( timeArray[0].length == 1 ) ? '0' + timeArray[0] : timeArray[0];
        mm = ( timeArray[1].length == 1 ) ? '0' + timeArray[1] : timeArray[1];

        $log.debug("Hora preexistente -> ", hh, ":", mm);
        meridian = mm[3] + mm[4];

        hh = Number(hh);
        mm = Number(mm[0] + mm[1]);

        if ( meridian == 'PM' )
            hh = hh + 12;

        var horario = {
            callback: function (val) {

                if (typeof (val) === 'undefined') {
                    if ( $rootScope.tipoDeOficina == 'recogida' ) $rootScope.abrirCalendario('recogida');
                    else $rootScope.abrirCalendario('entrega');
                } else {

                    var selectedTime = new Date(val * 1000);
                    var hours = (selectedTime.getUTCHours().toString().length == 1) ? '0' + selectedTime.getUTCHours().toString() : selectedTime.getUTCHours().toString();
                    var minutes = (selectedTime.getUTCMinutes().toString().length == 1) ? '0' + selectedTime.getUTCMinutes().toString() : selectedTime.getUTCMinutes().toString();

                    if ( $rootScope.tipoDeOficina == 'recogida' ){
                        $rootScope.horaRecogida = $rootScope.horaEntrega = hours + ":" + minutes;
                        $rootScope.abrirCalendario('entrega');
                    }
                    else if ( $rootScope.tipoDeOficina == 'entrega' ){
                        $rootScope.horaEntrega = hours + ":" + minutes;
                    }

                }
            },
            inputTime: ((hh * 60 * 60) + (mm * 60)),
            format: 24,
            step: 30,
            setLabel: $filter("translate")($rootScope.translations.general.seleccionar),
            closeLabel: $filter("translate")($rootScope.translations.general.cancelar),
            invalidHours: $rootScope.horasInvalidas
        };

        ionicTimePicker.openTimePicker(horario);
    };

    // -------------------------- //
    // MODAL SELECCIONAR OFICINAS //
    // -------------------------- //

    // CREAR MODAL SELECCIONAR OFICINA RECOGIDA / DEVOLUCION //

    $scope.createModalSeleccionarOficinas = function() {

        if ( typeof $rootScope.modalSeleccionarOficinas === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/home/seleccionar_oficinas.html', {
                vista: "Seleccionar oficinas",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalSeleccionarOficinas) {
                $rootScope.modalSeleccionarOficinas = modalSeleccionarOficinas;
                modalSeleccionarOficinas.show();
                $ionicLoading.hide();
            });
        } else {
            $rootScope.modalSeleccionarOficinas.show();
            $ionicLoading.hide();
        }
    };

    // CERRAR MODAL SELECCIONAR OFICINA RECOGIDA / DEVOLUCION //

    $rootScope.closeModalSeleccionarOficinas = function() {

        $rootScope.busquedaNueva = [];
        $rootScope.modalSeleccionarOficinas.remove();
        $rootScope.modalSeleccionarOficinas = undefined;
    }

    // ABRIR LUGAR DE RECOGIDA //

    $rootScope.abrirRecogida = function(renew){

        $ionicLoading.show();

        $rootScope.busquedaNueva = { "texto": null };

        GoldcarService.getOficinas().then(function (result) {

            $rootScope.oficinasBusqueda = [];

            if ( typeof result !== 'undefined' && typeof result.data != 'undefined' ) {

                if ( typeof result.data.error !== 'undefined' && result.data.error == true ) {

                    $ionicLoading.hide();

                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.titulo_atencion), template: $filter("translate")($rootScope.translations.disponibilidad.no_disponible)});
                } else {

                    result.data.forEach(function (oficina) {

                        $rootScope.oficinasBusqueda.push({
                            "Fullname" : oficina.Fullname,
                            "FullnameSinTildes" : $filter("sinTildes")(oficina.Fullname),
                            "Nombre": oficina.Nombre,
                            "Codigo" : oficina.Codigo,
                            "Tipo" : oficina.Tipo,
                            "busCortesia" : oficina.Buscortesia,
                            "Idpais": oficina.Idpais
                        });
                    });

                    $rootScope.elegirRecogida = 0;

                    $scope.createModalSeleccionarOficinas();
                    // if(renew) $rootScope.cerrarSeleccionDeFechas(true);
                }
            }
        });
    };

    // ABRIR LUGAR DE DEVOLUCION //

    $rootScope.abrirDevolucion = function(oficinaRecogidaCodigo) {

        $ionicLoading.show();

        if ( typeof oficinaRecogidaCodigo === 'undefined' && typeof localStorage['lastOffice'] !== 'undefined' ) {

            oficinaRecogidaCodigo = JSON.parse(localStorage['lastOffice']).lugarRecogidaCodigo;
        }

        GoldcarService.getOficinasDevol(oficinaRecogidaCodigo).then(function (result) {

            $rootScope.oficinasBusqueda = [];

            if ( typeof result !== 'undefined' && typeof result.data != 'undefined' ) {

                if ( typeof result.data.error !== 'undefined' && result.data.error == true ) {

                    $ionicLoading.hide();

                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.titulo_atencion), template: $filter("translate")($rootScope.translations.disponibilidad.no_disponible)});
                } else {

                    result.data.forEach(function (oficina) {

                        $rootScope.oficinasBusqueda.push({
                            "Fullname" : oficina.Fullname,
                            "FullnameSinTildes" : $filter("sinTildes")(oficina.Fullname),
                            "Nombre": oficina.Nombre,
                            "Codigo" : oficina.Codigo,
                            "Tipo" : oficina.Tipo,
                            "busCortesia" : oficina.Buscortesia,
                            "Idpais": oficina.Idpais
                        });
                    });

                    $rootScope.elegirRecogida = 1;

                    $scope.createModalSeleccionarOficinas();
                    $ionicLoading.hide();
                }
            }
        });
    };

    // SELECCIONAR UNA OFICINA DE RECOGIDA DE LA LISTA //
    $rootScope.seleccionaOficinaRecogida = function(codigoOficina, nombreOficina, nombreCorto, tipo, bus, index, from, codigoPais){

        $ionicLoading.show();

        if(typeof $rootScope.modalSeleccionDeFechas !== 'undefined' && $rootScope.modalSeleccionDeFechas.isShown()) $rootScope.cerrarSeleccionDeFechas(true);

        if ( typeof from === 'undefined' || from === '' || from === null) {

            $rootScope.edadModificada = true;
            
            $.Velocity.animate($('.oficina-' + index), { 'background-color': '#EFEFEF' }, { duration: 350 }).then(function() {
    
                $rootScope.nuevaReserva.lugarRecogida = nombreOficina;
                $rootScope.nuevaReserva.lugarEntrega = nombreOficina;
                //$rootScope.nuevaReserva.lugarRecogida = nombreCorto;
                //$rootScope.nuevaReserva.lugarEntrega = nombreCorto;
                $rootScope.nuevaReserva.lugarRecogidaNombreCorto = nombreCorto;
                $rootScope.nuevaReserva.lugarEntregaNombreCorto = nombreCorto;
    
                $rootScope.nuevaReserva.nombreRecogida = nombreCorto;
                $rootScope.nuevaReserva.nombreEntrega = nombreCorto;
    
                $rootScope.nuevaReserva.lugarRecogidaCodigo = codigoOficina;
                $rootScope.nuevaReserva.lugarEntregaCodigo = codigoOficina;
    
                $rootScope.nuevaReserva.pickupType = tipo;
                $rootScope.nuevaReserva.busCortesia = bus;

                $rootScope.nuevaReserva.codigoPais = codigoPais;
    
                localStorage['lastOffice'] = angular.toJson({ "lugarRecogida": $rootScope.nuevaReserva.lugarRecogida, "lugarRecogidaCodigo": $rootScope.nuevaReserva.lugarRecogidaCodigo, "codigoPais": codigoPais });
    
                $.Velocity.animate($('.oficina-' + index), { 'background-color': '#fff' }, {duration: 150}).then(function() {
    
                    $rootScope.closeModalSeleccionarOficinas();
                    $rootScope.abrirSeleccionDeFechas();
                });
            });
        } else if ((typeof from !== 'undefined' || from !== '' || from !== null) && from == 'oficinas'){

            $ionicLoading.show();

            $rootScope.nuevaReserva.lugarRecogida = nombreOficina;
            $rootScope.nuevaReserva.lugarEntrega = nombreOficina;

            $rootScope.nuevaReserva.lugarRecogidaNombreCorto = nombreCorto;
            $rootScope.nuevaReserva.lugarEntregaNombreCorto = nombreCorto;

            $rootScope.nuevaReserva.nombreRecogida = nombreCorto;
            $rootScope.nuevaReserva.nombreEntrega = nombreCorto;

            $rootScope.nuevaReserva.lugarRecogidaCodigo = codigoOficina;
            $rootScope.nuevaReserva.lugarEntregaCodigo = codigoOficina;

            $rootScope.nuevaReserva.pickupType = tipo;
            $rootScope.nuevaReserva.busCortesia = bus;

            $rootScope.nuevaReserva.codigoPais = codigoPais;

            localStorage['lastOffice'] = angular.toJson({ "lugarRecogida": $rootScope.nuevaReserva.lugarRecogida, "lugarRecogidaCodigo": $rootScope.nuevaReserva.lugarRecogidaCodigo, "codigoPais": codigoPais });

            $rootScope.abrirSeleccionDeFechas();
        }
    };

    // SELECCIONAR UNA OFICINA DE DEVOLUCION DE LA LISTA //
    $rootScope.diferenteOficina = false;

    $rootScope.seleccionaOficinaEntrega = function(codigoOficina, nombreOficina, nombreCorto, index, tipoOficina) {

        $ionicLoading.show();

        $('.oficina-' + index).velocity({ 'background-color': '#EFEFEF' });

        setTimeout(function() {
            $rootScope.nuevaReserva.lugarEntrega = nombreOficina;
            $rootScope.nuevaReserva.lugarEntregaNombreCorto = nombreCorto;
            $rootScope.nuevaReserva.nombreEntrega = nombreCorto;
            $rootScope.nuevaReserva.lugarEntregaCodigo = codigoOficina;
            $rootScope.nuevaReserva.pickupType = tipoOficina;

            $rootScope.closeModalSeleccionarOficinas();

            $.Velocity.animate($('.oficina-' + index), { 'background-color': '#fff' }).then(function() {
                $.Velocity.animate($(".anim-oficina"), { translateX: '150%' }).then(function() {
                    $rootScope.diferenteOficina = true;
                    $.Velocity.animate($(".anim-oficina"), { translateX: '0%' });
                    
                    $rootScope.limpiarDevolucion(true);
                    $ionicLoading.hide();
                });
            });
        }, 350);
    };

    // OPCIONES DE LA OFICINA DE DEVOLUCION //

    var mostrarOpciones = false;

    $rootScope.opcionesDevolucion = function() {

        if ( mostrarOpciones == false ) {

            $.Velocity.animate($(".options"), { left: 0 }, 600);
            mostrarOpciones = true;
        } else {

            $.Velocity.animate($(".options"), { left: '100%' }, 600);
            mostrarOpciones = false;
        }
    }

    // ELIMINAR LUGAR DE DEVOLUCION //

    $rootScope.eliminarDevolucion = function() {

        setTimeout(function() {
            $.Velocity.animate($(".anim-oficina"), { translateX: '150%' }, 600).then(function() {
                $rootScope.diferenteOficina = false;

                $rootScope.nuevaReserva.lugarEntrega = $rootScope.nuevaReserva.lugarRecogida;
                $rootScope.nuevaReserva.lugarEntregaCodigo = $rootScope.nuevaReserva.lugarRecogidaCodigo;

                $.Velocity.animate($(".anim-oficina"), { translateX: '0%' }, 600);
                $rootScope.limpiarDevolucion();
            });
        }, 500);
    }

    // ------------------------ //
    // MODAL CODIGO PROMOCIONAL //
    // ------------------------ //

    $scope.showModalCodigo = function() {

        if ( typeof $rootScope.modalCodigo === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/codigo_promocional/codigo_promocional.html', {

                vista: "Codigo Promocional",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function (modalCodigo) {

                $rootScope.modalCodigo = modalCodigo;
                $rootScope.modalCodigo.show();
            });
        } else {
            $rootScope.modalCodigo.show();
        }
    };

    // -------------------- //
    // ENVIAR DATOS RESERVA //
    // -------------------- //

    Session.set({
        "Lang": $rootScope.language
    }).then(function (result) {
        $scope.session = result;
        $log.debug($scope.session);
    });

    $rootScope.enviarReserva = function() {

        var sesionTime = $rootScope.bookingSession($rootScope.fechaRecogida, $rootScope.horaRecogida);

        if(sesionTime) {

            $ionicLoading.show();
    
            if ( typeof localStorage['lastOffice'] !== 'undefined' ) {
    
                if ( $rootScope.isLogged ) {
    
                    GoldcarService.getUsuario().then(function (result) {
                        Session.set({
                            "Lang": $rootScope.language,
                            "nombre": result.data.Nombre,
                            "apellidos": result.data.Apellidos,
                            "user": result.data.user,
                            "authenticated": result.data.Authenticated,
                            "paquetes_disponibilidad": [],
                            "group": "",
                            "Fuel": "",
                            "paquetes": []
                        }).then(function (result) {
                            $scope.session = result;
                        });
                    });
                } else {
    
                    Session.set(angular.merge({}, $scope.session, {
                        "Lang": $rootScope.language,
                        "nombre": "",
                        "apellidos": "",
                        "user": "",
                        "authenticated": false,
                        "group": "",
                        "Fuel": "",
                        "paquetes_disponibilidad": [],
                        "paquetes": []
                    }));
                }

                $scope.reserva = {
                    recogida: {
                        nombre: $rootScope.nuevaReserva.lugarRecogida,
                        lugar: $rootScope.nuevaReserva.lugarRecogidaCodigo,
                        fecha: moment($rootScope.fechaRecogida).format('YYYY-MM-DD'),
                        hora: $rootScope.horaRecogida,
                        date: $rootScope.fechaRecogida
                    },
                    entrega: {
                        nombre: $rootScope.diferenteOficina ? $rootScope.nuevaReserva.lugarEntrega : $rootScope.nuevaReserva.lugarRecogida,
                        lugar: $rootScope.diferenteOficina ? $rootScope.nuevaReserva.lugarEntregaCodigo : $rootScope.nuevaReserva.lugarRecogidaCodigo,
                        fecha: moment($rootScope.fechaEntrega).format('YYYY-MM-DD'),
                        hora: $rootScope.horaEntrega,
                        date: $rootScope.fechaEntrega
                    },
                    pickupType: $rootScope.nuevaReserva.pickupType,
                    busCortesia: $rootScope.nuevaReserva.busCortesia
                };

                if ( typeof $scope.codigoPromo != "undefined" )
                    var url = 'https://www.goldcar.es/reservas/disponibilidad/#pickupplace/' + $scope.reserva.recogida.lugar + '/pickupdate/' + $scope.reserva.recogida.fecha + '%20' + $scope.reserva.recogida.hora + '/dropoffplace/' + $scope.reserva.entrega.lugar + '/dropoffdate/' + $scope.reserva.entrega.fecha + '%20' + $scope.reserva.entrega.hora + '/codpromo/' + $scope.codigoPromo + '/referer/APP';
                else
                    var url = 'https://www.goldcar.es/reservas/disponibilidad/#pickupplace/' + $scope.reserva.recogida.lugar + '/pickupdate/' + $scope.reserva.recogida.fecha + '%20' + $scope.reserva.recogida.hora + '/dropoffplace/' + $scope.reserva.entrega.lugar + '/dropoffdate/' + $scope.reserva.entrega.fecha + '%20' + $scope.reserva.entrega.hora + '/referer/APP';

                if(typeof $rootScope.config.reservarEnWeb !== 'undefined' && $rootScope.config.reservarEnWeb) {
                    var options = {
                        location: 'no',
                        clearcache: 'no',
                        toolbar: 'no'
                    };
    
                    $cordovaInAppBrowser.open(url, '_system', options)
                        .then(function (event) {
                            // success
                        })
                        .catch(function (event) {
                            // error
                        });
                } else {
    
                    // $ionicLoading.show({
                    //     templateUrl: 'templates/loading.html'
                    // });

                    if(!$rootScope.edadModificada) { 
                        retornarBusqueda = true;
                        $rootScope.editarEdadConductor();
                    }
                    else {
                        if(!$rootScope.isLogged) $scope.session.authenticated = false;
                        Session.set(angular.merge({}, $scope.session, {
                            "Lang": $rootScope.language,
                            "pickupplace" : $scope.reserva.recogida.lugar,
                            "pickupplace_name" : $scope.reserva.recogida.nombre,
                            "pickupdate" : $scope.reserva.recogida.fecha,
                            "pickupdate_format" : moment($scope.reserva.recogida.date).format('DD MMM').toUpperCase(),
                            "pickuptime" : $scope.reserva.recogida.hora,
                            "dropoffplace" : $scope.reserva.entrega.lugar,
                            "dropoffplace_name" : $scope.reserva.entrega.nombre,
                            "dropoffdate" : $scope.reserva.entrega.fecha,
                            "dropoffdate_format" : moment($scope.reserva.entrega.date).format('DD MMM').toUpperCase(),
                            "dropofftime" : $scope.reserva.entrega.hora,
                            "pickupType" : $scope.reserva.pickupType,
                            "busCortesia" : $scope.reserva.busCortesia,
                            "paquetes_disponibilidad" : [],
                            "paquetes": [],
                            "edadUsu": $rootScope.edadUsu
                        })).then(function () {
                            $ionicLoading.hide();
                            $state.go('menu.reservarDisponibilidad', {}, { reload: true });
                        });
                    }
    
                }
            } else {
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.titulo_atencion), template: $filter("translate")($rootScope.translations.alertas.error_no_calendar)});
            }
        } else {
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.titulo_atencion), template: $filter("translate")($rootScope.translations.alertas_nuevas.pasada_reserva)});
        }
    };
    // };

    // ---------------------- //
    // ABRIR DETALLES RESERVA //
    // ---------------------- //

    $scope.abrirReserva = function (posicion) {
        $rootScope.reservaSeleccionada = $rootScope.reservasActivas[posicion];
        $rootScope.tipoReserva = 0;
        $rootScope.abrirModalDetalles();
    };

    // ------- //
    // TICKETS //
    // ------- //

    $scope.createTicketsModal = function(office, fn) {
        $rootScope.ticketOffice = office;
        $ionicModal.fromTemplateUrl('templates/tickets/tickets.html', {

            vista: "Tickets",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function (modalTickets) {

            $rootScope.modalTickets = modalTickets;
            $rootScope.modalTicketsIsClose = false;
            if(typeof fn === 'function') fn();
        });
    };

    $rootScope.showTickets = function(office, vuelo, extras) {
        // console.log("showTickets", office);
        // console.log("vuelo", vuelo);
        // console.log("extras", extras);
        // COMPRUEBA SI TIENE EL EXTRA DE EXPRESS SERVICE PARA FILTRAR COLAS
        var hasExpress = false;
        var tipoVuelo = null;
        if(typeof extras !== 'undefined' && extras.length > 0){
            for(var i = 0; i < extras.length; i++){
                if(typeof extras[i] !== 'undefined' && typeof extras[i].Codigo !== 'undefined' && extras[i].Codigo == 'ExpressService') {
                    hasExpress = true;
                    break;
                }
            }
        }
        // COMPRUEBA SI VIENE EN AVION O NO PARA FILTRAR COLAS
        if(typeof vuelo !== 'undefined' && vuelo == 'NO_FLIGHT') tipoVuelo = 'landside';
        else tipoVuelo = 'airside';

        $rootScope.ticketOffice = office;
        $rootScope.ticketVuelo = tipoVuelo;
        $rootScope.ticketExpress = hasExpress;
        if ( typeof $rootScope.modalTickets === "undefined" || $rootScope.modalTicketsIsClose == true ){
            $scope.createTicketsModal(office, function () {
                $rootScope.modalTicketsCreado = true;
                $rootScope.modalTickets.show();
                $rootScope.refreshticketServices(true);
            });
        }
        else {
            $rootScope.modalTickets.show();
            $rootScope.refreshticketServices(true);
        }
    };

    $rootScope.ticketAviso5min = false;
    $rootScope.ticketAvisoSuturno = false;
    if(localStorage['ticketCogido']) {
        $rootScope.ticketCogido = JSON.parse(localStorage['ticketCogido']);
        $log.debug("Existe el ticket: ", $rootScope.ticketCogido);
        var ticketTime = Date.parse($rootScope.ticketCogido.createdtime);
        var now = new Date();
        if(now - ticketTime > 60 * 60000) {
            $rootScope.ticketCogido = false;
            delete localStorage['ticketCogido'];
        } else {
            $scope.createTicketsModal($rootScope.ticketCogido.office, function () {
                $rootScope.refreshTicket();
            });
        }
    } else {
        $rootScope.ticketCogido = false;
    }

    if ( localStorage['tipoVehiculo'] ) {

        $rootScope.tipoSeleccionado = JSON.parse(localStorage['tipoVehiculo']);
    }

    if ( localStorage['filtroSeleccionado'] ) {

        $rootScope.filtroSeleccionado = JSON.parse(localStorage['filtroSeleccionado']);
    }

    if ( localStorage['soloAutomaticos'] ) {

        $rootScope.soloAutomaticos = JSON.parse(localStorage['soloAutomaticos']);
    }

    if ( localStorage['masCincoPlazas'] ) {

        $rootScope.masCincoPlazas = JSON.parse(localStorage['masCincoPlazas']);
    }

    // ABRIR URL CUSTOM DESDE WIDGET
    $scope.urlHandlerEvent = function () {

        if ( $rootScope.abrirLogin ) {

            $rootScope.mostrarModalLogin();
            $rootScope.abrirLogin = false;
        } else if ( $rootScope.abrirReservas ) {

            $state.go('menu.misReservas');
            $rootScope.abrirReservas = false;
        }
    }

    //-----------------------------------------------//
    // ABRIR SELECCION DE HORA DE RECOGIDA / ENTREGA //
    //-----------------------------------------------//

    // ABRIR SELECTOR DE HORA
    $rootScope.abrirSeleccionDeHoras = function(tipoForce) {

        if (typeof tipoForce !== 'undefined') tipoHora = tipoForce;

        if (typeof $rootScope.modalSeleccionDeHoras === "undefined") {
            $ionicModal.fromTemplateUrl('templates/home/seleccionar_horas.html', {
                id: 'horas',
                vista: "Seleccionar horas",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalSeleccionDeHoras) {
                $rootScope.modalSeleccionDeHoras = modalSeleccionDeHoras;
                if (tipoHora == 'recogida') {
                    $rootScope.horaRSeleccionada = false;
                    $rootScope.horaDSeleccionada = false;
                    $rootScope.horaRecogidaElegida = false;
                    $rootScope.horaDevolucionElegida = false;
                    $rootScope.indexHourSelected = -1;

                    getHorasValidas($scope.nuevaReserva.lugarRecogidaCodigo, $scope.fechaRecogida, tipoHora).then(function(){
                        modalSeleccionDeHoras.show().then(function(){
                            // SCROLL A HORA ACTUAL //
                            var index = Math.round(moment().get('hours') * 2);
                            var topScroll = $('.hora-' + index).position();
    
                            $ionicScrollDelegate.$getByHandle('scroll_horas').scrollTo(0, topScroll.top, true);

                            $ionicLoading.hide();
                        });
                    });
                } else if(tipoHora == 'entrega'){
                    getHorasValidas($scope.nuevaReserva.lugarEntregaCodigo, $scope.fechaEntrega, tipoHora).then(function(){
                        modalSeleccionDeHoras.show().then(function(){
                            // SCROLL A HORA ACTUAL //
                            var index = Math.round(moment().get('hours') * 2);
                            var topScroll = $('.hora-' + index).position();
    
                            $ionicScrollDelegate.$getByHandle('scroll_horas').scrollTo(0, topScroll.top, true);

                            $ionicLoading.hide();
                        });
                    });
                }
            });
        } else {
            $rootScope.modalSeleccionDeHoras.show();
        }
    }

    // SELECCIONAR HORA //
    var tipoHora = 'recogida';
    var horaRSeleccionada = false;
    var horaDSeleccionada = false;
    $rootScope.tipoSetHora = $filter("translate")($rootScope.translations.home.hora_recogida);

    function bloqueoHoras(status){
        if(status) $('.horas').css({'pointer-events': 'none'});
        else $('.horas').css({'pointer-events': ''});
    }

    $rootScope.horaRSeleccionada = false;
    $rootScope.horaDSeleccionada = false;

    $rootScope.seleccionarHora = function(hora, index, status) {

        if ( typeof status !== 'undefined' && status == true ) {
            bloqueoHoras(true);
            
            if ( tipoHora == 'recogida' ) {
                $ionicLoading.show();

                animacionesHora(index).then(function() {
                    $rootScope.horaRecogida = moment(hora, "HH:mm").format("HH:mm");
                    $rootScope.diaRecogida = $rootScope.diaRecogida + ' ' + moment().set('hour', $rootScope.horaRecogida.split(':')[0]).set('minute', $rootScope.horaRecogida.split(':')[1]).format("HH:mm");
                    tipoHora = 'entrega';
                    $rootScope.horaRSeleccionada = true;
                    $rootScope.tipoSetHora =  $filter("translate")($rootScope.translations.home.hora_entrega);
                    
                    $rootScope.rastrearVista('/' + $rootScope.language + '/reserva/paso2/fecha-devolucion');

                    if(typeof $rootScope.modalSeleccionDeHoras !== 'undefined')
                    {
                        $rootScope.modalSeleccionDeHoras.hide().then(function(){
                            calendarFactory.bloqueoCalendario(false);
                            $ionicLoading.hide();
                        });
                    }

                });
            } else if ( tipoHora == 'entrega' ) {
                animacionesHora(index).then(function() {
                    $rootScope.horaEntrega = moment(hora, "HH:mm").format("HH:mm");
                    $rootScope.diaEntrega = $rootScope.diaEntrega + ' ' + moment().set('hour', $rootScope.horaEntrega.split(':')[0]).set('minute', $rootScope.horaEntrega.split(':')[1]).format("HH:mm");
                    tipoHora = 'recogida';
                    $rootScope.horaDSeleccionada = true;
                    $rootScope.tipoSetHora = $filter("translate")($rootScope.translations.home.hora_recogida);

                    if(typeof $rootScope.modalSeleccionDeHoras !== 'undefined')
                    {
                        $rootScope.modalSeleccionDeHoras.hide().then(function(){
                            $rootScope.cerrarSeleccionDeFechas();

                            guardarHistorial();
                            cargarHistorial();
        
                            setTimeout(function() {
                                $rootScope.enviarReserva();
                            }, 700);
                        });
                    }
                    else
                    {
                        guardarHistorial();
                        cargarHistorial();
    
                        setTimeout(function() {
                            $rootScope.enviarReserva();
                        }, 700);
                    }
                });
            }
            $ionicLoading.hide();
        } else {

            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.seleccion_hora.titulo_hora_error), template: $filter("translate")($rootScope.translations.seleccion_hora.txt_hora_error) });
        }
    }

    // CERRAR SELECTOR DE HORAS
    $rootScope.cerrarSeleccionDeHoras = function() {
        $rootScope.modalSeleccionDeHoras.remove().then(function(){
            $rootScope.modalSeleccionDeHoras = undefined;
        });
    }

    // OBTENER HORAS VALIDAS //
    $rootScope.horasTotales = [];

    function getHorasValidas(oficina, fecha, tipo) {

        var defered = $q.defer();
        var promise = defered.promise;

        $ionicLoading.show();
        
        if(tipo == 'recogida') {
            $rootScope.horasTotales = [];
        }

        try{
            GoldcarService.getHorarioOficina(oficina, fecha, tipo).then(function(result) {
                if(tipo == 'entrega' && $rootScope.horasTotales.length <= 0){
                    $rootScope.tipoSetHora = $filter("translate")($rootScope.translations.home.hora_entrega);
                    for(var l in result.data){
                        $rootScope.horasTotales.push({ hora: l, status: result.data[l] });
                    }
                } 
                else {
                    for ( var i in result.data ) {
                        if ( tipo == 'recogida' ) {
                            $rootScope.horasTotales.push({ hora: i, status: result.data[i] });
                        } else if ( tipo == 'entrega' ) {
                            for( var l = 0; l < $rootScope.horasTotales.length; l++ ) {    
                                if ( $rootScope.horasTotales[l].hora == i ) {
                                    $rootScope.horasTotales[l].status = result.data[i];
                                }
                            }
                        }
                    }
                }
                defered.resolve();
            });
        }catch(err){
            defered.reject();
        }
        return promise;
    }

    // DETECTAR SI SE OCULTA LA SELECCION DE HORA //
    $rootScope.$on('modal.hidden', function (event, modal) {

        if ( modal.id == 'horas' ) {

            if ( !$rootScope.horaRSeleccionada ) {
                $rootScope.limpiarFechas(true);
            } else if ( !$rootScope.horaDSeleccionada ) {
                $rootScope.limpiarDevolucion(true);
            }

            setTimeout(function() {
                $rootScope.cerrarSeleccionDeHoras();
            }, 500);
        } 
        
        if ( modal.id == 'fechas' ) {

            if ( ( !$rootScope.horaRSeleccionada || !$rootScope.horaDSeleccionada ) || ( !$rootScope.elegidaFechaRecogida || !$rootScope.elegidaFechaDevolucion ) && $state.current.name == 'menu.reservarDisponibilidad' ) {

                // $state.go('menu.home', {}, { reload: true });
                $rootScope.fechaRecogida = fechaRecogidaAnterior;
                $rootScope.diaRecogida = diaRecogidaAnterior;
                $rootScope.fechaEntrega = fechaDevolucionAnterior;
                $rootScope.diaEntrega = diaDevolucionAnterior;
            }
        }
    });

    // ANIMACIONES APARTADO SELECCION HORA //
    function animacionesHora(index) {

        var defered = $q.defer();
        var promise = defered.promise;

        $('.hora-' + index).velocity({ 'background-color': '#A5B200' });
        $('.hora-' + index).css({ 'margin': '0' });
        $('.hora-' + index + ' > .hora').css({'color': '#FFF'});
        defered.resolve();

        return promise;
    }

    // ABRIR SELECTOR DE FECHAS //
    $rootScope.abrirSeleccionDeFechas = function() {
        if ( typeof $rootScope.modalSeleccionDeFechas === 'undefined' ) {
            
            $ionicModal.fromTemplateUrl('templates/home/seleccionar_fechas.html', {
                id: 'fechas',
                vista: "Seleccionar fechas",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalSeleccionDeFechas) {
                
                
                $rootScope.modalSeleccionDeFechas = modalSeleccionDeFechas;
                modalSeleccionDeFechas.show();

                calendarFactory.crearCalendario().then(function() {
                    // console.log("FECHA RECOGIDA", $rootScope.fechaRecogida);
                    // console.log("HORA RECOGIDA", $rootScope.horaRecogida);
                    
                    $('.content-fechas').removeClass('has-header');
                    $('.content-fechas').removeClass('scroll-content');
                    
                    calendarFactory.obtenerFechasRecogida($rootScope.nuevaReserva.lugarRecogidaCodigo).then(function(){ $ionicLoading.hide(); });
                    calendarFactory.obtenerNuevasFechas($rootScope.nuevaReserva.lugarRecogidaCodigo);
                });
            });
        }
    }

    // CERRAR SELECTOR DE FECHAS //
    $rootScope.cerrarSeleccionDeFechas = function(force) 
    {
        $rootScope.modalSeleccionDeFechas.remove().then(function()
        {
            $rootScope.modalSeleccionDeFechas = undefined;
            if($rootScope.diferenteOficina && force)
            {
                $rootScope.nuevaReserva.lugarEntrega = $rootScope.nuevaReserva.lugarRecogida;
                $rootScope.nuevaReserva.lugarEntregaCodigo = $rootScope.nuevaReserva.lugarRecogidaCodigo;
                $rootScope.diferenteOficina = false;
                $rootScope.limpiarFechas();
            }
        });
    }

    // ANIMACION SELECTOR DE FECHAS //
    $rootScope.tipoAnimacion = function(status) {

        if ( status == 'recogida' ) {

            $.Velocity.animate($('.fecha-recogida'), { translateX: '-100%' }).then(function() {

                $.Velocity.animate($('.fecha-recogida'), { opacity: 0 }).then(function() {

                    $rootScope.elegidaFechaRecogida = true;
                    $('.fecha-recogida').velocity({ opacity: 1 });

                    $.Velocity.animate($('.fecha-recogida'), { translateX: '0%' }).then(function() {


                        $('.barra-inferior').velocity({ translateX: '100%' });
                        $('.fecha-devolucion').velocity({ opacity: '1' });
                        $('.fecha-recogida').velocity({ opacity: '0.5' });
                    });
                });
            });
        } else if ( status == 'devolucion' || status == 'entrega' ) {

            $.Velocity.animate($('.fecha-devolucion'), { translateX: '100%' }).then(function() {

                $('.fecha-devolucion').velocity({ opacity: 0 });

                $rootScope.elegidaFechaDevolucion = true;

                $('.fecha-devolucion').velocity({ opacity: 1 });

                $('.fecha-devolucion').velocity({ translateX: '0%' });
            })
        } else if ( status == 'limpiar' ) {

            if ( $rootScope.elegidaFechaRecogida == true ) {

                $.Velocity.animate($('.fecha-recogida'), { translateX: '-100%' }).then(function() {

                    $rootScope.elegidaFechaRecogida == false;
                    $('.fecha-recogida').velocity({ opacity: '1' });

                    $.Velocity.animate($('.fecha-recogida'), { translateX: '0%' }).then(function() {


                        $('.barra-inferior').velocity({ translateX: '0%' });
                        $('.fecha-devolucion').velocity({ opacity: '0.5' });
                    });
                });
            }
        }
    }

    // LIMPIAR SELECTOR DE FECHAS //
    $rootScope.limpiarFechas = function(force) {

        $ionicLoading.show();

        if ( force ) {

            $rootScope.fechaRecogida = "";
            $rootScope.diaRecogida = "";
        }

        tipoHora = 'recogida';
        $rootScope.tipoSetHora =  $filter("translate")($rootScope.translations.home.hora_recogida);
        $rootScope.tipoDeSeleccion = 'recogida';

        $rootScope.tipoAnimacion('limpiar');

        $(".calendar-container").datepicker('clearCalendar');
        $('.sys-datepicker-invalid').removeClass('sys-datepicker-invalid');

        calendarFactory.obtenerFechasRecogida($rootScope.nuevaReserva.lugarRecogidaCodigo, true).then(function(){ $ionicLoading.hide(); });

        $rootScope.elegidaFechaRecogida = false;

        $rootScope.horaRSeleccionada = false;
    }

    $rootScope.limpiarDevolucion = function(force) {

        if ( force ) {

            $rootScope.fechaEntrega = "";
            $rootScope.diaEntrega = "";
        } else {

            tipoHora = 'entrega';
            $rootScope.tipoSetHora =  $filter("translate")($rootScope.translations.home.hora_entrega);
            $rootScope.tipoDeSeleccion = 'entrega';
        }

        $(".calendar-container").datepicker('clearEntrega');

        $('.sys-datepicker-last-day-selected').removeClass('sys-datepicker-last-day-selected');
        $('.sys-datepicker-inter-days-selected').removeClass('sys-datepicker-inter-days-selected');

        $rootScope.elegidaFechaDevolucion = false;

        $rootScope.horaDSeleccionada = false;
    }

    // --------------------- //
    // HISTORIAL DE BUSQUEDA //
    // --------------------- //

    $scope.historialCargado = false;
    $scope.historialBusqueda = [];

    function cargarHistorial() {
        setTimeout(function(){
            $ionicLoading.show();
            if ( typeof localStorage['historialBusqueda'] !== 'undefined' && localStorage['historialBusqueda'] !== '' ) {
                $scope.historialBusqueda = JSON.parse(localStorage['historialBusqueda']);
                var now = moment().locale($rootScope.language);
                
                for(var i = 0; i < $scope.historialBusqueda.length; i++){
                    var fecha = moment($scope.historialBusqueda[i].fechaCompletaR, 'YYYY-MM-DD');

                    console.log("fecha", fecha);
                    console.log("now", now);
                    console.log("isBefore", fecha.isBefore(now));

                    if(fecha.isBefore(now)) {
                        $scope.historialBusqueda.splice(i, 1);
                        delete localStorage['historialBusqueda'];
                    }
                }
                if($scope.historialBusqueda.length > 1) {
                    $scope.historialBusqueda = [];
                    delete localStorage['historialBusqueda'];
                } else {
                    $scope.historialCargado = true;
                }
            } else {
                $scope.historialCargado = false;
            }
            $ionicLoading.hide();
        }, 2000);
    }

    cargarHistorial();

    function guardarHistorial() {
        var historial = [];

        var fechaRecogida = moment($rootScope.fechaRecogida + " " + $rootScope.horaRecogida, 'YYYY-MM-DD HH:mm').format('DD MMM HH:mm');
        var fechaEntrega = moment($rootScope.fechaEntrega + " " + $rootScope.horaEntrega, 'YYYY-MM-DD HH:mm').format('DD MMM HH:mm');

        if(moment(fechaRecogida, 'DD MMM HH:mm').isValid() && moment(fechaEntrega, 'DD MMM HH:mm').isValid()){
            historial.push({
                lugarRecogida : $rootScope.nuevaReserva.lugarRecogida,
                lugarEntrega : $rootScope.nuevaReserva.lugarEntrega,
                lugarRecogidaCodigo : $rootScope.nuevaReserva.lugarRecogidaCodigo,
                lugarEntregaCodigo : $rootScope.nuevaReserva.lugarEntregaCodigo,
                pickupType : $rootScope.nuevaReserva.pickupType,
                busCortesia : $rootScope.nuevaReserva.busCortesia,
                lugarRecogidaCorto: $rootScope.nuevaReserva.lugarRecogidaNombreCorto,
                lugarEntregaCorto: $rootScope.nuevaReserva.lugarEntregaNombreCorto,
                fechaRecogida: fechaRecogida,
                fechaCompletaR: $rootScope.fechaRecogida,
                fechaEntrega: fechaEntrega,
                fechaCompletaE: $rootScope.fechaEntrega,
                codigoPais: $rootScope.nuevaReserva.codigoPais
            });

            localStorage['historialBusqueda'] = JSON.stringify(historial);
        }
    }

    function animacionHistorial(index) {
        $.Velocity.animate($('.busqueda-' + index + ' > .lugar-busqueda, .busqueda-' + index + ' > .cont-arrow'), { translateX: '3%' }).then(function() {
            $('.busqueda-' + index + ' > .lugar-busqueda, .busqueda-' + index + ' > .cont-arrow').velocity({ translateX: '0%' });
        });
    }

    $rootScope.buscarDelHistorial = function(index) {

        $ionicLoading.show();

        animacionHistorial(index);

        setTimeout(function() {
            
            var busqueda = JSON.parse(localStorage['historialBusqueda'])[index];

            var ahora = moment();
            var fechaReserva = moment(busqueda.fechaRecogida, 'DD MMM HH:mm');

            var isBefore = fechaReserva.isBefore(ahora);

            $rootScope.nuevaReserva = {
                lugarRecogida : busqueda.lugarRecogida,
                lugarEntrega : busqueda.lugarEntrega,
                lugarRecogidaCodigo : busqueda.lugarRecogidaCodigo,
                lugarEntregaCodigo : busqueda.lugarEntregaCodigo,
                pickupType : busqueda.pickupType,
                busCortesia : busqueda.busCortesia,
                lugarRecogidaNombreCorto : busqueda.lugarRecogidaCorto,
                lugarEntregaNombreCorto : busqueda.lugarEntregaCorto,
                edadUsu : busqueda.edadUsu,
                codigoPais: busqueda.codigoPais
            };

            localStorage['lastOffice'] = angular.toJson({ "lugarRecogida": busqueda.lugarRecogida, "lugarRecogidaCodigo": busqueda.lugarRecogidaCodigo, "codigoPais": busqueda.codigoPais });

            if(isBefore){
                if ($rootScope.nuevaReserva.lugarRecogida == $rootScope.nuevaReserva.lugarEntrega) {
                    $rootScope.abrirSeleccionDeFechas();
                } else {
                    $rootScope.abrirSeleccionDeFechas();
                    setTimeout(function() {
                        $.Velocity.animate($(".anim-oficina"), {translateX: '150%'}).then(function() {
                            $rootScope.diferenteOficina = true;
                            $.Velocity.animate($(".anim-oficina"), {translateX: '0%'});
                        });
                        $ionicLoading.hide();
                    }, 600);
                }
            }
            else {
                $rootScope.horaRecogida = moment(busqueda.fechaRecogida, 'DD MMM HH:mm').format('HH:mm');
                $rootScope.fechaRecogida = moment(busqueda.fechaRecogida, 'DD MMM HH:mm').format('YYYY-MM-DD');
                $rootScope.horaEntrega = moment(busqueda.fechaEntrega, 'DD MMM HH:mm').format('HH:mm');
                $rootScope.fechaEntrega = moment(busqueda.fechaEntrega, 'DD MMM HH:mm').format('YYYY-MM-DD');

                if($rootScope.nuevaReserva.lugarRecogida != $rootScope.nuevaReserva.lugarEntrega) $rootScope.diferenteOficina = true;
                else $rootScope.diferenteOficina = false;

                $rootScope.enviarReserva();
            }
        }, 500);
    };

    $rootScope.limpiarHistorial = function() {
        $scope.historialBusqueda = [];
        $scope.historialCargado = false;
        localStorage.removeItem('historialBusqueda');
        localStorage.removeItem('lastOffice');
    }

    $rootScope.editarFecha = function(tipo) {

        // $ionicLoading.show();

        // $rootScope.elegidaFechaRecogida = false;
        // $rootScope.elegidaFechaDevolucion = false;
        //
        // $rootScope.abrirSeleccionDeFechas();
        var texto = null;
        
        if(typeof tipo !== 'undefined' && tipo == 'recogida') texto = $rootScope.translations.disponibilidad_nueva.editar_recogida;
        else if(typeof tipo !== 'undefined' && tipo == 'devolucion') texto = $rootScope.translations.disponibilidad_nueva.editar_devolucion;

        var confirmPopup = $ionicPopup.confirm(
        {
            cssClass: 'alerta-editar-fechas',
            template: texto,
            cancelText: $rootScope.translations.alerta_volver_home.cancelar,
            okText: $rootScope.translations.general.editar
        });
       
        confirmPopup.then(function(res) {
            if(res) 
            {
                if(tipo == 'recogida')
                {
                    tipoHora = 'recogida';
                    $rootScope.elegidaFechaRecogida = false;
                    $rootScope.elegidaFechaDevolucion = false;
                    editarFechas('recogida');
                }
                else
                {
                    tipoHora = 'recogida';
                    $rootScope.elegidaFechaRecogida = true;
                    $rootScope.elegidaFechaDevolucion = false;
                    editarFechas('entrega');
                }
            }
        });
        
    }
    
    $rootScope.editarFechaDevolucion = function() {
        tipoHora = 'recogida';
        $rootScope.elegidaFechaRecogida = true;
        $rootScope.elegidaFechaDevolucion = false;
        editarFechas('entrega');
    }

    $rootScope.bannerTopTickets = function(){
        if(typeof localStorage['ticketCogido'] != 'undefined' && localStorage['ticketCogido'] != '' && JSON.parse(localStorage['ticketCogido']) != false){
            $('.pane, .view').addClass('push-content-bottom');
            $('.ticket-bar').addClass('ticket-bar-show');
        }
    }

    // $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){ 
    //     setTimeout(function(){
    //         $rootScope.bannerTopTickets();
    //     }, 500);
    // })


    var inputTimeout = null;
    var oldOficinasBusqueda = [];
    $rootScope.busquedaOficinas = function(){
        if(oldOficinasBusqueda == '') oldOficinasBusqueda = $rootScope.oficinasBusqueda;

        if($rootScope.busquedaNueva.texto != '' && $rootScope.busquedaNueva.texto.length > 1){
            $ionicLoading.show();

            if(inputTimeout != null) clearTimeout(inputTimeout);
            
            inputTimeout = setTimeout(function(){
                var nuevaBusqueda = [];
                GoldcarService.filtrarBusqueda($rootScope.busquedaNueva.texto).then(function(result){
                    if(typeof result.data.error === 'undefined' && result.data.error != true){
                        for(var i = 0; i < result.data.length; i++){
                            nuevaBusqueda.push({
                                Codigo: result.data[i].codigo,
                                Fullname: result.data[i].fullName,
                                Nombre: result.data[i].nombre,
                                Tipo: result.data[i].tipo,
                                busCortesia: result.data[i].buscortesia,
                                Idpais: result.data[i].Idpais
                            });
                        }
                        $rootScope.oficinasBusqueda = nuevaBusqueda;
                        $ionicScrollDelegate.$getByHandle('lista-oficinas-scroll').scrollTop(true);
                    }else{
                        $rootScope.oficinasBusqueda = null;
                        $ionicScrollDelegate.$getByHandle('lista-oficinas-scroll').scrollTop(true);
                    }
                    $ionicLoading.hide();
                }).catch(function(){
                    console.log("Ha ocurrido un error");
                });
            }, 600);
        } else $rootScope.oficinasBusqueda = oldOficinasBusqueda;
    }
    
    // FILTRAR LISTA BUSCADOR OFICINAS ONEWAY //

    $rootScope.busquedaOficinasOneWay = function(){
        if(oldOficinasBusqueda == '') oldOficinasBusqueda = $rootScope.oficinasBusqueda;

        if($rootScope.busquedaNueva.textoOneWay != '' && $rootScope.busquedaNueva.textoOneWay.length > 1){
            $ionicLoading.show();

            if(inputTimeout != null) clearTimeout(inputTimeout);
            
            inputTimeout = setTimeout(function(){
                var nuevaBusqueda = [];
                GoldcarService.filtrarBusquedaOneWay($rootScope.nuevaReserva.lugarRecogidaCodigo, $rootScope.busquedaNueva.textoOneWay).then(function(result){
                    if(typeof result.data.error === 'undefined' && result.data.error != true){
                        console.log(result);
                        for(var i = 0; i < result.data.length; i++){
                            nuevaBusqueda.push({
                                Codigo: result.data[i].Codigo,
                                Fullname: result.data[i].Fullname,
                                Nombre: result.data[i].Nombre,
                                Tipo: result.data[i].Tipo,
                                busCortesia: result.data[i].Buscortesia,
                                Idpais: result.data[i].Idpais
                            });
                        }
                        console.log(nuevaBusqueda);
                        $rootScope.oficinasBusqueda = nuevaBusqueda;
                        $ionicScrollDelegate.$getByHandle('lista-oficinas-scroll').scrollTop(true);
                    }else{
                        $rootScope.oficinasBusqueda = null;
                        $ionicScrollDelegate.$getByHandle('lista-oficinas-scroll').scrollTop(true);
                    }
                    $ionicLoading.hide();
                }).catch(function(){
                    console.log("Ha ocurrido un error");
                });
            }, 600);
        } else $rootScope.oficinasBusqueda = oldOficinasBusqueda;
    }

    //-----------------------//
    // EDITAR EDAD CONDUCTOR //
    //-----------------------//

    var modalSeleccionarEdad = undefined;
    $rootScope.edadConductor = '25 ' + $rootScope.translations.nueva_home.o_mas;
    $rootScope.edadModificada = false;
    $rootScope.edadUsu = 0;
    var retornarBusqueda = false;

    $rootScope.edades = [
        { edadUsu: 0, number: '25 ' + $rootScope.translations.nueva_home.o_mas },
        { edadUsu: 1, number: '24' },
        { edadUsu: 1, number: '23' },
        { edadUsu: 1, number: '22' },
        { edadUsu: 1, number: '21' },
        { edadUsu: 2, number: '20' },
        { edadUsu: 2, number: '19' }
    ];

    $rootScope.editarEdadStyle = {};
    var edadHeight = (56 + (45 * $rootScope.edades.length));
    if(ionic.Platform.isIOS()) $rootScope.editarEdadStyle = {'min-height': (edadHeight + 50) + 'px', 'top': 'calc(100vh - ' + (edadHeight + 50) + 'px)'};
    else $rootScope.editarEdadStyle = {'min-height': edadHeight + 'px', 'top': 'calc(100vh - ' + edadHeight + 'px)'};

    $rootScope.editarEdadConductor = function(){
        $ionicModal.fromTemplateUrl('templates/home/seleccionar_edad.html', {
            id: 'selectAge',
            vista: '/' + $rootScope.language + '/reserva/paso2/edad',
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(seleccionarEdad) {
            modalSeleccionarEdad = seleccionarEdad;
            modalSeleccionarEdad.show().then(function() {
                $ionicLoading.hide();
            });
        });
    }

    $rootScope.cerrarSeleccionEdad = function(){
        modalSeleccionarEdad.remove();
        modalSeleccionarEdad = undefined;
    }

    $rootScope.seleccionarEdad = function(edad){
        $rootScope.edadConductor = edad.number;
        $rootScope.edadUsu = edad.edadUsu;
        $rootScope.edadModificada = true;
        $rootScope.cerrarSeleccionEdad();
        if(retornarBusqueda) $rootScope.enviarReserva();
    }

    // RESETEAR EDAD CUANDO EL USUARIO DEJA LA HOME //
    $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
        if(fromState.name == "menu.home") $rootScope.edadModificada = false;
    });

    // EDITAR HORA DE RECOGIDA / DEVOLUCION
    function abrirModalCalendario(type){
        if ( typeof $rootScope.modalSeleccionDeFechas === 'undefined' ) {
            $ionicModal.fromTemplateUrl('templates/home/seleccionar_fechas.html', {
                id: 'fechas',
                vista: "Seleccionar fechas",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalSeleccionDeFechas) {
                $rootScope.modalSeleccionDeFechas = modalSeleccionDeFechas;
                modalSeleccionDeFechas.show().then(function(){
                    abrirCalendario(type);     
                });
            });
        }
    }

    function abrirCalendario(type){
        calendarFactory.abrirCalendario(type).then(function(){
            $('.content-fechas').removeClass('has-header');
            $('.content-fechas').removeClass('scroll-content');
            // console.log("$rootScope.edadConductor", $rootScope.edadConductor);
            // console.log("$rootScope.edadUsu", $rootScope.edadUsu);
            $rootScope.edadModificada = true;

            calendarFactory.obtenerFechasRecogida($rootScope.nuevaReserva.lugarRecogidaCodigo).then(function(){
                calendarFactory.obtenerNuevasFechas($rootScope.nuevaReserva.lugarRecogidaCodigo);
                
                if(typeof type !== 'undefined' && type == 'recogida') calendarFactory.seleccionarFechaRecogida($rootScope.fechaRecogida);
                else if(typeof type !== 'undefined' && type == 'entrega') {
                    calendarFactory.seleccionarFechaRecogida($rootScope.fechaRecogida).then(function(){
                        seleccionarHoraRecogida();           
                        calendarFactory.seleccionarFechaDevolucion($rootScope.fechaEntrega);
                    });
                }
                $rootScope.abrirSeleccionDeHoras(type);
                // $ionicLoading.hide();
            });
        });
    }

    function seleccionarHoraRecogida(){
        $rootScope.diaRecogida = moment($rootScope.fechaRecogida).format('D MMM') + ' ' + moment().set('hour', $rootScope.horaRecogida.split(':')[0]).set('minute', $rootScope.horaRecogida.split(':')[1]).format("HH:mm");        
    }

    $rootScope.editarHora = function(type){
        abrirModalCalendario(type);
    }

    var fechaRecogidaAnterior = null;
    var diaRecogidaAnterior = null;
    var horaRecogidaAnterior = null;
    var fechaDevolucionAnterior = null;
    var diaDevolucionAnterior = null;
    var horaDevolucionAnterior = null;

    function editarFechas(type) {

        // GUARDAR FECHAS ANTERIORES
        fechaRecogidaAnterior = $rootScope.fechaRecogida;
        diaRecogidaAnterior = $rootScope.diaRecogida;
        horaRecogidaAnterior = $rootScope.horaRecogida;
        fechaDevolucionAnterior = $rootScope.fechaEntrega;
        diaDevolucionAnterior = $rootScope.diaEntrega;
        horaDevolucionAnterior = $rootScope.horaEntrega;

        console.log("$scope.session editarFechas", $scope.session);
        if(typeof $scope.session !== 'undefined'){
            if(typeof $scope.session.dropoffplace !== 'undefined' && typeof $scope.session.pickupplace !== 'undefined'){
                if($scope.session.dropoffplace != $scope.session.pickupplace) $rootScope.diferenteOficina = true;
            }
        }

        if (typeof $rootScope.modalSeleccionDeFechas === 'undefined'){
            $ionicModal.fromTemplateUrl('templates/home/seleccionar_fechas.html', {
                id: 'fechas',
                vista: "Seleccionar fechas",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalSeleccionDeFechas) {
                $rootScope.modalSeleccionDeFechas = modalSeleccionDeFechas;
                var posicionDia = null;
                modalSeleccionDeFechas.show();

                calendarFactory.abrirCalendario(type).then(function() {
                    // console.log("FECHA RECOGIDA", $rootScope.fechaRecogida);
                    // console.log("HORA RECOGIDA", $rootScope.horaRecogida);

                    $('.content-fechas').removeClass('has-header');
                    $('.content-fechas').removeClass('scroll-content');

                    if(type == 'recogida') 
                    {
                        calendarFactory.obtenerFechasRecogida($rootScope.nuevaReserva.lugarRecogidaCodigo);
                        calendarFactory.obtenerNuevasFechas($rootScope.nuevaReserva.lugarRecogidaCodigo);
                        $("div[data-date=" + moment(fechaRecogidaAnterior).format('YYYY-MM-DD') + "]").css({"border": "1px solid #A3AF2D", "border-top-right-radius": 0, "border-bottom-right-radius": 0}); // MARCAR DIA ANTERIORMENTE ELEGIDO
                    }
                    else 
                    {
                        calendarFactory.seleccionarFechaRecogida(fechaRecogidaAnterior);
                        calendarFactory.obtenerFechasDevolucion($rootScope.nuevaReserva.lugarEntregaCodigo);
                        $rootScope.seleccionarHora(horaRecogidaAnterior, 0, true);
                    }

                    $("div[data-date=" + moment(fechaDevolucionAnterior).format('YYYY-MM-DD') + "]").css({"border": "1px solid #A3AF2D", "border-top-left-radius": 0, "border-bottom-left-radius": 0}); // MARCAR DIA ANTERIORMENTE ELEGIDO
                    posicionDia = $("div[data-date=" + moment(fechaRecogidaAnterior).format('YYYY-MM-DD') + "]")[0].offsetTop;
                    $ionicScrollDelegate.$getByHandle('scrollFechas').scrollTo(0, posicionDia, true);
                });
            });
        }
    }

    // NUEVA VALORACIÓN APP //
    var analytics;
    $rootScope.mostrarValoracionAPP = function()
    {
        $rootScope.popupValoracion = $ionicPopup.show({
            cssClass: 'alerta-valoracion',
            templateUrl: 'templates/alertas/alerta-valoracion.html',
            scope: $rootScope
        });
        $rootScope.popupValoracion.then(function()
        {
            if(typeof analytics !== 'undefined') analytics.sendEvent('RES Confirm', 'Push', 'VOTE_Open_' + $rootScope.language, '', successAnalyticsEvent, errorAnalyticsEvent);
        });
    }

    function successAnalyticsEvent()
    {
        console.log("Analytics Track Event OK");
    }

    function errorAnalyticsEvent()
    {
        console.log("Analytics Track Event Fail");
    }

    $rootScope.valorarAPP = function(status)
    {
        if(status)
        {
            if(typeof analytics !== 'undefined') analytics.sendEvent('RES Confirm', 'Push', 'VOTE_Yes_' + $rootScope.language, '', successAnalyticsEvent, errorAnalyticsEvent);
            if(ionic.Platform.isIOS()) window.open('https://itunes.apple.com/es/app/goldcar/id1070220317?mt=8', '_system');
            else if(ionic.Platform.isAndroid()) window.open('https://play.google.com/store/apps/details?id=com.goldcar.app&hl=es', '_system');
            $rootScope.popupValoracion.close();
        }
        else
        {
            if(typeof analytics !== 'undefined') analytics.sendEvent('RES Confirm', 'Push', 'VOTE_No_' + $rootScope.language, '', successAnalyticsEvent, errorAnalyticsEvent);
            $rootScope.popupValoracion.close();
        }
    }
});
