angular.module('goldcar').controller('HomeReservaCtrl', function ($filter, $scope, $ionicSlideBoxDelegate, $cordovaInAppBrowser, $ionicModal, $rootScope, $ionicLoading, GoldcarService, JsonService, $state, $log) {
    //----------------------------
    // DATOS TARJETAS
    //----------------------------

    $scope.pocoTiempo = function () {

        if(typeof localStorage['user'] === 'undefined') {
            $state.go('menu.home');
            return;
        }

        if( $rootScope.homeReservaLoadFirstTime ){
            $ionicLoading.show({
                template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.recuperando_reservas) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
            });
        }

        var success = false;
        var tags = null;
        var now = new Date().getTime();
        var time = $rootScope.config.proximasReservas.desdeHoras*60*60*1000;
        var closerTime = $rootScope.config.proximasReservas.desdeHorasCercanas*60*60*1000;

        //////////

        GoldcarService.getReservasActivas().then(function (result) {
            $rootScope.reservasFuturas = [];
            $rootScope.reservasProximas = [];
            $rootScope.reservasInminentes = [];

            if(result.data.length > 0){
                result.data.forEach(function (reserva) {
                    var diffHours = reserva.Pickupdate - now;

                    if (diffHours > time) {
                        $rootScope.reservasFuturas.push(reserva);
                        tags = 'Futuras';
                    }

                    else if (diffHours <= time && diffHours > closerTime) {
                        success = true;
                        $rootScope.reservasProximas.push(reserva);
                        tags = 'Proximas';
                    }

                    else if (diffHours <= closerTime && diffHours > 0) {
                        success = true;
                        $rootScope.reservasInminentes.push(reserva);
                        tags = 'Inminentes';
                    }
                });
            }
            reservasPosiblementeActivas(now, success,tags);
        },
            function(error){
                $log.debug("Error cargando reservasActivas: " + error);
                reservasPosiblementeActivas(now, success,tags);
            }
        );
    };

    var reservasPosiblementeActivas = function(now, success, tags){
        GoldcarService.getReservasAnteriores().then(function (result) {
                $rootScope.reservasActuales = [];

                if(result.data.length > 0){
                    result.data.forEach(function (reserva) {
                        var diffHoursRecogida = reserva.Pickupdate;
                        var diffHoursEntrega = reserva.Dropoffdate;
                        
                        if(reserva.Estado == 2 || reserva.Estado == 5){
                            if(now > diffHoursRecogida && now < diffHoursEntrega) {
                                success = true;
                                $rootScope.reservasActuales.push(reserva);
                                tags = 'Actuales';
                            }
                        }
                    });
                }
                $rootScope.homeReservaLoadFirstTime = false;
                checkRedirect(success,tags);
            },
            function(error){
                $log.debug("Error con reservasAnteriores: " + error);
                checkRedirect(success,tags);
            }
        );
    };

    var checkRedirect = function(success,tags){
        if(!success) {
            if( $rootScope.homeReservaLoadFirstTime ) {
                $ionicLoading.hide();
            }
            $state.go('menu.home');
        }

        else{
            if( $rootScope.homeReservaLoadFirstTime ) {
                $ionicLoading.hide();
            }
            $rootScope.estadoBannersHomeReserva = 2;                           // estadoBanners = 2 -> CARGANDO
            $log.debug('Tags que se enviarian: ' + tags);
            //JsonService.getBanners(tags).then(function (result) { // TODO: DESCOMENTAR ESTA LINEA, Y ELIMINAR LA SIGUIENTE LINEA
            JsonService.getBanners('Home').then(function (banners) {
                $rootScope.bannersHomeReserva = [];
                $rootScope.bannersHomeReserva = banners;
                if(typeof banners[0] === "undefined"){
                    $rootScope.bannersHomeReservaText = $filter("translate")($rootScope.translations.home.sin_ofertas);
                    $rootScope.estadoBannersHomeReserva = 0;                   // estadoBanners = 0 -> VACIO
                }
                else
                    $rootScope.estadoBannersHomeReserva = 1;                   // estadoBanners = 1 -> RELLENADO

                $ionicSlideBoxDelegate.update();
            });

            if( !$rootScope.homeReservaLoadFirstTime )
                $rootScope.$broadcast('scroll.refreshComplete');
        }
    };

    $scope.abrirReservaFutura = function(posicion) {
        $rootScope.reservaSeleccionada = $rootScope.reservasFuturas[posicion];
        $rootScope.tipoReserva = 0;
        $rootScope.abrirModalDetalles();
    };

    $scope.abrirReservaProxima = function(posicion) {
        $rootScope.reservaSeleccionada = $rootScope.reservasProximas[posicion];
        $rootScope.tipoReserva = 0;
        $rootScope.abrirModalDetalles();
    };

    $scope.abrirReservaInminente = function(posicion) {
        $rootScope.reservaSeleccionada = $rootScope.reservasInminentes[posicion];
        $rootScope.tipoReserva = 1;
        $rootScope.abrirModalDetalles();
    };

    $scope.abrirReservaActual = function(posicion) {
        $rootScope.reservaSeleccionada = $rootScope.reservasActuales[posicion];
        $rootScope.tipoReserva = 2;
        $rootScope.abrirModalDetalles();
    };

    //----------------------------
    // TICKETS
    //----------------------------

    $scope.createTicketsModal = function(office, fn) {
        $rootScope.ticketOffice = office;
        
        $ionicModal.fromTemplateUrl('templates/tickets/tickets.html', {

            vista: "Tickets",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function (modalTickets) {
            
            $rootScope.modalTickets = modalTickets;
            $rootScope.modalTicketsIsClose = false;
            if(typeof fn === 'function') fn();
        });
    };

    // $rootScope.showTickets = function(office) {
    //     $log.debug("showTickets", office);
    //     $rootScope.ticketOffice = office;
    //     if ( typeof $rootScope.modalTickets === "undefined" || $rootScope.modalTicketsIsClose == true ){
    //         $scope.createTicketsModal(office, function () {
    //             $rootScope.modalTicketsCreado = true;
    //             $rootScope.modalTickets.show();
    //             $rootScope.refreshticketServices(true);
    //         });
    //     }

    //     else {
    //         $rootScope.modalTickets.show();
    //         $rootScope.refreshticketServices(true);
    //     }
    // };

    $rootScope.ticketAviso5min = false;
    $rootScope.ticketAvisoSuturno = false;
    if(localStorage['ticketCogido']) {
        $rootScope.ticketCogido = JSON.parse(localStorage['ticketCogido']);
        $log.debug("Existe el ticket: ", $rootScope.ticketCogido);
        var ticketTime = Date.parse($rootScope.ticketCogido.createdtime);
        var now = new Date();
        if(now - ticketTime > 60 * 60000) {
            $rootScope.ticketCogido = false;
            delete localStorage['ticketCogido'];
        } else {
            $scope.createTicketsModal($rootScope.ticketCogido.office, function () {
                $rootScope.refreshTicket();
            });
        }
    } else {
        $rootScope.ticketCogido = false;
    }

});