angular.module('goldcar').controller('OficinasCtrl', function ($filter, $rootScope, $scope, $ionicLoading, $ionicModal) {

    //----------------------------------
    // CREAR FUNCION DE SORTING
    //----------------------------------

    function arraySorting(property){
        var sortOrder = 1;
        if(property[0] === "-") {
            sortOrder = -1;
            property = property.substr(1);
        }
        return function (a,b) {
            var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
            return result * sortOrder;
        }
    };

    //----------------------------------
    // CREAR MODAL DE OFICINAS POR PAIS
    //----------------------------------

    $rootScope.createModalOficinas = function(fn) {
        $ionicModal.fromTemplateUrl('templates/oficinas/oficinas.html', {

            vista: "Oficinas en " + $rootScope.paisSeleccionado,
            scope: $rootScope,
            id: "oficinas",
            animation: 'slide-in-right'
        }).then(function(modalOficinas) {
            $rootScope.modalOficinas = modalOficinas;
            if(fn) fn();
        });
    };

    //----------------------------------
    // COMPROBAR SI YA EXISTEN OFICINAS
    //----------------------------------

    $scope.checkOficinas = function() {

        var status = false;

        if(typeof $rootScope.paises !== 'undefined') {

            while($rootScope.paises.length <= 0){
                if(!status){
                    $ionicLoading.show({
    
                        template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 15px;">' + $filter("translate")($rootScope.translations.loading.cargando_oficinas) + '</i><br><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
                    });
                    status = true;
                }
            }
        } else {

            $ionicLoading.hide();
        }

        if(status)
            $ionicLoading.hide();
    };

    //----------------------------------
    // ABRIR PAIS DESEADO
    //----------------------------------

    $rootScope.abrirPais = function(posicion, nombrePais) {

        $rootScope.oficinas = [];
        $rootScope.paisSeleccionado = nombrePais;

        $rootScope.todasLasOficinas[posicion].offices.forEach(function (oficina) {
            var tipoIcono;
            if(oficina.type == null)
                tipoIcono = 0;                             //EDIFICIO
            else{
                if(oficina.type == 'airport')
                    tipoIcono = 1;                         //AEROPUERTO
                if(oficina.type == 'train-station')
                    tipoIcono = 2;                         //TREN AVE
            }

            $rootScope.oficinas.push({
                nombreCorto: oficina.name,
                nombre: oficina.fullname,
                tipoIcono: tipoIcono,
                id: oficina.code
            });
        });

        $rootScope.oficinas.sort(arraySorting("nombreCorto"));
        if ( typeof $rootScope.modalOficinas === "undefined" ) {

            $rootScope.createModalOficinas(function () {
                $rootScope.modalOficinas.show();
            });
        } else {

            $rootScope.modalOficinas.show();
        }
    };
});