angular.module('goldcar').controller('FiturCtrl', function ($scope, $rootScope, Ionicitude, $ionicLoading, $ionicPopup, $ionicModal, $timeout) {

    $scope.getMatriculas = function () {

        if ( localStorage['matriculasCreadas'] ) {

            $scope.matriculasCreadas = JSON.parse(localStorage['matriculasCreadas']);
        } else {

            $scope.matriculasCreadas = [];
        }
    };

    $scope.getMatriculas();

    $scope.abrirModalMatricula = function () {

        if ( typeof $rootScope.modalCrearMatricula === 'undefined' ) {

            $ionicModal.fromTemplateUrl('templates/promo_fitur/modal_crear_matricula.html', {

                vista: "Crear matricula",
                scope: $rootScope,
                animation: 'slide-in-right'
            }).then(function(modalCrearMatricula) {

                $rootScope.modalCrearMatricula = modalCrearMatricula;
                modalCrearMatricula.show();
            });
        } else {

            $rootScope.modalCrearMatricula.show();
        }
    };

    $scope.cerrarModalMatricula = function () {

        $rootScope.modalCrearMatricula.remove();
        $rootScope.modalCrearMatricula = undefined;
    };

    $scope.matricula = [];

    $scope.guardarMatriculaNueva = function () {

        if ( localStorage['matriculasCreadas'] ) {

            var matriculas = [];
            matriculas = JSON.parse(localStorage['matriculasCreadas']);
            matriculas.push({
                'texto': $scope.matricula.name
            });

            localStorage['matriculasCreadas'] = JSON.stringify(matriculas);
        } else {

            var matriculas = [];
            matriculas.push({
                'texto': $scope.matricula.name
            });

            localStorage['matriculasCreadas'] = JSON.stringify(matriculas);
        }

        $scope.cerrarModalMatricula();
    };

    $scope.$on('modal.removed', function () {

        $scope.getMatriculas();
    });

    $scope.seleccionaMatricula = false;

    $scope.seleccionarMatricula = function (index) {

        console.log('Matricula seleccionada: ' + index);
        $scope.seleccionaMatricula = true;
    };

    $scope.eliminarMatricula = function (index) {

        $scope.matriculasCreadas.splice(index, 1);
        localStorage['matriculasCreadas'] = JSON.stringify($scope.matriculasCreadas);
    };

    $scope.generarAR = function () {

        console.log('AR Generada');
    };
});