angular.module('goldcar').controller('RaCtrl', function ($scope, $rootScope, Ionicitude, $ionicLoading, $ionicPopup) {

    console.log(ionic.Platform.platform());
    console.log(ionic.Platform.isWebView());

    $ionicLoading.show({

        template: 'Cargando realidad aumentada..<br><br><ion-spinner></ion-spinner>'
    });

    if ( ionic.Platform.isIOS() || ionic.Platform.isAndroid() ) {

        Ionicitude.checkDevice().then(function (success) {

            console.log("Ionicitude is available for this device.");
            console.log(success);

            Ionicitude.ready(function () {

                setTimeout(function () {

                    $ionicLoading.hide();
                }, 1000);
            });
        }).catch(function (error) {

            console.log("Seems like your device is not available to load Ionicitude.");
            console.log(error);
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: 'Atención',
                template: 'Tu dispositivo no es compatible con la realidad aumentada.'
            });
            $rootScope.goTo('menu.home');
        });
    } else {

        $ionicLoading.hide();
        $ionicPopup.alert({
            title: 'Atención',
            template: 'Tu dispositivo no es compatible con la realidad aumentada.'
        });
        $rootScope.goTo('menu.home');
    }

    $scope.openWorld = function (worldName) {

        if ( worldName == 'world_fitur' ) {

            Ionicitude.launchAR(worldName).then(function (success) {

                console.log('Mundo cargado correctamente.');
                console.log(success);

                var textoMatriculaSeleccionado = 'Carlos MARTINEZ'; // TEXTO PARA PONER EN LA MATRICULA

                Ionicitude.callJavaScript("World.getPegatina('" + textoMatriculaSeleccionado + "');"); // LLAMADA A LA FUNCION QUE APLICA EL TEXTO A LA MATRICULA DINAMICAMENTE

            }).catch(function (error) {

                console.log('Error al cargar el mundo.');
                console.log(error);
            });
        } else {

            Ionicitude.launchAR(worldName).then(function (success) {

                console.log('Mundo cargado correctamente.');
                console.log(success);

            }).catch(function (error) {

                console.log('Error al cargar el mundo.');
                console.log(error);
            });
        }
    }
});