angular.module('goldcar').controller('DisponibilidadCtrl', function ($state, $ionicPopup, $stateParams, $scope, $ionicModal, $ionicLoading, $rootScope, $log, $ionicHistory, $location, Session, GoldcarService, $filter, $ionicSlideBoxDelegate, $timeout, $ionicScrollDelegate) {

    $rootScope.tituloDisponibilidad = "Disponibilidad";
    $rootScope.mostrarResumen = false;
    $rootScope.mostrarExtras = false;
    $rootScope.seleccionadoGrupo = false;

    function cambiarTituloDisponibilidad(texto) {

        $.Velocity.animate($('.all-titles'), { opacity: 0 }).then(function (element) {

            $rootScope.tituloDisponibilidad = texto;
            $('.all-titles').velocity({ opacity: 1 }, { delay: 300 });
        });
    }

    $scope.showFooter = false;

    $scope.showModalInformation = function (value) {

        console.log("informationRent" + value);
        $scope.tariff = value;
        $scope.informationRent.show();
    }


    $ionicModal.fromTemplateUrl('templates/reservar/information.html', {
        vista: 'Personaliza tu tarifa',
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.informationRent = modal;
    });



    $rootScope.closeModalInformationRent = function () {
        $scope.informationRent.hide();
    };



    //*****
    //***** CONFIGURA TUS TARIFA
    //*****

    $scope.tariff = {};
    $scope.tariff.cb1 = false;
    $rootScope.cb1 = false;




    //*******
    //******* ADD TARIFF
    //*******

    $scope.sumTotalTariff = [];



    $scope.flagTariff = '';
    $rootScope.isDisabled = false;
    $scope.kilo90Disabled = false;
    $rootScope.tarifaSeleccionada = '';

    //*******
    //******* ADD EXTRAS
    //*******

    $scope.sumTotalExtras = [];
    $rootScope.listOfExtras = [];
    $rootScope.arrayExtras = [];
    $scope.showTariff = false;
    $scope.setTariff = [];
    $scope.setExtras = [];
    $scope.setPackage = [];
    $rootScope.radioTrue = [];
    $rootScope.disableKeynGoTariff = false;
    $rootScope.disableCancelable = false;
    $scope.grupo = [];

    // ******************************* //
    // ANIMACIONES SET TARIFA Y EXTRAS //
    // ******************************* //

    // AUTO SCROLL A TARIFA //
    var scrollTimer;
    $scope.semaforoScroll = false;

    $rootScope.comprobarScroll = function (categoria) {

        if($scope.semaforoScroll) return;

        if (scrollTimer) $timeout.cancel(scrollTimer);
        var position = $ionicScrollDelegate.$getByHandle('scroll-' + categoria).getScrollPosition();

        scrollTimer = $timeout(function () {
            var widthCard = $('.tarjeta-' + categoria + '-0').outerWidth(true);
            var posicion_cards = Math.round(position.left / widthCard);

            scrollGrupoSeleccionado('tarjeta-' + categoria + '-' + posicion_cards, posicion_cards, categoria, false);
        }, 500);
    }

    function scrollGrupoSeleccionado(element, index, categoria, force) {

        var tamanyo_elementos = $('.' + element).outerWidth(true);
        var total_tamanyo = tamanyo_elementos;
        var position = total_tamanyo * index;
        var scroll = $("#scroll-" + categoria);
        var handleScroll = $ionicScrollDelegate.$getByHandle('scroll-' + categoria);

        if(typeof handleScroll.getScrollPosition() !== "undefined") {
            var left = Math.floor(handleScroll.getScrollPosition().left);
            if(force || (left != position && (!scroll.data("lastPosition") || scroll.data("lastPosition") != left))) {
                scroll.data("lastPosition", left);
                handleScroll.scrollTo(position, 0, true);
                if($rootScope.seleccionadoGrupo) {
                  var grp = $filter("filter")(
                                $filter("filter")(
                                    $scope.categories,
                                    {"Idgrupocategoria" : categoria}
                                )[0].grupos,
                                {"grupo" : $("." + element).data("grp")}
                              )[0];
                  $scope.selectCar(grp, categoria, index, false);
                }
            }
        }
        $scope.semaforoScroll=false;

    }

    function animacionSetTariff(cat, element, index, categoria_final) {
        // $.Velocity.mock = 6;
        $.Velocity.animate($('.set-tariff'), { 'top': '206px' }, { duration: 650 }).then(function() {
            $('.cat-' + cat).css({ 'position': '' });
            scrollGrupoSeleccionado(element, index, categoria_final, true);
            $rootScope.seleccionadoGrupo = true;
        });
    }

    // ANIMACION AL SELECCIONAR GRUPO //
    function animacionDisponibilidad(category, index, element) {

        var categoria_final = "";
        var categorias = $scope.categories;

        // $.Velocity.mock = 6;

        $.Velocity.animate($('.titulo-categoria'), { translateX: '-100%', opacity: 0 }).then(function (element) {

            $.Velocity.animate($(element), { height: 0, padding: 0 }).then(function (element) {

                $(element).css({ "display": 'none' });
            })
        });

        for (var i in categorias) {
            if (categorias[i].Idgrupocategoria != category) {
                $.Velocity.animate($('.cat-' + categorias[i].Idgrupocategoria), { translateX: '-100%', opacity: 0 }).then(function (element) {
                    $(element).velocity({ 'padding-bottom': 0 });
                    $.Velocity.animate($(element), { height: 0 });
                });
            } else {
                categoria_final = categorias[i].Idgrupocategoria;
                var categoryDiv = $('.cat-' + categoria_final);
                categoryDiv.css({ 'position': 'absolute' });
                var top = (categoryDiv.position()).top;
                categoryDiv.css({ 'top': top });
                categoryDiv.detach().appendTo('.content-disponibilidad');
                $ionicScrollDelegate.$getByHandle('scroll_disponibilidad').scrollTop(true);
                $.Velocity.animate(categoryDiv, { 'top': '5px' }).then(function (element) {
                    categoryDiv.detach().insertBefore('.set-tariff');
                })
            }
        }

        $('.container-categoria').velocity({ 'padding-bottom': 0 });

        $.Velocity.animate($('.tarjeta-coche'), { width: '90vw' }).then(function () {

            $('.region-scroll').velocity({ height: '200px' });
            $('.bottom-tarjeta > .part-1 > img').velocity({ width: '145px' });

            $('.bottom-tarjeta > .part-2').velocity({ opacity: 0 })
            $.Velocity.animate($('.tarjeta-coche'), { height: '172px' }).then(function () {

                $.Velocity.animate($('.top-tarjeta > .part-2'), { translateY: '58%', translateX: '8%' }).then(function () {

                    $('.precio-diario').velocity({ opacity: 1 });
                    $('.region-scroll').velocity({ 'background-color': '#EFEFEF' });
                    $('.footer-precio').velocity({ height: '58px' });
                    animacionSetTariff(categoria_final, element, index, categoria_final);
                })
            })
        });
    }

    $scope.selectCar = selectCar;
    $scope.selectedGroup = null;
    $scope.tarifaConfigurada = {
        tarifa: null,
        extras: [],
        paquetes: [],
        diff_cancelable: 0,
        diff_fuel: 0,
        diff_limkm: 0,
        diff_cobertura: 0,
        diff_mostrador: 0,
        hab_no_cancelable: false,
        hab_cancelable: false,
        hab_flexfuel: false,
        hab_fullfull: false,
        hab_limkm: false,
        hab_ilimkm: false,
        hab_cobparcial: false,
        hab_cobsuper: false,
        hab_recmostrador: false,
        hab_express: false,
        hab_keyngo: false,
        cb_keyngo: false,
        cb_cancelable: false,
        cb_fuel: false,
        cb_limkm: false,
        cb_cobertura: false,
        cb_mostrador: false
    };

    $scope.changeTarifaConfigurada = function(key, value, modified) {
        $scope.tarifaConfigurada[key] = value;
        $scope.closeModalInformationRent();
        $scope.recalcularTarifaConfigurada(modified);
    }

    $scope.recalcularTarifaConfigurada = function(modified) {

      console.log("MODIFIED ",modified);

      switch (modified) {

        case 'keyngo':
          $ionicScrollDelegate.$getByHandle("scroll_disponibilidad").resize();
          break;
        case 'cancelable':
        console.log("{{tarifaConfigurada.cb_cancelable}} fuera", $scope.tarifaConfigurada.cb_cancelable);
        console.log("$scope.tarifaConfigurada.tarifa.cancelable ", $scope.tarifaConfigurada.tarifa.cancelable);
          if($scope.tarifaConfigurada.cb_cancelable && !$scope.tarifaConfigurada.tarifa.cancelable) {
            var nextTarifa = $filter("orderBy")($filter("filter")(objectValues($rootScope.setTariff.tarifas), { cancelable: true }), "precio_totalf")[0];
            $scope.tarifaConfigurada.tarifa = nextTarifa;
            $scope.tarifaConfigurada.cb_cancelable = true;
            $scope.tarifaConfigurada.cb_fuel = nextTarifa.fuel;
            console.log("{{tarifaConfigurada.cb_cancelable}} if", $scope.tarifaConfigurada.cb_cancelable);
            if(nextTarifa.fuel == 'FullFuel') $scope.tarifaConfigurada.cb_limkm = 1;
          }
          else if(!$scope.tarifaConfigurada.cb_cancelable && $scope.tarifaConfigurada.tarifa.cancelable) {
            var nextTarifa = $filter("orderBy")($filter("filter")(objectValues($rootScope.setTariff.tarifas), { cancelable: false }), "precio_totalf")[0];
            $scope.tarifaConfigurada.tarifa = nextTarifa;
            $scope.tarifaConfigurada.cb_cancelable = false;
            console.log("{{tarifaConfigurada.cb_cancelable}} else", $scope.tarifaConfigurada.cb_cancelable);
            $scope.tarifaConfigurada.cb_fuel = nextTarifa.fuel;
          }
          break;

        case 'fuel':

            if($scope.tarifaConfigurada.cb_fuel == 'FlexFuel' && $scope.tarifaConfigurada.tarifa.fuel != 'FlexFuel') {
              var nextTarifa = $filter("orderBy")($filter("filter")(objectValues($rootScope.setTariff.tarifas), { fuel: "FlexFuel", cancelable: $scope.tarifaConfigurada.cb_cancelable }), "precio_totalf")[0];
              if(nextTarifa) {
                $scope.tarifaConfigurada.tarifa = nextTarifa;
                $scope.tarifaConfigurada.cb_fuel = nextTarifa.fuel;
              } else {
                var nextTarifa = $filter("orderBy")($filter("filter")(objectValues($rootScope.setTariff.tarifas), { fuel: "FlexFuel" }), "precio_totalf")[0];
                $scope.tarifaConfigurada.tarifa = nextTarifa;
                $scope.tarifaConfigurada.cb_cancelable = nextTarifa.cancelable;
                $scope.tarifaConfigurada.cb_fuel = nextTarifa.fuel;
              }
            }
            else if($scope.tarifaConfigurada.cb_fuel == 'FullFuel' && $scope.tarifaConfigurada.tarifa.fuel != 'FullFuel') {
              var nextTarifa = $filter("orderBy")($filter("filter")(objectValues($rootScope.setTariff.tarifas), { fuel: "FullFuel"}), "precio_totalf")[0];
              $scope.tarifaConfigurada.tarifa = nextTarifa;
              $scope.tarifaConfigurada.cb_cancelable = true;
              $scope.tarifaConfigurada.cb_fuel = nextTarifa.fuel;
              $scope.tarifaConfigurada.cb_limkm = 1;
            }

            break;

          case 'cobertura':

            if($scope.tarifaConfigurada.cb_cobertura) {
                $scope.tarifaConfigurada.extras.push($scope.tarifaConfigurada.superelax_extra);
            } else {
                $scope.tarifaConfigurada.extras.splice($scope.tarifaConfigurada.extras.indexOf($scope.tarifaConfigurada.superelax_extra), 1);
            }

            break;

          case 'mostrador':

            if($scope.tarifaConfigurada.cb_mostrador == 0) {
                $scope.tarifaConfigurada.extras.push($scope.tarifaConfigurada.expressservice_extra);
            } else {
                $scope.tarifaConfigurada.extras.splice($scope.tarifaConfigurada.extras.indexOf($scope.tarifaConfigurada.expressservice_extra), 1);
            }

            break;

        default:

      }

      if($scope.tarifaConfigurada.cb_fuel == 'FlexFuel') $scope.tarifaConfigurada.cb_limkm = 0;
      $scope.tarifaConfigurada.hab_limkm = $scope.tarifaConfigurada.tarifa.fuel == 'FullFuel';


      if($scope.tarifaConfigurada.paquete_kmilimitados) {
        var existPaqueteKMIlimitados = $scope.tarifaConfigurada.paquetes.indexOf($scope.tarifaConfigurada.paquete_kmilimitados)>-1;
        if($scope.tarifaConfigurada.cb_limkm == 0 && $scope.tarifaConfigurada.cb_fuel == 'FullFuel') {
          if(!existPaqueteKMIlimitados) $scope.tarifaConfigurada.paquetes.push($scope.tarifaConfigurada.paquete_kmilimitados);
        }
        else if($scope.tarifaConfigurada.cb_limkm == 1 && existPaqueteKMIlimitados){
           $scope.tarifaConfigurada.paquetes.splice($scope.tarifaConfigurada.paquetes.indexOf($scope.tarifaConfigurada.paquete_kmilimitados),1);
        }
      } else {
        if($scope.tarifaConfigurada.cb_fuel == 'FullFuel') {
          $scope.tarifaConfigurada.cb_limkm = 1;
          $scope.tarifaConfigurada.hab_ilimkm = false;
        } else {
          $scope.tarifaConfigurada.hab_ilimkm = true;
        }
      }


      console.log("TARIFAS", $rootScope.setTariff.tarifas);
      console.log('recalcularTarifaConfigurada init', $scope.tarifaConfigurada);

      /*
      diff_cancelable: 0,
      diff_fuel: 0,
      diff_limkm: 0,
      diff_cobertura: 0,
      diff_mostrador: 0,
      */
      $scope.tarifaConfigurada.diff_cancelable = 0;
      if($scope.tarifaConfigurada.tarifa.tarifa_id !== $scope.selectedGroup.minTarifa.tarifa_id && $scope.tarifaConfigurada.tarifa.fuel == $scope.selectedGroup.minTarifa.fuel) {
          $scope.tarifaConfigurada.diff_cancelable = (parseFloat($scope.tarifaConfigurada.tarifa.precio_totalf) - parseFloat($scope.selectedGroup.minTarifa.precio_totalf));
      }

      $scope.tarifaConfigurada.diff_fuel = 0;
      if($scope.tarifaConfigurada.tarifa.fuel != $scope.selectedGroup.minTarifa.fuel)
        $scope.tarifaConfigurada.diff_fuel = (parseFloat($scope.tarifaConfigurada.tarifa.precio_totalf) - parseFloat($scope.selectedGroup.minTarifa.precio_totalf));

      $scope.tarifaConfigurada.diff_limkm = 0;
      if($scope.tarifaConfigurada.paquetes.indexOf($scope.tarifaConfigurada.paquete_kmilimitados)>-1) {
        $scope.tarifaConfigurada.diff_limkm = parseFloat($scope.tarifaConfigurada.paquete_kmilimitados.preciof);
      }

      $scope.tarifaConfigurada.diff_cobertura = 0;
      if($scope.tarifaConfigurada.extras.indexOf($scope.tarifaConfigurada.superelax_extra)>-1) {
        $scope.tarifaConfigurada.diff_cobertura = parseFloat($scope.tarifaConfigurada.superelax_extra.precio_total);
      }


      $scope.tarifaConfigurada.diff_mostrador = 0;
      if($scope.tarifaConfigurada.extras.indexOf($scope.tarifaConfigurada.expressservice_extra)>-1) {
        $scope.tarifaConfigurada.diff_mostrador = parseFloat($scope.tarifaConfigurada.expressservice_extra.precio_total);
      }


      if($scope.tarifaConfigurada.cb_keyngo)
        $scope.tarifaConfigurada.total = parseFloat($scope.tarifaConfigurada.precio_keyngo.toString().replace(',','.'));
      else
        $scope.tarifaConfigurada.total =
            $scope.selectedGroup.minTarifa.precio_totalf
            + $scope.tarifaConfigurada.diff_cancelable
            + $scope.tarifaConfigurada.diff_fuel
            + $scope.tarifaConfigurada.diff_limkm
            + $scope.tarifaConfigurada.diff_cobertura
            + $scope.tarifaConfigurada.diff_mostrador;

      $rootScope.totalTariff = $scope.tarifaConfigurada.total;
      $rootScope.tarifaConfigurada = $scope.tarifaConfigurada;

      console.log('recalcularTarifaConfigurada end', $scope.tarifaConfigurada);

      $scope.session.Fuel = $scope.tarifaConfigurada.cb_fuel;
      $scope.session.group = $rootScope.setTariff.grupo;
      console.log("Fuel and Group ", $scope.session.Fuel, $scope.session.group);

      Session.set(angular.merge({}, $scope.session, {
          group: $scope.session.group,
          Fuel: $scope.session.Fuel
        })).then(function () {


      });


    }//end recalcularTarifaConfigurada

    // $scope.showModalInformation = function (value) {
    //
    //     console.log("informationRent" + value);
    //     $scope.tariff = value;
    //     $scope.informationRent.show();
    // }
    //
    //
    // $ionicModal.fromTemplateUrl('templates/disponibilidad/upgrade.html', {
    //     vista: 'upgrade',
    //     scope: $scope,
    //     animation: 'slide-in-up'
    // }).then(function (modal) {
    //     $scope.upgradeModal = modal;
    // });
    // $rootScope.closeModalUpgradeModal = function () {
    //     $scope.upgradeModal.hide();
    // };
    $scope.IWant = function (){
        console.log("i want ",$scope.upgradeData);

        $scope.cerrarUpgrade();
    }

    $scope.showUpgrade = function () {

        var upgradeConfirm = $ionicPopup.confirm({

            templateUrl: 'templates/reservar/upgrade.html',
            cssClass: 'upgradeConfirm',
            scope: $scope,
            buttons: [
                { text: 'no lo quiero'},
                { text: 'lo quiero' }
            ]
        });

        upgradeConfirm.then( function (res ) {

            if( res ){

                console.log('you are sure', res);
            }else{

                console.log('you are not sure');
            }
        })

        $scope.cerrarUpgrade = function () {

            upgradeConfirm.close();
        }
    };

    function selectCar(grupo, category, index, withAnimations) {

        $scope.upgradeDatas = {};

        GoldcarService.getSubirGrupo().then ( function ( result ) {
            console.log("DATA UPGRADE", result);

            $scope.upgradeDatas = result.data;

        });


        $scope.showUpgrade();

        if($scope.selectedGroup && $scope.selectedGroup.grupo == grupo.grupo) return;
        $scope.selectedGroup = grupo;

        $scope.tarifaConfigurada = {
            tarifa: grupo.minTarifa,
            extras: [],
            paquetes: [],
            diff_cancelable: 0,
            diff_fuel: 0,
            diff_limkm: 0,
            diff_cobertura: 0,
            diff_mostrador: 0,
            hab_no_cancelable: false,
            hab_cancelable: false,
            hab_flexfuel: false,
            hab_fullfull: false,
            hab_limkm: false,
            hab_ilimkm: false,
            hab_cobparcial: false,
            hab_cobsuper: false,
            hab_recmostrador: false,
            hab_express: false,
            hab_keyngo: false,
            cb_keyngo: false,
            cb_cancelable: false,
            cb_fuel: false,
            cb_limkm: false,
            cb_cobertura: false,
            cb_mostrador: false,
            paquete_kmilimitados: false,
            total: 0
        };

        //SCROLL REPOSITION
        $scope.semaforoScroll=true;
        var handleScroll = $ionicScrollDelegate.$getByHandle('scroll-' + category);
        if(typeof handleScroll.getScrollPosition() !== "undefined") {
            var left = Math.floor(handleScroll.getScrollPosition().left);
            $("#scroll-" + category).data("lastPosition", left);
        }
        //END REPOSITION

        var element = 'tarjeta-' + category + '-' + index;
        var price = grupo.minTarifa != null ? grupo.minTarifa.precio_totalf : parseFloat(grupo.preciof) ;
        cambiarTituloDisponibilidad("Personaliza tu tarifa");

        if(withAnimations) {
          if(!$rootScope.seleccionadoGrupo) {
            animacionDisponibilidad(category, index, element);
          } else {
            scrollGrupoSeleccionado(element, index, category, true);
          }
        }

        $scope.showFooter = true;
        $rootScope.setTariff = $filter('filter')($scope.categories, {"Idgrupocategoria" : category})[0].grupos[index];

        Session.set(angular.merge({}, $scope.session, { group: grupo.grupo, paquetes: [] })).then(function () {
            GoldcarService.getDatosGrupo().then(function (data) {

                $scope.divisa = data.data.divisa;
                $rootScope.divisaFinal = data.data.divisa;

                $scope.tiposDePago = data.data.formas_pago;
                var extrasMostrar = data.data.extras;
                $rootScope.todosExtrasMostrar = [];
                $rootScope.todasSillas = [];

                var cobSuperRelaxExtra = null;
                var expressServiceExtra = null;

                for (var i in extrasMostrar) {

                    if (extrasMostrar[i].disponible && extrasMostrar[i].alias == 'CoverSuperRelax') cobSuperRelaxExtra = extrasMostrar[i];
                    if (extrasMostrar[i].disponible && extrasMostrar[i].alias == 'ExpressService') expressServiceExtra = extrasMostrar[i];

                    if (extrasMostrar[i].disponible && extrasMostrar[i].alias != 'CoverSuperRelax' && extrasMostrar[i].alias != 'ExpressService') {
                        extrasMostrar[i].selected = false;
                        if (extrasMostrar[i].alias == 'MaxiCosi' || extrasMostrar[i].alias == 'BabySeat' || extrasMostrar[i].alias == 'BoosterSeat') {
                            extrasMostrar[i].cantidad = 0;
                            $rootScope.todasSillas.push(extrasMostrar[i]);
                        } else {
                            $rootScope.todosExtrasMostrar.push(extrasMostrar[i]);
                        }
                    }

                }

                $scope.grupo = data.data;
                var packIlimitKM = null;

                if ( typeof data.data.paquetes != 'undefined' ) {

                  for (var i = 0; i < data.data.paquetes.length; i++) {
                      // $scope.setPackage.push(data.data.paquetes[i]);
                      if (data.data.paquetes[i].reference == "15106") { //Pack Tarifa Full/Full + Kilómetros Ilimitados
                          if (data.data.paquetes[i].disponible == true) {
                              packIlimitKM = data.data.paquetes[i];

                          }
                      }
                  }
                }

                var tarifasArray = objectValues($rootScope.setTariff.tarifas);
                console.log("$rootScope.setTariff", $rootScope.setTariff);
                console.log("tarifasArray", tarifasArray);
                var hasKeyNGo = $rootScope.setTariff.PackKeyngo !== null;
                var hasCancelable = $filter("filter")(tarifasArray, { cancelable: true}).length > 0;
                var hasNoCancelable = $filter("filter")(tarifasArray, { cancelable: false}).length > 0;
                var hasFlexFuel = $filter("filter")(tarifasArray, { fuel: "FlexFuel"}).length > 0;
                var hasFullFull = $filter("filter")(tarifasArray, { fuel: "FullFuel"}).length > 0;
                var hasLimitKm = hasFullFull;
                var hasIlimitKm = hasFlexFuel || packIlimitKM!= null;

                $scope.tarifaConfigurada.tarifa = grupo.minTarifa;
                $scope.tarifaConfigurada.hab_keyngo = hasKeyNGo;
                $scope.tarifaConfigurada.precio_keyngo = hasKeyNGo ? $rootScope.setTariff.PackKeyngo.precio_total : null;

                $scope.tarifaConfigurada.hab_no_cancelable =  hasNoCancelable;
                $scope.tarifaConfigurada.hab_cancelable =  hasCancelable;
                $scope.tarifaConfigurada.cb_cancelable =  grupo.minTarifa.cancelable;

                $scope.tarifaConfigurada.hab_flexfuel = hasFlexFuel;
                $scope.tarifaConfigurada.hab_fullfull = hasFullFull;
                $scope.tarifaConfigurada.cb_fuel = grupo.minTarifa.tarifa_fuel;

                $scope.tarifaConfigurada.hab_limkm = hasLimitKm && grupo.minTarifa.tarifa_fuel == "FullFuel";
                $scope.tarifaConfigurada.hab_ilimkm = hasIlimitKm;
                $scope.tarifaConfigurada.cb_limkm = grupo.minTarifa.tarifa_fuel == "FlexFuel" ? 0  : 1;

                $scope.tarifaConfigurada.hab_cobparcial = true;
                $scope.tarifaConfigurada.hab_cobsuper = cobSuperRelaxExtra != null;
                $scope.tarifaConfigurada.cb_cobertura = 0;

                $scope.tarifaConfigurada.hab_recmostrador = true;
                $scope.tarifaConfigurada.hab_express = expressServiceExtra != null;
                $scope.tarifaConfigurada.cb_mostrador = 1;

                $scope.tarifaConfigurada.paquete_kmilimitados = packIlimitKM;
                $scope.tarifaConfigurada.superelax_extra = cobSuperRelaxExtra;
                $scope.tarifaConfigurada.expressservice_extra = expressServiceExtra;

                $scope.recalcularTarifaConfigurada(null);
            });
        });


        $rootScope.totalTariff = price;

        $rootScope.totalTariffEnt = Math.floor($rootScope.totalTariff);
        $rootScope.totalTariffDecimal = 100 * ($rootScope.totalTariff - $rootScope.totalTariffEnt).toFixed(2);
        console.log($scope.tarifaConfigurada);

        $scope.showTariff = true;
    }

    // CONTINUAR DESPUES DE DISPONIBILIDAD Y TARIFA //
    $rootScope.mostrarExtras = false;

    function animacionMostrarExtras() {

        $.Velocity.animate($('.set-tariff'), { 'translateY': '100%' }, { duration: 650 }).then(function (element) {

            $timeout(function() {

                $ionicScrollDelegate.$getByHandle('content-disponibilidad').resize();

                $('.set-tariff').css({ 'top': '100%', 'translateY': '0', 'display': 'none' });

                $rootScope.seleccionadoGrupo = false;
                $rootScope.mostrarExtras = true;

                $.Velocity.animate($('.set-extras'), { 'top': '206px' }, { duration: 650 }).then(function (element) {

                });
            });
        });
    }

    function animacionMostrarResumen() {

        $('.footer-precio').velocity({ translateY: '100%' });
        $.Velocity.animate($('.set-extras'), { 'translateY': '100%' }, { duration: 650 }).then(function (element) {

            $timeout(function() {

                $('.set-extras').css({ 'top': '', 'translateY': '' });
                $rootScope.seleccionadoGrupo = false;
                $rootScope.mostrarExtras = false;
                $rootScope.mostrarResumen = true;
                $.Velocity.animate($('.set-tariff-next-process'), { 'top': '206px' }, { duration: 650 }).then(function (element) {

                  $ionicScrollDelegate.$getByHandle('scroll_disponibilidad').resize();
                });
            });
        });
    }

    function blockScroll() {

        $ionicScrollDelegate.$getByHandle('scroll-' + $scope.selectedGroup.Idgrupocategoria).freezeScroll(true);
    }

    $scope.countProcess = 0;
    $scope.nextProcess = function () {

        $ionicScrollDelegate.$getByHandle('scroll_disponibilidad').scrollTop(true);

        setTimeout(function () {

            if ($scope.countProcess == 0) {

                cambiarTituloDisponibilidad("Configura tus extras");

                blockScroll();

                getCodigosPromocionales();

                animacionMostrarExtras();

                $scope.countProcess++
            } else {
                $scope.showPago = $scope.tiposDePago.indexOf("pago")>-1;
                $scope.showPostpago = $scope.tiposDePago.indexOf("postpago")>-1 && $scope.tarifaConfigurada.cb_keyngo == 0;

                if($scope.tarifaConfigurada.cb_keyngo) {
                  $rootScope.paquetes_dispon = [ { "reference": "15100" } ];
                  $scope.session.Fuel = "FullFuel";
                } else {
                  $rootScope.paquetes_dispon = [];
                  for ( var i = 0; i < $scope.tarifaConfigurada.paquetes.length; i++ ) {
                    var item = $scope.tarifaConfigurada.paquetes[i];
                    $rootScope.paquetes_dispon.push({
                        "cantidad": 1,
                        "extras": item.extras,
                        "precio": item.preciof,
                        "reference": item.reference,
                        "tarifa": item.tarifa,
                        "unico": true
                    });
                  }
                }
                $rootScope.addedExtras = $.merge($scope.tarifaConfigurada.extras, $rootScope.addedExtras);

                $scope.countProcess = 0;
                // $state.go("menu.detallesReserva");
                cambiarTituloDisponibilidad("Resumen de tu reserva");

                addSillasToExtras();

                animacionMostrarResumen();
            }
        }, 500);
    }




    //*****
    //***** CONFIGURA TUS EXTRAS
    //*****
    $scope.data = {};
    $scope.data.cb1 = false;
    $scope.data.cb2 = false;
    $scope.data.cb3 = false;
    $scope.data.cb4 = false;
    $scope.data.cb5 = false;
    $scope.data.cb6 = false;
    $scope.data.cb7 = false;

    //*******   COUNTER SILLITAS      *******//
    $scope.counter = 0;
    $scope.counter2 = 0;
    $scope.counter3 = 0;
    $scope.min = 0;
    $scope.max = 3;
    $scope.sumMaxiCosi = 0;
    $scope.isBoosterSeatDisabled = false;
    $scope.isMaxiCosiDisabled = false;
    $scope.isBabySeatDisabled = false;

    $scope.increase3 = function (tipo, status, tariff, stage) {


        if (tipo === 'BoosterSeat' && $scope.counter3 < 3 && totalSillas < 3) {

            $scope.counter3++;

            totalSillas++;

            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.counter3);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);

            $scope.changeTariffExtras(status, tariff, stage);

            if ($scope.counter3 == 3) {
                $scope.isBabySeatDisabled = true;
                $scope.isMaxiCosiDisabled = true;

            }
            if ($scope.counter3 == 2 && $scope.counter2 == 1 || $scope.counter2 == 2 && $scope.counter3 == 1) {
                $scope.isMaxiCosiDisabled = true;

            }
            if ($scope.counter3 == 2 && $scope.counter == 1 || $scope.counter == 2 && $scope.counter3 == 1) {
                $scope.isBabySeatDisabled = true;

            }

        } else if (tipo === 'BabySeat' && $scope.counter2 < 3 && totalSillas < 3) {

            $scope.counter2++;
            totalSillas++;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.counter2);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);

            $scope.changeTariffExtras(status, tariff, stage);

            if ($scope.counter2 == 3) {
                $scope.isBoosterSeatDisabled = true;

            }
            if ($scope.counter2 == 2 && $scope.counter == 1 || $scope.counter == 2 && $scope.counter2 == 1) {
                $scope.isBoosterSeatDisabled = true;

            }
            if ($scope.counter2 == 2 && $scope.counter3 == 1 || $scope.counter3 == 2 && $scope.counter2 == 1) {
                $scope.isMaxiCosiDisabled = true;

            }

        } else if (tipo === 'MaxiCosi' && $scope.counter < 3 && totalSillas < 3) {

            $scope.counter++;
            totalSillas++;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.counter);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);

            $scope.changeTariffExtras(status, tariff, stage);

            if ($scope.counter == 3) {
                $scope.isBabySeatDisabled = true;
                $scope.isBoosterSeatDisabled = true;

            }
            if ($scope.counter == 2 && $scope.counter2 == 1 || $scope.counter == 1 && $scope.counter2 == 2) {
                $scope.isBoosterSeatDisabled = true;

            }
            if ($scope.counter == 2 && $scope.counter3 == 1 || $scope.counter3 == 2 && $scope.counter == 1) {
                $scope.isBabySeatDisabled = true;

            }
        }
    };

    $scope.decrement3 = function (tipo, status, tariff, stage) {

        if (tipo === 'BoosterSeat' && $scope.counter3 >= 1 && totalSillas > 0) {

            $scope.counter3--;
            totalSillas--;

            $scope.changeTariffExtras(status, tariff, stage);

            if ($scope.counter3 == 0 && $scope.data.cb7 == true) {

                $scope.data = { cb7: false };
            }

            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.counter3);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
            $scope.isBabySeatDisabled = false;
            $scope.isMaxiCosiDisabled = false;

        } else if (tipo === 'BabySeat' && $scope.counter2 >= 1 && totalSillas > 0) {

            $scope.isBoosterSeatDisabled = false;
            $scope.isMaxiCosiDisabled = false;
            $scope.counter2--;
            totalSillas--;

            $scope.changeTariffExtras(status, tariff, stage);

            if ($scope.counter2 == 0 && $scope.data.cb6 == true) {

                $scope.data = { cb6: false };
            }

            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.counter2);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);

        } else if (tipo === 'MaxiCosi' && $scope.counter >= 1 && totalSillas > 0) {

            $scope.isBoosterSeatDisabled = false;
            $scope.isBabySeatDisabled = false;

            $scope.counter--;
            totalSillas--;

            $scope.changeTariffExtras(status, tariff, stage);

            if ($scope.counter == 0 && $scope.data.cb2 == true) {

                $scope.data = { cb2: false };
            }

            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.counter);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        }
    };


    var totalSillas = 0;

    $scope.agregarSilla = function (tipoSilla, cantidad) {

        for (var i = 0; i < $rootScope.aplicadosExtras.length; i++) {

            if ($rootScope.aplicadosExtras[i].alias === tipoSilla) {

                $rootScope.aplicadosExtras[i].cantidad = cantidad;
            }
        }

    };


    $scope.mostrarSilla1 = false;
    $scope.mostrarSilla2 = false;
    $scope.mostrarSilla3 = false;

    // SELECCIONAR EXTRAS

    $rootScope.aplicadosExtras = [];
    //alias,
    $scope.seleccionarExtra = function (alias, cantidad, tipoSilla) {
        console.log(cantidad);
        console.log(tipoSilla);
        if (tipoSilla === 'BoosterSeat' && totalSillas < 3 && !$scope.mostrarSilla1) {

            $scope.mostrarSilla1 = true;
            $scope.counter3 = 1;
            if ($scope.mostrarSilla1) {

                totalSillas++;
                $log.debug("totalSillas", totalSillas);
            } else {

                totalSillas--;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if (tipoSilla === 'BoosterSeat' && $scope.mostrarSilla1) {

            if ($scope.mostrarSilla1) {

                $log.debug("CANTIDAD", cantidad);
                $scope.mostrarSilla1 = false;
                totalSillas = totalSillas - cantidad;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if (tipoSilla === 'BoosterSeat' && totalSillas == 3 && !$scope.mostrarSilla1) {

            setTimeout(function () {
                angular.element(document.querySelector('#boosterSeat')).triggerHandler('click');
            }, 500);
            totalSillas = 4;
            $log.debug("totalSillas", totalSillas);
        }

        else if (tipoSilla === 'BoosterSeat' && totalSillas == 4 && !$scope.mostrarSilla1) {

            totalSillas = 3;
            $log.debug("totalSillas", totalSillas);
        }

        if (tipoSilla === 'MaxiCosi' && totalSillas < 3 && !$scope.mostrarSilla2) {

            $scope.mostrarSilla2 = !$scope.mostrarSilla2;
            $scope.counter2 = 1;
            if ($scope.mostrarSilla2) {

                totalSillas++;
                $log.debug("totalSillas", totalSillas);
            } else {

                totalSillas--;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if (tipoSilla === 'MaxiCosi' && $scope.mostrarSilla2) {

            if ($scope.mostrarSilla2) {

                $log.debug("CANTIDAD", cantidad);
                $scope.mostrarSilla2 = false;
                totalSillas = totalSillas - cantidad;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if (tipoSilla === 'MaxiCosi' && totalSillas == 3 && !$scope.mostrarSilla2) {

            setTimeout(function () {
                angular.element(document.querySelector('#maxiCosi')).triggerHandler('click');
            }, 500);
            totalSillas = 4;
            $log.debug("totalSillas", totalSillas);
        }

        else if (tipoSilla === 'MaxiCosi' && totalSillas == 4 && !$scope.mostrarSilla2) {

            totalSillas = 3;
            $log.debug("totalSillas", totalSillas);
        }

        if (tipoSilla === 'BabySeat' && totalSillas < 3 && !$scope.mostrarSilla3) {

            $scope.mostrarSilla3 = !$scope.mostrarSilla3;
            $scope.counter = 1;
            if ($scope.mostrarSilla3) {

                totalSillas++;
                $log.debug("totalSillas", totalSillas);
            } else {

                totalSillas--;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if (tipoSilla === 'BabySeat' && $scope.mostrarSilla3) {

            if ($scope.mostrarSilla3) {

                $log.debug("CANTIDAD", cantidad);
                $scope.mostrarSilla3 = false;
                totalSillas = totalSillas - cantidad;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if (tipoSilla === 'BabySeat' && totalSillas == 3 && !$scope.mostrarSilla3) {

            setTimeout(function () {
                angular.element(document.querySelector('#babySeat')).triggerHandler('click');
            }, 500);
            totalSillas = 4;
            $log.debug("totalSillas", totalSillas);
        }

        else if (tipoSilla === 'BabySeat' && totalSillas == 4 && !$scope.mostrarSilla3) {

            totalSillas = 3;
            $log.debug("totalSillas", totalSillas);
        }

        if (typeof cantidad === 'undefined') {

            cantidad = 1;
        }

        var encontrado = false;
        var extraSeleccionado;

        $scope.grupo.extras.forEach(function (extra) {
            if (extra.alias == alias) {
                extraSeleccionado = extra;
                return;
            }
        });

        if ($rootScope.aplicadosExtras.length > 0) {

            for (var i = 0; i < $rootScope.aplicadosExtras.length; i++) {

                if (encontrado == false && extraSeleccionado.alias === $rootScope.aplicadosExtras[i].alias) {

                    $rootScope.aplicadosExtras.splice(i, 1);
                    encontrado = true;
                }
            }

            if (encontrado == false) {

                $rootScope.aplicadosExtras.push({
                    "alias": extraSeleccionado.alias,
                    "cantidad": cantidad, // REVISAR CASO SILLITAS
                    "depende": extraSeleccionado.depende,
                    "depende_paquete": extraSeleccionado.depende_paquete,
                    "descripcion": extraSeleccionado.descripcion,
                    "divisa": $scope.grupo.divisa,
                    "extras_no_compatibles": extraSeleccionado.extras_no_compatibles,
                    "precio": extraSeleccionado.precio,
                    "precio_total": extraSeleccionado.precio_total
                });
            }

        }

        else {

            $rootScope.aplicadosExtras.push({
                "alias": extraSeleccionado.alias,
                "cantidad": cantidad, // REVISAR CASO SILLITAS
                "depende": extraSeleccionado.depende,
                "depende_paquete": extraSeleccionado.depende_paquete,
                "descripcion": extraSeleccionado.descripcion,
                "divisa": $scope.grupo.divisa,
                "extras_no_compatibles": extraSeleccionado.extras_no_compatibles,
                "precio": extraSeleccionado.precio,
                "precio_total": extraSeleccionado.precio_total
            });
        }

        $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);

        if ($rootScope.aplicadoPremio && $rootScope.aplicadoPremio.Texto === 'Conductor adicional') {

            for (var i = 0; i < $rootScope.aplicadosExtras.length; i++) {

                var eliminado = false;

                if (!eliminado && $rootScope.aplicadosExtras[i].alias === 'AdditionalDriver') {

                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_incompatible) });
                    $rootScope.aplicadoPremio = {};
                    eliminado = true;
                }
            }

        }

    };



    function decodeHtml(html) {
        var txt = document.createElement("textarea");
        txt.innerHTML = html;
        return txt.value;
    }

    $scope.goBack = function () {

        $state.go('menu.home', {}, { reload: true });
    };

    // $scope.goContinue = function () {

    //     if ($scope.session.group && $scope.session.Fuel) {
    //         var selgrupo = {};
    //         $rootScope.disponibilidad.forEach(function (grupo) {
    //             if (grupo.grupo == $scope.session.group) {
    //                 selgrupo = grupo;
    //                 return;
    //             }
    //         });
    //         if (selgrupo) {
    //             $scope.seleccionaGrupo(selgrupo, $scope.session.Fuel, $scope.session.cancelable);
    //         }
    //     }
    // };

    // $scope.mostrarUpgrade = function () {

    //     var upgradePopup = $ionicPopup.show({

    //         templateUrl: 'templates/upgrade.html',
    //         cssClass: 'upgradePopup'
    //     });

    //     upgradePopup;

    //     $scope.cerrarUpgrade = function () {

    //         upgradePopup.close();
    //     }
    // };

    $scope.muestroCaracteristicas = false;
    $scope.tarifaSeleccionadaColor = false;

    $scope.seleccionaGrupo = function (grupo, tarifaId, cancelable, precio, botonApretado) {

        $log.debug("$scope.session", $scope.session);

        $scope.tarifaSeleccionadaColor = true;
        $scope.botonApretado = botonApretado;

        $rootScope.tarifaSeleccionada = tarifaId;

        if (!grupo.disponible) {

            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.disponibilidad.disponibilidad_titulo),
                template: $filter("translate")($rootScope.translations.disponibilidad.disponibilidad_texto)
            });

        } else {

            $scope.muestroPrecioDiario = !$scope.muestroPrecioDiario;

            $log.debug("GRRRRUPO", grupo);
            $log.debug("TARIFA ID", tarifaId);

            if (grupo.tarifas[tarifaId].paquetes) {

                var paquetes_disp = [{ reference: grupo.tarifas[tarifaId].paquetes }];
            } else {

                var paquetes_disp = [];
            }

            $log.debug("Session.set de seleccionaGrupo con angular.merge -> disponibilidad.js");
            Session.set(angular.merge({}, $scope.session, {
                "group": grupo.grupo,
                "Fuel": grupo.tarifas[tarifaId].tarifa_fuel,
                "cancelable": cancelable,
                "extras_disponibilidad": [],
                "paquetes_disponibilidad": paquetes_disp,
                "extras": [],
                "extras_seleccionados": [],
                "extras_obligatorios": [],
                "paquetes": paquetes_disp,
                "premios": []
            })).then(function () {

                $rootScope.upgrade = $scope.getUpgrade(grupo, tarifaId, precio);

                if ($rootScope.upgrade === false || $rootScope.tarifaSeleccionada == 'PackKeyngo') {

                    $ionicLoading.show({
                        templateUrl: 'templates/loading.html'
                    });

                    $state.go('menu.reservarExtras');
                } else {

                    $scope.mostrarUpgrade();
                }
            });
        }

    };

    // $rootScope.accionUpgrade = function (respuesta) {

    //     if (!respuesta) {                         // SI NO QUIEREN EL UPGRADE

    //         $scope.cerrarUpgrade();

    //         $ionicLoading.show({ templateUrl: 'templates/loading.html' });

    //         setTimeout(function () { $state.go('menu.reservarExtras') }, 200);

    //     } else {                                    // SI QUIEREN EL UPGRADE

    //         $log.debug("Session.set de accionUpgrade con angular.merge -> disponibilidad.js");
    //         Session.set(angular.merge({}, $scope.session, {
    //             group: $rootScope.upgrade.grupo
    //         })).then(function () {

    //             $scope.cerrarUpgrade();

    //             $ionicLoading.show({ templateUrl: 'templates/loading.html' });

    //             setTimeout(function () { $state.go('menu.reservarExtras') }, 200);
    //         });
    //     }
    // };



    $rootScope.buscarDisponibilidad = function (tipo) {
        //console.log(localStorage['tipoVehiculo']);

        console.log("buscarDisponibilidad");
        if (JSON.parse(localStorage['tipoVehiculo']).id != 0 ||
            $rootScope.tipoSeleccionado.id != 0 ||
            JSON.parse(localStorage['filtroSeleccionado']).status != 0 || $rootScope.filtroSeleccionado.status != 0 ||
            JSON.parse(localStorage['soloAutomaticos']) != false || $rootScope.soloAutomaticos != false ||
            JSON.parse(localStorage['masCincoPlazas']) != false || $rootScope.masCincoPlazas != false) {

            $scope.mostrarIconoFiltros = true;
        } else {

            $scope.mostrarIconoFiltros = false;
        }

        if (tipo) {

            $rootScope.noGuardarPreferencias = true;
            $ionicLoading.show();
        } else {

            $rootScope.noGuardarPreferencias = false;
        }

        if ($rootScope.modalPreferenciasBusqueda) {

            $rootScope.modalPreferenciasBusqueda.hide();
        }

        /////////



        $log.debug("Session.get cada vez que entramos -> disponibilidad.js");
        Session.get().then(function (result) {

            var session = result;
            $scope.session = session;
            // $scope.comprobarAltaDemanda(result.pickupdate);

            $scope.muestroPrecioDiario = true;

            $rootScope.disponibilidad = [];
            $rootScope.disponibilidadMonovolumenes = [];
            $rootScope.disponibilidadCompactos = [];
            $rootScope.disponibilidadFamiliares = [];
            $rootScope.disponibilidadSUV = [];
            $rootScope.disponibilidadSedanes = [];
            $rootScope.disponibilidadAutomaticos = [];
            $rootScope.disponibilidadEconomicos = [];
            $scope.tarifas = {};

            Session.set(angular.merge({}, {

                extras_disponibilidad: [],
                extras: [],
                extras_obligatorios: [],
                extras_seleccionados: []
            })).then(function () {

              GoldcarService.getDisponibilidad().then(function (data) {
                  console.log(data);
                  $log.debug("get Disponibilidad: ", data);
                  $scope.disponibilidadTotal = data;
                  $rootScope.disponibilidad = data;

                  var categories = [];
                  var ordenGruposCategorias = $rootScope.config.ordenGruposCategorias;

                  for (var i = 0; i < data.length; i++) {
                      var group = data[i];
                      group.Idgrupocategoria = group.categoria.Idgrupocategoria;
                      var cats = $filter('filter')(categories, {'Idgrupocategoria': group.categoria.Idgrupocategoria});
                      if(cats && cats.length > 0) {
                          var category = cats[0];
                          delete group.categoria;
                          category.grupos.push(group);
                      } else {
                          var category = group.categoria;
                          delete group.categoria;
                          category.grupos = [group];
                          category.orderApp = ordenGruposCategorias.indexOf(category.Idgrupocategoria);
                          if(category.orderApp === -1) category.orderApp = 1000;
                          categories.push(category);
                      }
                  }

                  $scope.categories = $filter('orderBy')(categories, "orderApp");

                  if (session.group) {
                      $location.hash('grupo-' + session.group);
                  }

                  $ionicLoading.hide();
                  localStorage['disponibilidad'] = JSON.stringify($rootScope.disponibilidad);

                  var disponibilidadFiltered = [];

              }, function (error) {
                  $ionicLoading.hide();
                  $log.debug("Error recuperando disponibilidad: ", error);
                  $ionicPopup.alert({
                      title: $filter("translate")($rootScope.translations.disponibilidad.disponibilidad_titulo),
                      template: $filter("translate")($rootScope.translations.disponibilidad.problemas_disponibilidad)
                  }).then(function () {
                      $scope.goBack();
                  });
              });
            });
        });
    };

    // $scope.infoTarifa = false;
    // $scope.infoBus = false;
    // $scope.electrico = false;
    // $scope.ilimitado = false;

    // $scope.abrirInfo = function (zona, tarifa, km_ilimitado, grupo) {

    //     if (zona == 'info-tarifa') {

    //         if ($scope.infoBus) {

    //             $scope.infoBus = !$scope.infoBus;
    //         }

    //         $scope.infoTarifa = !$scope.infoTarifa;

    //     } else if (zona == 'info-bus') {

    //         if ($scope.infoTarifa) {

    //             $scope.infoTarifa = !$scope.infoTarifa;
    //         }

    //         $scope.infoBus = !$scope.infoBus
    //     }

    //     if (grupo) {

    //         if (km_ilimitado || grupo.flag == 'electrico') {

    //             $scope.ilimitado = !$scope.ilimitado;
    //         }

    //         $scope.tarifaSelect = tarifa;

    //         if (grupo.flag == 'electrico') {

    //             $scope.electrico = !$scope.electrico;
    //         }

    //         $scope.grupo = grupo;
    //     }
    // };

    // $scope.getUpgrade = function (grupo, tarifaSeleccionada, precioSeleccionado) {

    //     // $log.debug("TARIFA SELECCIONADA", tarifaSeleccionada);

    //     var calcularDiferencia = function (precioTarifa, precioUpgrade) {
    //         return precioUpgrade - precioTarifa;
    //     };

    //     for (var i = 0; i < $rootScope.disponibilidad.length; i++) {

    //         if ($rootScope.disponibilidad[i].grupo === grupo.grupo) {

    //             if (typeof $rootScope.disponibilidad[i + 1] !== "undefined") {

    //                 var grupoSiguiente = $rootScope.disponibilidad[i + 1];
    //                 break;
    //             } else {

    //                 var grupoSiguiente = false;
    //             }
    //         }
    //     }

    //     if (grupoSiguiente == false) {

    //         return false;
    //     } else {

    //         if (grupoSiguiente.disponible) {

    //             var precioSiguiente = grupoSiguiente.tarifas[tarifaSeleccionada].precio_totalf;

    //             return {
    //                 precio: calcularDiferencia(precioSeleccionado, precioSiguiente),
    //                 grupo: grupoSiguiente.grupo,
    //                 imagen: "https://s3-eu-west-1.amazonaws.com/goldcar/goldcarweb" + grupoSiguiente.imagenes[0].Imagen,
    //                 divisa: grupoSiguiente.divisa
    //             };

    //         } else {

    //             return false;
    //         }
    //     }
    // };

    // $scope.comprobarAltaDemanda = function (pickupdate) {

    //     $log.debug("pickupdate", pickupdate);

    //     $scope.mostrarAltaDemanda = false;
    //     var dia = moment(pickupdate).day();

    //     $log.debug(dia);

    //     for (var i = 0; i < $rootScope.config.alta_demanda.idiomas.length; i++) {

    //         if ($rootScope.language === $rootScope.config.alta_demanda.idiomas[i]) {

    //             $scope.idiomaAltaDemanda = true;

    //         }
    //     }

    //     for (var j = 0; j < $rootScope.config.alta_demanda.dias.length; j++) {

    //         if ($scope.idiomaAltaDemanda && (dia === $rootScope.config.alta_demanda.dias[j])) {

    //             $scope.mostrarAltaDemanda = true;
    //         }
    //     }
    // }

    $scope.filter = false;

    // VOLVER ATRAS //
    $rootScope.irAtrasDisponibilidad = function (estado) {

      if ( typeof estado != 'undefined' && estado == 'datos' ) {

        $state.go('menu.disponibilidad');
      } else {

        $.Velocity.animate($('.content-disponibilidad'), { 'translateY': '100%' }, { duration: 650 }).then(function () {

            $state.reload();
        });
      }
    }

    // TIPO PAGO //
    function ocultarOpcionesPago() {

        $.Velocity.animate($('.set-tariff-next-process'), { 'translateY': '100%' }, { duration: 650 }).then(function (element) {

            $timeout(function(){

                $rootScope.mostrarResumen = false;
            });
        });
    }

    $rootScope.goDatos = function (pago, tipo) {

      if ( tipo == 'pago' ) {

        $.Velocity.animate($('.btn-pago-fin'), { 'border-color': '#CCDD1E' }).then(function (element) {

          $.Velocity.animate($('.btn-pago-fin > .texto'), { 'color': '#444' }).then(function (element) {

              $.Velocity.animate($('.btn-pago-fin > .part-2 > .container-precio > .precio'), { 'color': '#444' }).then(function (element) {

                  $('.btn-pago-fin > .container-btn-go').velocity({ 'background-color': '#A3AF2D' });
              });
          });
        });
      } else {

        $.Velocity.animate($('.btn-postpago-fin'), { 'border-color': '#CCDD1E' }).then(function (element) {

          $.Velocity.animate($('.btn-postpago-fin > .texto'), { 'color': '#444' }).then(function (element) {

              $.Velocity.animate($('.btn-postpago-fin > .part-2 > .container-precio > .precio'), { 'color': '#444' }).then(function (element) {

                  $('.btn-postpago-fin > .container-btn-go').velocity({ 'background-color': '#A3AF2D' });
              });
          });
        });
      }

        $ionicLoading.show();

        Session.set(angular.merge({}, $scope.session, {

            "Tipopago": pago,
            "referer": "app"
        })).then(function () {

            $ionicLoading.hide();

            $rootScope.tipoPago = pago;

            ocultarOpcionesPago();
            $state.go('menu.reservarDatos');

        }, function (error) {

            $log.debug("Error en set Session goDatos: ", error);
        })
    };

    $rootScope.addedExtras = [];

    $scope.addExtras = function(index) {

        var exist = false;
        var i = 0;

        for ( i; i < $rootScope.addedExtras.length; i++ ) {

            if ( $rootScope.todosExtrasMostrar[index].alias == $rootScope.addedExtras[i].alias ) {

                exist = true;
                break;
            }
        }

        if ( !exist ) {

            $rootScope.todosExtrasMostrar[index].selected = true;
            $rootScope.addedExtras.push($rootScope.todosExtrasMostrar[index]);
            $rootScope.totalTariff = $rootScope.totalTariff + $rootScope.todosExtrasMostrar[index].precio_total;

            $('.extra-' + index).velocity({ 'background-color': '#D3DD62' });
            $('.extra-' + index + ' > ' + '.precio-total').css({ 'color': '#FFFFFF' });
            $('.extra-' + index + ' > ' + '.contenido > .texto-precio > .precio-dia').css({ 'color': '#FFFFFF' });
        } else {

            $rootScope.todosExtrasMostrar[index].selected = false;
            $rootScope.addedExtras.splice(i, 1);
            $rootScope.totalTariff = $rootScope.totalTariff - $rootScope.todosExtrasMostrar[index].precio_total;

            $('.extra-' + index).velocity({ 'background-color': '#FFFFFF' });
            $('.extra-' + index + ' > ' + '.precio-total').css({ 'color': 'rgba(95, 95, 95, 0.4)' });
            $('.extra-' + index + ' > ' + '.contenido > .texto-precio > .precio-dia').css({ 'color': 'rgba(95, 95, 95, 0.4)' });
        }
    }

    // ACTIVAR SILLITA
    function animacionSillitasON(index) {

        $('.sillita-' + index).velocity({ 'background-color': '#D3DD62' });
        $('.sillita-' + index + ' > .extra > .precio-total').css({ 'color': '#FFFFFF' });
        $('.sillita-' + index + ' > .extra > .contenido > .texto-precio > .precio-dia').css({ 'color': '#FFFFFF' });
        $('.sillita-' + index + ' > .cantidad > .container-btn > .btn-mas-menos').css({ 'background-color': '#FFFFFF' });
        $('.sillita-' + index + ' > .cantidad > .container-btn > .contador').css({ 'border-color': '#FFFFFF', 'background-color': 'rgb(210, 210, 210)' });
    }

    // DESACTIVAR SILLITA
    function animacionSillitasOFF(index) {

        $('.sillita-' + index).velocity({ 'background-color': '#FFFFFF' });
        $('.sillita-' + index + ' > .extra > .precio-total').css({ 'color': 'rgba(95, 95, 95, 0.4)' });
        $('.sillita-' + index + ' > .extra > .contenido > .texto-precio > .precio-dia').css({ 'color': 'rgba(95, 95, 95, 0.4)' });
        $('.sillita-' + index + ' > .cantidad > .container-btn > .btn-mas-menos').css({ 'background-color': 'lightgray' });
        $('.sillita-' + index + ' > .cantidad > .container-btn > .contador').css({ 'border-color': 'rgba(0, 0, 0, 0.2)', 'background-color': 'rgba(0, 0, 0, 0.1)' });
    }

    $rootScope.statusCheckSillas = function(index, silla, force) {

        if ( $rootScope.todasSillas[index].selected == false ) {

            if ( force ) {

                var cantidad = 0;

                for ( var i = 0; i < $rootScope.todasSillas.length; i++ ) {

                    cantidad = cantidad + $rootScope.todasSillas[i].cantidad;
                }

                if ( cantidad < 3) {

                    animacionSillitasON(index);
                    $rootScope.todasSillas[index].selected = true;
                    $rootScope.statusCheckSillas(index, silla, false);
                } else {

                    console.log("no se puede añadir, maximo de 3");
                    $ionicPopup.alert({ title: 'Atención', template: 'Máximo de 3 sillitas por vehículo.' });
                }

            } else {

                animacionSillitasOFF(index);
                $rootScope.totalTariff = $rootScope.totalTariff - ( $rootScope.todasSillas[index].precio_total * $rootScope.todasSillas[index].cantidad );
                $rootScope.todasSillas[index].cantidad = 0;
            }
        } else {

            if ( $rootScope.todasSillas[index].selected == true && $rootScope.todasSillas[index].cantidad < 1 ) {

                $rootScope.calculoSilla('sumar', silla);
            } else {

                $rootScope.todasSillas[index].selected = false;
                $rootScope.statusCheckSillas(index, silla);
            }
        }
    }

    $rootScope.calculoSilla = function(tipo, silla) {

        var cantidad = 0;

        for ( var i = 0; i < $rootScope.todasSillas.length; i++ ) {

            cantidad = cantidad + $rootScope.todasSillas[i].cantidad;
        }

        // AJUSTAR CANTIDAD SILLAS //
        for ( var i = 0; i < $rootScope.todasSillas.length; i++ ) {

            if ( $rootScope.todasSillas[i].alias == silla ) {

                if ( tipo == 'sumar' && cantidad < 3 ) {

                    $rootScope.todasSillas[i].cantidad++;
                    $rootScope.totalTariff = $rootScope.totalTariff + $rootScope.todasSillas[i].precio_total;
                } else if ( tipo == 'restar' && cantidad > 0 && $rootScope.todasSillas[i].cantidad > 0 ){

                    $rootScope.todasSillas[i].cantidad--;
                    $rootScope.totalTariff = $rootScope.totalTariff - $rootScope.todasSillas[i].precio_total;
                } else if ( tipo == 'sumar' && cantidad == 3 ) {

                    $ionicPopup.alert({ title: 'Atención', template: 'Máximo de 3 sillitas por vehículo.' });
                }
            }

            // MARCAR CHECKBOX CADA SILLA //
            if ( $rootScope.todasSillas[i].cantidad > 0 ) {

                $rootScope.todasSillas[i].selected = true;
                animacionSillitasON(i);
            } else {

                $rootScope.todasSillas[i].selected = false;
                animacionSillitasOFF(i);
            }
        }
    }

    function addSillasToExtras() {

        // $rootScope.addedExtras
        for ( var i = 0; i < $rootScope.todasSillas.length; i++ ) {

            if ( $rootScope.todasSillas[i].cantidad > 0 && $rootScope.todasSillas[i].selected == true ) {

                $rootScope.addedExtras.push($rootScope.todasSillas[i]);
            }
        }
    }

    function objectValues(obj) {
      return $.map(obj, function(val, key) { return val; });
    }

    // PREMIOS Y CODIGOS PROMOCIONALES //
    $scope.premios = [];
    $scope.premiosPromo = [];

    $scope.nuevoCodigo = {
        "codigo": ""
    };


    // OBTENER PREMIOS Y CODIGOS PROMOCIONALES //
    function getCodigosPromocionales() {

        $scope.session.extras_seleccionados = [];

        Session.set(angular.merge({}, $scope.session, {

            "promo_code": false,
            "group": $rootScope.setTariff.group,
            "promo_code_total": false,
            "totExtras": 0,
            "totExtrasObl": 0,
            "totPaquetes": 0,
            "totRate": $rootScope.totalTariff,
            "timestamp": moment().format("YYYY-MM-DDTHH:mm:ss.SSS") + "Z"
        })).then(function (result) {

            $scope.session = result;

            GoldcarService.getUsuario().then(function(result) {

                console.log("GETUSUARIO", result.data);

                // PREMIOS PROMO = DESCUENTO MONETARIO //
                if ( typeof result.data.PremiosPromo !== 'undefined' && result.data.PremiosPromo.length > 0 ) {

                    $scope.premiosPromo = result.data.PremiosPromo;
                }

                console.log("PREMIOS PROMO", $scope.premiosPromo);

                // PREMIOS = CONDUCTOR ADICIONAL GRATIS //
                if ( typeof result.data.Premios !== 'undefined' && result.data.Premios.length > 0 ) {

                    for ( var i = 0; i < result.data.Premios.length; i++ ) {

                        var encontradoPremio = false;

                        if ( $scope.premios.length == 0 ) {

                            $scope.premios.push(result.data.Premios[i]);
                        } else {

                            for ( var l = 0; l < $scope.premios.length; l++ ) {

                                if ( $scope.premios[l].reference == result.data.Premios[i].reference ) {

                                    encontradoPremio = true;
                                }
                            }

                            if ( !encontradoPremio ) {

                                $scope.premios.push(result.data.Premios[i]);
                            }
                        }
                    }
                }

                console.log("PREMIOS", $scope.premios);

            }).catch(function(error) {

                console.log("ERRORUSUARIO", error);
                $ionicPopup.alert({ title: '¡Recuerda!', template: 'Identificate para poder utilizar tus códigos promocionales y premios durante la reserva.' });
            })
        });
    }

    // VALIDAR Y CANJEAR CODIGOS PROMOCIONALES //
    $scope.codigoValidado = false;
    $scope.codigoCardValidado = false;
    $scope.sinCodigo = false;
    var lastCodeSelected = false;

    $scope.canjearCodigoPromocional = function(origen, codigoPromo, indiceCodigoSelected) {

        $ionicLoading.show();

        Session.set(angular.merge({}, $scope.session, {

            "promo_code": false,
            "group": $rootScope.setTariff.group,
            "promo_code_total": false,
            "totExtras": 0,
            "totExtrasObl": 0,
            "totPaquetes": 0,
            "totRate": $rootScope.totalTariff,
            "timestamp": moment().format("YYYY-MM-DDTHH:mm:ss.SSS") + "Z"
        })).then(function (result) { // CLUBEEJ640792

            $scope.session = result;

            if ( origen == 'card' ) {

                if ( !$scope.codigoCardValidado ) {

                    GoldcarService.getCodigoPromo(codigoPromo).then(function(result) {

                        if ( typeof result.data !== 'undefined' && typeof result.data.error !== 'undefined' && result.data.error == true ) {

                            $ionicPopup.alert({ title: 'Error', template: 'El código promocional parece no ser válido, inténtalo con otro.' });
                        } else {

                            $scope.codigoCardValidado = true;
                            lastCodeSelected = indiceCodigoSelected;

                            $timeout(function() {

                                $('.codigo-' + indiceCodigoSelected).velocity({ 'background-color': '#CCDD1E' });
                                $('.codigo-' + indiceCodigoSelected + ' > .part-1 > .icon > .tag-container').velocity({ 'color': '#FFF' });

                                $.Velocity.animate($('.nuevo-codigo'), { 'translateX': '-100%' }).then(function (element) {

                                    $.Velocity.animate($(element), { 'height': '0px', 'margin-bottom': '0px' }).then(function () {

                                        $scope.sinCodigo = true;
                                    });
                                });
                            });

                            console.log("DATOS GET CODIGO PROMO", result.data);
                            Session.set(angular.merge({}, $scope.session, {

                                "promo_code": result.data.Promocode,
                                "promo_code_total": result.data.Importe
                            })).then(function (result) {

                                console.log("RESULTADO SESION CON CODIGO PROMO", result);
                                $scope.session = result;
                            });

                        }

                        $ionicLoading.hide();
                    })
                    .catch(function(error) {

                        console.log("error", error);
                        $ionicLoading.hide();
                    });
                } else {

                    $('.codigo-' + lastCodeSelected).velocity({ 'background-color': '#FFF' });
                    $('.codigo-' + lastCodeSelected + ' > .part-1 > .icon > .tag-container').velocity({ 'color': '#CCDD1E' });

                    $scope.sinCodigo = false;
                    $timeout(function() {

                        $.Velocity.animate($('.nuevo-codigo'), { 'height': '40px', 'margin-bottom': '25px' }).then(function (element) {

                            $.Velocity.animate($(element), { 'translateX': '0%' }).then(function () {

                            });
                        });
                    })

                    $scope.codigoCardValidado = false;

                    Session.set(angular.merge({}, $scope.session, {

                        "promo_code": false,
                        "promo_code_total": false
                    })).then(function (result) {

                        console.log("RESULTADO SESION ELIMINANDO CODIGO PROMO", result);
                        $scope.session = result;
                    });

                    $ionicLoading.hide();
                }
            } else if ( origen == 'input' ) {

                if ( !$scope.codigoValidado ) {

                    if ( $scope.nuevoCodigo.codigo == '' || $scope.nuevoCodigo.codigo == null ) {

                        $ionicLoading.hide();
                        $ionicPopup.alert({ title: 'Atención', template: 'Introduce un codigo en el campo para validarlo.' });
                    } else {

                        GoldcarService.getCodigoPromo($scope.nuevoCodigo.codigo).then(function(result) {

                            if ( typeof result.data !== 'undefined' && typeof result.data.error !== 'undefined' && result.data.error == true ) {

                                $('.nuevo-codigo > .container-input > .input-codigo').velocity({ 'border-color': '#FF6961' });
                                $.Velocity.animate($('.nuevo-codigo > .container-input'), { 'translateX': '-10px' }, { 'duration': 150 }).then(function (element) {

                                    $.Velocity.animate($('.nuevo-codigo > .container-input'), { 'translateX': '10px' }, { 'duration': 150 }).then(function (element) {

                                        $('.nuevo-codigo > .container-input').velocity({ 'translateX': '0px' }, { 'duration': 150 });
                                        $('.nuevo-codigo > .container-input > .input-codigo').velocity({ 'border-color': '#B9BFC3' });
                                        // $ionicPopup.alert({ title: 'Error', template: 'El código promocional introducido parece no ser válido, inténtalo con otro.' });
                                    });
                                });

                            } else {

                                $('.nuevo-codigo > .container-input > .input-codigo').velocity({ 'border-color': '#CCDD1E' });
                                $.Velocity.animate($('.nuevo-codigo > .container-input'), { 'translateY': '-10px' }, { 'duration': 150 }).then(function (element) {

                                    $.Velocity.animate($('.nuevo-codigo > .container-input'), { 'translateY': '10px' }, { 'duration': 150 }).then(function (element) {

                                        $('.nuevo-codigo > .container-input').velocity({ 'translateY': '0px' }, { 'duration': 150 });

                                        $.Velocity.animate($('.scroll-codigos'), { 'translateX': '-100%' }).then(function (element) {

                                            $.Velocity.animate($(element), { 'height': '0px', 'margin': '0px' }).then(function () {

                                                $scope.codigoValidado = true;
                                            });
                                        });

                                        console.log("DATOS GET CODIGO PROMO", result.data);
                                        Session.set(angular.merge({}, $scope.session, {

                                            "promo_code": result.data.Promocode,
                                            "promo_code_total": result.data.Importe
                                        })).then(function (result) {

                                            console.log("RESULTADO SESION CON CODIGO PROMO", result);
                                            $scope.session = result;
                                            $ionicPopup.alert({ title: '¡Validado!', template: 'Código promocional añadido correctamente, disfruta de tu descuento.' });
                                        });
                                    });
                                });
                            }

                            $ionicLoading.hide();
                        })
                        .catch(function(error) {

                            console.log("error", error);
                            $ionicLoading.hide();
                        });
                    }
                } else {

                    $('.nuevo-codigo > .container-input > .input-codigo').velocity({ 'border-color': '#B9BFC3' });
                    $scope.nuevoCodigo.codigo = '';

                    $.Velocity.animate($('.scroll-codigos'), { 'height': '100%', 'margin': '1px 20px 20px 20px' }).then(function (element) {

                        $.Velocity.animate($(element), { 'translateX': '0%' }).then(function () {

                            $scope.codigoValidado = false;
                        });
                    });

                    Session.set(angular.merge({}, $scope.session, {

                        "promo_code": false,
                        "promo_code_total": false
                    })).then(function (result) {

                        console.log("RESULTADO SESION ELIMINANDO CODIGO PROMO", result);
                        $scope.session = result;
                    });

                    $ionicLoading.hide();
                }
            }
        });
    }

    $scope.canjearPremio = function(premio, index) {

        $ionicLoading.show();

        Session.get().then(function(result) {

            $scope.session = result;

            var encontradoExtra = false;
            var indice = 0;

            for ( var i = 0; i < $scope.session.extras_seleccionados.length; i++ ) {

                if ( premio.extras == $scope.session.extras_seleccionados[i].alias ) {

                    encontradoExtra = true;
                    indice = i;
                    break;
                }
            }

            if ( !encontradoExtra ) {

                $scope.session.extras_seleccionados.push({

                    "alias": premio.extras,
                    "cantidad": 1,
                    "depende": "",
                    "depende_paquete": "",
                    "descripcion": premio.descripcion,
                    "extras_no_compatibles": "",
                    "extras_obligatorios": "",
                    "paquete_recomendado": "",
                    "precio": premio.precio,
                    "precio_total": premio.precio,
                    "premio": true
                })

                Session.set(angular.merge({}, $scope.session, {})).then(function (result) {

                    $('.premio-' + index).velocity({ 'background-color': '#CCDD1E' });
                    $('.premio-' + index + ' > .part-1 > .icon > .gift-container > .fa-gift').velocity({ 'color': '#FFF' });

                    for ( var n = 0; n < $rootScope.todosExtrasMostrar.length; n++ ) {

                        if ( premio.extras == $rootScope.todosExtrasMostrar[n].alias ) {

                            $('.extra-' + n).css({ 'pointer-events': 'none' });
                            $('.extra-' + n).velocity({ 'background-color': '#D3DD62' });
                            $('.extra-' + n + ' > .precio-total').css({ 'color': '#FFFFFF' });
                            $('.extra-' + n + ' > .contenido > .texto-precio > .precio-dia').css({ 'color': '#FFFFFF' });
                            $('.extra-' + n + ' > .checkbox-tariff > .checkbox-extras').addClass('md-checked');
                            $('.extra-' + n + ' > .precio-total').html('0 ' + $rootScope.divisaFinal);
                            $('.extra-' + n + ' > .contenido > .texto-precio > .precio-dia').css({ 'text-decoration': 'line-through' });
                        }
                    }

                    $ionicLoading.hide();
                });
            } else {

                $scope.session.extras_seleccionados.splice(indice, 1);

                Session.set(angular.merge({}, $scope.session, {})).then(function (result) {

                    $('.premio-' + index).velocity({ 'background-color': '#FFF' });
                    $('.premio-' + index + ' > .part-1 > .icon > .gift-container > .fa-gift').velocity({ 'color': '#CCDD1E' });

                    for ( var n = 0; n < $rootScope.todosExtrasMostrar.length; n++ ) {

                        if ( premio.extras == $rootScope.todosExtrasMostrar[n].alias ) {

                            $('.extra-' + n).css({ 'pointer-events': '' });
                            $('.extra-' + n).velocity({ 'background-color': '#FFFFFF' });
                            $('.extra-' + n + ' > .precio-total').css({ 'color': 'rgba(95, 95, 95, 0.4)' });
                            $('.extra-' + n + ' > .contenido > .texto-precio > .precio-dia').css({ 'color': 'rgba(95, 95, 95, 0.4)' });
                            $('.extra-' + n + ' > .checkbox-tariff > .checkbox-extras').removeClass('md-checked');
                            $('.extra-' + n + ' > .precio-total').html($rootScope.todosExtrasMostrar[n].precio_total + $rootScope.divisaFinal);
                            $('.extra-' + n + ' > .contenido > .texto-precio > .precio-dia').css({ 'text-decoration': '' });
                        }
                    }

                    $ionicLoading.hide();
                });
            }
        });
    }
})

.directive('repeatDirectivePremios', function() {
    return function(scope) {
        if (scope.$last) {
            setTimeout(function() {
                var alturaMax = 0;
                $( ".premio-card .descuento" ).each(function() {
                    if ( alturaMax < $(this).height() ) {
                        alturaMax = $(this).height();
                    }
                });
                $( ".premio-card .descuento" ).css({ "height": alturaMax });
            }, 300);
        }
    };
})

.directive('repeatDirectivePromos', function() {
    return function(scope) {
        if (scope.$last) {
            setTimeout(function() {
                var alturaMax = 0;
                $( ".codigo-card .descuento" ).each(function() {
                    console.log("height", $(this).height());
                    if ( alturaMax < $(this).height() ) {
                        alturaMax = $(this).height();
                    }
                });
                $( ".codigo-card .descuento" ).css({ "height": alturaMax });
            }, 300);
        }
    };
})
