angular.module('goldcar').controller('DatosCtrl', function ($filter, $state, $ionicPopup, $stateParams, $scope, $ionicModal, $ionicLoading, $rootScope, $log, Session, JsonService, GoldcarService, $cordovaDatePicker, $ionicScrollDelegate) {

    $ionicLoading.show({
        templateUrl: 'templates/loading.html'
    });

    $rootScope.userData = {};
    $rootScope.travelData = {};
    $rootScope.cardData = {};
    $rootScope.cardData.aceptoSuscripcion = true;
    $scope.statusReserva = "";
    $scope.bonoReserva = "";
    $scope.idReserva = "";
    $scope.esMenor = false;
    $scope.extraMenor = '';
    $scope.saveCard = {};
    $scope.tarjetaSeleccionada = 'nueva';
    $scope.listaTarjetas = [];

    $scope.goBack = function (status) {

        $ionicLoading.show();

        if ( status == 'atras' ) {

            $state.go('menu.reservarDisponibilidad', {}, { reload: true });
        } else {

            $state.go('menu.home', {}, { reload: true });
        }
    };

    $scope.isKeyNGo = false;

    Session.get().then(function (result) {

        $log.debug("Session.get cada vez que entramos -> datos.js");
        $scope.session = result;

        for ( var i = 0; i < result.paquetes_disponibilidad.length; i++ ) {

            if ( result.paquetes_disponibilidad[i].reference == '15100' ) {

                $scope.isKeyNGo = true;
            }
        }
    });

    if ( $rootScope.isLogged ) {

        GoldcarService.postTarjetas().then(function(data) {

            $scope.listaTarjetas = data.data;
        });
    }

    JsonService.getContentData('goldcarapp-countries').then(function(result) {

        $scope.nacionalidades = [];

        result = JSON.parse(result.content.text);

        for (var index in result) {

            $scope.nacionalidades.push({"name": result[index], "value": index});
        }

        // console.log($scope.nacionalidades);
    });

    // FECHA NACIMIENTO

    $scope.setFechaNacimiento = function() {

        var dateSelec;

        if ( typeof $scope.userData.fechaNacimiento === 'undefined' || $scope.userData.fechaNacimiento == '' ) {

            dateSelec = new Date();
        } else {

            var dia = ($scope.userData.fechaNacimiento).split('-')[2];
            var mes = ($scope.userData.fechaNacimiento).split('-')[1];
            var anyo = ($scope.userData.fechaNacimiento).split('-')[0];

            dateSelec = new Date(mes + '/' + dia + '/' + anyo);
        }

        console.log(dateSelec);

        var options = {
            date: dateSelec,
            mode: 'date',
            androidTheme: 3
        };

        $cordovaDatePicker.show(options).then(function(date){

            // $scope.userData.fechaNacimiento = moment(date).format('DD/MM/YYYY');
            var ahora = moment();
            var fechaNacimiento = moment(date);

            var diferencia = moment.duration(ahora.diff(fechaNacimiento))._data.years;
            console.log(diferencia);
            console.log(typeof diferencia);

            if ( diferencia < 25 && diferencia > 21) {

                $scope.esMenor = false;
                $scope.userData.fechaNacimiento = moment(date).format('YYYY-MM-DD');

                GoldcarService.getDisponibilidadGrupo().then(function (data) {

                    for ( var i = 0; i < data.extras.length; i++ ) {

                        if ( data.extras[i].alias == 'YoungDriver' ) {

                            if ( data.extras[i].disponible ) {

                                $scope.extraMenor = data.extras[i];
                            }
                        }
                    }
                });

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.datos.extra_anyadido), template: $filter("translate")($rootScope.translations.datos.extra_anyadido_menor25_texto) });
            } else if ( diferencia < 21 ) {

                $scope.esMenor = true;
                $scope.userData.fechaNacimiento = moment(date).format('YYYY-MM-DD');
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.datos.menor_21_anyos), template: $filter("translate")($rootScope.translations.datos.menor_21_anyos_texto_1) + '. ' + $filter("translate")($rootScope.translations.datos.menor_21_anyos_texto_2) });
            } else {

                $scope.esMenor = false;
                $scope.userData.fechaNacimiento = moment(date).format('YYYY-MM-DD');
            }

        });
    };

    $rootScope.recuperarDatos = function() {

        if ( $rootScope.isLogged ) {

            if ( $rootScope.datosUsuario.Nombre ) {

                $rootScope.userData.Nombre = $rootScope.datosUsuario.Nombre;
            }

            if ( $rootScope.datosUsuario.Apellidos ) {

                $rootScope.userData.Apellidos = $rootScope.datosUsuario.Apellidos;
            }

            if ( $rootScope.datosUsuario.Email ) {

                $rootScope.userData.Email = $rootScope.userData.Email2 = $rootScope.datosUsuario.Email;
            }

            if ( $rootScope.datosUsuario.Telefono ) {

                $rootScope.userData.Telefono = $rootScope.datosUsuario.Telefono;
            }

            if ( $rootScope.tarifaSeleccionada == 'PackKeyngo' ) {

                if ( $rootScope.datosUsuario.Direccion ) {

                    $rootScope.userData.direccion = $rootScope.datosUsuario.Direccion;
                }

                if ( $rootScope.datosUsuario.Cpostal ) {

                    $rootScope.userData.codigo_postal = Number($rootScope.datosUsuario.Cpostal);
                }

                if ( $rootScope.datosUsuario.Poblacion ) {

                    $rootScope.userData.poblacion = $rootScope.datosUsuario.Poblacion;
                }

                if ( $rootScope.datosUsuario.Provincia ) {

                    $rootScope.userData.provincia = $rootScope.datosUsuario.Provincia;
                }
            }

            // if ( $rootScope.datosUsuario.Pais ) {

            //     $rootScope.userData.pais = $rootScope.datosUsuario.Pais;
            // }

            // if ( $rootScope.datosUsuario.Pasaporte != "" ) {

            //     $rootScope.userData.tipo_documento = "pasaporte";
            //     $rootScope.userData.numero_documento = $rootScope.datosUsuario.Pasaporte;
            // } else if ( $rootScope.datosUsuario.Dni != "" ) {

            //     $rootScope.userData.tipo_documento = "dni";
            //     $rootScope.userData.numero_documento = $rootScope.datosUsuario.Dni;
            // }

        }

        $ionicLoading.hide();
    };

    // console.log("$rootScope.datosUsuario", $rootScope.datosUsuario);

    $rootScope.recogerDatosLogin = function (user_data){

        $log.debug("Session.get en recogerDatosLogin -> datos.js");
        Session.get().then(function (result) {

            $scope.session = result;

            if ( $scope.session ) {

                $log.debug("Session.set de recogerDatosLoginExtra si hay $scope.session igualando variables -> extras.js");
                $scope.session.nombre = user_data.Nombre;
                $scope.session.apellidos = user_data.Apellidos;
                $scope.session.user = user_data.user;
                $scope.session.authenticated = user_data.Authenticated;

            } else {

                $log.debug("Session.set de recogerDatosLogin si NO hay $scope.session -> datos.js");
                Session.set({

                    "Lang": $rootScope.language,
                    "nombre": user_data.Nombre,
                    "apellidos": user_data.Apellidos,
                    "user": user_data.user,
                    "authenticated": user_data.Authenticated,
                    "referer": "app"
                });
            }

            $rootScope.recuperarDatos();
        });
    };

    $rootScope.recuperarDatos();

    $scope.updateTravelData = function (texto) {

        if (texto !== '') {
            $rootScope.travelData.Numero = texto;
        }

        else {
            if ( $rootScope.travelData.Numero === 'NO_REMEMBER' || $rootScope.travelData.Numero === 'NO_FLIGHT' ){
                $rootScope.travelData.Numero = '';
            }
        }
    };

    $rootScope.scanCard = function () {

        var onCardIOComplete = function (response) {
            $rootScope.cardData.Number = response.cardNumber;
            $rootScope.cardData.SecretNumber = response.redactedCardNumber;
            $rootScope.cardData.Type = response.cardType;
            $rootScope.cardData.Holder = response.cardholderName;
            if (response.expiryMonth < 10) response.expiryMonth = '0' + response.expiryMonth;
            var yearFiltered = response.expiryYear.toString();
            $rootScope.cardData.Date = response.expiryMonth + "/" + yearFiltered[2] + yearFiltered[3];
            $rootScope.cardData.Year = response.expiryYear.toString();
            $rootScope.cardData.Month = response.expiryMonth;
            $rootScope.cardData.CVC = response.cvv;
            $rootScope.$apply();
        };

        var onCardIOCancel = function () {
            $log.debug("card.io scan cancelled");
        };

        var onCardIOCheck = function (canScan) {
            if (!canScan) {
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.alertas.atencion),
                    template: $filter("translate")($rootScope.translations.datos.error_escaner)
                })
            }
            else {
                CardIO.scan({
                        "requireExpiry": true,
                        "scanExpiry": true,
                        "requireCVV": true,
                        "requireCardholderName": true,
                        "languageOrLocale": $rootScope.config.mapeo_api['es'],
                        "supressManual": true,
                        "suppressConfirmation": false,
                        "guideColor": "#A3AC2C",
                        "hideCardIOLogo": true
                    },
                    onCardIOComplete,
                    onCardIOCancel
                );
            }
        };

        CardIO.canScan(onCardIOCheck);
    };

    var pasoFinal = function(result) {

        $scope.statusReserva = result.data.status;
        $scope.bonoReserva = result.data.BonoAgencia;
        $scope.idReserva = result.data.Idreserva;

        $state.go('menu.misReservas', {}, { reload: true });
        $ionicPopup.alert({
            title: $filter("translate")($rootScope.translations.datos.estado_reserva),
            template: $filter("translate")($rootScope.translations.mensaje_reserva['status_' + result.data.status]),
            buttons:[
                {
                    text: 'OK',
                    onTap: function (e) {

                        // $rootScope.crearModalEncuesta();
                    }
                }
            ]
        });
    }

    $scope.checkData = function () {

        // PROCESO DE RESERVA


        var procesoReserva = function() {

            if ( $rootScope.aplicadoPremioFinal == null && typeof $rootScope.aplicadoPremioFinal === 'undefined' && !$rootScope.aplicadoPremioFinal) {

                $rootScope.aplicadoPremioFinal = {};
                $rootScope.aplicadoPremioFinal.paquetes = [];
                $rootScope.aplicadoPremioFinal.premios = [];
            }

            // NUEVOS EXTRAS //
            if ( typeof $rootScope.addedExtras !== 'undefined' && $rootScope.addedExtras.length !== 0 ) {

                $rootScope.aplicadosExtras = [];

                for ( var i = 0; i < $rootScope.addedExtras.length; i++ ) {

                    if ( $rootScope.addedExtras[i].alias == 'MaxiCosi' || $rootScope.addedExtras[i].alias == 'BabySeat' || $rootScope.addedExtras[i].alias == 'BoosterSeat' ) {

                        $rootScope.aplicadosExtras.push({

                            "alias": $rootScope.addedExtras[i].alias,
                            "cantidad": $rootScope.addedExtras[i].cantidad,
                            "depende": $rootScope.addedExtras[i].depende,
                            "depende_paquete": $rootScope.addedExtras[i].depende_paquete,
                            "descripcion": $rootScope.addedExtras[i].descripcion,
                            "divisa": $rootScope.divisaFinal,
                            "extras_no_compatibles": $rootScope.addedExtras[i].extras_no_compatibles,
                            "precio": $rootScope.addedExtras[i].precio,
                            "precio_total": $rootScope.addedExtras[i].precio_total
                        })
                    } else {

                        $rootScope.aplicadosExtras.push({

                            "alias": $rootScope.addedExtras[i].alias,
                            "cantidad": 1,
                            "depende": $rootScope.addedExtras[i].depende,
                            "depende_paquete": $rootScope.addedExtras[i].depende_paquete,
                            "descripcion": $rootScope.addedExtras[i].descripcion,
                            "divisa": $rootScope.divisaFinal,
                            "extras_no_compatibles": $rootScope.addedExtras[i].extras_no_compatibles,
                            "precio": $rootScope.addedExtras[i].precio,
                            "precio_total": $rootScope.addedExtras[i].precio_total
                        })
                    }
                }

                console.log("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
            }
            // ------------- //

            if ($rootScope.extrasFree.length > 0){
                for(var i = 0; i < $rootScope.extrasFree.length; i++){
                    $rootScope.aplicadoPremioFinal.premios.push($rootScope.extrasFree[i]);
                    $rootScope.aplicadosExtras.push($rootScope.extrasFree[i]);
                }
            }

            if ( $rootScope.paquetes_dispon ) {

                var paquetes = [];

                for ( var i = 0; i < $rootScope.paquetes_dispon.length; i++ ) {

                    paquetes.push({

                        "cantidad": 1,
                        "extras": $rootScope.paquetes_dispon[i].extras,
                        "precio": $rootScope.paquetes_dispon[i].preciof,
                        "reference": parseInt($rootScope.paquetes_dispon[i].reference),
                        "tarifa": $rootScope.paquetes_dispon[i].tarifa,
                        "unico": true
                    });
                }

                $scope.todo = {
                    "pickupplace": $scope.session.pickupplace,
                    "pickupdate": $scope.session.pickupdate,
                    "pickuptime": $scope.session.pickuptime,
                    "dropoffdate": $scope.session.dropoffdate,
                    "dropofftime": $scope.session.dropofftime,
                    "group": $scope.session.group,
                    "email": $rootScope.userData.Email,
                    "nombre": $rootScope.userData.Nombre,
                    "apellidos": $rootScope.userData.Apellidos,
                    "Tipopago": $rootScope.tipoPago,
                    "vuelo": $rootScope.travelData.Numero,
                    "Lang": $scope.session.Lang,
                    "Fuel": $scope.session.Fuel,
                    "dropoffplace": $scope.session.dropoffplace,
                    "telefono": $rootScope.userData.Telefono,
                    "extras": $rootScope.aplicadosExtras,
                    "extras_seleccionados": $rootScope.aplicadosExtras,
                    "paquetes": paquetes,
                    "paquetes_disponibilidad": paquetes,
                    "premios": $rootScope.aplicadoPremioFinal.premios,
                    "promo_code": $scope.session.promo_code,
                    "num-tarjeta": $rootScope.cardData.Number,
                    "mes-anyo": $rootScope.cardData.Date,
                    "cvc": $rootScope.cardData.CVC,
                    "usuario_publicidad": $rootScope.cardData.aceptoSuscripcion
                };
            } else {

                $scope.todo = {
                    "pickupplace": $scope.session.pickupplace,
                    "pickupdate": $scope.session.pickupdate,
                    "pickuptime": $scope.session.pickuptime,
                    "dropoffdate": $scope.session.dropoffdate,
                    "dropofftime": $scope.session.dropofftime,
                    "group": $scope.session.group,
                    "email": $rootScope.userData.Email,
                    "nombre": $rootScope.userData.Nombre,
                    "apellidos": $rootScope.userData.Apellidos,
                    "Tipopago": $rootScope.tipoPago,
                    "vuelo": $rootScope.travelData.Numero,
                    "Lang": $scope.session.Lang,
                    "Fuel": $scope.session.Fuel,
                    "dropoffplace": $scope.session.dropoffplace,
                    "telefono": $rootScope.userData.Telefono,
                    "extras": $rootScope.aplicadosExtras,
                    "extras_seleccionados": $rootScope.aplicadosExtras,
                    "paquetes": $rootScope.aplicadoPremioFinal.paquetes,
                    "premios": $rootScope.aplicadoPremioFinal.premios,
                    "promo_code": $scope.session.promo_code,
                    "num-tarjeta": $rootScope.cardData.Number,
                    "mes-anyo": $rootScope.cardData.Date,
                    "cvc": $rootScope.cardData.CVC,
                    "usuario_publicidad": $rootScope.cardData.aceptoSuscripcion
                };
            }

            if ( $scope.extraMenor && $scope.extraMenor != '' ) {

                $scope.todo.extras.push($scope.extraMenor);
            }

            ///////
            if ( $scope.tarjetaSeleccionada != 'nueva' ) {

                $scope.todo.tarjeta = $scope.listaTarjetas[$scope.tarjetaSeleccionada].IdCliTpv;
            } else if ( $scope.tarjetaSeleccionada == 'nueva' && $scope.saveCard.guardarTarjeta == true ) {

                $scope.todo.favorito = true;
                $scope.todo.alias = $scope.saveCard.cardAlias;
                $scope.todo.tarjeta = 'nuevaTarjeta';
            } else {

                $scope.todo.favorito = false;
            }

            ///////
            var status = "OK";

            if (typeof $rootScope.userData.Nombre === "undefined" || $rootScope.userData.Nombre === '')
                status = $filter("translate")($rootScope.translations.datos.falta_nombre);

            if (typeof $rootScope.userData.Apellidos === "undefined" || $rootScope.userData.Apellidos === '')
                status = $filter("translate")($rootScope.translations.datos.falta_apellidos);

            if (typeof $rootScope.userData.Email === "undefined" || $rootScope.userData.Email === '')
                status = $filter("translate")($rootScope.translations.datos.falta_email);

            if (typeof $rootScope.userData.Email2 === "undefined" || $rootScope.userData.Email2 === '')
                status = $filter("translate")($rootScope.translations.datos.falta_email2);

            if (typeof $rootScope.userData.Email != "undefined" && typeof $rootScope.userData.Email2 != "undefined") {
                if ($rootScope.userData.Email != $rootScope.userData.Email2)
                    status = $filter("translate")($rootScope.translations.datos.falta_coincidir);
            }

            if ( $scope.isKeyNGo ) {

                if (typeof $rootScope.userData.permConducir === "undefined" || $rootScope.userData.permConducir === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.permiso_conducir = $rootScope.userData.permConducir;
                }

                if (typeof $rootScope.userData.fechaNacimiento === "undefined" || $rootScope.userData.fechaNacimiento === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.fecha_nacimiento = $rootScope.userData.fechaNacimiento;
                }

                if (typeof $rootScope.userData.direccion === "undefined" || $rootScope.userData.direccion === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.direccion = $rootScope.userData.direccion;
                }

                if (typeof $rootScope.userData.codigo_postal === "undefined" || $rootScope.userData.codigo_postal === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.codigo_postal = $rootScope.userData.codigo_postal;
                }

                if (typeof $rootScope.userData.poblacion === "undefined" || $rootScope.userData.poblacion === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.poblacion = $rootScope.userData.poblacion;
                }

                if (typeof $rootScope.userData.provincia === "undefined" || $rootScope.userData.provincia === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.provincia = $rootScope.userData.provincia;
                }

                if (typeof $rootScope.userData.pais === "undefined" || $rootScope.userData.pais === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.pais = $rootScope.userData.pais;
                }

                if (typeof $rootScope.userData.nacionalidad === "undefined" || $rootScope.userData.nacionalidad === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.nacionalidad = $rootScope.userData.nacionalidad;
                }

                if (typeof $rootScope.userData.tipo_documento === "undefined" || $rootScope.userData.tipo_documento === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.tipo_documento = $rootScope.userData.tipo_documento;
                }

                if (typeof $rootScope.userData.numero_documento === "undefined" || $rootScope.userData.numero_documento === '') {

                    status = $filter("translate")($rootScope.translations.alertas.revise_los_campos_del_formulario);
                } else {

                    $scope.todo.numero_documento = $rootScope.userData.numero_documento;
                }
            }

            if (typeof $rootScope.userData.Telefono === "undefined" || $rootScope.userData.Telefono === '')
                status = $filter("translate")($rootScope.translations.datos.falta_telefono);

            if (typeof $rootScope.travelData.Numero === "undefined" || $rootScope.travelData.Numero === '')
                status = $filter("translate")($rootScope.translations.datos.falta_vuelo);

            if ( $rootScope.tipoPago && ($rootScope.tipoPago !== "postpago") ) {

                if ( $scope.tarjetaSeleccionada == 'nueva' ) {

                    if ( $rootScope.cardData.Date ) {

                        var res = $rootScope.cardData.Date.split("/");
                        var givenMonth = res[0];
                        var givenYear = res[1];
                    }

                    $log.debug(givenMonth);
                    $log.debug(givenYear);
                    var year = new Date().getFullYear();
                    var month = new Date().getMonth() + 1;

                    var regexNumero = /^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|6(?:011|5[0-9]{2})[0-9]{12}|(?:2131|1800|35\d{3})\d{11})$/gm; // Cualquier tarjeta
                    var regexHolder = /^[^\d\/\\?¿]{1,}([\s][^\d\/\\]{1,})+$|^[^\d\/\\]{1,}$/gm; // Nombre | Nombre Apellido | Nombre Apellido Apellido
                    var regexMonth = /^([0][1-9])$|^([1][0-2])$/gm; // 01-12
                    var regexYear = /^([1][6-9])$|^([2-9][0-9])$/gm; // 16-99
                    var regexCVC = /^[0-9]{3}$/gm; // 000-999

                    if ( typeof $rootScope.cardData.Number !== "undefined" ) {

                        $rootScope.cardData.Number = $rootScope.cardData.Number.replace(/ /g,'');

                        if ($rootScope.cardData.Number.match(regexNumero) == null) {

                            status = $filter("translate")($rootScope.translations.datos.error_tarjeta);
                        } else {

                            $log.debug("$rootScope.cardData.Number1", $rootScope.cardData.Number);
                            $log.debug("lenghtCardNumber", ($rootScope.cardData.Number).length);
                        }
                    } else {

                        $log.debug("else");
                        status = $filter("translate")($rootScope.translations.datos.falta_tarjeta);
                    }

                    if ( typeof $rootScope.cardData.Holder !== "undefined" ) {

                        if ($rootScope.cardData.Holder.match(regexHolder) == null) {

                            status = $filter("translate")($rootScope.translations.datos.error_titular);
                        }
                    } else {

                        status = $filter("translate")($rootScope.translations.datos.falta_titular);
                    }

                    if ( typeof givenMonth !== "undefined" ) {

                        if (givenMonth.match(regexMonth) == null)
                            status = $filter("translate")($rootScope.translations.datos.error_mes_caducidad);

                        if (givenMonth[0] == '0')
                            givenMonth = givenMonth[1];
                    } else {

                        status = $filter("translate")($rootScope.translations.datos.falta_mes_caducidad);
                    }

                    if ( typeof givenYear !== "undefined" ) {

                        if (givenYear.match(regexYear) == null)
                            status = $filter("translate")($rootScope.translations.datos.error_ano_caducidad);

                        if (givenYear.length == 2)
                            givenYear = '20' + givenYear;
                    } else {

                        status = $filter("translate")($rootScope.translations.datos.falta_ano_caducidad);
                    }

                    if ( typeof $rootScope.cardData.Date === "undefined" || $rootScope.cardData.Date === '' ) {

                        status = $filter("translate")($rootScope.translations.datos.falta_fecha_caducidad);
                    }

                    if ( typeof givenMonth !== "undefined" && typeof givenYear !== "undefined" ) {

                        if (givenYear == year && givenMonth < month)
                            status = $filter("translate")($rootScope.translations.datos.fecha_superior);
                    }

                    if ( typeof $rootScope.cardData.CVC !== "undefined" ) {

                        if ( $rootScope.cardData.CVC.match(regexCVC) == null ) {

                            status = $filter("translate")($rootScope.translations.datos.error_cvc);
                        }
                    } else {

                        status = $filter("translate")($rootScope.translations.datos.falta_cvc);
                    }

                    if ( $scope.saveCard.guardarTarjeta ) {

                        if ( typeof $scope.saveCard.cardAlias === "undefined" || $scope.saveCard.cardAlias === '' ) {

                            status = $filter("translate")($rootScope.translations.tarjetas.rellena_alias);
                        }
                    }
                }
            }

            if ( status !== 'OK' ) {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.datos.error_reserva_titulo), template: status });
            }

            if ( status === 'OK' ) {

                $ionicLoading.show({ template: '<div class="cargando">{{translations.datos.realiza_reserva}}<br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>', duration: 140000 });

                Session.set(angular.merge({}, $scope.session, $scope.todo, {
                    "descuento_pago_activado": $rootScope.isDescuento
                })).then(function () {

                    GoldcarService.postSolicitarReserva().then(function (result) {

                        $ionicLoading.hide();

                        if ( !result.data.Idreserva || typeof result.data.Idreserva === 'undefined' ) {

                            $rootScope.divisas = result.data;
                            $scope.crearModalDivisa();
                        } else {

                            pasoFinal(result);
                        }
                    })
                });
            }
        }

        if ( typeof localStorage['bloqueoHuella'] != "undefined" && JSON.parse(localStorage['bloqueoHuella']) == true ) {

            // CONTROL POR HUELLA DACTILAR
            Fingerprint.isAvailable(successFn, errorFn);

            function successFn(result) {

                Fingerprint.show({

                    clientId: 'Goldcar-APP',
                    clientSecret: 'aN9W9h5uBB'
                }, successFingerFn);

                function successFingerFn(result) {

                    procesoReserva();
                }
            }

            function errorFn() {

                procesoReserva();
            }
        } else {

            procesoReserva();
        }
    };

    $scope.crearModalTerminosDatos = function () {

        $ionicModal.fromTemplateUrl('templates/reservar/terminos.html', {

            vista: "Terminos",
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modalTerminosDatos) {

            $scope.modalTerminosDatos = modalTerminosDatos;
            modalTerminosDatos.show();
        });
    };

    $rootScope.abrirTerminosDatos = function () {

        $ionicLoading.show();

        GoldcarService.getCondicionesServicio($scope.session.pickupplace, $scope.session.pickupdate, $scope.session.dropoffdate, $scope.session.group).then(function (result) {

            if ( result.data.status ) {

                $scope.terminos = result.data.texto;
                $scope.crearModalTerminosDatos();

                $ionicLoading.hide();
            } else {

                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.datos.error_titulo), template: $filter("translate")($rootScope.translations.datos.error_texto) });
            }
        })
    };

    $rootScope.enviarEncuestaSatisfaccion = function (valor) {

        var data = {
            'referrer': 'app',
            'user': $scope.session.user,
            'pickup_office': $scope.session.pickupplace,
            'dropoff_office': $scope.session.dropoffplace,
            'group': $scope.session.group,
            'rating': valor,
            'bookId': $scope.idReserva,
            'agencyId': $scope.bonoReserva,
            'bookStatus': $scope.statusReserva
        };

        JsonService.postEncuesta(data).then(function (result) {

            $rootScope.modalEncuesta.hide();
        })
    }

    $scope.seleccionarTarjeta = function(index) {

        console.log("seleccionarTarjeta", index);

        $scope.tarjetaSeleccionada = index;
        $scope.saveCard.guardarTarjeta = false;
        $ionicScrollDelegate.$getByHandle('content_datos').resize();
    }

    $scope.elegirAlias = function() {

        $scope.saveCard.guardarTarjeta = !$scope.saveCard.guardarTarjeta;
        $ionicScrollDelegate.resize();
    }

    //----------------------------
    // SELECCION DE DIVISA
    //----------------------------

    $scope.crearModalDivisa = function () {

        if ( typeof $rootScope.modalDivisa === "undefined" ) {

            $ionicModal.fromTemplateUrl('templates/tipo_divisa/divisa.html', {

                vista: "Tipo de divisa",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function (modalDivisa) {

                $rootScope.modalDivisa = modalDivisa;
                modalDivisa.show();
            })
        } else {

            $rootScope.modalDivisa.show();
        }
    };

    $rootScope.pagarDiferenteDivisa = function(divisa) {

        GoldcarService.postPrepagoDivisa(divisa).then(function(result) {

            pasoFinal(result);
        })
    }

});
