angular.module('goldcar').controller('ExtrasCtrl', function ($state, $ionicPopup, $stateParams, $ionicScrollDelegate, $scope, $ionicModal, $ionicLoading, $rootScope, $log, Session, GoldcarService, $filter) {

    $scope.descrip = false;
    $scope.todoCargado = false;
    $scope.todosExtras = false;

    Session.get().then(function (result) {

        console.log("---------------");
        console.log(result);
    });

    $scope.extraFilter = function (extra) {

        if ( extra && extra.alias === 'Kiosk' ) {
            // NO HACER NADA
        }
        else if ( extra.alias == 'ExpressService' && $rootScope.tarifaSeleccionada === 'PackKeyngo' ) {
            // NO HACER NADA
        }
        else {

            return extra;
        }
    };

    $scope.mostrarExtras = function () {

        $scope.todosExtras = !$scope.todosExtras;
        setTimeout(function () {

            $ionicScrollDelegate.resize();
        }, 300);
    };

    $scope.goBack = function () {

        $ionicLoading.show();

        Session.set({

            group: [],
            Fuel: [],
            cancelable: [],
            extras_disponibilidad: [],
            paquetes_disponibilidad: [],
            extras: [],
            extras_obligatorios: [],
            paquetes: [],
            premios: []
        }).then(function () {

            $state.go('menu.reservarDisponibilidad');
        });
    };

    $scope.goContinue = function () {

        $ionicLoading.show({
            templateUrl: 'templates/loading.html'
        });

        if ( $rootScope.aplicadosExtras ) {

            $log.debug("Session.set de goContinue con angular.merge -> extras.js");
            $log.debug("$scope.session: ", $scope.session);
            if ( $rootScope.promo_code ) {

                $scope.session.promo_code = $rootScope.promo_code;
                $scope.session.promo_code_total = $rootScope.promo_importe;
            }
            Session.set(angular.merge({}, $scope.session, {

                "extras": $rootScope.aplicadosExtras
            })).then(function () {

                if ( $rootScope.aplicadoPremioFinal ) {

                    $log.debug("Session.set de goContinue con angular.merge 2 -> extras.js");
                    Session.set(angular.merge({}, $scope.session, $rootScope.aplicadoPremioFinal)).then(function () {

                        setTimeout(function () {

                            $state.go('menu.reservarPago');
                        }, 300);
                    });
                } else {

                    setTimeout(function () {

                        $state.go('menu.reservarPago');
                    }, 300);
                }
            });
        }

        else {

            if ( $rootScope.aplicadoPremioFinal ) {

                $log.debug("Session.set de goContinue con angular.merge 3 -> extras.js");
                Session.set(angular.merge({}, $scope.session, $rootScope.aplicadoPremioFinal)).then(function () {

                    setTimeout(function () {

                        $state.go('menu.reservarPago');
                    }, 300);
                });
            }

            else {

                setTimeout(function () {

                    $state.go('menu.reservarPago');
                }, 300);
            }
        }
    };

    $rootScope.recogerDatosLoginExtra = function (user_data){

        $log.debug("Session.get en recogerDatosLoginExtra -> extras.js");
        Session.get().then(function (result) {

            $scope.session = result;

            if ( $scope.session ) {

                $log.debug("Session.set de recogerDatosLoginExtra si hay $scope.session igualando variables -> extras.js");
                $scope.session.nombre = user_data.Nombre;
                $scope.session.apellidos = user_data.Apellidos;
                $scope.session.user = user_data.user;
                $scope.session.authenticated = user_data.Authenticated;
                $scope.session.promo_code = false;
                $scope.session.promo_code_total = false;

            } else {

                $log.debug("Session.set de recogerDatosLoginExtra si NO hay $scope.session-> extras.js");
                Session.set({

                    "Lang": $rootScope.language,
                    "nombre": user_data.Nombre,
                    "apellidos": user_data.Apellidos,
                    "user": user_data.user,
                    "authenticated": user_data.Authenticated,
                    "promo_code": false,
                    "promo_code_total": false
                });
            }
        });
    };

    $scope.modelo = [];
    $rootScope.paquetes_dispon = [];

    // RECUPERAR SESION

    $log.debug("Session.get cada vez que entramos -> extras.js");
    Session.get().then(function (result) {

        $scope.session = result;

        // COMPROBAR LA DISPONIBILIDAD DEL GRUPO SELECCIONADO

        $scope.grupo = {};

        GoldcarService.getDisponibilidadGrupo().then(function (data) {

            $scope.grupo.extras = data.extras;

            for ( var i = 0; i < $scope.grupo.extras.length; i++ ) {

                if ( !$scope.grupo.extras[i].disponible ) {

                    $scope.grupo.extras.splice(i, 1);
                }
            }

            $ionicLoading.hide();

            for ( var k = 0; k < data.paquetes.length; k++ ) {

                for ( var l = 0; l < $scope.session.paquetes_disponibilidad.length; l++ ) {

                    if ( $scope.session.paquetes_disponibilidad[l].reference == data.paquetes[k].reference ) {

                        $rootScope.paquetes_dispon.push(data.paquetes[k]);
                    }
                }
            }

            Session.set(angular.merge({}, $scope.session, {
                "paquetes": $rootScope.paquetes_dispon

            })).then(function () {

                var listaExtras = {};
                $scope.paquetesDis = undefined;
                $log.debug("$rootScope.paquetes_dispon", $rootScope.paquetes_dispon);

                for ( var j = 0; j < $rootScope.paquetes_dispon.length; j++ ) {

                    listaExtras = {"extra": $rootScope.paquetes_dispon[j].extras.split(",")};
                    $log.debug("LISTA EXTRAS", listaExtras);
                    $scope.paquetesDis = listaExtras;
                }

                console.log("$scope.paquetesDis", $scope.paquetesDis);

                if ( typeof $scope.paquetesDis != 'undefined' ) {

                    $log.debug("paquetes_dispon", $scope.paquetesDis);

                    for ( var n = 0; n < $scope.grupo.extras.length; n++ ) {

                        for ( var i = 0; i < $scope.paquetesDis.extra.length; i++ ) {

                            if ( $scope.paquetesDis.extra[i] == $scope.grupo.extras[n].alias ) {

                                $scope.grupo.extras[n].activo = true;
                                break;
                            } else {

                                $scope.grupo.extras[n].activo = false;
                            }
                        }
                    }
                }
            });

            $log.debug("GRUPO EXTRAS ACTIVO", $scope.grupo.extras);

            $log.debug("EXTRAS DISPONIBLES", $scope.grupo.extras);

            $scope.todoCargado = true;
        });

        for ( var i = 0; i < $rootScope.disponibilidad.length; i++ ) {

            if ( $rootScope.disponibilidad[i].grupo === $scope.session.group ) {

                $scope.grupo = $rootScope.disponibilidad[i];
            }
        }

        if(!$scope.grupo.disponible) {
            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.extras.disponibilidad_titulo),
                template: $filter("translate")($rootScope.translations.home.disponibilidad_texto)
            }).then(function () {
                $scope.goBack();
            });
        }

        $rootScope.divisa = $scope.grupo.divisa;

    });

    // RECUPERAR PREMIOS & CODIGOS PROMOCIONALES

    $scope.premios = [];
    $scope.tienePremios = false;
    $scope.codigosPromocionales = [];

    if ( $rootScope.isLogged ) {

        GoldcarService.getUsuario().then(function () {

            GoldcarService.getCodigosPromo().then(function (result) {

                for ( var i = 0; i < result.data.length; i++ ) {

                    if ( result.data[i].Code == '3' || result.data[i].Code == '4' ) {

                        $scope.premios.push(result.data[i]);
                        $scope.tienePremios = true;
                    } else if ( result.data[i].Code == '0' || result.data[i].Code == '1' || result.data[i].Code == '2' ) {

                        $scope.codigosPromocionales.push(result.data[i]);
                    }
                }
            })
        });
    }

    $rootScope.getPromos = function () {

        if ( $rootScope.isLogged ) {

            GoldcarService.getUsuario().then(function () {

                GoldcarService.getCodigosPromo().then(function (result) {

                    for ( var i = 0; i < result.data.length; i++ ) {

                        if ( result.data[i].Code == '0' || result.data[i].Code == '1' || result.data[i].Code == '2' ) {

                            $scope.codigosPromocionales.push(result.data[i]);
                            $ionicLoading.hide();
                        }
                    }
                })
            });
        }
    };

    $rootScope.getPremios = function () {

        $scope.premios = [];

        if ( $rootScope.isLogged ) {

            GoldcarService.getUsuario().then(function () {

                GoldcarService.getCodigosPromo().then(function (result) {

                    for ( var i = 0; i < result.data.length; i++ ) {

                        if ( result.data[i].Code == '3' || result.data[i].Code == '4' ) {

                            $scope.premios.push(result.data[i]);
                            $scope.tienePremios = true;
                            $ionicLoading.hide();
                        }
                    }
                })
            });
        }
    };

    // AÑADIR O QUITAR CODIGOS PROMOCIONALES // Accion: add -> Añade nuevo codigo promo; remove -> Elimina codigo promo; // CLUBJHM47868 // CLUBJYH184163

    $scope.codigoPromo = function (accion, codigo, index) {

        console.log(codigo);

        var precioTotal;

        for (var tarifaId in $scope.grupo.tarifas) {

            var tarifa = $scope.grupo.tarifas[tarifaId];

            if ( tarifa.fuel === $scope.session.Fuel ) {

                precioTotal = tarifa.precio_totalf;
            }
        }

        var date = new Date();
        date = date.toISOString();

        $log.debug("Session.set de seleccionaPremio con angular.merge -> extras.js");
        Session.set(angular.merge({}, $scope.session, {
            "totExtras": "0",
            "totPaquetes": "0",
            "totRate": precioTotal,
            "promo_code": false,
            "promo_code_total": false,
            "timestamp": date

        })).then(function () {

            if ( accion == 'add' && typeof codigo != 'undefined' ) {

                // ADD
                GoldcarService.getCodigoPromo(codigo).then(function (result) {

                    var nuevoPremio = {};
                    var encontrado = false;

                    $log.debug("RESSSSSSSSSSULT", result);

                    if ( result.data.Promocode ) {

                        if ( $scope.codigosPromocionales.length == 0 ) {

                            nuevoPremio.Code = 1;
                            nuevoPremio.Codigo = result.data.Promocode;
                            nuevoPremio.Nombre = $filter("translate")($rootScope.translations.extras.descuento) + result.data.Importe + " " + $scope.grupo.divisa;
                            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_nuevo)});
                            nuevoPremio.seleccionado = true;
                            nuevoPremio.Nombre = $filter("translate")($rootScope.translations.extras.descuento_promocional);
                            $scope.codigosPromocionales.push(nuevoPremio);
                            i = $scope.codigosPromocionales.length - 1;
                            $log.debug("$scope.codigosPromocionales", $scope.codigosPromocionales);
                            $scope.seleccionarPromo(i);
                            encontrado = true;
                        } else {

                            for ( var i = 0; i < $scope.codigosPromocionales.length; i++ ) {

                                if ( result.data.Promocode == $scope.codigosPromocionales[i].Codigo && encontrado == false ) {

                                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_dispone)});
                                    $scope.seleccionarPromo(i);
                                    encontrado = true;
                                } else if ( result.data.Promocode != $scope.codigosPromocionales[i].Codigo && encontrado == false ) {

                                    nuevoPremio.Code = 1;
                                    nuevoPremio.Codigo = result.data.Promocode;
                                    nuevoPremio.Nombre = $filter("translate")($rootScope.translations.extras.descuento) + result.data.Importe + " " + $scope.grupo.divisa;
                                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_nuevo)});
                                    nuevoPremio.seleccionado = true;
                                    nuevoPremio.Nombre = $filter("translate")($rootScope.translations.extras.descuento_promocional);
                                    $scope.codigosPromocionales.push(nuevoPremio);
                                    i = $scope.codigosPromocionales.length - 1;
                                    $log.debug("$scope.codigosPromocionales", $scope.codigosPromocionales);
                                    $scope.seleccionarPromo(i);
                                    encontrado = true;
                                }
                            }
                        }

                    } else if ( result.data.error ) {

                        $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_error), template: $filter("translate")($rootScope.translations.extras.codigo_promo_error_texto)});
                    }
                }, function (error) {

                    $log.error("Error trayendo CodigosPromo: ", error);
                })

            } else if ( accion == 'remove' && typeof index != 'undefined' ) {

                // REMOVE
                $scope.codigosPromocionales.splice(index, 1);
                $rootScope.promo_code = false;
                Session.set(angular.merge({}, $scope.session, {
                    "promo_code": false,
                    "promo_code_total": false

                })).then(function (result) {

                    $scope.session = result;
                });
                $rootScope.getPromos();
                $rootScope.aplicadoCodigoPromo = null;
            }
        });
    };

    // SELECCIONAR CODIGO PROMOCIONAL

    $scope.seleccionarPromo = function (index) {

        $ionicLoading.show();

        $rootScope.aplicadoCodigoPromo = {};

        $scope.modelo.promo = false;

        if ( $rootScope.aplicadoCodigoPromo && ($rootScope.aplicadoCodigoPromo.Codigo || $rootScope.aplicadoCodigoPromo.Error) ) {

            $rootScope.aplicadoCodigoPromo = {};
            $scope.codigosPromocionales = [];
            $rootScope.promo_code = false;

            $rootScope.getPromos();
        } else {

            $ionicLoading.show();

            var precioTotal;

            $rootScope.aplicadoCodigoPromo = {};

            for (var tarifaId in $scope.grupo.tarifas) {

                var tarifa = $scope.grupo.tarifas[tarifaId];

                if ( tarifa.fuel === $scope.session.Fuel ) {

                    precioTotal = tarifa.precio_totalf;
                }
            }

            $log.debug("Session.set de seleccionaPremio con angular.merge -> extras.js");
            Session.set(angular.merge({}, $scope.session, {
                "totExtras": "",
                "totPaquetes": "",
                "totRate": precioTotal

            })).then(function () {

                $log.debug(index);
                var promo = $scope.codigosPromocionales[index];
                $log.debug("$scope.codigosPromocionales[index]", $scope.codigosPromocionales[index]);
                $log.debug("PROMO", promo);

                // GoldcarService.getActivarCodigoPromo(promo.Codigo).then(function (result) {
                //
                //     console.log(result);
                // });

                GoldcarService.getCodigoPromo(promo.Codigo).then(function (result) {

                    $log.debug("RESSSSSSULT", result);

                    if ( !result.data.error ) {

                        $log.debug("Session.set de recogerDatosLoginExtra con angular.merge 2 -> extras.js");
                        Session.set(angular.merge({}, $scope.session, {

                            "promo_code": promo.Codigo,
                            "promo_code_total": result.data.Importe
                        }));

                        $rootScope.promo_code = promo.Codigo;
                        $rootScope.promo_importe = result.data.Importe;

                        $rootScope.aplicadoCodigoPromo = {
                            "Texto": "Descuento Promocional",
                            "Codigo": promo.Codigo,
                            "Precio": result.data.Importe,
                            "Divisa": $scope.grupo.divisa
                        };

                        $scope.modelo.promo = true;

                        var codigoAplicado = [];

                        codigoAplicado.push($scope.codigosPromocionales[index]);

                        $scope.codigosPromocionales = codigoAplicado;

                        $ionicLoading.hide();
                    } else {

                        $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_precio) });

                        $scope.aplicadoCodigoPromo.Error = true;

                        $ionicLoading.hide();

                        $scope.codigosPromocionales = [];

                        $rootScope.getPromos();
                    }

                })
            })
        }
    };

    // SELECCIONAR PREMIO

    $scope.seleccionarPremio = function (index) {

        if ( $rootScope.aplicadoPremio && typeof $rootScope.aplicadoPremio.Texto != 'undefined' ) {

            $ionicLoading.show();

            $rootScope.aplicadoPremio = {};

            $rootScope.getPremios();
        }

        else {

            $ionicLoading.show();

            $rootScope.aplicadoPremio = {};

            GoldcarService.getUsuario().then(function (result) {

                var usuario = result.data;

                if ( usuario.Premios[index].extras === 'AdditionalDriver' && $rootScope.tarifaSeleccionada === 'PackKeyngo') {

                    $ionicLoading.hide();
                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.premio_incompatible) });
                }

                else if ( usuario.Premios[index].extras === 'AdditionalDriver' && $rootScope.tarifaSeleccionada !== 'PackKeyngo') {

                    $rootScope.aplicadoPremio = {
                        "Texto": "Conductor adicional",
                        "reference": usuario.Premios[index].id
                    };

                    $rootScope.aplicadoPremioFinal = {
                        "paquetes": [{
                            "cantidad": 1,
                            "extras": usuario.Premios[index].extras,
                            "precio": parseFloat(usuario.Premios[index].precio),
                            "reference": usuario.Premios[index].reference,
                            "tarifa": false,
                            "unico": true
                        }],
                        "premios": [{
                            "cantidad": 1,
                            "id": $scope.premios[index].IdPremio
                        }]
                    };

                    var premioSeleccionado = [];

                    premioSeleccionado.push($scope.premios[index]);

                    $scope.premios = [];

                    $scope.premios = premioSeleccionado;

                    $ionicLoading.hide();
                }

                else {

                    $rootScope.aplicadoPremio = {
                        "Texto": usuario.Premios[index].extras,
                        "reference": usuario.Premios[index].id
                    };

                    $rootScope.aplicadoPremioFinal = {
                        "paquetes": [{
                            "cantidad": 1,
                            "extras": usuario.Premios[index].extras,
                            "precio": parseFloat(usuario.Premios[index].precio),
                            "reference": usuario.Premios[index].reference,
                            "tarifa": false,
                            "unico": true
                        }],
                        "premios": [{
                            "cantidad": 1,
                            "id": $scope.premios[index].IdPremio
                        }]
                    };

                    var premioSeleccionado = [];

                    premioSeleccionado.push($scope.premios[index]);

                    $scope.premios = [];

                    $scope.premios = premioSeleccionado;

                    $ionicLoading.hide();
                }

            });

            if ( $rootScope.aplicadoPremio.Texto === 'Conductor adicional' ) {

                for ( var i = 0; i < $rootScope.aplicadosExtras.length; i++ ) {

                    var eliminado = false;

                    if ( !eliminado && $rootScope.aplicadosExtras[i].alias === 'AdditionalDriver' ) {

                        $rootScope.aplicadosExtras.splice(i, 1);
                        $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_incompatible) });
                        eliminado = true;
                    }
                }
            }
        }
    };

    var totalSillas = 0;

    $scope.agregarSilla = function (tipoSilla, cantidad) {

        for ( var i = 0; i < $rootScope.aplicadosExtras.length; i++ ) {

            if ( $rootScope.aplicadosExtras[i].alias === tipoSilla ) {

                $rootScope.aplicadosExtras[i].cantidad = cantidad;
            }
        }
    };

    $scope.sumarSillita = function (tipo) {

        if ( tipo === 'BoosterSeat' && $scope.sillita1 < 3 && totalSillas < 3 ) {
          console.log(tipo);
            $scope.sillita1++;
            totalSillas++;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.sillita1);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        } else if ( tipo === 'MaxiCosi' && $scope.sillita2 < 3 && totalSillas < 3 ) {

            $scope.sillita2++;
            totalSillas++;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.sillita2);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        } else if ( tipo === 'BabySeat' && $scope.sillita3 < 3 && totalSillas < 3 ) {

            $scope.sillita3++;
            totalSillas++;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.sillita3);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        }
    };

    $scope.restarSillita = function (tipo) {

        if ( tipo === 'BoosterSeat' && $scope.sillita1 > 1 && totalSillas > 0 ) {

            $scope.sillita1--;
            totalSillas--;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.sillita1);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        } else if ( tipo === 'MaxiCosi' && $scope.sillita2 > 1 && totalSillas > 0 ) {

            $scope.sillita2--;
            totalSillas--;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.sillita2);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        } else if ( tipo === 'BabySeat' && $scope.sillita3 > 1 && totalSillas > 0 ) {

            $scope.sillita3--;
            totalSillas--;
            $log.debug("totalSillas", totalSillas);
            $scope.agregarSilla(tipo, $scope.sillita3);
            $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);
        }
    };

    $scope.mostrarSilla1 = false;
    $scope.mostrarSilla2 = false;
    $scope.mostrarSilla3 = false;

    // SELECCIONAR EXTRAS

    $rootScope.aplicadosExtras = [];

    $scope.seleccionarExtra = function (alias, cantidad, tipoSilla) {

        if ( tipoSilla === 'BoosterSeat' && totalSillas < 3 && !$scope.mostrarSilla1 ) {

            $scope.mostrarSilla1 = true;
            $scope.sillita1 = 1;
            if ( $scope.mostrarSilla1 ) {

                totalSillas++;
                $log.debug("totalSillas", totalSillas);
            } else {

                totalSillas--;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if ( tipoSilla === 'BoosterSeat' && $scope.mostrarSilla1 ) {

            if ( $scope.mostrarSilla1 ) {

                $log.debug("CANTIDAD", cantidad);
                $scope.mostrarSilla1 = false;
                totalSillas = totalSillas - cantidad;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if ( tipoSilla === 'BoosterSeat' && totalSillas == 3 && !$scope.mostrarSilla1 ) {

            setTimeout(function() {
                angular.element(document.querySelector('#boosterSeat')).triggerHandler('click');
            }, 500);
            totalSillas = 4;
            $log.debug("totalSillas", totalSillas);
        }

        else if ( tipoSilla === 'BoosterSeat' && totalSillas == 4 && !$scope.mostrarSilla1 ){

            totalSillas = 3;
            $log.debug("totalSillas", totalSillas);
        }

        if ( tipoSilla === 'MaxiCosi' && totalSillas < 3 && !$scope.mostrarSilla2 ) {

            $scope.mostrarSilla2 = !$scope.mostrarSilla2;
            $scope.sillita2 = 1;
            if ( $scope.mostrarSilla2 ) {

                totalSillas++;
                $log.debug("totalSillas", totalSillas);
            } else {

                totalSillas--;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if ( tipoSilla === 'MaxiCosi' && $scope.mostrarSilla2 ) {

            if ( $scope.mostrarSilla2 ) {

                $log.debug("CANTIDAD", cantidad);
                $scope.mostrarSilla2 = false;
                totalSillas = totalSillas - cantidad;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if ( tipoSilla === 'MaxiCosi' && totalSillas == 3 && !$scope.mostrarSilla2 ) {

            setTimeout(function() {
                angular.element(document.querySelector('#maxiCosi')).triggerHandler('click');
            }, 500);
            totalSillas = 4;
            $log.debug("totalSillas", totalSillas);
        }

        else if ( tipoSilla === 'MaxiCosi' && totalSillas == 4 && !$scope.mostrarSilla2 ){

            totalSillas = 3;
            $log.debug("totalSillas", totalSillas);
        }

        if ( tipoSilla === 'BabySeat' && totalSillas < 3 && !$scope.mostrarSilla3 ) {

            $scope.mostrarSilla3 = !$scope.mostrarSilla3;
            $scope.sillita3 = 1;
            if ( $scope.mostrarSilla3 ) {

                totalSillas++;
                $log.debug("totalSillas", totalSillas);
            } else {

                totalSillas--;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if ( tipoSilla === 'BabySeat' && $scope.mostrarSilla3 ) {

            if ( $scope.mostrarSilla3 ) {

                $log.debug("CANTIDAD", cantidad);
                $scope.mostrarSilla3 = false;
                totalSillas = totalSillas - cantidad;
                $log.debug("totalSillas", totalSillas);
            }
        }

        else if ( tipoSilla === 'BabySeat' && totalSillas == 3 && !$scope.mostrarSilla3 ) {

            setTimeout(function() {
                angular.element(document.querySelector('#babySeat')).triggerHandler('click');
            }, 500);
            totalSillas = 4;
            $log.debug("totalSillas", totalSillas);
        }

        else if ( tipoSilla === 'BabySeat' && totalSillas == 4 && !$scope.mostrarSilla3 ){

            totalSillas = 3;
            $log.debug("totalSillas", totalSillas);
        }

        if ( typeof cantidad === 'undefined' ) {

            cantidad = 1;
        }

        var encontrado = false;
        var extraSeleccionado;

        $scope.grupo.extras.forEach(function (extra) {
            if ( extra.alias == alias ){
                extraSeleccionado = extra;
                return;
            }
        });

        if ( $rootScope.aplicadosExtras.length > 0 ) {

            for ( var i = 0; i < $rootScope.aplicadosExtras.length; i++ ) {

                if ( encontrado == false && extraSeleccionado.alias === $rootScope.aplicadosExtras[i].alias ) {

                    $rootScope.aplicadosExtras.splice(i, 1);
                    encontrado = true;
                }
            }

            if ( encontrado == false ) {

                $rootScope.aplicadosExtras.push({
                    "alias": extraSeleccionado.alias,
                    "cantidad": cantidad, // REVISAR CASO SILLITAS
                    "depende": extraSeleccionado.depende,
                    "depende_paquete": extraSeleccionado.depende_paquete,
                    "descripcion": extraSeleccionado.descripcion,
                    "divisa": $scope.grupo.divisa,
                    "extras_no_compatibles": extraSeleccionado.extras_no_compatibles,
                    "precio": extraSeleccionado.precio,
                    "precio_total": extraSeleccionado.precio_total
                });
            }

        }

        else {

            $rootScope.aplicadosExtras.push({
                "alias": extraSeleccionado.alias,
                "cantidad": cantidad, // REVISAR CASO SILLITAS
                "depende": extraSeleccionado.depende,
                "depende_paquete": extraSeleccionado.depende_paquete,
                "descripcion": extraSeleccionado.descripcion,
                "divisa": $scope.grupo.divisa,
                "extras_no_compatibles": extraSeleccionado.extras_no_compatibles,
                "precio": extraSeleccionado.precio,
                "precio_total": extraSeleccionado.precio_total
            });
        }

        $log.debug("$rootScope.aplicadosExtras", $rootScope.aplicadosExtras);

        if ( $rootScope.aplicadoPremio && $rootScope.aplicadoPremio.Texto === 'Conductor adicional' ) {

            for ( var i = 0; i < $rootScope.aplicadosExtras.length; i++ ) {

                var eliminado = false;

                if ( !eliminado && $rootScope.aplicadosExtras[i].alias === 'AdditionalDriver' ) {

                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.extras.codigo_promo_titulo), template: $filter("translate")($rootScope.translations.extras.codigo_promo_incompatible) });
                    $rootScope.aplicadoPremio = {};
                    eliminado = true;
                }
            }
        }
    };

    $scope.abrirModalInfoRelax = function () {

        $ionicModal.fromTemplateUrl('templates/reservar/infoRelax.html', {

            vista: "InfoRelax",
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modalInfoRelax) {

            $scope.modalInfoRelax = modalInfoRelax;
            modalInfoRelax.show();
        });

    };
});
