angular.module('goldcar').controller('RoboCtrl', function($filter, $log, $ionicModal, $scope, $rootScope, $ionicLoading, JsonService, $ionicPopup) {

	//---------------------------
	// ROBO MATRICULA (PASO 1)
	//---------------------------

    $scope.inicializarVariables = function (){

        $rootScope.data = {};
        $rootScope.imagen = [];
        $scope.envioRobo = {};
    };

	$scope.irPaso2 = function() {

		if ( typeof $rootScope.data.numeroMatricula == "undefined" || $rootScope.data.numeroMatricula == "" )
			$ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.faltan_datos), template: $filter("translate")($rootScope.translations.alertas.aviso_matricula) });
		else
			$scope.modalRobo2.show();
	};

	//-------------------------------------
	// ROBO FOTOGRAFIAS DENUNCIA (PASO 2)
	//-------------------------------------
	
	$scope.nuevaImagen = function() {
		$ionicLoading.show();

		navigator.camera.getPicture(onSuccess, onFail, {
			quality: 50,
    		destinationType: Camera.DestinationType.DATA_URL
		});

		function onSuccess(imageData) {

		    $rootScope.imagen.push("data:image/jpeg;base64," + imageData);
			$ionicLoading.hide();
		}

		function onFail(message) {

            $log.error("Error capturando imagen: ", message)
		    $ionicLoading.hide();
		}
	};

    //-------------------------------------
    // CREAR MODAL AMPLIAR IMAGEN
    //-------------------------------------

    $scope.createModalAmpliarImagen = function() {
        $ionicModal.fromTemplateUrl('templates/robo/detallesImagen.html', {

			vista: "Detalles Imagen Robo",
            scope: $rootScope,
            animation: 'slide-in-up'
        }).then(function(modalDetallesImagen) {

            $rootScope.modalDetallesImagen = modalDetallesImagen;
            $rootScope.modalDetallesImagen.show();
        });
    };

    //-------------------------------------
    // ABRIR IMAGEN FILTRADA
    //-------------------------------------

    $scope.ampliarImagen = function(image, index){
        $rootScope.imagenAmpliada = {image : image, position: index};
        $scope.createModalAmpliarImagen();
    };

    //-------------------------------------
    // BORRAR IMAGEN AMPLIADA
    //-------------------------------------

	$scope.deleteImagen = function(index) {

		$rootScope.imagen.splice(index, 1);
        $rootScope.modalDetallesImagen.hide();
	};

    //-------------------------------------
    // IR AL PASO 3
    //-------------------------------------

	$scope.irPaso3 = function() {

		if( typeof $rootScope.imagen === "undefined" || $rootScope.imagen == "" )
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.faltan_datos), template: $filter("translate")($rootScope.translations.alertas.aviso_fotografias) });

		else{

			$rootScope.dataRobo = [];
			$rootScope.dataRobo.matricula = $rootScope.data.numeroMatricula;
			$rootScope.dataRobo.imagenes = $rootScope.imagen;

			$scope.modalRobo3.show();
		}
	};

	//---------------------------
	// ROBO RESUMEN (PASO 3)
	//---------------------------

	$scope.volverPaso2 = function() {

		$scope.modalRobo3.hide();
	};

	$scope.enviarRobo = function() {

		$ionicLoading.show({

            template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.enviando) + '</i><br><ion-spinner icon="lines" class="spinner-calm"></ion-spinner></div>'
        });
		
		$scope.envioRobo = {
	        handle: "goldcarapp-robo",
	        lang: $rootScope.language,
	        matricula: $rootScope.dataRobo.matricula,
	        attachments: []
    	};

	    for ( var j = 0; j != $rootScope.dataRobo.imagenes.length; j++ ) {

	    	$scope.envioRobo.attachments[j] = {
	    		"name": "robo" + j + ".jpg",
	    		"data": ($rootScope.dataRobo.imagenes[j]).substr(23)
	    	}
	    } 

		JsonService.postMail($scope.envioRobo).then(function () {
            $ionicPopup.alert({title: $filter("translate")($rootScope.translations.alertas.exito), template: $filter("translate")($rootScope.translations.alertas.envio_realizado)});

			$rootScope.data.numeroMatricula = "";
			$rootScope.dataRobo.imagenes.splice(0, $rootScope.dataRobo.imagenes.length);
			$rootScope.imagen.splice(0, $rootScope.imagen.length);
			$ionicLoading.hide();

		}, function () {
            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.general.error),
                template: $filter("translate")($rootScope.translations.alertas.error_conexion)
            });
            $ionicLoading.hide();
		})
	}

});