angular.module('goldcar').controller('SugerenciasCtrl', function($filter, $scope, $rootScope, JsonService, $ionicLoading, $ionicPopup, $log, $cordovaDevice, $cordovaNetwork) {

	$scope.sugerencia = [];
    $scope.sugerencia.nombre = "";
    $scope.sugerencia.email = "";
    $scope.sugerencia.text = "";

    var appVersion = $rootScope.versionAPP;
    var deviceModel = $cordovaDevice.getModel();
    var devicePlatform = $cordovaDevice.getPlatform();
    var deviceVersion = $cordovaDevice.getVersion();
    var deviceNetwork = $cordovaNetwork.getNetwork();

	$scope.enviarSugerencia = function(nombre, email, text) {

		$ionicLoading.show({

      		template: '<div class="cargando"><i style="font-weight: bold; padding-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.enviando) + '</i><br><ion-spinner icon="lines" class="spinner-positive"></ion-spinner></div>'
    	});

        if ( nombre != "" || email != "" || text != "" ) {

            var envioSugerencia = {

                handle: "goldcarapp-sugerencias",
                lang: $rootScope.language,
                nombre: nombre,
                email: email,
                sugerencias: text,
                "version APP": appVersion,
                modelo: deviceModel,
                plataforma: devicePlatform,
                "version OS": deviceVersion,
                "tipo conexion": deviceNetwork
            };

            console.log(envioSugerencia);

            JsonService.postMail(envioSugerencia).then(function (result) {

                $scope.sugerencia.nombre = "";
                $scope.sugerencia.email = "";
                $scope.sugerencia.text = "";
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.alertas.exito),
                    template: $filter("translate")($rootScope.translations.alertas.sugerencia_enviada)
                });
            }, function (error) {

                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.alertas.error_conexion)
                });
                $log.error(error);
            })    
        } else {

            $ionicLoading.hide();
            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.alertas.faltan_datos),
                template: $filter("translate")($rootScope.translations.alertas.sugerencia_incompleta)
            });
        }
	};

	$scope.borrarCampos = function() {

		$scope.sugerencia.nombre = "";
		$scope.sugerencia.email = "";
		$scope.sugerencia.text = "";
	};

});