angular.module('goldcar').controller('TarjetasCtrl', function ($scope, $rootScope, GoldcarService, $ionicScrollDelegate, $ionicPopup, $ionicLoading, $filter) {
    
    $scope.tarjetaNueva = {}; // DATOS TARJETA NUEVA
    
    $scope.abrirFormulario = function() {
        
        $scope.mostrarFormularioTarjeta = !$scope.mostrarFormularioTarjeta;
        $ionicScrollDelegate.resize();
        setTimeout(function() {
            
            $ionicScrollDelegate.scrollBottom(true);
        }, 200);
        
        if ( !$scope.mostrarFormularioTarjeta ) {
            
            $ionicScrollDelegate.resize();
            setTimeout(function() {

                $ionicScrollDelegate.scrollTop(true);
            }, 200);
        }
    }

    // RECOGER TARJETAS
    var obtenerTarjetas = function() {
        
        $ionicLoading.show();
        
        if ( $rootScope.isLogged ) {

            GoldcarService.postTarjetas().then(function(data) {

                $scope.listaTarjetas = data.data;
                $ionicLoading.hide();
            });   
        }   
    }
    
    obtenerTarjetas();
    
    $scope.recargarTarjetas = function() {
        
        obtenerTarjetas();
    }
    
    // ELIMINAR TARJETAS
    var eliminarTarjetaFn = function(id) {
        
        $ionicLoading.show();
        
        GoldcarService.postEliminarTarjeta({ Idtarjeta: id}).then(function(response) {
            
            if ( response.data ) {
                
                obtenerTarjetas();   
            } else {
                
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.tarjetas.error_eliminar_tarjeta)
                });
            }
            
            $ionicLoading.hide();
        })
    }
    
    $scope.eliminarTarjeta = function(id) {
        
        $ionicPopup.confirm({
            
            title: $filter("translate")($rootScope.translations.general.borrar),
            template: $filter("translate")($rootScope.translations.tarjetas.quieres_borrar_tarjeta)
        }).then(function(res) {
            
            if(res) {
                
                eliminarTarjetaFn(id);     
            }
        });
    }
    
    // CREAR TARJETAS
    var crearTarjetaFn = function() {
        
        $ionicLoading.show();
        
        $scope.tarjetaNueva.tarjeta_fecha = $scope.tarjetaNueva.tarjeta_fecha.replace('/', '');
        $scope.tarjetaNueva.tarjeta_numero = $scope.nuevaTarjetaNumero;
        
        GoldcarService.postNuevaTarjeta($scope.tarjetaNueva).then(function(response) {
            
            if ( response.data.status ) {
                
                obtenerTarjetas();   
                $scope.tarjetaNueva = {};
            } else {
                
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.general.error),
                    template: $filter("translate")($rootScope.translations.tarjetas.error_guardar_tarjeta)
                });
            }
            
            $ionicLoading.hide();
        })
    }
    
    $scope.crearTarjeta = function() {

        if (typeof $scope.tarjetaNueva.tarjeta_fecha !== 'undefined' && $scope.tarjetaNueva.tarjeta_fecha !== '') {
            var res = $scope.tarjetaNueva.tarjeta_fecha.split("/");
            var givenMonth = res[0];
            var givenYear = res[1];
        } else {
            status = $filter("translate")($rootScope.translations.datos.falta_fecha_caducidad);
        }

        var year = new Date().getFullYear();
        var month = new Date().getMonth() + 1;
        
        var status = 'ok';
        
        var regexNumero = /^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|6(?:011|5[0-9]{2})[0-9]{12}|(?:2131|1800|35\d{3})\d{11})$/gm; // Cualquier tarjeta
        var regexHolder = /^[^\d\/\\?¿]{1,}([\s][^\d\/\\]{1,})+$|^[^\d\/\\]{1,}$/gm; // Nombre | Nombre Apellido | Nombre Apellido Apellido
        var regexMonth = /^([0][1-9])$|^([1][0-2])$/gm; // 01-12
        var regexYear = /^([1][6-9])$|^([2-9][0-9])$/gm; // 16-99
        var regexCVC = /^[0-9]{3}$/gm; // 000-999

        //--//

        if ( typeof $scope.tarjetaNueva.tarjeta_numero !== "undefined" ) {

            $scope.nuevaTarjetaNumero = $scope.tarjetaNueva.tarjeta_numero.replace(/ /g,'');

            if ($scope.nuevaTarjetaNumero.match(regexNumero) == null) {

                status = $filter("translate")($rootScope.translations.datos.error_tarjeta);
            }
        } else {
            status = $filter("translate")($rootScope.translations.datos.falta_tarjeta);
        }
        
        //--//

        if ( typeof $scope.tarjetaNueva.name === "undefined" || typeof $scope.tarjetaNueva.name === '' ) {

            status = $filter("translate")($rootScope.translations.datos.falta_titular);
        }

        //--//

        if ( typeof givenMonth !== "undefined" ) {

            if (givenMonth.match(regexMonth) == null) 
                status = $filter("translate")($rootScope.translations.datos.error_mes_caducidad);

            if (givenMonth[0] == '0')
                givenMonth = givenMonth[1];
        } else {

            status = $filter("translate")($rootScope.translations.datos.falta_mes_caducidad);
        }

        //--//

        if ( typeof givenYear !== "undefined" ) {

            if (givenYear.match(regexYear) == null) 
                status = $filter("translate")($rootScope.translations.datos.error_ano_caducidad);

            if (givenYear.length == 2)
                givenYear = '20' + givenYear;
        } else {

            status = $filter("translate")($rootScope.translations.datos.falta_ano_caducidad);
        }

        //--//

        if (typeof $scope.tarjetaNueva !== 'undefined' && typeof $scope.tarjetaNueva.tarjeta_fecha !== 'undefined'){
            var thisYear = parseInt(moment().format('YY'));
            var thisMonth = parseInt(moment().format('MM'));
            var theirYear = parseInt(($scope.tarjetaNueva.tarjeta_fecha).split('/')[1]);
            var theirMonth = parseInt(($scope.tarjetaNueva.tarjeta_fecha).split('/')[0]);
        }

        if(theirYear < thisYear){
            status = $filter("translate")($rootScope.translations.datos.error_ano_caducidad);
        } else {
            if(theirMonth < thisMonth){
                status = $filter("translate")($rootScope.translations.datos.error_mes_caducidad);
            }
        }

        //--//

        if ( typeof $scope.tarjetaNueva.tarjeta_fecha === "undefined" || $scope.tarjetaNueva.tarjeta_fecha === '' ) {
            status = $filter("translate")($rootScope.translations.datos.falta_fecha_caducidad);
        }

        //--//

        if ( typeof givenMonth !== "undefined" && typeof givenYear !== "undefined" ) {
            if (givenYear == year && givenMonth < month)
                status = $filter("translate")($rootScope.translations.datos.fecha_superior);
        }

        //--//

        if ( typeof $scope.tarjetaNueva.tarjeta_cvc !== "undefined" ) {
            if ( $scope.tarjetaNueva.tarjeta_cvc.match(regexCVC) == null ) {
                status = $filter("translate")($rootScope.translations.datos.error_cvc);
            }
        } else {
            status = $filter("translate")($rootScope.translations.datos.falta_cvc);
        }

        //--//

        if (typeof $scope.tarjetaNueva.tarjeta_alias === 'undefined' || $scope.tarjetaNueva.tarjeta_alias === '') {
            status = $filter("translate")($rootScope.translations.tarjetas.rellena_alias);
        }

        //--//
        
        if ( status == 'ok' ) {
            
            $ionicScrollDelegate.scrollTop(true);
            crearTarjetaFn();   
        } else {
            
            $ionicPopup.alert({
                title: $filter("translate")($rootScope.translations.general.error),
                template: status
            });
        }
    } 
});