angular.module('goldcar').controller('TicketsCtrl', function ($filter, $scope, $ionicModal, $ionicPopup, $rootScope, $log, $timeout, $cordovaLocalNotification, $ionicLoading, JsonService, $ionicBackdrop) {

    $rootScope.$on('$cordovaLocalNotification:trigger', function (event, notification, state) {
        $log.debug("TicketsCtrl Notification trigger?", notification, state);
        if (notification.id == 100) {
            if ($rootScope.ticketCogido) $rootScope.ticketAviso5min = true;

            cordova.plugins.notification.local.isPresent(100, function (present) {
                if (present) {
                    if (state == 'foreground') $cordovaLocalNotification.clear(100, $rootScope);
                    $cordovaLocalNotification.cancel(100, $rootScope);
                }
                $ionicPopup.alert({
                    title: $filter("translate")($rootScope.translations.alertas.aviso_colas),
                    template: $filter("translate")($rootScope.translations.alertas.aviso_5_minutos)
                });
            });
            return;
        }
        if (notification.id == 200) {
            $log.info("Lanzo aviso Su turno?", !$rootScope.ticketAvisoSuturno)
            if ($rootScope.ticketCogido && !$rootScope.ticketAvisoSuturno) {
                $rootScope.ticketAvisoSuturno = true;
                cordova.plugins.notification.local.isPresent(200, function (present) {
                    if (present) {
                        if (state == 'foreground') $cordovaLocalNotification.clear(200, $rootScope);
                        $cordovaLocalNotification.cancel(200, $rootScope);
                    }
                    $log.debug("TicketsCtrl avisoSuturno?", $rootScope.ticketAvisoSuturno);
                    $ionicPopup.alert({
                        title: $filter("translate")($rootScope.translations.alertas.aviso_colas),
                        template: $filter("translate")($rootScope.translations.alertas.aviso_su_turno)
                    });
                });
            }
            return;
        }
    });

    $rootScope.$on('$cordovaLocalNotification:click', function (event, notification, state) {
        $log.debug("TicketsCtrl notification click?", notification, state);
        if (notification.id == 100) {
            if ($rootScope.ticketCogido) $rootScope.ticketAviso5min = true;
            $cordovaLocalNotification.clear(100, $rootScope);
            return;
        }
        if (notification.id == 200) {
            $cordovaLocalNotification.clear(200, $rootScope);
            return;
        }
    });

    $rootScope.waitingForLists = null;
    // $rootScope.refreshticketServicesHandler = false;
    $rootScope.refreshticketServices = function (spinner) {
        // console.log("TicketsCtrl Refresh services", $rootScope.ticketOffice);
        // console.log("TicketsCtrl Vuelo", $rootScope.ticketVuelo);
        // console.log("TicketsCtrl Express Service", $rootScope.ticketExpress);
        // console.log("spinner", spinner);
        if(spinner) {
            $ionicLoading.show({
                template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.recuperando_tickets) + '</i><br><ion-spinner icon="bubbles" class="spinner-positive"></ion-spinner></div>'
            });
        }
        JsonService.getTicket($rootScope.ticketOffice, null, null, $rootScope.ticketVuelo, $rootScope.ticketExpress)
            .then(function (result) {
                $log.debug("TicketsCtrl JsonService.getTicket", result);
                if (result.data && result.data.success) {
                    $rootScope.waitingForLists = result.data.waitingForList;
                    $log.debug($rootScope.waitingForLists);
                } else {
                    $log.error("TicketsCtrl ERROR Getting Ticket services", result);
                    $rootScope.waitingForLists = false;
                }
                if(spinner) {
                    $ionicLoading.hide();
                }
                // $rootScope.refreshticketServicesHandler = $timeout($rootScope.refreshticketServices, 5000);
            }, function (result) {
                $log.error("TicketsCtrl ERROR Getting Ticket services", result);
                $rootScope.waitingForLists = false;
                if(spinner) {
                    $ionicLoading.hide();
                }
                // $rootScope.refreshticketServicesHandler = $timeout($rootScope.refreshticketServices, 5000);
            });
    };

    $rootScope.notificationTicket = false;
    $rootScope.refreshTicketHandler = false;
    $rootScope.refreshTicket = function () {
        $log.debug("TicketsCtrl Refresh ticket");
        if($rootScope.refreshTicketHandler) $timeout.cancel($rootScope.refreshTicketHandler);
        if ($rootScope.ticketCogido) {
            $log.debug("TicketsCtrl Refresh ticket -> getting info", $rootScope.ticketCogido);
            JsonService.getTicket($rootScope.ticketCogido.office, $rootScope.ticketCogido.service, $rootScope.ticketCogido.id)
                .then(function (result) {
                    $log.debug("TicketsCtrl Refresh ticket -> result", result);
                    for (var attr in result.data.ticket) {
                        if($rootScope.ticketCogido[attr] != result.data.ticket[attr]) {
                            $rootScope.ticketCogido[attr] = result.data.ticket[attr];
                            $log.debug("ticketCogido." + attr, $rootScope.ticketCogido[attr]);
                        }
                    }

                    if ($rootScope.notificationTicket) {
                        $cordovaLocalNotification.cancel(100);
                        $rootScope.notificationTicket = false;
                    }


                    $log.debug("TicketsCtrl Last Ticket id ", $rootScope.ticketCogido.id);
                    $log.debug("TicketsCtrl Last CurrentTicket id ", $rootScope.ticketCogido.currentTicket);

                    if ($rootScope.ticketCogido.id == $rootScope.ticketCogido.currentTicket) {
                        $log.debug("TicketsCtrl Ticket actual. ya he avisado Su turno?", $rootScope.ticketAvisoSuturno);
                        if (!$rootScope.ticketAvisoSuturno) {
                            $log.debug("Tiene plugin cordova local notification", (window.cordova && window.cordova.plugins.notification.local));
                            if (window.cordova && window.cordova.plugins.notification.local) {
                                var dataNot = {
                                    id: 200,
                                    title: $filter("translate")($rootScope.translations.tickets.notificacion_ticket),
                                    led: "FF0000",
                                    text: $filter("translate")($rootScope.translations.tickets.notificacion_ticket_texto1),
                                    scope: $rootScope
                                };
                                window.cordova.plugins.notification.local.isScheduled(200, function (present) {
                                    $log.debug("notification 200 present?", present);
                                    if (present)
                                        $cordovaLocalNotification.cancel(200);
                                    $log.info("TicketsCtrl aviso Su turno creado", dataNot);
                                    $cordovaLocalNotification.schedule(dataNot, $rootScope);
                                });
                            }
                        }
                    } else {
                        if ($rootScope.ticketCogido.waitingTime > 0) {
                            $log.debug("TicketsCtrl aviso5min?", $rootScope.ticketAviso5min);
                            if (!$rootScope.ticketAviso5min && window.cordova && window.cordova.plugins.notification.local) {
                                var atMin = $rootScope.ticketCogido.waitingTime - 5;
                                var now = new Date().getTime();
                                var _5minsBefore = new Date(now + atMin * 60 * 1000);
                                $log.debug("atMin", atMin, "_5minsBefore", _5minsBefore);
                                var dataNot = {
                                    id: 100,
                                    title: $filter("translate")($rootScope.translations.tickets.notificacion_ticket),
                                    text: $filter("translate")($rootScope.translations.tickets.notificacion_ticket_texto2),
                                    led: "FF0000",
                                    at: _5minsBefore,
                                    scope: $rootScope
                                };
                                window.cordova.plugins.notification.local.isScheduled(100, function (present) {
                                    $log.debug("notification 200 present?", present);
                                    if (present)
                                        $cordovaLocalNotification.cancel(100, $rootScope);
                                    $log.info("TicketsCtrl aviso 5 min creado", dataNot);
                                    $cordovaLocalNotification.schedule(dataNot, $rootScope);
                                    $rootScope.notificationTicket = true;
                                });
                            }
                        }
                    }

                    if ($rootScope.ticketCogido && $rootScope.ticketCogido.status < 2) {
                        $rootScope.refreshTicketHandler = $timeout($rootScope.refreshTicket, 12000);
                    } else {
                        if ($rootScope.refreshTicketHandler)
                            $timeout.cancel($rootScope.refreshTicketHandler);
                        $rootScope.refreshTicketHandler = false;
                        $rootScope.ticketCogido = false;
                        delete localStorage['ticketCogido'];
                        if($rootScope.refreshTicketHandler) $timeout.cancel($rootScope.refreshTicketHandler);
                        if ($rootScope.modalTickets.isShown()) {
                            $rootScope.refreshticketServices()
                        }
                    }
                });
        }
    };

    $rootScope.closeModalTickets = function () {
        if ($rootScope.refreshticketServicesHandler)
            $timeout.cancel($rootScope.refreshticketServicesHandler);
    };

    $rootScope.cerrarTickets = function(){

        $rootScope.modalTicketsIsClose = true;
        $rootScope.modalTickets.remove();
        $ionicBackdrop.release();
        $rootScope.modalTicketsCreado = false;
        $rootScope.closeModalTickets();
    };

    $scope.cogerTicket = function (service) {

        $ionicLoading.show({
            template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 5px;">' + $filter("translate")($rootScope.translations.loading.enviando) + '</i><br><ion-spinner icon="lines" class="spinner-calm"></ion-spinner></div>'
        });

        JsonService.createTicket({
            "office": $rootScope.ticketOffice,
            "service": service,
            "userData": localStorage.getItem('EndpointArn')
        }).then(function (result) {
            if (result && result.data && result.data.success) {
                $rootScope.ticketAviso5min = false;
                $rootScope.ticketAvisoSuturno = false;
                var data = result.data;
                data.ticket.office = $rootScope.ticketOffice;
                data.ticket.createdtime = new Date();
                localStorage['ticketCogido'] = JSON.stringify($rootScope.ticketCogido = data.ticket);
                $ionicLoading.hide();
                $rootScope.refreshTicket();
                $rootScope.bannerTopTickets();
                $rootScope.cerrarTickets();
            }
        }, function (error) {
                $ionicLoading.hide();
                $log.debug("Error creando el ticket: ", error);
            }
        );
    };
});