angular.module('goldcar')

    .config(function (uiGmapGoogleMapApiProvider) {
        uiGmapGoogleMapApiProvider.configure({
            // key: 'AIzaSyAba0fIX2esRvg_VMKswOpx1iFVA_yvqjs',
            key: 'AIzaSyCJiEPHc36MuFRC6BwsNb4eh-5KNZmlYmE',
            v: '3.20', //defaults to latest 3.X anyhow
            libraries: 'weather,geometry,visualization'
        });
    })

    .controller('TransferCtrl', function ($filter, $scope, $rootScope, uiGmapGoogleMapApi, $log, $timeout, JsonService, $ionicPopup, $ionicLoading, $ionicModal) {

        $scope.createModalLiveBus = function(fn) {
            $ionicModal.fromTemplateUrl('templates/transfer/liveBus.html', {

                vista: "Seguimiento en vivo del bus",
                scope: $rootScope,
                animation: 'slide-in-up'
            }).then(function(modalLiveBus) {

                $rootScope.modalLiveBus = modalLiveBus;
                if(fn) fn();
            });
        };

        $ionicLoading.show();

        $scope.initMaps = function () {
            var office = JsonService.getOfficeByCode($rootScope.modalTransferOfficeCode);
            var color = ['#EC407A','#9C27B0','#3F51B5','#009688','#FF5722'];

            if (office) {
                var busData = office.busData;
                var busStops = [];
                $scope.polylines = [];

                ///////////////////////////////////
                //	GENERAMOS LAS PARADAS DE BUS
                ////////////////////////////////////

                busData.points.forEach(function (busStop, k) {
                    var pathArray = [];

                    if (typeof busStop.polyline !== "undefined") {
                        busStop.polyline.forEach(function (pl) {
                            pathArray.push({
                                latitude: pl[0],
                                longitude: pl[1]
                            });
                        });
                        $scope.polylines.push({
                            id: k + 1,
                            path: pathArray,
                            stroke: {
                                color: color[k % color.length],
                                weight: 3
                            },
                            geodesic: true,
                            visible: true
                        });
                        busStops.push({
                            address: busStop.address,
                            polyline: pathArray,
                            busIframe: busStop.busIframe,
                            coordinates: {
                                "latitude": busStop.coordinates[0],
                                "longitude": busStop.coordinates[1]
                            }
                        });
                    }
                    else {
                        busStops.push({
                            address: busStop.address,
                            busIframe: busStop.busIframe,
                            coordinates: {
                                "latitude": busStop.coordinates[0],
                                "longitude": busStop.coordinates[1]
                            }
                        });
                    }
                });

                uiGmapGoogleMapApi.then(function (maps) {
                    $scope.googleVersion = maps.version;
                    maps.visualRefresh = true;
                    var latLngBounds = new google.maps.LatLngBounds();

                    $scope.busStopMarkers = [];

                    ///////////////////////////////////
                    //	AÑADIMOS LA OFICINA COMO MARKER
                    ////////////////////////////////////

                    var image = {
                        url: 'img/marker-goldcar.svg'
                    };

                    $scope.busStopMarkers.push({
                        idKey: 1,
                        coords: {
                            latitude: office.latitude,
                            longitude: office.longitude
                        },
                        options: {
                            animation: google.maps.Animation.DROP,
                            icon: image
                        }
                    });

                    ///////////////////////////////////
                    //	AÑADIMOS CADA UNO DE LOS PUNTOS DE TRANSFER
                    ////////////////////////////////////

                    busStops.forEach(function (busStop, i) {

                        var j = i + 1;
                        var image = {
                            url: 'img/marker-bus-' + (j % color.length) + '.svg'
                        };

                        $scope.busStopMarkers.push({
                            idKey: i + 2,
                            coords: {
                                latitude: busStop.coordinates.latitude,
                                longitude: busStop.coordinates.longitude
                            },
                            options: {
                                animation: google.maps.Animation.DROP,
                                icon: image,
                                draggable: true
                            },
                            events: {
                                click: function() {
                                    $log.debug("Iframe del bus" + busStop.address + ": ", busStop.busIframe);
                                    $rootScope.liveBusSelected = [];
                                    $rootScope.liveBusSelected.titulo = busStop.address;
                                    $rootScope.liveBusSelected.iframe = busStop.busIframe;
                                    $scope.createModalLiveBus(function () {
                                        $rootScope.modalLiveBus.show();
                                    });
                                }
                            }
                        });
                        latLngBounds.extend(new google.maps.LatLng(busStop.coordinates.latitude, busStop.coordinates.longitude));
                        if (typeof busStop.polyline !== "undefined") {
                            busStop.polyline.forEach(function (pl) {
                                latLngBounds.extend(new google.maps.LatLng(pl.latitude, pl.longitude));
                            });
                        }
                    });

                    ///////////////////////////////////
                    //	AÑADIMOS LOS DETALLES DEL MAPA
                    ////////////////////////////////////

                    $scope.map = {
                        center: {
                            latitude: latLngBounds.getCenter().lat(),
                            longitude: latLngBounds.getCenter().lng()
                        },
                        bounds: {
                            northeast: {
                                latitude: latLngBounds.getNorthEast().lat(),
                                longitude: latLngBounds.getNorthEast().lng()
                            },
                            southwest: {
                                latitude: latLngBounds.getSouthWest().lat(),
                                longitude: latLngBounds.getSouthWest().lng()
                            }
                        },
                        control: {},
                        zoom: 14
                    };
                });
                $ionicLoading.hide();
            }
            else{
                $ionicLoading.hide();
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.alertas.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion)});
                $log.debug("Existe un error con la oficina con código: ", office);
            }
        }
    }

);