angular.module('goldcar').controller('tuCuentaCtrl', function($filter, $scope, $rootScope, $cordovaDatePicker, GoldcarService, $ionicLoading, $ionicPopup, $log, $q, $ionicScrollDelegate) {

    moment.locale($rootScope.config.mapeo_moment[$rootScope.language]);

    function firstToUpperCase(texto) {

        return texto.substr(0, 1).toUpperCase() + texto.substr(1);
    }

    $scope.formatearMes = function(mes) {

        $log.debug("Mes sin formatear", mes);
        
        $scope.fecha = [];

        var fechaFormateada = moment.months('MMMM', mes - 1);

        $log.debug("Mes formateado", fechaFormateada);

        $scope.fecha.mesNacimientoMostrar = firstToUpperCase(fechaFormateada);
    };
    
    $scope.getDate = function(dia, mes, anyo) {

        if ( dia === null || mes === null || anyo === null ) {

            var options = {
                date: new Date(),
                mode: 'date',
                androidTheme: 3
            }
        } else {

            var options = {
                date: new Date(mes + '/' + dia + '/' + anyo),
                mode: 'date',
                androidTheme: 3
            };
        }
        
        $cordovaDatePicker.show(options).then(function(date){
            
            // FORMATEAR FECHA ACORDE A LO QUE PIDE LA API
            var mesEnvioAPI = function(month) {
                
                if ( month < 10 ) {
                    
                    month = "0" + month;
                    return month;
                } else {
                
                    return month;
                }
            };

            $scope.usuario.diaNacimiento = date.getUTCDate() + 1;
            $scope.usuario.mesNacimiento = mesEnvioAPI(date.getMonth() + 1);
            $scope.usuario.anyoNacimiento = date.getFullYear();
            $scope.formatearMes($scope.usuario.mesNacimiento);
        });
    };
    
    $rootScope.recuperarDatosUsuario = function() {

        $ionicLoading.show();

        GoldcarService.getUsuario().then(function(result) {

            $rootScope.usuarioIdentificado = result.data;

            // VALORES BAJA DE USUARIO //
            var patronBaja = 'Vj5yTeewM#M@';
            var params = $rootScope.usuarioIdentificado.Email + patronBaja;
            var hash = new jsSHA("SHA-256", "TEXT");
            hash.update(params);
            $scope.bajaUsuario.params = hash.getHash("HEX");
            $scope.bajaUsuario.email = $rootScope.usuarioIdentificado.Email;

            var anyo = null;
            var mes = null;
            var dia = null;

            if($rootScope.usuarioIdentificado.FechaNacimiento){

                anyo = ($rootScope.usuarioIdentificado.FechaNacimiento).split('-')[0];
                mes = ($rootScope.usuarioIdentificado.FechaNacimiento).split('-')[1];
                dia = ($rootScope.usuarioIdentificado.FechaNacimiento).split('-')[2];
            }

            if(typeof result.data.club_checked !== 'undefined' && result.data.club_checked) $scope.gdpr.club_accepted_club = true
            if(typeof result.data.perfil_checked !== 'undefined' && result.data.perfil_checked) $scope.gdpr.perfil_accepted_club = true
            if(typeof result.data.publi_checked !== 'undefined' && result.data.publi_checked) $scope.gdpr.publi_accepted_club = true

            $scope.usuario = {

                "nombre": $rootScope.usuarioIdentificado.Nombre,
                "apellidos": $rootScope.usuarioIdentificado.Apellidos,
                "anyoNacimiento": anyo,
                "mesNacimiento": mes,
                "diaNacimiento": dia,
                "direccion": $rootScope.usuarioIdentificado.Direccion,
                "cp": $rootScope.usuarioIdentificado.Cpostal,
                "poblacion": $rootScope.usuarioIdentificado.Poblacion,
                "provincia": $rootScope.usuarioIdentificado.Provincia,
                "club": $rootScope.usuarioIdentificado.Club,
                "urlWallet": $rootScope.usuarioIdentificado.UrlWallet
            };

            if ( anyo != null || mes != null || dia != null ) {

                $scope.formatearMes(mes);
            }

            if ( $scope.usuario.club == true ) {

                $scope.clubDeshabilitado = true;
            } else {

                $scope.clubDeshabilitado = false;
            }

            $ionicLoading.hide();

        }, function() {

            $rootScope.hacerLogout();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
            $ionicLoading.hide();
            $scope.modalTuCuenta.remove();
        });
    };

    // ABRIR PASSBOOK

    $scope.openUserPassbook = function (urlPassbook) {

        console.log(urlPassbook);

        cordova.InAppBrowser.open(urlPassbook, '_system');
    };

    // MODIFICAR DATOS USUARIO
    $scope.modificarDatos = function() {
        
        $ionicLoading.show({
            
            template: '<div class="cargando"><i style="font-weight: bold; margin-bottom: 15px;">{{translations.loading.update_data}}</i><br><ion-spinner icon="lines" class="spinner-positive"></ion-spinner></div>'
        });

        $scope.usuarioNuevo = {
            "ok": true,
            "Afiliacion": $rootScope.usuarioIdentificado.Afiliacion,
            "Authenticated": $rootScope.usuarioIdentificado.Authenticated,
            "Clublang": $rootScope.usuarioIdentificado.Clublang,
            "CodCliente": $rootScope.usuarioIdentificado.CodCliente,
            "Dni": $rootScope.usuarioIdentificado.Dni,
            "Fechaalta": $rootScope.usuarioIdentificado.Fechaalta,
            "Newemail": $rootScope.usuarioIdentificado.Email,
            "user": $rootScope.usuarioIdentificado.user,
            "Email": $rootScope.usuarioIdentificado.Email,
            "Nombre": $scope.usuario.nombre,
            "Paramsb": $rootScope.usuarioIdentificado.Paramsb,
            "Pasaporte": $rootScope.usuarioIdentificado.Pasaporte,
            "Premios": $rootScope.usuarioIdentificado.Premios,
            "Promocode": $rootScope.usuarioIdentificado.Promocode,
            "Puntosclub": $rootScope.usuarioIdentificado.Puntosclub,
            "ResAnyo": $rootScope.usuarioIdentificado.ResAnyo,
            "TarjetaFisica": $rootScope.usuarioIdentificado.TarjetaFisica,
            "Telefono": $rootScope.usuarioIdentificado.Telefono,
            "UrlWallet": $rootScope.usuarioIdentificado.UrlWallet,
            "Apellidos": $scope.usuario.apellidos,
            "Direccion": $scope.usuario.direccion,
            "Cpostal": $scope.usuario.cp,
            "Poblacion": $scope.usuario.poblacion,
            "Provincia": $scope.usuario.provincia,
            "Pais": $rootScope.usuarioIdentificado.Pais,
            "Club": $scope.usuario.club,
            "Dia": $scope.usuario.diaNacimiento,
            "Mes": $scope.usuario.mesNacimiento,
            "Anyo": $scope.usuario.anyoNacimiento,
            "Idioma": $rootScope.language,
            "idioma": $rootScope.language,
            "tipo": "modify"
        };

        if ( (typeof $scope.usuario.nuevoPasswd !== "undefined" && typeof $scope.usuario.nuevoPasswdRepetir !== "undefined") && ($scope.usuario.nuevoPasswd !== "" && $scope.usuario.nuevoPasswdRepetir !== "") ) {

            $scope.usuarioNuevo.Password = $scope.usuario.nuevoPasswd;
            $scope.usuarioNuevo.RepetirPassword = $scope.usuario.nuevoPasswdRepetir;

            if ( $scope.usuario.diaNacimiento === null || $scope.usuario.mesNacimiento === null || $scope.usuario.anyoNacimiento === null ) {

                $scope.usuario.diaNacimiento = "";
                $scope.usuario.mesNacimiento = "";
                $scope.usuario.anyoNacimiento = "";
            }
        }
        else{
            delete $scope.usuario.nuevoPasswd;
            delete $scope.usuario.nuevoPasswdRepetir;
        }
        
        if($scope.gdpr.privacidad_accepted_club){
            GoldcarService.postUsuario($scope.usuarioNuevo).then(function(result) {
                modificacionGdpr().then(function(){
                    GoldcarService.getUsuario().then(function(result) {
                        $rootScope.usuarioIdentificado = result.data;
                        typeof result.data.club_checked !== 'undefined' && result.data.club_checked ? $scope.gdpr.club_accepted_club = true : $scope.gdpr.club_accepted_club = false;
                        typeof result.data.perfil_checked !== 'undefined' && result.data.perfil_checked ? $scope.gdpr.perfil_accepted_club = true : $scope.gdpr.perfil_accepted_club = false;
                        typeof result.data.publi_checked !== 'undefined' && result.data.publi_checked ? $scope.gdpr.publi_accepted_club = true : $scope.gdpr.publi_accepted_club = false;

                        if(typeof result.error === 'undefined' || !result.error) $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.guardar_cambios), cssClass: 'single-popup', template: $filter("translate")($rootScope.translations.registro.datos_modificados) });
                        else $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                        $ionicLoading.hide();
                    }, function(error) {
                        
                        $ionicLoading.hide();
                        $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), cssClass: 'single-popup', template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                        $log.debug("Error de conexion en getUsuario: ", error);
                    })
                })
                .catch(function(err){
                    $ionicLoading.hide();
                    $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), cssClass: 'single-popup', template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                });
            }, function(error) {
                
                $ionicLoading.hide();
                $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), cssClass: 'single-popup', template: $filter("translate")($rootScope.translations.alertas.error_conexion) });
                $log.debug("Error de conexion en postUsuario: ", error);
            });
        }
        else{
            $ionicLoading.hide();
            $ionicPopup.alert({ title: $filter("translate")($rootScope.translations.general.error), cssClass: 'single-popup', template: $filter("translate")($rootScope.translations.alertas_nuevas.confirmar_politica) });
        }
    }

    // MODIFICACIONES GDPR //
    $scope.gdpr = {
        privacidad_accepted_club: false,
        publi_accepted_club: false,
        club_accepted_club: false,
        perfil_accepted_club: false
    }

    function modificacionGdpr(){
        var defered = $q.defer();  
        var promise = defered.promise;

        $ionicLoading.show();
        
        GoldcarService.setCheckOptionsClub($scope.gdpr).then(function(result){
            console.log(result);
            defered.resolve(true);
        })
        .catch(function(err){
            console.log(err);
            defered.reject(err);
        });       
        $ionicLoading.hide();
        
        return promise;
    }

    // DAR DE BAJA USUARIO //
    $scope.bajaUsuario = {
        "status": false,
        "club_goldcar": false,
        "goldcar": false,
        "newsletter": false
    }
    $scope.mostrarChecksBaja = function()
    {
        $scope.bajaUsuario.status = !$scope.bajaUsuario.status;
        $ionicScrollDelegate.$getByHandle('contentPerfil').resize();
    }
    $scope.darDeBaja = function()
    {
        var confirmPopup = $ionicPopup.confirm({
            cssClass: 'nueva-alerta',
            templateUrl: 'templates/alertas/alerta-tu-cuenta.html',
            cancelText: $rootScope.translations.general.cancelar,
            okText: $rootScope.translations.tu_cuenta.dar_baja
        });
       
        confirmPopup.then(function(res) 
        {
            if(res) 
            {
                $ionicLoading.show();
                GoldcarService.unsubscribeUser($scope.bajaUsuario).then(function(res){
                    if(typeof res.data.status !== 'undefined' && res.data.status)
                    {
                        if($scope.bajaUsuario.goldcar)
                        {
                            var alertPopup = $ionicPopup.alert({
                                cssClass: 'alerta-simple',
                                template: $filter("translate")($rootScope.translations.tu_cuenta.baja_cuenta_ok)
                            });
                        
                            alertPopup.then(function() 
                            {
                                $rootScope.hacerLogout();
                                $rootScope.modalTuCuenta.remove();
                            });
                        }
                        else if($scope.bajaUsuario.club_goldcar || $scope.bajaUsuario.newsletter)
                        {
                            var alertPopup = $ionicPopup.alert({
                                cssClass: 'alerta-simple',
                                template: $filter("translate")($rootScope.translations.tu_cuenta.baja_ofertas_ok)
                            });
                        
                            alertPopup.then(function() 
                            {
                                // NO HACER NADA AL CERRAR ALERTA
                            });
                        }
                        else
                        {
                            var alertPopup = $ionicPopup.alert({
                                cssClass: 'alerta-simple',
                                template: $filter("translate")($rootScope.translations.tu_cuenta.marcar_una_opcion)
                            });
                        
                            alertPopup.then(function() 
                            {
                                // NO HACER NADA AL CERRAR ALERTA
                            });
                        }
                        $ionicLoading.hide();
                    }
                    else
                    {
                        var alertPopup = $ionicPopup.alert({
                            cssClass: 'alerta-simple',
                            template: $filter("translate")($rootScope.translations.tu_cuenta.baja_cuenta_ko)
                        });
                    
                        alertPopup.then(function() 
                        {
                            
                        });
                    }
                });
            } 
        });
    }
});
